/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 238 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    ABORT_P = 269,
    ABSOLUTE_P = 270,
    ACCESS = 271,
    ACTION = 272,
    ADD_P = 273,
    ADMIN = 274,
    AFTER = 275,
    AGGREGATE = 276,
    ALL = 277,
    ALSO = 278,
    ALTER = 279,
    ALWAYS = 280,
    ANALYSE = 281,
    ANALYZE = 282,
    AND = 283,
    ANY = 284,
    ARRAY = 285,
    AS = 286,
    ASC = 287,
    ASSERTION = 288,
    ASSIGNMENT = 289,
    ASYMMETRIC = 290,
    AT = 291,
    ATTRIBUTE = 292,
    AUTHORIZATION = 293,
    BACKWARD = 294,
    BEFORE = 295,
    BEGIN_P = 296,
    BETWEEN = 297,
    BIGINT = 298,
    BINARY = 299,
    BIT = 300,
    BOOLEAN_P = 301,
    BOTH = 302,
    BY = 303,
    CACHE = 304,
    CALLED = 305,
    CASCADE = 306,
    CASCADED = 307,
    CASE = 308,
    CAST = 309,
    CATALOG_P = 310,
    CHAIN = 311,
    CHAR_P = 312,
    CHARACTER = 313,
    CHARACTERISTICS = 314,
    CHECK = 315,
    CHECKPOINT = 316,
    CLASS = 317,
    CLOSE = 318,
    CLUSTER = 319,
    COALESCE = 320,
    COLLATE = 321,
    COLLATION = 322,
    COLUMN = 323,
    COMMENT = 324,
    COMMENTS = 325,
    COMMIT = 326,
    COMMITTED = 327,
    CONCURRENTLY = 328,
    CONFIGURATION = 329,
    CONNECTION = 330,
    CONSTRAINT = 331,
    CONSTRAINTS = 332,
    CONTENT_P = 333,
    CONTINUE_P = 334,
    CONVERSION_P = 335,
    COPY = 336,
    COST = 337,
    CREATE = 338,
    CROSS = 339,
    CSV = 340,
    CURRENT_P = 341,
    CURRENT_CATALOG = 342,
    CURRENT_DATE = 343,
    CURRENT_ROLE = 344,
    CURRENT_SCHEMA = 345,
    CURRENT_TIME = 346,
    CURRENT_TIMESTAMP = 347,
    CURRENT_USER = 348,
    CURSOR = 349,
    CYCLE = 350,
    DATA_P = 351,
    DATABASE = 352,
    DAY_P = 353,
    DEALLOCATE = 354,
    DEC = 355,
    DECIMAL_P = 356,
    DECLARE = 357,
    DEFAULT = 358,
    DEFAULTS = 359,
    DEFERRABLE = 360,
    DEFERRED = 361,
    DEFINER = 362,
    DELETE_P = 363,
    DELIMITER = 364,
    DELIMITERS = 365,
    DESC = 366,
    DICTIONARY = 367,
    DISABLE_P = 368,
    DISCARD = 369,
    DISTINCT = 370,
    DO = 371,
    DOCUMENT_P = 372,
    DOMAIN_P = 373,
    DOUBLE_P = 374,
    DROP = 375,
    EACH = 376,
    ELSE = 377,
    ENABLE_P = 378,
    ENCODING = 379,
    ENCRYPTED = 380,
    END_P = 381,
    ENUM_P = 382,
    ESCAPE = 383,
    EVENT = 384,
    EXCEPT = 385,
    EXCLUDE = 386,
    EXCLUDING = 387,
    EXCLUSIVE = 388,
    EXECUTE = 389,
    EXISTS = 390,
    EXPLAIN = 391,
    EXTENSION = 392,
    EXTERNAL = 393,
    EXTRACT = 394,
    FALSE_P = 395,
    FAMILY = 396,
    FETCH = 397,
    FIRST_P = 398,
    FLOAT_P = 399,
    FOLLOWING = 400,
    FOR = 401,
    FORCE = 402,
    FOREIGN = 403,
    FORWARD = 404,
    FREEZE = 405,
    FROM = 406,
    FULL = 407,
    FUNCTION = 408,
    FUNCTIONS = 409,
    GLOBAL = 410,
    GRANT = 411,
    GRANTED = 412,
    GREATEST = 413,
    GROUP_P = 414,
    HANDLER = 415,
    HAVING = 416,
    HEADER_P = 417,
    HOLD = 418,
    HOUR_P = 419,
    IDENTITY_P = 420,
    IF_P = 421,
    ILIKE = 422,
    IMMEDIATE = 423,
    IMMUTABLE = 424,
    IMPLICIT_P = 425,
    IN_P = 426,
    INCLUDING = 427,
    INCREMENT = 428,
    INDEX = 429,
    INDEXES = 430,
    INHERIT = 431,
    INHERITS = 432,
    INITIALLY = 433,
    INLINE_P = 434,
    INNER_P = 435,
    INOUT = 436,
    INPUT_P = 437,
    INSENSITIVE = 438,
    INSERT = 439,
    INSTEAD = 440,
    INT_P = 441,
    INTEGER = 442,
    INTERSECT = 443,
    INTERVAL = 444,
    INTO = 445,
    INVOKER = 446,
    IS = 447,
    ISNULL = 448,
    ISOLATION = 449,
    JOIN = 450,
    KEY = 451,
    LABEL = 452,
    LANGUAGE = 453,
    LARGE_P = 454,
    LAST_P = 455,
    LATERAL_P = 456,
    LC_COLLATE_P = 457,
    LC_CTYPE_P = 458,
    LEADING = 459,
    LEAKPROOF = 460,
    LEAST = 461,
    LEFT = 462,
    LEVEL = 463,
    LIKE = 464,
    LIMIT = 465,
    LISTEN = 466,
    LOAD = 467,
    LOCAL = 468,
    LOCALTIME = 469,
    LOCALTIMESTAMP = 470,
    LOCATION = 471,
    LOCK_P = 472,
    MAPPING = 473,
    MATCH = 474,
    MATERIALIZED = 475,
    MAXVALUE = 476,
    MINUTE_P = 477,
    MINVALUE = 478,
    MODE = 479,
    MONTH_P = 480,
    MOVE = 481,
    NAME_P = 482,
    NAMES = 483,
    NATIONAL = 484,
    NATURAL = 485,
    NCHAR = 486,
    NEXT = 487,
    NO = 488,
    NONE = 489,
    NOT = 490,
    NOTHING = 491,
    NOTIFY = 492,
    NOTNULL = 493,
    NOWAIT = 494,
    NULL_P = 495,
    NULLIF = 496,
    NULLS_P = 497,
    NUMERIC = 498,
    OBJECT_P = 499,
    OF = 500,
    OFF = 501,
    OFFSET = 502,
    OIDS = 503,
    ON = 504,
    ONLY = 505,
    OPERATOR = 506,
    OPTION = 507,
    OPTIONS = 508,
    OR = 509,
    ORDER = 510,
    OUT_P = 511,
    OUTER_P = 512,
    OVER = 513,
    OVERLAPS = 514,
    OVERLAY = 515,
    OWNED = 516,
    OWNER = 517,
    PARSER = 518,
    PARTIAL = 519,
    PARTITION = 520,
    PASSING = 521,
    PASSWORD = 522,
    PLACING = 523,
    PLANS = 524,
    POSITION = 525,
    PRECEDING = 526,
    PRECISION = 527,
    PRESERVE = 528,
    PREPARE = 529,
    PREPARED = 530,
    PRIMARY = 531,
    PRIOR = 532,
    PRIVILEGES = 533,
    PROCEDURAL = 534,
    PROCEDURE = 535,
    PROGRAM = 536,
    QUOTE = 537,
    RANGE = 538,
    READ = 539,
    REAL = 540,
    REASSIGN = 541,
    RECHECK = 542,
    RECURSIVE = 543,
    REF = 544,
    REFERENCES = 545,
    REFRESH = 546,
    REINDEX = 547,
    RELATIVE_P = 548,
    RELEASE = 549,
    RENAME = 550,
    REPEATABLE = 551,
    REPLACE = 552,
    REPLICA = 553,
    RESET = 554,
    RESTART = 555,
    RESTRICT = 556,
    RETURNING = 557,
    RETURNS = 558,
    REVOKE = 559,
    RIGHT = 560,
    ROLE = 561,
    ROLLBACK = 562,
    ROW = 563,
    ROWS = 564,
    RULE = 565,
    SAVEPOINT = 566,
    SCHEMA = 567,
    SCROLL = 568,
    SEARCH = 569,
    SECOND_P = 570,
    SECURITY = 571,
    SELECT = 572,
    SEQUENCE = 573,
    SEQUENCES = 574,
    SERIALIZABLE = 575,
    SERVER = 576,
    SESSION = 577,
    SESSION_USER = 578,
    SET = 579,
    SETOF = 580,
    SHARE = 581,
    SHOW = 582,
    SIMILAR = 583,
    SIMPLE = 584,
    SMALLINT = 585,
    SNAPSHOT = 586,
    SOME = 587,
    STABLE = 588,
    STANDALONE_P = 589,
    START = 590,
    STATEMENT = 591,
    STATISTICS = 592,
    STDIN = 593,
    STDOUT = 594,
    STORAGE = 595,
    STRICT_P = 596,
    STRIP_P = 597,
    SUBSTRING = 598,
    SYMMETRIC = 599,
    SYSID = 600,
    SYSTEM_P = 601,
    TABLE = 602,
    TABLES = 603,
    TABLESPACE = 604,
    TEMP = 605,
    TEMPLATE = 606,
    TEMPORARY = 607,
    TEXT_P = 608,
    THEN = 609,
    TIME = 610,
    TIMESTAMP = 611,
    TO = 612,
    TRAILING = 613,
    TRANSACTION = 614,
    TREAT = 615,
    TRIGGER = 616,
    TRIM = 617,
    TRUE_P = 618,
    TRUNCATE = 619,
    TRUSTED = 620,
    TYPE_P = 621,
    TYPES_P = 622,
    UNBOUNDED = 623,
    UNCOMMITTED = 624,
    UNENCRYPTED = 625,
    UNION = 626,
    UNIQUE = 627,
    UNKNOWN = 628,
    UNLISTEN = 629,
    UNLOGGED = 630,
    UNTIL = 631,
    UPDATE = 632,
    USER = 633,
    USING = 634,
    VACUUM = 635,
    VALID = 636,
    VALIDATE = 637,
    VALIDATOR = 638,
    VALUE_P = 639,
    VALUES = 640,
    VARCHAR = 641,
    VARIADIC = 642,
    VARYING = 643,
    VERBOSE = 644,
    VERSION_P = 645,
    VIEW = 646,
    VOLATILE = 647,
    WHEN = 648,
    WHERE = 649,
    WHITESPACE_P = 650,
    WINDOW = 651,
    WITH = 652,
    WITHOUT = 653,
    WORK = 654,
    WRAPPER = 655,
    WRITE = 656,
    XML_P = 657,
    XMLATTRIBUTES = 658,
    XMLCONCAT = 659,
    XMLELEMENT = 660,
    XMLEXISTS = 661,
    XMLFOREST = 662,
    XMLPARSE = 663,
    XMLPI = 664,
    XMLROOT = 665,
    XMLSERIALIZE = 666,
    YEAR_P = 667,
    YES_P = 668,
    ZONE = 669,
    NULLS_FIRST = 670,
    NULLS_LAST = 671,
    WITH_TIME = 672,
    POSTFIXOP = 673,
    UMINUS = 674
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 176 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 735 "gram.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 763 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  715
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   76224

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  437
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  558
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2318
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4454

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   674

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   426,     2,     2,
     431,   432,   424,   422,   435,   423,   433,   425,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   436,   434,
     419,   418,   420,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   429,     2,   430,   427,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   421,   428
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   678,   678,   685,   692,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   817,
     827,   838,   839,   848,   849,   853,   854,   858,   863,   867,
     872,   877,   881,   885,   890,   894,   948,   950,   954,   958,
     962,   966,   980,   998,  1009,  1010,  1014,  1022,  1040,  1052,
    1073,  1080,  1099,  1106,  1123,  1141,  1152,  1153,  1165,  1172,
    1189,  1202,  1212,  1230,  1248,  1249,  1253,  1260,  1268,  1269,
    1270,  1271,  1272,  1273,  1287,  1293,  1299,  1308,  1316,  1324,
    1328,  1336,  1344,  1351,  1358,  1366,  1377,  1385,  1393,  1404,
    1412,  1420,  1427,  1436,  1446,  1447,  1454,  1455,  1458,  1460,
    1464,  1465,  1466,  1467,  1471,  1472,  1473,  1479,  1491,  1495,
    1499,  1514,  1537,  1538,  1539,  1543,  1544,  1545,  1549,  1550,
    1554,  1561,  1568,  1575,  1582,  1592,  1593,  1598,  1599,  1604,
    1610,  1616,  1622,  1628,  1638,  1648,  1649,  1653,  1654,  1662,
    1677,  1683,  1689,  1695,  1713,  1722,  1731,  1740,  1749,  1758,
    1767,  1776,  1785,  1794,  1806,  1807,  1812,  1820,  1828,  1837,
    1845,  1853,  1862,  1871,  1880,  1889,  1899,  1912,  1926,  1935,
    1943,  1951,  1961,  1971,  1978,  1985,  1993,  2001,  2009,  2017,
    2025,  2032,  2039,  2047,  2054,  2061,  2069,  2077,  2085,  2093,
    2101,  2109,  2119,  2126,  2134,  2142,  2150,  2157,  2167,  2168,
    2172,  2173,  2174,  2178,  2186,  2190,  2191,  2195,  2198,  2199,
    2203,  2204,  2209,  2213,  2217,  2222,  2237,  2250,  2251,  2256,
    2265,  2275,  2285,  2310,  2316,  2346,  2375,  2397,  2398,  2402,
    2403,  2412,  2413,  2414,  2417,  2418,  2423,  2424,  2428,  2432,
    2436,  2440,  2444,  2448,  2452,  2456,  2460,  2464,  2468,  2472,
    2476,  2485,  2489,  2493,  2497,  2501,  2505,  2509,  2510,  2515,
    2519,  2526,  2533,  2534,  2535,  2536,  2537,  2541,  2545,  2553,
    2564,  2579,  2595,  2611,  2640,  2641,  2642,  2643,  2644,  2651,
    2658,  2659,  2663,  2664,  2668,  2669,  2673,  2677,  2684,  2688,
    2695,  2696,  2697,  2701,  2702,  2705,  2725,  2745,  2746,  2750,
    2758,  2759,  2760,  2791,  2798,  2805,  2816,  2827,  2837,  2846,
    2879,  2886,  2893,  2900,  2911,  2921,  2922,  2923,  2927,  2928,
    2929,  2930,  2931,  2932,  2941,  2949,  2953,  2966,  2981,  2995,
    3010,  3024,  3042,  3063,  3064,  3068,  3069,  3073,  3074,  3077,
    3083,  3087,  3095,  3100,  3106,  3107,  3111,  3116,  3123,  3124,
    3134,  3136,  3138,  3140,  3143,  3146,  3149,  3153,  3154,  3155,
    3156,  3157,  3160,  3161,  3166,  3167,  3168,  3169,  3172,  3173,
    3174,  3175,  3178,  3179,  3182,  3183,  3186,  3201,  3216,  3230,
    3231,  3232,  3244,  3259,  3272,  3273,  3285,  3304,  3316,  3324,
    3335,  3336,  3339,  3340,  3343,  3347,  3351,  3355,  3359,  3363,
    3367,  3371,  3375,  3379,  3383,  3387,  3393,  3394,  3398,  3399,
    3404,  3407,  3408,  3420,  3432,  3447,  3448,  3456,  3457,  3461,
    3462,  3466,  3467,  3471,  3472,  3476,  3487,  3500,  3501,  3511,
    3521,  3522,  3535,  3542,  3559,  3567,  3578,  3581,  3585,  3589,
    3593,  3605,  3615,  3618,  3622,  3635,  3645,  3655,  3664,  3673,
    3682,  3692,  3701,  3711,  3721,  3731,  3740,  3749,  3758,  3767,
    3776,  3785,  3794,  3803,  3812,  3821,  3830,  3839,  3848,  3866,
    3877,  3878,  3879,  3880,  3884,  3885,  3889,  3890,  3900,  3911,
    3931,  3939,  3951,  3952,  3956,  3960,  3968,  3972,  3976,  3983,
    3987,  3992,  3997,  4004,  4011,  4016,  4026,  4040,  4041,  4046,
    4047,  4051,  4052,  4062,  4073,  4093,  4102,  4110,  4127,  4142,
    4167,  4176,  4194,  4206,  4207,  4208,  4218,  4226,  4243,  4262,
    4282,  4307,  4308,  4309,  4313,  4315,  4337,  4339,  4341,  4343,
    4345,  4350,  4355,  4365,  4366,  4370,  4371,  4375,  4376,  4380,
    4381,  4382,  4386,  4392,  4393,  4394,  4398,  4399,  4404,  4405,
    4432,  4433,  4434,  4435,  4436,  4437,  4442,  4453,  4476,  4486,
    4500,  4502,  4507,  4512,  4514,  4519,  4529,  4530,  4531,  4532,
    4544,  4564,  4587,  4597,  4608,  4618,  4628,  4639,  4648,  4655,
    4662,  4671,  4680,  4689,  4698,  4707,  4718,  4721,  4722,  4725,
    4729,  4736,  4737,  4738,  4739,  4740,  4743,  4744,  4747,  4750,
    4751,  4759,  4766,  4767,  4770,  4772,  4783,  4793,  4803,  4815,
    4816,  4832,  4847,  4848,  4852,  4862,  4873,  4882,  4892,  4901,
    4902,  4905,  4906,  4909,  4910,  4911,  4914,  4928,  4933,  4943,
    4952,  4964,  4965,  4969,  4977,  4989,  5000,  5014,  5025,  5048,
    5058,  5076,  5087,  5098,  5109,  5123,  5124,  5125,  5126,  5127,
    5128,  5129,  5130,  5131,  5132,  5133,  5134,  5135,  5136,  5137,
    5138,  5139,  5143,  5144,  5147,  5148,  5151,  5153,  5166,  5177,
    5178,  5179,  5211,  5220,  5229,  5238,  5247,  5256,  5265,  5275,
    5284,  5293,  5302,  5311,  5320,  5332,  5333,  5334,  5335,  5336,
    5337,  5338,  5339,  5340,  5341,  5342,  5343,  5344,  5345,  5346,
    5347,  5348,  5349,  5350,  5351,  5352,  5353,  5354,  5358,  5359,
    5373,  5384,  5395,  5406,  5417,  5430,  5431,  5435,  5436,  5437,
    5438,  5439,  5440,  5441,  5442,  5443,  5444,  5445,  5446,  5447,
    5450,  5451,  5461,  5467,  5475,  5483,  5491,  5499,  5507,  5515,
    5523,  5531,  5539,  5547,  5555,  5563,  5571,  5579,  5587,  5595,
    5605,  5606,  5609,  5610,  5620,  5636,  5650,  5676,  5678,  5680,
    5682,  5689,  5698,  5699,  5702,  5709,  5716,  5723,  5737,  5745,
    5753,  5761,  5769,  5777,  5785,  5793,  5801,  5809,  5817,  5825,
    5833,  5841,  5849,  5857,  5869,  5870,  5873,  5883,  5897,  5898,
    5902,  5903,  5908,  5924,  5937,  5947,  5959,  5960,  5963,  5964,
    5974,  5984,  5985,  5989,  5993,  5997,  6008,  6021,  6035,  6052,
    6053,  6054,  6055,  6067,  6094,  6095,  6099,  6100,  6104,  6105,
    6109,  6110,  6113,  6114,  6122,  6133,  6144,  6157,  6158,  6161,
    6162,  6163,  6166,  6167,  6168,  6171,  6172,  6173,  6189,  6201,
    6214,  6229,  6230,  6233,  6234,  6238,  6239,  6247,  6248,  6252,
    6253,  6268,  6277,  6286,  6295,  6304,  6316,  6317,  6318,  6319,
    6320,  6326,  6330,  6345,  6346,  6352,  6362,  6366,  6371,  6381,
    6382,  6389,  6393,  6397,  6401,  6405,  6409,  6413,  6417,  6421,
    6425,  6429,  6433,  6437,  6441,  6445,  6453,  6457,  6461,  6465,
    6471,  6472,  6479,  6480,  6483,  6495,  6499,  6514,  6525,  6526,
    6531,  6532,  6547,  6558,  6572,  6583,  6597,  6608,  6622,  6630,
    6632,  6634,  6639,  6641,  6654,  6663,  6664,  6668,  6672,  6684,
    6695,  6706,  6719,  6720,  6721,  6725,  6738,  6739,  6753,  6761,
    6771,  6784,  6785,  6788,  6789,  6799,  6809,  6818,  6827,  6836,
    6845,  6855,  6864,  6874,  6883,  6892,  6902,  6912,  6921,  6930,
    6940,  6950,  6960,  6970,  6980,  6990,  7000,  7010,  7020,  7030,
    7040,  7050,  7061,  7072,  7083,  7094,  7104,  7115,  7126,  7136,
    7146,  7154,  7163,  7172,  7181,  7190,  7199,  7208,  7217,  7226,
    7235,  7244,  7258,  7259,  7262,  7263,  7273,  7283,  7292,  7301,
    7310,  7319,  7329,  7339,  7349,  7359,  7368,  7377,  7386,  7395,
    7404,  7413,  7422,  7431,  7440,  7449,  7458,  7467,  7476,  7485,
    7502,  7511,  7519,  7527,  7535,  7543,  7552,  7560,  7568,  7577,
    7586,  7595,  7603,  7611,  7619,  7627,  7635,  7643,  7651,  7668,
    7685,  7686,  7687,  7692,  7698,  7707,  7708,  7709,  7710,  7711,
    7715,  7716,  7719,  7720,  7721,  7722,  7726,  7727,  7728,  7733,
    7744,  7766,  7776,  7777,  7780,  7789,  7795,  7814,  7821,  7828,
    7835,  7842,  7849,  7856,  7864,  7872,  7880,  7888,  7896,  7903,
    7910,  7919,  7920,  7921,  7925,  7928,  7931,  7934,  7937,  7944,
    7946,  7948,  7953,  7955,  7967,  7979,  7991,  8003,  8018,  8024,
    8030,  8036,  8046,  8062,  8072,  8073,  8077,  8081,  8085,  8089,
    8093,  8097,  8101,  8105,  8109,  8113,  8117,  8121,  8125,  8129,
    8133,  8137,  8147,  8148,  8159,  8166,  8177,  8188,  8189,  8193,
    8207,  8214,  8231,  8244,  8253,  8261,  8269,  8278,  8289,  8300,
    8310,  8311,  8322,  8332,  8342,  8352,  8362,  8372,  8380,  8401,
    8424,  8432,  8441,  8452,  8453,  8465,  8481,  8497,  8511,  8531,
    8556,  8557,  8561,  8562,  8563,  8564,  8568,  8582,  8599,  8600,
    8604,  8605,  8608,  8609,  8612,  8613,  8617,  8618,  8631,  8638,
    8648,  8655,  8665,  8666,  8667,  8668,  8669,  8670,  8671,  8672,
    8673,  8677,  8681,  8688,  8695,  8696,  8700,  8701,  8702,  8712,
    8722,  8723,  8727,  8728,  8729,  8730,  8740,  8747,  8765,  8766,
    8776,  8782,  8788,  8794,  8810,  8820,  8826,  8832,  8841,  8843,
    8848,  8859,  8860,  8871,  8885,  8886,  8897,  8908,  8909,  8912,
    8913,  8914,  8915,  8916,  8917,  8918,  8919,  8922,  8923,  8934,
    8952,  8953,  8957,  8958,  8962,  8970,  8998,  9009,  9010,  9020,
    9031,  9034,  9035,  9036,  9037,  9038,  9041,  9042,  9043,  9091,
    9092,  9096,  9097,  9112,  9113,  9120,  9128,  9136,  9144,  9152,
    9160,  9171,  9172,  9199,  9214,  9215,  9234,  9238,  9242,  9257,
    9264,  9274,  9275,  9278,  9290,  9291,  9295,  9307,  9315,  9320,
    9325,  9330,  9335,  9343,  9351,  9356,  9361,  9368,  9369,  9372,
    9373,  9374,  9381,  9382,  9383,  9384,  9388,  9389,  9393,  9397,
    9398,  9401,  9410,  9423,  9424,  9425,  9426,  9430,  9431,  9435,
    9437,  9447,  9452,  9455,  9460,  9461,  9469,  9479,  9480,  9481,
    9489,  9493,  9494,  9497,  9498,  9503,  9504,  9508,  9509,  9513,
    9514,  9518,  9519,  9523,  9524,  9528,  9539,  9540,  9541,  9542,
    9546,  9547,  9552,  9558,  9576,  9577,  9581,  9582,  9588,  9593,
    9602,  9611,  9646,  9671,  9675,  9701,  9705,  9717,  9730,  9744,
    9755,  9770,  9776,  9781,  9787,  9794,  9795,  9803,  9807,  9811,
    9817,  9824,  9829,  9830,  9831,  9832,  9836,  9837,  9849,  9850,
    9855,  9862,  9869,  9876,  9887,  9888,  9901,  9905,  9912,  9922,
    9927,  9928,  9933,  9934,  9942,  9947,  9948,  9952,  9956,  9962,
    9991,  9996, 10003, 10008, 10014, 10019, 10028, 10030, 10033, 10037,
   10038, 10039, 10040, 10041, 10042, 10047, 10077, 10078, 10079, 10080,
   10091, 10097, 10105, 10106, 10112, 10117, 10122, 10127, 10132, 10137,
   10142, 10147, 10153, 10159, 10165, 10172, 10194, 10203, 10207, 10215,
   10219, 10227, 10239, 10260, 10264, 10270, 10274, 10287, 10306, 10329,
   10331, 10333, 10335, 10337, 10339, 10344, 10345, 10349, 10350, 10357,
   10366, 10374, 10383, 10394, 10402, 10403, 10404, 10408, 10410, 10412,
   10414, 10416, 10418, 10420, 10425, 10430, 10436, 10444, 10449, 10456,
   10463, 10467, 10471, 10501, 10502, 10504, 10512, 10534, 10536, 10538,
   10540, 10542, 10544, 10546, 10548, 10550, 10552, 10554, 10557, 10559,
   10561, 10564, 10566, 10568, 10571, 10573, 10586, 10588, 10601, 10603,
   10616, 10618, 10632, 10645, 10658, 10671, 10694, 10701, 10708, 10715,
   10722, 10745, 10752, 10759, 10766, 10773, 10780, 10787, 10791, 10799,
   10803, 10813, 10820, 10827, 10840, 10853, 10872, 10893, 10903, 10910,
   10926, 10931, 10949, 10951, 10953, 10955, 10957, 10959, 10961, 10963,
   10965, 10967, 10969, 10971, 10973, 10975, 10977, 10979, 10981, 10985,
   10990, 10994, 10998, 11003, 11020, 11021, 11022, 11037, 11049, 11051,
   11053, 11063, 11086, 11096, 11106, 11114, 11133, 11146, 11159, 11172,
   11185, 11198, 11215, 11228, 11251, 11264, 11290, 11300, 11313, 11330,
   11343, 11353, 11366, 11376, 11389, 11402, 11415, 11428, 11441, 11454,
   11467, 11469, 11482, 11500, 11514, 11530, 11552, 11568, 11581, 11594,
   11607, 11611, 11618, 11626, 11634, 11638, 11642, 11646, 11650, 11654,
   11669, 11673, 11682, 11686, 11690, 11695, 11709, 11711, 11715, 11717,
   11719, 11722, 11725, 11728, 11729, 11732, 11740, 11750, 11751, 11754,
   11755, 11756, 11761, 11765, 11769, 11773, 11784, 11785, 11789, 11790,
   11795, 11803, 11805, 11819, 11822, 11849, 11850, 11853, 11854, 11865,
   11883, 11890, 11899, 11916, 11961, 11969, 11977, 11985, 11993, 12014,
   12015, 12016, 12019, 12020, 12021, 12024, 12025, 12028, 12029, 12030,
   12031, 12032, 12033, 12034, 12035, 12036, 12039, 12041, 12046, 12048,
   12053, 12055, 12057, 12059, 12061, 12063, 12075, 12079, 12086, 12090,
   12096, 12100, 12111, 12112, 12115, 12119, 12123, 12129, 12130, 12135,
   12139, 12146, 12147, 12148, 12149, 12150, 12151, 12152, 12153, 12163,
   12167, 12174, 12181, 12182, 12198, 12202, 12207, 12211, 12226, 12231,
   12235, 12238, 12241, 12242, 12243, 12246, 12253, 12263, 12277, 12278,
   12282, 12293, 12294, 12297, 12298, 12301, 12305, 12312, 12316, 12320,
   12327, 12337, 12338, 12342, 12343, 12346, 12347, 12358, 12359, 12368,
   12369, 12377, 12388, 12389, 12392, 12408, 12416, 12424, 12446, 12447,
   12458, 12462, 12489, 12491, 12496, 12499, 12502, 12504, 12506, 12508,
   12518, 12520, 12531, 12535, 12539, 12543, 12547, 12556, 12563, 12588,
   12592, 12598, 12615, 12619, 12623, 12629, 12630, 12631, 12633, 12635,
   12639, 12640, 12641, 12657, 12658, 12659, 12664, 12665, 12666, 12671,
   12672, 12673, 12674, 12680, 12681, 12682, 12683, 12684, 12704, 12705,
   12706, 12707, 12708, 12709, 12710, 12711, 12712, 12713, 12714, 12715,
   12716, 12717, 12718, 12719, 12720, 12721, 12722, 12723, 12724, 12725,
   12726, 12727, 12728, 12729, 12730, 12731, 12732, 12733, 12734, 12735,
   12736, 12737, 12738, 12739, 12740, 12741, 12742, 12743, 12744, 12745,
   12746, 12747, 12748, 12749, 12750, 12751, 12752, 12753, 12754, 12755,
   12756, 12757, 12758, 12759, 12760, 12761, 12762, 12763, 12764, 12765,
   12766, 12767, 12768, 12769, 12770, 12771, 12772, 12773, 12774, 12775,
   12776, 12777, 12778, 12779, 12780, 12781, 12782, 12783, 12784, 12785,
   12786, 12787, 12788, 12789, 12790, 12791, 12792, 12793, 12794, 12795,
   12796, 12797, 12798, 12799, 12800, 12801, 12802, 12803, 12804, 12805,
   12806, 12807, 12808, 12809, 12810, 12811, 12812, 12813, 12814, 12815,
   12816, 12817, 12818, 12819, 12820, 12821, 12822, 12823, 12824, 12825,
   12826, 12827, 12828, 12829, 12830, 12831, 12832, 12833, 12834, 12835,
   12836, 12837, 12838, 12839, 12840, 12841, 12842, 12843, 12844, 12845,
   12846, 12847, 12848, 12849, 12850, 12851, 12852, 12853, 12854, 12855,
   12856, 12857, 12858, 12859, 12860, 12861, 12862, 12863, 12864, 12865,
   12866, 12867, 12868, 12869, 12870, 12871, 12872, 12873, 12874, 12875,
   12876, 12877, 12878, 12879, 12880, 12881, 12882, 12883, 12884, 12885,
   12886, 12887, 12888, 12889, 12890, 12891, 12892, 12893, 12894, 12895,
   12896, 12897, 12898, 12899, 12900, 12901, 12902, 12903, 12904, 12905,
   12906, 12907, 12908, 12909, 12910, 12911, 12912, 12913, 12914, 12915,
   12916, 12917, 12918, 12919, 12920, 12921, 12922, 12923, 12924, 12925,
   12926, 12927, 12928, 12929, 12930, 12931, 12932, 12933, 12934, 12935,
   12936, 12937, 12938, 12939, 12940, 12941, 12942, 12943, 12944, 12945,
   12946, 12947, 12948, 12949, 12950, 12951, 12952, 12953, 12954, 12955,
   12956, 12957, 12971, 12972, 12973, 12974, 12975, 12976, 12977, 12978,
   12979, 12980, 12981, 12982, 12983, 12984, 12985, 12986, 12987, 12988,
   12989, 12990, 12991, 12992, 12993, 12994, 12995, 12996, 12997, 12998,
   12999, 13000, 13001, 13002, 13003, 13004, 13005, 13006, 13007, 13008,
   13009, 13010, 13011, 13012, 13013, 13014, 13015, 13016, 13017, 13031,
   13032, 13033, 13034, 13035, 13036, 13037, 13038, 13039, 13040, 13041,
   13042, 13043, 13044, 13045, 13046, 13047, 13048, 13049, 13050, 13051,
   13052, 13053, 13063, 13064, 13065, 13066, 13067, 13068, 13069, 13070,
   13071, 13072, 13073, 13074, 13075, 13076, 13077, 13078, 13079, 13080,
   13081, 13082, 13083, 13084, 13085, 13086, 13087, 13088, 13089, 13090,
   13091, 13092, 13093, 13094, 13095, 13096, 13097, 13098, 13099, 13100,
   13101, 13102, 13103, 13104, 13105, 13106, 13107, 13108, 13109, 13110,
   13111, 13112, 13113, 13114, 13115, 13116, 13117, 13118, 13119, 13120,
   13121, 13122, 13123, 13124, 13125, 13126, 13127, 13128, 13129, 13130,
   13131, 13132, 13133, 13134, 13135, 13136, 13137, 13138, 13139
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LATERAL_P", "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF",
  "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL",
  "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH",
  "MATERIALIZED", "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P",
  "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO",
  "NONE", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING",
  "PLANS", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETOF",
  "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC",
  "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE",
  "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS",
  "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P",
  "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'",
  "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "xmlexists_argument",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,    61,    60,
      62,   673,    43,    45,    42,    47,    37,    94,   674,    91,
      93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -4044

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4044)))

#define YYTABLE_NINF -2225

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2225)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    5677,   873, 11610, -4044, -4044,   873, -4044, 51579,   -38,   115,
     575,   132, 11248, 51991, 58995,   222,   271, 11357,   873, 58995,
    2195, 38395, 49107, 58995,  1104,   854, 38395, 58995, 59407,  1087,
    1070,   736, 59819, 52403, 47871,   851, 58995,  1137,   282, 60231,
   52815,  1002, 53227,   854, 35531,   108,  1015, 60643,  1295,  1493,
    1065, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,   -38, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,   343, -4044,   663,
     347,  1606,   722,  1331, -4044, -4044, -4044, 43339, 58995, 58995,
   58995,  1310, 58995,  1396, 58995,   632, 43339, 43751, 61055,  1532,
    1409, 32155, -4044, 41691, 58995, 58995, 61467, 58995, 53639, 58995,
    1495, 58995, 58995, 44163, 61879,  1669,  1466, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, 58995,  5198,  1104, -4044,
   -4044, 58995,  1460, 43339, 58995,  1449, 58995,  1479, 58995, -4044,
   58995,  1526, 62291,   699,   595, 43751,  1172, 32580,  1616, 43751,
   62703, 58995, 58995, -4044, -4044,  1612, 58995, 58995, -4044,  1724,
   44575,   952,  1736,  1883,  1822,   762, -4044, 54051, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, 42103,   271, -4044, -4044, 44987,
   58995,  1885, -4044, -4044, 63115, -4044,  1694, -4044,   713, 45399,
   45811,  1988,  1682, 33005,  2032, 46223, 63527, -4044, -4044, 63939,
   -4044, 64351,  1776, 64763, -4044, 46635, -4044,  1897, 65175, -4044,
    1677,  1393,  1471, 28804, -4044, -4044, -4044,   -38, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,   287,  1562,   309,   175,
     363, -4044, -4044,   182,   187,   188,   287,  2125,  2125, -4044,
   58995, -4044, -4044,  1562,     6,  1717,  1717,  1717,  1903,   -20,
   -4044,  1717, -4044, -4044, -4044, -4044, 53227, -4044,  1732,  1104,
    1728,  2127,  1842, 58995, -4044, 58995, -4044, 58995, 58995, -4044,
   -4044,  2200,  1830,  2062,  1846, -4044,  2014,  2035,  2051,    96,
    1104,  1951, -4044,  2185, -4044,  2088, 19460,  1104, 54463, 65587,
     335, 42103,  1104, 54875,  1924,   855,  2110, -4044, -4044,   640,
   -4044,  2325,  1956,  2175,  1846,  1466, 30058, -4044,  1952,   500,
   53227, -4044, -4044, -4044,   192,  2230, 19889, -4044, 58995,  1950,
   -4044,  1960,  1961,  1982,  1606, -4044,  5677, 58995,   286,   286,
    2344,   286,   173,  1619, -4044,  1451, -4044,  2264,  2242, 53227,
    1015,   195, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,  1989,   500, -4044,   197, -4044,
    1480,  2000,  1575,  1363, -4044, -4044,   225, 58995,  2114,   353,
     -29,  2049, 55287,  5152,  2011, -4044,   783, -4044, -4044, -4044,
   -4044,  2312,  2927,   303, 65999, -4044, 58995, 58995, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2036, -4044, -4044,
    2043,  2298,    82,  2234,   622,  2346,  8562,  1337,  2356,  4294,
    1312,   744,  2244,  1027,  2351,  1199,  2364,  6202, 58995, -4044,
    2300,  2404,   735, -4044,   141, -4044,  2134,  2270,   963, 43339,
    2091, -4044, -4044, 58995, -4044, -4044, -4044,  2166, -4044,   714,
   43339, -4044,  2293,  2148, 33430, -4044, 58995, -4044, -4044, -4044,
   -4044, -4044,  2235, 58995, -4044, -4044,  2350, 58995, -4044,  1717,
    2274,  2132,  2496, 74607,   324, 58995,  2168,  2541, 58995,  2342,
    2168,  2178, 66411, -4044, -4044,  2168, -4044, -4044, 58995, 58995,
    2157,  1684,  2168,  2355,  2557,  2563,  2237,  2345,   838,   258,
     158,  2463,  2168,  2223, 58995, 66823, 58995,  2224, 58995,  2545,
   43339, 58995, -4044,  2340, -4044, -4044,  1162, -4044, -4044, -4044,
   -4044,  2492,  1989,   715,  2493,  2198,  2497, -4044, -4044,  2231,
   -4044,  2498,  2011,  2499, -4044,  2203, 67235, -4044, 67647, 68059,
    2500,  2036, 43751,  2504,  2203,  2505,  2381,  2508,   715,  2509,
   -4044,  1076,  2511,  2401,  2516,  1115,  2203, 42515,  2517,   393,
   -4044, 21605, -4044,  2306, -4044,  1015, -4044,  1538, -4044, 37983,
   -4044,  1471,  1562, -4044, 58995,  1562, 58995,  1562, 58995,  1562,
   58995,  1562, 58995, 58995, 58995,  1562, -4044, -4044, -4044, 58995,
    2225, 58995, 58995, -4044, -4044, -4044, 49519, 43751, 49931, -4044,
   -4044,    80,  1104, -4044, -4044, 74607,  2623, 43751, 58995,  2512,
    2512,  2512, -4044, -4044, -4044,  2450, 58995,  2514,  2519, 49519,
   43751, -4044, 68471, 42103,  2413,  2240, -4044, -4044, -4044, -4044,
   -4044,  1259,  2658,   220,  2663, 21605,  2241,   169,   169,  2243,
    2527, -4044, -4044, -4044,   226,  2247,  2248, -4044,   230,   230,
    2408,  2254,  2255, -4044,   235,  2257,  2684,  2685,   252,  2262,
    2263,  2266,  1683,   169, 21605, -4044,  2268,   230,  2271,  2272,
    2273,  2690,  2275, -4044,  2691,  2276,   201,   284,  2277,  2278,
   -4044,  2254, -4044,   227,  2279,  2280,  2284,  2288,  2289,  2291,
    2294,  2295, 21605, 21605, -4044, 18602,   500,  1104, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,   121, -4044,   253,  4647, -4044,
   -4044,  2465, 21605, -4044, -4044,   598, -4044,   254, -4044, -4044,
   -4044,   500, -4044, -4044,   221,  2296, -4044,   314, -4044, -4044,
   -4044, -4044, -4044, -4044, 40455,  2697, -4044,   822,  1104,   141,
    1263,  2646, 37159, 37571, -4044, -4044,  2525, -4044, 58995, -4044,
   -4044, 21605, 35119, -4044,   500,   124, -4044, -4044, -4044,  1557,
   -4044, -4044, -4044,   -38, -4044, 10913, -4044,  1597,  1950, 58995,
   58995,  2704, -4044, -4044, -4044,  1960, -4044, -4044,  1606,  1606,
   21605,  1606,   816,  1207, 20318, 21605,  2591,  2491,  1092,  1194,
    2595, -4044,  2501,   173,  1619, 53227, 58995, 68883,  2419, -4044,
   36355,  1642,   500,  2387,  2388,  2435, 39219,  2315,  2394,  2397,
    2443,  2399,  2400, 69295, -4044, -4044, -4044, -4044,  1288,   881,
     207,  2403,   190,   935,  2687, -4044,  1212,  2452, -4044, -4044,
   -4044,  3453, 58995,  2634,  6278,  2521,   303,  2455, -4044, -4044,
    2568,  2417,  2418,  2536,   303,   209, 69707, -4044, -4044, -4044,
   -4044, -4044, -4044,  2265, 17371, -4044,  2420,  2405, 58995, 47047,
    2710,  2532,  1237,   289,   179, 58995,  2606,  2540, 58995,  2357,
    2430,  2432,  2361,  1218,  2717,  2366, -4044, -4044, -4044,  1505,
    2534, -4044,  2665,  6372,  2423,  2424, 73393,    51, 33855,  2708,
      50,  2453, -4044,    50, 58995,  2457,  2458, 58995,   303, -4044,
    2759,   303,   303,  1687,  2761,  2459,   351,  1274,  2168,  2366,
    1322, -4044,  2460,  2466,   810, -4044,  2559, 53227,   331,  1381,
    2366,  2467,  2468,  2361,  2361, 58995, 58995, 58995, 58995, 58995,
     193,  2790,  2792,  2477,   172,  2523,  2402, -4044, 40867,  2479,
   65587, -4044, -4044, 58995,  2481,  1766,  2366,  1477,  1595, -4044,
   -4044, -4044,  1466, -4044, 58995, -4044, 58995,  1989, 74607,  2592,
   -4044,  2442, -4044,  2011,   303, -4044, 58995, 58995,  2036,  1017,
    1102,  2594, 58995,  2652,  2448, -4044,   194, 36757,  2157, -4044,
    2427, -4044, -4044,  2461, -4044,  2461,  2461,  2431,  2431,  2433,
   -4044, -4044, -4044,  1683,  2461,  2431, -4044, 75409, -4044,  1291,
    1507, -4044,  2817,  2820, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,   915,  1465, -4044, 58995, 39219, -4044,  2834,
   -4044, -4044, 74607,  2612,  2720, -4044, 58995,  2632,  2437, -4044,
    2767,  2494, -4044, -4044,    36, -4044,  2737, 43751,   223,  1104,
    2485, 58995,  2664, 58995, 58995, 58995, 58995, -4044, -4044,  2636,
     840,    95, -4044, 40867, -4044, 58995,  1322,  2644,  2852,    43,
    1717, 58995,  2739, -4044, 58995,  2456,  2855,  2692, -4044,  1522,
   -4044,  2575, -4044, 43339,   715, -4044, -4044, -4044, -4044, 74607,
   58995, 70119, 43339,   715, 43751, 43751,  2756,   393,  2757,  2515,
    2760,  2524, 33855,   715,   406, 43751, 58995, 58995, 58995, -4044,
   58995, -4044, -4044, -4044, -4044, 58995, 58995, 43751, 40867,  2763,
    2765,   715, 58995, 58995, -4044, 10913,  1608, 58995,  1471, 41279,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, 58995, -4044,
   58995, -4044, 58995, -4044, 58995, -4044, 58995, -4044, -4044, -4044,
   58995, -4044, 58995,  1615, -4044, -4044,  1633,  1049, 58995, 58995,
     704, 43339, 58995,  2660, 58995, 58995, 58995, 58995, 58995,  2549,
    2296,  1091, -4044,   234, 53227,  2668, -4044, -4044,  1656,  1295,
     919,  2513, -4044, -4044, -4044, -4044, -4044, -4044, 49931, 49107,
    2751,    67, 58995, -4044, -4044,  3384, 21605,   500, 19031, -4044,
   -4044, -4044,  2480, 10913,  2522, 21605, -4044, -4044, 21605,  2483,
    2125,  2125, 21605, -4044, -4044, -4044, -4044,   916,  2125, -4044,
   21605, 21605,  2125,  2125,  2461,  2461, -4044,  5596, 21605, -4044,
   33855, 21605, 24179, 16531, 21605,  2561,  2503,  2125, -4044,  2125,
   -4044, 21605, 18173, -4044, 21605,  2693, 25031, 21605,  1263,  2694,
   21605,  1263,  2901,  2901,  2495,  5161,  2484,   500, -4044,  2601,
    2125, -4044,  2125,   837, -4044,   185, 74607, 21605, 39219,  2574,
     181, 58995, 21605,  2487,  1193, -4044, 21605,   213, -4044,  2518,
   21605,  2578, 21605, 21605, 21605, 21605, 21605, 21605, 21605, 21605,
   21605, -4044, 25867,   246,   -21,  2135, 55699, 19460,  2780, 16101,
   -4044,   275, -4044, -4044, -4044, 58995,  2697, -4044, -4044,  2573,
   -4044, -4044, -4044, -4044, -4044,   259, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  2507, -4044, -4044, -4044, -4044,  2507, -4044,
    2528,  4569, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2771,  2778,
     715, 58995,   192, 50343, -4044, 19889, -4044,  1657, -4044,  2531,
   -4044,  2758, -4044,  2520, -4044,  8876,  2758, -4044, -4044,   327,
    2618,  2752,  2700, -4044, -4044, -4044,  2529, 10913, -4044,  1627,
   10913,  1833, -4044, -4044, -4044, -4044, -4044, -4044,  1073, -4044,
   58995,  2668,  2591,  1194,  2584,   828, 58995, -4044, 30476,  2533,
    1688,  2590,  2596,  2642, 43751, 58995, 58995, -4044, 39219, 43751,
   58995, 58995, 43751, 58995, 58995, -4044,  2893,     8, 49107,  2657,
   48283, -4044, -4044,  2542, 58995,  2597,  2779,  2782,  1047, -4044,
   -4044, 70531, -4044,  2734, 43751, 58995, 58995, 21605,  2740, 58995,
   58995, -4044,   407,  2624,  2625, -4044, 58995,  2627, 43339,  2555,
   58995, 58995, 58995,  2628,   728, 43339,  2599, 34280, 58995, 58995,
   58995, 58995,  2678, 58995, 58995,  2796,  1442, 53227,   231,  1871,
    2366,  2755, -4044,  1153, -4044, 43751, 58995,  2747, -4044, -4044,
   -4044, 56111,  2963,  2671, -4044, -4044, 70943, -4044, -4044,  2748,
   -4044, -4044, 75409, -4044, -4044,  1704, -4044, 75008, 71355, -4044,
   -4044,   476, 43751, 43751,  7199, 58995,  1294, -4044, -4044, 74607,
   -4044, 58995, 58995, 58995, 50755, 71756, 72168,  1356,  1359, 58995,
   51167, -4044, 58995, -4044, -4044, 39631, 43751, 58995, 39219, -4044,
   58995,  2762,   860, -4044, 58995,  6909, -4044,  2648, 58995,   378,
    1923,  2366, 58995, 58995,  2571,  1733,  2650,  2699, -4044, 58995,
   -4044, 43751,  1445, -4044,  2714, 43751, 58995, 12006, -4044, -4044,
     303, -4044, -4044, -4044, -4044, -4044, 58995, 58995,   303, 58995,
     303,  1260, -4044, 43751, 58995, -4044, -4044, -4044,  7231, 58995,
   58995, 58995, 58995, 43751, 58995, -4044, -4044,  1029,  1177,   618,
    1195,  2719, 58995,  2837, 58995, 72580, 43751, 58995, 58995, 58995,
     922, -4044, -4044,  2696, -4044, 43751,  1445,  7597, 58995, 58995,
    2662,  2669,   184,  2731, -4044, -4044, -4044, -4044, -4044, -4044,
    2828,  2990, 58995, -4044,  2830,  2833,  2649,  2651,  2835,   814,
   58995, -4044, -4044, -4044, -4044, 58995,  2839,   814,  2784,   737,
   -4044, -4044,  2168, -4044,  2616,  1742, -4044, -4044, 21605,  3007,
   74607,  2609,  2613,  2686,  2689,  2698, -4044,  2610,  2701,  2125,
   -4044, -4044,  1578, -4044, -4044,  1761, -4044,  2626,   840,  1709,
   -4044, 39219, 58995,   684,    89,  2913, 47459,  1457,  2903, 58995,
    2666, 58995,  1457, 58995, -4044,  1482, 49107, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044,  2905, -4044,  1104,  2157,
    2157,  2157,  2157, -4044, -4044, -4044, -4044,  2806,  1453, -4044,
    2630,  2157, 58995,  2733,  1457,  2631, -4044,  1322,  2921,   796,
   58995, 47459,  1801,  2667,  3028,  1717,  1104,  2814, -4044, 17772,
    2736,  2816, 42103,  2904,  2907,  2920, -4044,  1989, -4044,  3037,
   -4044,  2936,   715,  2011, -4044,  2203, -4044, 58995, -4044, 58995,
   58995, 58995, 58995,  2036, -4044, -4044,  2203,  2823,   715,   715,
   -4044,  2825,   715,  2203,  2764,  2932, 42103, -4044,   393, -4044,
   -4044, 21605,  1717, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044,  1768, -4044, 58995, -4044,  2908,  2909,  2911,  2656,  2659,
    2683, 58995,  2661, -4044,  2656,   303,  2656,  2296,  2296,  2656,
    2659, 42927,  3068,  2935,   683, -4044,   799,    21,  2869, -4044,
   -4044, -4044, -4044, 74607, -4044, -4044, -4044, -4044, -4044, 58995,
     196, -4044,   103,  2846,  2670, 42927,  3050,   715, -4044, 43339,
   -4044, -4044, -4044,  2743,  2753, 43339,  2862,  2716, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,  2910, 58995,  1778, -4044, -4044,
    1429, -4044,  1487, 21605, 21605,   126, -4044,  9141,  1794, 21605,
    2677,  2679,  1795, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
    2680,  2959, -4044,  2681,  1796,  1807,  2682,  2688, -4044, -4044,
    4941,  2695,  9837,  2703, 24179, 24179,   772, -4044, -4044, 24179,
    2705, -4044,  1808,  9243,  2706,  2707,  2709, -4044,  2711,  2712,
    9967, 20747, 21605, 20747, 20747, 10087,  2706,  2713,  1813, 39219,
    2849, 10427,  1819, -4044, 21605, 39219,  5013, 21605, -4044, 21605,
   58995,  2715,  2718, -4044, -4044,  5596, -4044,  2722, -4044, 24179,
   24179, -4044,  1986, 18602, -4044, -4044,  2966, -4044, -4044,  1247,
   -4044,  2702, -4044, -4044,  5936,   199, 21605,  2487, 21605,  2768,
   33855,  6527, 21605,  3200,  3219,  3219,   412,   412,   266,   266,
     266,  1864,  2135, -4044, -4044, -4044,  2724,  2275, 21605, -4044,
    1722,  1772, 58995,  2365,  3766,  4091, -4044, -4044, -4044, 27132,
    2725, 21605, 21605, 21605,  2721,  2860,  3108, 10913,   966, -4044,
    3109, -4044,  1466,  2125,   837, 37983, -4044, -4044, 21605, -4044,
   -4044, -4044,  1960, -4044, -4044, -4044, -4044, -4044, 58995,  1295,
   21605, -4044, -4044,   987,  1789, 21605,  1627, -4044, -4044,  2754,
   -4044, 21605, -4044, -4044, -4044,  2296, -4044, -4044, -4044, 27132,
    2730,  2744, 29640,  2836, -4044, -4044, 58995,   110, -4044, -4044,
   -4044,  2728, -4044, -4044, -4044, 43751, 58995, 58995, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2930, -4044,
   43751, 43751,  2881, 58995,  2896,  2902, 21605,   891, 58995,  2732,
    2735,  1298,  2985, 58995, -4044,  3026,   715, -4044, -4044,  2807,
   -4044, 10913, -4044, -4044, -4044, -4044, -4044, 43751, 58995, -4044,
   42103, -4044,  1989, 74607, -4044, -4044, -4044, 58995,  2769, 58995,
   -4044, 58995, 58995, 58995,  2036, -4044, -4044, -4044, -4044,  1110,
   -4044, -4044, 58995, 58995,    85,  2810,  2813, 58995, -4044,    68,
    2559,  7706, 58995, 58995, 58995,  2989, -4044, -4044, -4044, -4044,
    2933, -4044, -4044,  1465, -4044, 71355, 75008, -4044, 75008, -4044,
    1465,  1452, -4044,  2203,  2818,  2366, -4044,  2924,   980, -4044,
   -4044, -4044, -4044, -4044,  3039,   715,  3043,   715, 58995, 58995,
   58995, 58995, -4044, -4044, -4044, -4044, -4044, 39219, 39219, 39219,
    1820, -4044, -4044,  1104, -4044, -4044, -4044,  1828, -4044,   997,
   -4044, -4044, -4044, -4044, -4044, -4044, 43751,  8117, 58995, 58995,
   58995,  1645, -4044,  1098, 74607, -4044, 73794, 43751, 58995, -4044,
   -4044, -4044,  2969,  2915, -4044,   817,  2918, 43751,  2811, -4044,
    2831, -4044, -4044,  2841,  1935,  2366,  1322, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044,   425,  1937,  2366,  2843, -4044,
    2848, -4044, -4044, -4044,  2972,  2973,  2974,  2850,  2853,  2894,
    2857,  2858,  2897, -4044,  2863,  2900,  2864,  2912,  2866,   715,
   74607,  2993,  1104,  2919,  3094,   715, -4044,  2876, -4044, -4044,
    3198, -4044, 58995, -4044,  2880,  1946,  2366, -4044, -4044, 43751,
   58995, -4044, -4044, -4044,   814, 74607,  3047,   814,   814, 58995,
   58995,   814, -4044, -4044, -4044,  3052,  3053,   814, -4044, -4044,
   -4044, -4044,  2274,  2815, 31730, -4044,  3244,  5458,  2819,  2613,
    2821,  2125,   229,  1093,   638,  2934,  2125,  3025,  2822, -4044,
   -4044, 39219, 31730,  1678,  3042,  2838,  2838,  2838,  2838,  2838,
    2838,  2838, -4044,   176,   377,  2168, 42103, 58995, 42103, -4044,
      89,  2924, 58995, 58995,  2826,  2824, -4044, -4044, -4044, -4044,
   43751,   127, 43751,  2125, -4044, -4044,  2891, -4044, 58995,  1717,
    3224,  2563,   223,  2967,  1376,  3167, -4044, -4044, -4044, -4044,
   -4044, 58995, 58995,   840,  1104, -4044,  2842,  2847, -4044, 58995,
   58995, 58995, 58995,  2513,  2856,  2854, 74607,    52,  3017,  3032,
    2361,  3261,  1295,  2667,  2937, 58995, -4044,  1829,   118, -4044,
    1104, 42103, 72992, -4044,  2560, -4044, -4044,   781,  3135, -4044,
   -4044,  1295,   715, 74607, 58995, -4044,   715,   393,  2923,   715,
    2925,   715,   715, 58995, -4044, -4044, 58995, -4044, 58995, 40867,
     715, -4044, 10913, -4044, -4044,  2986,  2988,  2991, 58995,  2656,
   43339, -4044,  2870, 43751,  1156, -4044, -4044,  3054, -4044, -4044,
   -4044, -4044, -4044,  3175,  3177, -4044, -4044, -4044, -4044,  3215,
   43751, 49519,   446, 43751, -4044,  1989, -4044, -4044,  2011,   303,
   -4044, 58995,  3120, -4044, -4044, -4044,  2884,  1835, 10691, 21605,
   -4044,  3189, 74607, -4044,  5887, -4044, -4044, -4044, -4044, 21605,
   -4044, -4044, -4044, -4044, -4044, 21605, -4044, 21605,  3165, -4044,
    3306,  3306, 74607, 24179,  1420,  2271, 24179, 24179, 24179, 24179,
   24179, 24179, 24179, 24179, 24179, 26296,   420, -4044, -4044, 21605,
   21605,  3172,  3165, -4044, -4044,   -48,   -48, 74607,  2887,  2706,
    2888,  2890, 21605, -4044, -4044,  1839, 25449,  2892, 39219, -4044,
   21605,  9488,  1848,  2938, 10735,   500,  6232, -4044,  3265,  1104,
   21605,   473,  1329, 21605,  1861, 21605,  3174, -4044, -4044, -4044,
    2895, -4044, -4044, 74607, 21605, 24179, 24179,  7230, -4044,  7686,
   21605,  2899,  7820, 18602, -4044,   854,   854,   854,   854, -4044,
   58995, 58995, 58995, 27550, 26714, 56523,  2898,  1721, -4044, 56523,
   56935, -4044,  2906,   500, 21605,  3170,    18,    18,  2916,  2860,
   30894, -4044, 21605,   224, 21176,  2928,   141,  2931, -4044, -4044,
    5607, -4044, -4044,  2941, -4044,  2914, -4044,  1789, -4044, -4044,
   -4044,  6637,  3084, -4044, -4044,  2898, 22034,  2836, -4044,  1866,
   -4044, -4044, 19460, -4044, -4044,  1872, 30476,  2730, 19889,   500,
   -4044, -4044, -4044,  2838,  2203,  2203,  1011,  2656,  3194,  1011,
    6664, -4044, -4044, 27968, 58995, 58995, -4044, 58995,  1874,  1051,
   58995, -4044, 58995, -4044, -4044, -4044, -4044,  3304, -4044, 58995,
   -4044, -4044,  2962,  2965, -4044, 58995, 58995, 58995, 58995, -4044,
   -4044,  2000, -4044, -4044, 43751, 58995, -4044, -4044, -4044,   427,
    2047,  2366, -4044,  2995, -4044, -4044,  3168,  1555, -4044, -4044,
   -4044,  2987, 58995,  2926, -4044,   200,  2361,   784, -4044, -4044,
    2996, 58995, -4044, 58995, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, 39631, -4044, -4044, -4044, 39219, 31730, 39219,
   -4044,   430,  2087,  2366, -4044,  2998, -4044,  2999,  3002,  3056,
     749,   152,  3008,  3009,  3058,  2942,  2943,  2944, -4044, -4044,
     287,  1104, -4044, -4044,  1104,  2203,  1104, 58995, 58995, 58995,
   58995, 58995, 58995, 58995, 58995,  3218,   880,  1623, 43751, 58995,
   58995, 43751, 58995, 58995, 58995, 58995, 58995, 58995, 58995, -4044,
    3311,  3243,  1841,  3283,  3014, 58995, -4044, 58995,  2559, 58995,
   58995, -4044, -4044, -4044,  2950,   814, -4044, -4044,  3191,  3192,
   -4044,   814,   814, -4044,   194, 39219, -4044,  2232,  2914,  2125,
    1505, -4044, -4044, -4044, -4044, -4044, -4044,  2616, -4044, -4044,
    2125,  1928,  2955, -4044,  2958, -4044, -4044, -4044, -4044, -4044,
   -4044,  2964, -4044,   837, -4044, -4044, 58995,  2838, -4044,   917,
     835,   934,  1272, 57347, 57759, 58171,  2960, 58995, 58995, 24179,
   -4044,  1149,   743, -4044,  3199, 58995,  2997, -4044, -4044, -4044,
    3117, 58995, -4044, -4044, -4044, -4044, -4044,  2968, -4044,  3079,
   47459,  2203, 43751, 43751,  2203, -4044, 74607,  2975,  2667, 43751,
     223,  1166, 66823,  3010,  2978,  3268, -4044,  2984,  2982, -4044,
   -4044, 58995,  2924,  1884,   584,  1677, -4044, 48695,  1801,  3230,
   -4044, -4044, -4044,  3347,  3072, -4044,  1295,  2513,  3072,  1104,
    2597, -4044, 71355, 21605, 21605, -4044,  2992, -4044,  2994,  4468,
   -4044,  2157, -4044, -4044, -4044, -4044, -4044, -4044,  3065, 58995,
   -4044, -4044,  3000,   715, -4044, -4044, 58995, -4044, 58995, -4044,
   -4044,   715,   715, -4044,  3102, -4044, 58995, 58995, 58995,  2656,
   -4044,   303, -4044,  3270, 42927, -4044, -4044, -4044, -4044, -4044,
      67,  3278, -4044, -4044,  3239,  3241,  3248,  3250,   844, -4044,
   -4044, 21605, 10913, -4044,  3012, -4044, 10913,  7176, 10913,  3172,
   -4044,  1762,  3295, -4044,  1232,  3016,  1762,  2031,  2031,   379,
     379,   174,   174,   174,  3306,   420, 10913, 10913, -4044, -4044,
   -4044, -4044,  3018, -4044, -4044, -4044,  2706, -4044, 22463,  3160,
    3406, -4044, -4044, -4044,  3061,  3063,  3030, -4044, 21605, 22892,
    3029, 75409, -4044, -4044,   837,   890, 24179, 24179,  1593, -4044,
    1792, 21605, 74607,  1904,  1593,  1523,  1999, 21605, 21605, 10359,
     365, 21605,  7480, 58995, 58995, 58995, 58995, -4044, -4044, -4044,
   56523, 56935, 16952,  1721,  3031, 58995, -4044, -4044,  3034, 27132,
    3271,  3203, -4044, 27132,  3203,  1564,  3203,  3273, -4044, 31312,
   -4044, -4044,  3038, 16101,  1571, 10913,  3423,  3312, 21605,  3040,
   -4044,  3044,  2860, -4044, 74195, -4044, -4044, 10913, -4044, -4044,
   21605, -4044,  2860,  1104, -4044, -4044, 33855, -4044, -4044, -4044,
    3232, 10913, -4044,  1295, 58995,   500,  3045,  3057, 58995, -4044,
    2836, -4044,   287, -4044, -4044, -4044, -4044,  3121, 49107,  3328,
   -4044, 21605,  1913, -4044,  3085,  3417,   117,  1914,  1920,  1051,
   -4044,  2997, -4044,  1318,  3309,   107, -4044,   715, -4044, 74607,
   -4044, 58995, 58995, -4044, -4044, -4044, -4044,  2315, -4044, -4044,
   58995, 58995, 58995, 58995, -4044,  3122, -4044, -4044, 39219,   176,
    3247, -4044, -4044,  3260,   287, 58995, -4044, 74607,   715,   715,
   -4044, -4044, -4044,  3083, 58995, 58995, 58995, 58995, 43751, 58995,
   58995,  2125,  2125, 74607,  3069, -4044,  2125,  2125,  3070, -4044,
   43751, 58995, 58995, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044,  3149, -4044, -4044, -4044, 58995, 58995,
   58995, 58995,  3373, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, 58995, -4044, -4044,  1104,  1104, 74607,
     715,   715, -4044, -4044, -4044,  3317, -4044,   814,   814, -4044,
   -4044,   131,  1926, -4044, 28386, -4044, -4044,  2541,  1104,  2541,
     106, -4044, -4044,  2541, -4044,  2541, -4044,  1051,  3080,  1112,
    3358, -4044, -4044, -4044, -4044,  3361,   287, -4044, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   -4044, -4044, 21605, -4044,   214,  1762, -4044, -4044, -4044, -4044,
    2997,  1717,  3136, 43339,   262, -4044,  3343,   684, 47459,   198,
   58995, -4044,  2203,  2203,  3137, 58995,  3486, -4044,   587, 58995,
    3397,  3126, -4044,  1104, -4044, -4044,  2667, 58995, 47459,  2513,
    1932, -4044, -4044, -4044,  3124,  3032,  3091,  1801,  1108, 58995,
   -4044,  3127, -4044, -4044,  3374,  3095, -4044, 10913, 10913,  1104,
   75810,  2560, -4044, 58995,  3348,   715, -4044,   715,   715, -4044,
   -4044, 58995,  2656,  2656,  2656, -4044,  3277, -4044,   715, 42927,
     844,   844,   844,   844, -4044, -4044, -4044, 10913, -4044, -4044,
   -4044, 24179,  3379, -4044,  3100, 74607, -4044,  3103,  1939,  1943,
   25031,  3246, -4044, -4044, -4044,  7880,  3152, 10913,  3204,  3107,
    3110, -4044,  1044,  1044,  1792,  1949, -4044, 24179, 24179,  1593,
    1593, 21605,  1593, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
   56523,  3114, 58995,  1721, 27132, -4044, -4044,  2123, -4044, 27132,
    3345, -4044, 27132, 58995,  3115, 58995,   988, 21605, 21605,  3154,
    2860,  2860, -4044,  3286, -4044,  3123, -4044,   837,  3125, 58995,
   -4044, -4044,  1015, -4044, -4044, -4044, 42927,  3303, 42927,  1051,
    7982,  2997, 27968, 34705, 58995, 58583, 58583,  3263,  2997,  3136,
   -4044, -4044, -4044, -4044, -4044, -4044,  3128, -4044, -4044, -4044,
    3197, -4044, -4044, -4044,  1955, -4044, -4044, -4044, -4044, -4044,
    3311, -4044, -4044, 31730, -4044,  3201, -4044, -4044, -4044, -4044,
   -4044, 29222, 33855, -4044,   749,  3130,  3131,   152, -4044, -4044,
   -4044, 58995,  1299,  1182,  3159,  2656,  3413, -4044, -4044, -4044,
    3311, -4044, -4044,   814, -4044, -4044, -4044,  2168,  3454, -4044,
   39219, -4044, 40043, -4044, -4044, -4044,  1104, -4044,  1104,  3325,
   35943,  1104,  1104, -4044, 43339,  3536,  3536, 58995, -4044, -4044,
    8280,  3329, -4044,  3136,  3349,  3396, -4044,  3141, 58995,  3293,
    3143,  3144,   901,   901,  2924, 58995,  1966,  1295,   223, 47459,
    2924, -4044,  1264,  3146,  3444, -4044,  3548,  2856,  3153, -4044,
   -4044, 48695,  3331,  3072, 58995,  3032,  3272, -4044,  3279, -4044,
     946, -4044, 58995, 27968, -4044, 75008, -4044,  1995, -4044, -4044,
    2725, 58995,    78, -4044, -4044, -4044, -4044, -4044, -4044,   446,
   -4044, -4044, -4044, -4044,   642, 24179, 74607,  2005, 21605, -4044,
   21605, -4044,  3538, -4044, -4044, -4044,    49, -4044, -4044, -4044,
    1044,  1044,  1593, -4044, 58995,  2033, -4044, 21605,  3158, -4044,
   -4044, 27132,  2123,  2042, 58995,  2055, 74607,  2860,  2706, 10913,
   58995, -4044, -4044, -4044,  3542,  3336,  2860, -4044, -4044, -4044,
   -4044,  1156,  1011,   446,  3417,  3136, -4044,  3161, -4044, -4044,
   58995, -4044,   825,   825, 58995,  3136, -4044, -4044, 58995, -4044,
   39219,  3214, -4044, 58995, 74607,  2011,    69, -4044, 74607, 74607,
   -4044, -4044, 58995, 58995, 58995, 58995, 58995,   715, -4044,  2815,
    1104, -4044, -4044,  2057, -4044, -4044, -4044, 58995, -4044,  2978,
   -4044, -4044,  3536,   832, -4044, -4044, -4044,  1696,  3362, -4044,
     626,  3350,  3245,  3164, -4044, 43339,  3592,  3281, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  3457,  2667,  3127,
   -4044, -4044, -4044, -4044, 21605,  3320,  1295,  1801,  3230, -4044,
   -4044, -4044,  2066,  3072, -4044, -4044,  3543,  3353,  3547, -4044,
    2085, -4044, -4044,  4468, 75810,  3492, -4044,  3226, 58995, -4044,
   -4044, -4044,   642,  2096, -4044,  2097,  2101,  3321,  3227, -4044,
    2103, -4044, 10913, 58995, -4044, -4044, -4044,  2111, -4044,  3178,
   -4044,  3581, 21605,   645, -4044, -4044,  3463, -4044, 58583,  3222,
   33855, -4044,  1789,  1789,  1717, -4044,  1051, -4044, -4044, 21605,
   -4044, -4044,  2141, -4044,    79,  3330,  3475,  2150,  2151,  2659,
    3233,  2659, -4044,  2656, -4044, -4044, -4044, -4044, 40043,  2978,
   -4044, -4044, -4044,  3508,  3455, -4044, -4044, -4044, -4044,   659,
   -4044,  3385,  3386, 58995, -4044,  3202, -4044,  2164, 58995, 58995,
    3605,  3609, -4044,  8330, 43339, -4044,  3032,  1801,   176, -4044,
   -4044,  3395, -4044,  3399,  2667, 27968,  2560, -4044,   270, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  2165, -4044, 58995,
    3221,  2706, 23321, 23321,  3229, 42927,   825,  3225, -4044,  3234,
   -4044, -4044,  3349,  1051, 10913, 43339,  3611, -4044, -4044, -4044,
    3330, -4044, -4044, 58995, -4044,  3356, -4044,   918,   918,  3545,
   -4044,  3288, -4044, -4044,  3237, -4044,  3665,  2924, -4044,   749,
    1295, -4044,  3240,  3072,  3032, -4044, -4044,  3072, -4044, -4044,
   -4044, -4044,  1463, -4044, -4044, -4044, 24608,  3364,   733,  9826,
   -4044, -4044, -4044, -4044,   446,  1789, 21605,  1051, -4044,  3350,
    2011, 58995, -4044, -4044,  3126, -4044,  3658, -4044,   999, -4044,
   -4044, -4044, -4044, -4044,  3069, -4044, 38807, -4044,  3072,  2725,
   -4044,  1697, -4044, -4044, -4044, -4044, -4044, -4044, -4044,  3648,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  8412, -4044, -4044,
   -4044,  3546, -4044, -4044, -4044, -4044,  2170, -4044, -4044, -4044,
   -4044, -4044, -4044,  1760, -4044, -4044,  1777,  1982, 23750, -4044,
    1051,  3401, -4044, 38807, -4044,  1697, -4044, 43339, -4044, -4044,
    3251, 38807,  2176, -4044
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1375,  1173,   528,  1259,  1258,  1173,   239,     0,  1261,     0,
    1173,   352,   942,     0,     0,     0,     0,   528,  1173,     0,
    1375,     0,     0,     0,     0,  1388,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1173,     0,     0,  1395,     0,
       0,     0,     0,  1388,     0,  1263,     0,     0,     0,     0,
       2,     4,    59,    60,    24,    23,    29,    28,    82,    83,
      47,    17,    73,    53,   116,   115,   117,    35,    31,    67,
      21,    22,    32,    36,    55,    37,    48,    94,    54,    20,
      52,    77,    56,    80,    42,    11,    12,    43,    71,    13,
      44,    72,    14,    45,    15,    61,    84,    27,    57,    81,
      58,     5,    38,    69,    65,    10,    49,    50,    51,    74,
      75,    76,    99,    79,   111,    34,   108,    88,    89,   105,
      90,   106,     8,    91,    46,    16,   102,   101,   103,    68,
      39,    70,   100,   104,    18,    19,   107,    78,    97,    93,
     112,   110,   118,    95,    62,     6,     7,    85,    41,     9,
      26,    25,    40,    33,   114,    30,  1261,    87,    98,    86,
      63,    92,    66,    96,   113,    64,   109,  1362,  1349,  1397,
    1361,  1374,     0,  1364,  1172,  1171,  1157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1183,  1903,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,   324,  1926,  1927,  1928,
    1929,  1930,  1931,  1932,  1933,  1934,  1935,  2172,  2173,  2174,
    2175,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  2176,  2177,
    1943,  1944,  1945,  1946,  1947,  2178,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  2179,  2180,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  2181,  1993,  1994,  1995,  2182,  1996,  1997,
    2183,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2184,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2185,  2021,  2022,  2023,  2024,
    2186,  2187,  2188,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2189,  2035,  2036,  2037,  2038,  2039,  2040,
    2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2190,  2191,  2052,  2053,  2192,  2054,  2055,  2056,  2193,
    2057,  2194,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2195,
    2196,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2197,
    2073,  2198,  2076,  2074,  2075,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2199,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,
    2101,  2102,  2103,  2200,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2201,  2118,
    2119,  2120,  2202,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2203,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,  2139,  2204,  2205,  2140,  2206,  2141,  2207,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,
    2153,  2154,  2155,  2156,  2157,  2158,  2208,  2209,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2210,  2211,
    2212,  2213,  2214,  2215,  2216,  2217,  2218,  2169,  2170,  2171,
     323,  1340,  1874,  1904,  1905,  1260,  1241,   528,     0,  1160,
     351,     0,     0,     0,     0,     0,     0,     0,     0,   719,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     165,     0,     0,   375,   374,     0,     0,     0,   914,   380,
       0,     0,     0,     0,     0,   516,  1302,  2074,  1300,  1341,
     240,   243,   241,   242,  1896,     0,  1014,  1015,  1017,     0,
       0,  1027,   754,   755,     0,   753,     0,   757,     0,     0,
       0,   749,     0,     0,     0,     0,     0,   756,   746,     0,
     745,     0,     0,     0,   752,     0,   747,     0,     0,  1161,
    1299,   381,  1375,     0,  1277,  1278,  1279,  1261,  1268,  1280,
    1273,  1275,  1274,  1276,  1272,  1895,  1919,   853,   853,   853,
     853,   850,   851,   853,   853,   853,  2091,     0,     0,   832,
       0,   834,  1900,   853,   858,   436,   436,   436,     0,   857,
     862,   436,  1154,  1192,  1879,  1387,     0,   833,  1153,  2140,
    1291,     0,     0,     0,  1031,     0,  1032,     0,  2106,  1165,
     224,  2116,  2204,  2140,   220,   194,  1923,     0,     0,   857,
       0,  1162,  1163,   816,  1394,  1392,     0,  1941,  1954,  2038,
     217,  2102,  2107,  2116,  2204,  2140,  2168,   174,   179,     0,
     233,  2116,  2204,  2140,   229,  1183,     0,  1365,  1480,  1870,
       0,  1156,  1155,  1262,     0,  1265,     0,  1442,  2087,  1369,
    1371,  1267,  1362,     0,     0,     1,  1375,  1256,  1391,  1391,
       0,  1391,     0,  1354,  1362,  1357,  1361,     0,     0,     0,
       0,  1903,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,
    2227,  2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,
    2237,  2238,  2239,  2240,  2241,     0,     0,  1880,  1904,  1908,
       0,   764,     0,   122,  1875,   902,     0,     0,     0,     0,
    1874,     0,     0,     0,     0,  1909,     0,  1897,  1910,  1911,
    1912,  2010,     0,     0,     0,  1775,  1945,  1996,  1785,  1783,
    1784,  1777,  1778,  1779,  1780,  1781,  1782,     0,  1012,  1776,
       0,   144,   122,     0,     0,  2010,     0,     0,  2010,     0,
       0,     0,     0,     0,  2041,   122,  2010,     0,     0,  1177,
       0,     0,     0,  1179,  1182,  1158,  1244,     0,  1870,     0,
       0,   795,   785,     0,   796,   786,   791,     0,   798,     0,
       0,   788,     0,     0,     0,   799,     0,   787,   789,   801,
     790,   797,     0,     0,   792,   793,     0,     0,  1169,   436,
     330,     0,     0,     0,     0,     0,   122,  1231,     0,  2010,
     122,     0,     0,   379,   378,   122,   377,   376,  1945,  1996,
       0,   941,   122,  2010,     0,   167,   598,   531,     0,     0,
     676,  2041,   122,     0,     0,     0,     0,     0,     0,   917,
       0,     0,   515,   528,  1303,  1301,     0,  1018,   219,   218,
    1016,  2010,     0,   302,     0,     0,  2010,  1220,   751,     0,
     750,  2010,     0,  2010,  1898,   158,     0,   748,  1945,  1996,
    2010,     0,     0,  2010,   150,  2010,     0,  2010,   302,  2010,
     532,     0,  2010,     0,  2010,  2041,   152,     0,  2010,   302,
     762,     0,  1296,     0,  1270,  2208,  1285,     0,  1281,  1288,
    1284,  1375,   853,   852,     0,   853,     0,   853,     0,   853,
       0,   853,     0,     0,     0,   853,  1901,  1902,   835,     0,
     859,     0,     0,   866,   865,   864,     0,     0,     0,   867,
    1484,  1318,     0,  1151,  1168,     0,     0,     0,     0,  1034,
    1034,  1034,  1164,   223,   221,     0,     0,     0,     0,     0,
       0,  1170,     0,     0,     0,     0,  1883,  1885,  1886,  1786,
    1853,     0,  2173,  2174,  2175,  1844,     0,  2176,  2177,  2178,
    2221,  1698,  1685,  1694,  1699,  1686,  1688,  1695,  2179,  2180,
    1980,  2181,  2182,  1893,  2183,  2184,  2186,  2187,  2188,  2189,
    1690,  1692,  2190,  2191,     0,  1894,  2193,  2194,  2062,  2196,
    2197,  2199,  2200,  1696,  2202,  2203,  2204,  2205,  2206,  2207,
    1892,     0,  1697,  2209,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,     0,     0,  1867,     0,  1670,     0,  1516,  1517,
    1539,  1540,  1518,  1545,  1546,  1558,  1519,     0,  1866,  1583,
    1669,  1675,     0,  1668,  1664,  1377,  1862,     0,  1665,  1882,
    1884,  1845,   186,   235,     0,   236,  1868,  2116,   175,   216,
     188,   215,   189,   187,     0,  1943,   176,     0,     0,   177,
       0,     0,     0,     0,   232,   230,     0,  1159,     0,  1482,
    1481,     0,     0,  1851,  1871,   771,  1254,  1255,  1253,     0,
    1250,  1252,  1264,  1261,  1858,  1857,  1859,     0,  1370,     0,
       0,     0,  1352,  1351,     3,  1267,  1389,  1390,     0,     0,
       0,     0,     0,     0,     0,     0,  1432,  1405,  1406,  1408,
    1429,  1433,  1441,     0,  1358,     0,     0,  1486,     0,  1443,
       0,     0,  1881,     0,     0,     0,     0,   765,     0,     0,
       0,     0,     0,     0,   121,  1218,   226,  1216,     0,     0,
       0,     0,     0,     0,     0,  1223,     0,     0,   156,   157,
     543,   528,     0,  2010,     0,     0,     0,     0,   974,   981,
       0,     0,     0,     0,     0,     0,     0,   975,   973,   976,
     228,   985,   998,  1001,     0,   892,     0,     0,     0,     0,
    1083,     0,     0,  1083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   246,   254,   297,   508,     0,
       0,   510,  2010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   126,     0,     0,     0,     0,     0,     0,   495,
     507,     0,     0,     0,     0,     0,   504,     0,   122,   248,
     488,   492,     0,     0,     0,   607,   606,     0,  1083,     0,
     244,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   316,   317,     0,     0,
       0,   126,   149,     0,     0,     0,   250,     0,     0,  1178,
    1175,  1176,     0,  1181,     0,  1240,     0,     0,     0,     0,
     803,     0,   800,     0,     0,   794,  1945,  1996,     0,     0,
       0,     0,     0,     0,   354,   329,     0,     0,     0,   673,
       0,  1906,  1527,  1556,  1534,  1556,  1556,  1523,  1523,  1536,
    1524,  1525,  1563,     0,  1556,  1523,  1528,     0,  1526,  1566,
    1566,  1551,     0,  1508,  1509,  1510,  1511,  1537,  1538,  1512,
    1543,  1544,  1513,  1580,  1523,  1907,     0,     0,   684,     0,
    1195,  1230,     0,     0,     0,   537,     0,  2010,     0,   124,
     720,     0,   674,   380,     0,   124,     0,     0,   161,     0,
     602,     0,     0,     0,     0,     0,     0,   622,   621,     0,
       0,     0,   675,     0,   124,     0,   491,  2010,     0,   436,
     436,     0,     0,   916,   919,     0,     0,     0,  1344,  1346,
    1345,     0,  1343,     0,   302,   300,   301,   671,  1026,     0,
       0,     0,     0,   302,     0,     0,  2010,   302,  2010,     0,
    2010,     0,     0,   302,   302,     0,     0,     0,     0,   603,
       0,   761,   759,   758,   760,     0,     0,     0,     0,     0,
    2010,   302,     0,     0,   742,  1796,     0,     0,  1375,     0,
     205,   206,   204,  1286,   207,  1287,  1283,  1269,     0,   843,
       0,   847,     0,   838,     0,   844,     0,   839,   836,   837,
       0,   842,     0,     0,   437,   439,     0,     0,  1965,  1979,
       0,  2001,  2029,  2030,  2107,  2112,     0,  2135,  2144,     0,
     868,   897,   863,     0,     0,  1328,  1152,  1802,     0,  1375,
       0,   481,  1033,  1030,  1029,  1028,   222,   195,     0,     0,
       0,   899,  2106,  1167,   815,   528,     0,  1666,     0,  1673,
    1674,  1555,  1542,  1843,     0,     0,  1550,  1549,     0,     0,
       0,     0,     0,  1532,  1531,  1530,  1672,  1810,     0,  1529,
       0,     0,     0,     0,  1556,  1556,  1554,  1603,     0,  1533,
       0,     0,  1823,     0,  1829,     0,     0,     0,  1562,     0,
    1560,     0,     0,  1639,     0,     0,     0,     0,     0,     0,
       0,     0,  1587,  1588,  1670,  1796,     0,  1671,  1889,     0,
       0,  1548,     0,  1580,  1865,  1786,     0,     0,     0,     0,
    1856,     0,  1794,     0,     0,  1617,  1792,     0,  1619,     0,
       0,     0,  1785,  1783,  1784,  1777,  1778,  1779,  1780,  1781,
    1782,  1790,  1600,     0,     0,  1599,     0,     0,  1445,     0,
    1887,  1846,   237,   238,   234,     0,     0,   191,   190,     0,
     209,   213,   214,   185,   212,     0,   208,   193,  1738,  1737,
     192,   184,   182,   180,   196,   198,   199,   183,   181,   231,
       0,     0,  1913,  2242,  2243,  2244,  2245,  2246,  2247,  2248,
    2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,  2258,
    2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,  2268,
    2269,  2270,  2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,
    2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,
    2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,
    2299,  2300,  2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,
    2309,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    1848,  1847,  1877,  1914,  1915,  1916,  1917,  1852,     0,     0,
     302,  1248,     0,  1245,  1861,     0,  1372,     0,  1872,     0,
    1257,  1368,  1367,  1398,  1399,   934,  1366,  1423,  1424,  1419,
       0,     0,     0,  1438,  1436,  1415,  1409,  1414,  1412,     0,
    1416,  1583,  1431,  1356,  1403,  1404,  1407,  1355,     0,  1434,
       0,  1328,  1432,  1408,  1315,     0,     0,  1487,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   766,     0,     0,
       0,     0,     0,     0,  2135,   225,  1214,     0,     0,     0,
       0,   901,   900,     0,     0,   921,     0,     0,     0,  1226,
     425,     0,   299,     0,     0,     0,     0,     0,     0,     0,
       0,   669,   666,     0,     0,   665,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   577,     0,  1083,     0,
     610,     0,   983,     0,   982,     0,     0,     0,   984,   979,
     980,  2107,  2116,  2140,   227,  1000,     0,   999,   997,   956,
     958,   957,     0,   960,   944,     0,   945,     0,     0,   955,
     963,   961,     0,     0,     0,     0,  1989,   256,   269,     0,
    1082,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   289,     0,   292,   291,     0,     0,     0,     0,   296,
       0,     0,     0,   295,     0,     0,   509,     0,     0,  1083,
       0,   252,     0,     0,     0,     0,     0,     0,  1013,     0,
     147,     0,   143,   146,     0,     0,     0,     0,   494,   506,
       0,   498,   499,   496,   500,   501,     0,     0,     0,     0,
       0,     0,   493,     0,     0,   600,   599,   605,     0,     0,
       0,     0,     0,     0,     0,  1075,  1074,     0,     0,     0,
       0,     0,     0,   710,     0,     0,     0,     0,     0,     0,
       0,   613,   614,     0,   615,     0,   148,     0,     0,     0,
       0,     0,     0,     0,   203,  1174,  1180,  1243,  1878,  1242,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
       0,   804,   805,   806,   807,     0,     0,     0,     0,     0,
     332,   333,   122,   331,  1906,     0,   699,   672,     0,  1508,
       0,  1504,  1500,  1569,  1570,  1571,  1568,  1581,  1567,     0,
    1514,  1572,  1523,  1520,   685,     0,   687,   690,     0,  1193,
     398,     0,     0,   534,   577,     0,   383,   154,     0,     0,
       0,     0,   120,   165,   167,   381,     0,   166,   168,   170,
     171,   172,   169,   173,   597,   601,     0,   530,     0,     0,
       0,     0,     0,   623,   627,   626,   630,   628,     0,   624,
       0,     0,  1496,     0,   142,     0,   487,   490,     0,     0,
       0,   383,   467,   309,     0,   436,     0,     0,   918,     0,
       0,     0,     0,     0,     0,     0,  1342,     0,  1004,     0,
    1221,  2010,   302,     0,  1002,   159,  1899,     0,   743,     0,
       0,     0,     0,     0,  1006,   739,   151,     0,   302,   302,
     533,     0,   302,   153,     0,     0,     0,   525,   302,   763,
    1298,     0,   436,  1271,  1282,   840,   849,   848,   846,   845,
     841,     0,   860,     0,   435,     0,     0,     0,   874,   875,
       0,     0,   873,   890,   876,     0,   878,   870,   869,   879,
     880,     0,     0,   899,     0,  1325,     0,  1323,     0,  1485,
    1327,  1316,  1290,     0,  1289,  1293,  1295,  1294,  1292,     0,
       0,   486,     0,     0,   857,     0,     0,   302,  1166,     0,
     817,   818,   824,     0,     0,     0,     0,     0,   825,   821,
     822,   823,   826,   827,   828,     0,     0,     0,  1854,  1806,
       0,  1807,     0,     0,     0,  1842,  1838,     0,     0,     0,
       0,     0,     0,  1811,  1814,  1815,  1816,  1813,  1817,  1812,
       0,     0,  1818,     0,     0,     0,     0,     0,  1553,  1552,
       0,     0,     0,     0,     0,     0,     0,  1642,  1675,     0,
       0,  1770,     0,  1796,  1828,     0,     0,  1564,     0,     0,
       0,     0,     0,     0,     0,  1796,  1834,     0,     0,     0,
       0,  1736,     0,  1733,     0,     0,     0,     0,  1853,     0,
       0,     0,     0,  1890,  1584,  1601,  1864,     0,  1855,     0,
       0,  1585,  1608,     0,  1835,  1635,     0,  1640,  1623,     0,
    1616,     0,  1621,  1625,  1604,  1856,  1795,     0,  1793,     0,
       0,  1602,     0,  1597,  1595,  1596,  1589,  1590,  1591,  1592,
    1593,  1594,  1598,  1774,  1772,  1773,     0,     0,     0,  1620,
    2003,  2038,     0,  1388,  1388,  1388,  1376,  1386,  1863,     0,
    1491,     0,     0,     0,     0,  1753,     0,  1800,     0,  1798,
    1880,  1869,     0,     0,  1580,     0,  1483,  1849,     0,   769,
     770,   768,  1267,  1251,  1247,  1246,  1860,  1266,     0,  1375,
       0,   932,   933,     0,   937,     0,     0,  1417,  1439,     0,
    1430,     0,  1421,  1422,  1413,  1440,  1435,  1360,  1359,     0,
    1494,     0,     0,  1312,  1305,  1488,     0,  1445,  1330,  1332,
    1333,     0,  1853,   697,   696,     0,     0,     0,  1111,  1036,
    1087,   767,  1112,  1037,  1088,  1113,  1038,  1215,     0,  1217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   648,  2010,   302,  1224,  1114,     0,
    1039,   298,  1225,  1089,  1229,   668,   667,     0,     0,  1090,
       0,   542,     0,     0,   547,   548,   549,     0,     0,     0,
     550,     0,  1945,  1996,     0,   555,   562,   567,   557,     0,
     568,   563,     0,     0,     0,     0,     0,     0,   574,   581,
       0,     0,     0,     0,     0,     0,   977,   978,  1115,  1042,
       0,  1091,   959,  1523,   943,     0,     0,   954,     0,   953,
    1523,  1523,  1043,   155,     0,   247,   257,   583,  1085,   275,
     288,   283,   284,   282,  2010,   302,  2010,   302,     0,     0,
       0,     0,   285,   280,   281,   277,   290,  1922,  1981,  2117,
       0,   587,   589,     0,   594,   293,  1057,     0,   310,   313,
     294,   273,   276,   274,   270,   255,     0,     0,     0,     0,
       0,     0,  1876,     0,     0,  1008,     0,     0,     0,   145,
    1071,   135,     0,     0,   131,     0,     0,     0,     0,   125,
       0,  1121,  1047,     0,     0,   249,   489,   497,   502,  1051,
     505,  1101,   503,  1127,  1048,  1083,     0,   245,     0,  1049,
       0,  1095,  1123,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1232,     0,     0,     0,     0,     0,   302,
       0,     0,     0,  1085,  2010,   302,  1122,     0,  1080,  1109,
       0,   318,     0,  1072,     0,     0,   251,  1053,  1103,     0,
       0,   201,   200,   202,     0,     0,     0,     0,     0,     0,
       0,     0,   809,   778,   808,     0,     0,     0,   772,   353,
     327,   328,   330,   337,     0,   698,     0,     0,  1505,  1501,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1521,
     686,     0,     0,     0,     0,  1213,  1213,  1213,  1213,  1213,
    1213,  1213,  1194,  1222,     0,   122,     0,     0,     0,   536,
     576,   583,     0,     0,     0,   382,   386,   390,   391,   392,
       0,     0,     0,     0,   136,   123,     0,   728,     0,   436,
       0,   167,   160,     0,     0,     0,   529,   683,   681,   680,
     682,     0,     0,     0,   703,   679,     0,  1495,  1497,     0,
       0,     0,     0,   481,   385,     0,   439,     0,     0,   471,
       0,     0,     0,   309,     0,     0,   948,     0,   966,   949,
       0,     0,     0,   988,   993,   989,   969,     0,   513,  1347,
    1348,     0,   302,     0,     0,   578,   302,   302,     0,   302,
       0,   302,   302,     0,  1149,   604,     0,   656,     0,     0,
     302,   741,  1797,   861,   438,     0,     0,     0,     0,   872,
       0,   511,   877,     0,   889,   884,   886,     0,   893,  1326,
    1319,  1321,  1320,     0,     0,  1317,  1803,   740,   479,     0,
       0,     0,   302,     0,   894,     0,   819,   820,     0,     0,
     829,     0,     0,  1393,  1804,  1805,     0,     0,     0,     0,
    1839,     0,     0,  1711,     0,  1687,  1689,  1522,  1701,     0,
    1535,  1712,  1713,  1691,  1693,     0,  1787,     0,     0,  1702,
    1644,  1645,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1657,  1656,  1703,  1769,     0,
       0,  1826,  1827,  1704,  1565,  1566,  1566,     0,     0,  1833,
       0,     0,     0,  1709,  1714,     0,     0,     0,     0,  1720,
       0,  1741,     0,     0,     0,  1667,  1797,  1557,  1558,     0,
       0,     0,     0,     0,     0,     0,     0,  1641,  1624,  1618,
       0,  1622,  1626,     0,     0,     0,     0,  1610,  1636,  1606,
       0,     0,  1612,     0,  1637,  1388,  1388,  1388,  1388,  1385,
       0,     0,     0,     0,     0,  1466,  1444,  1446,  1453,  1466,
    1471,  1489,     0,  1870,     0,  1426,  1397,  1397,     0,  1753,
       0,  1676,     0,  1753,     0,     0,   178,     0,   210,   197,
       0,  1249,  1873,     0,  1400,     0,  1788,   937,   935,   936,
    1402,     0,     0,  1437,  1410,  1314,     0,  1312,  1307,     0,
    1308,  1853,     0,  1304,  1337,     0,     0,  1494,     0,  1336,
    1110,  1035,  1086,  1213,   904,   905,     0,   903,     0,     0,
       0,   424,   920,     0,     0,     0,   648,     0,     0,   428,
       0,  1227,     0,  1128,  1070,   544,   545,     0,   556,     0,
     565,   564,     0,     0,   552,     0,     0,     0,     0,   551,
     570,   517,   571,   573,     0,     0,   572,   575,   580,  1083,
       0,   611,  1059,     0,  1107,   971,     0,  1523,   946,   951,
     952,     0,     0,     0,   398,     0,     0,     0,   258,   268,
       0,     0,   272,     0,   266,   286,   278,   287,   279,   591,
     592,   590,   586,     0,   593,   595,   307,     0,     0,     0,
    1117,  1083,     0,   253,  1055,     0,  1105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,  1092,
       0,     0,   128,   127,     0,   134,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   319,
     304,     0,   706,     0,     0,     0,   321,     0,     0,     0,
       0,  1116,  1044,   773,     0,     0,   774,   782,     0,     0,
     775,     0,     0,   784,     0,     0,   326,   334,  2062,  1777,
    1778,   694,   701,   691,   693,   695,   692,     0,   700,   648,
       0,     0,     0,  1506,     0,  1574,  1575,  1576,  1577,  1578,
    1579,     0,  1573,  1580,   688,   689,     0,  1213,  1212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     410,     0,     0,   404,     0,     0,   993,   397,   400,   401,
       0,     0,   537,   540,   538,   539,   569,     0,   417,     0,
       0,   138,     0,     0,   139,   137,     0,     0,   309,     0,
     163,   381,     0,     0,   629,   632,   625,     0,   702,   704,
     677,     0,   583,     0,     0,  1299,   477,     0,   467,   463,
     465,   464,   466,     0,   473,   308,     0,   481,   473,     0,
     921,   947,     0,     0,     0,   986,   990,   987,     0,     0,
     962,     0,   970,   940,  1144,  1145,  1142,  1143,     0,     0,
    1339,  1005,     0,   302,  1003,   744,     0,   735,     0,   737,
    1007,   302,   302,   616,     0,   526,     0,     0,     0,   871,
     891,     0,   887,     0,     0,   854,   896,  1324,  1322,   480,
     899,     0,   855,   898,     0,     0,     0,     0,     0,  1808,
    1541,     0,  1841,  1837,     0,  1684,  1809,     0,  1821,  1820,
    1643,  1822,     0,  1662,     0,     0,  1654,  1652,  1653,  1646,
    1647,  1648,  1649,  1650,  1651,  1655,  1831,  1830,  1824,  1825,
    1561,  1559,     0,  1706,  1707,  1708,  1832,  1715,     0,  1936,
    1742,  1719,  1735,  1734,     0,     0,     0,  1722,     0,     0,
    1731,     0,  1771,  1547,  1580,  1586,     0,     0,  1609,  1836,
    1627,     0,     0,     0,  1605,     0,     0,     0,     0,  1614,
    1787,     0,     0,     0,     0,     0,     0,  1379,  1378,  1384,
    1466,  1471,  1362,     0,  1453,     0,  1465,  1451,  1464,     0,
       0,  1477,  1475,     0,  1477,     0,  1477,     0,  1448,     0,
    1467,  1449,  1464,     0,  1871,  1490,     0,  1428,     0,     0,
    1396,     0,  1753,  1683,  1756,  1751,  1752,  1801,  1677,  1888,
       0,  1799,  1753,     0,  1850,  1373,     0,  1401,  1418,  1411,
    1961,  1492,  1313,     0,     0,  1310,  1311,     0,     0,  1331,
    1312,  1334,     0,   910,   911,   909,   912,     0,     0,     0,
     648,     0,     0,   444,     0,   928,   928,     0,     0,   430,
     476,   993,   651,     0,     0,     0,   649,   302,  1040,     0,
     566,     0,     0,   561,   559,   558,   560,   518,  1126,  1041,
       0,     0,     0,     0,   972,     0,   964,  1058,     0,   395,
       0,   263,  1084,     0,     0,     0,   262,     0,   302,   302,
     588,   311,   312,   315,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   729,   712,     0,     0,   730,   731,
       0,     0,     0,  1010,  1011,  1009,   132,   129,   130,   133,
    1068,  1052,  1102,  1050,     0,  1096,  1065,  1061,     0,     0,
       0,     0,     0,  1125,  1079,  1100,  1124,  1077,  1098,  1076,
    1097,  1078,  1099,  1069,     0,  1499,   709,     0,     0,     0,
     302,   302,   618,  1054,  1104,     0,   776,     0,     0,   777,
     779,   356,     0,   359,   366,   338,   343,  1231,     0,  1231,
       0,   340,   344,  1231,   339,  1231,   336,   670,     0,     0,
       0,  1502,  1507,  1582,  1515,   647,     0,  1204,  1203,  1202,
    1206,  1205,  1208,  1207,  1199,  1198,  1211,  1210,  1197,  1196,
    1201,  1200,     0,   402,     0,   408,   412,   413,   411,   403,
     993,   436,   475,     0,     0,   660,     0,   535,   383,   414,
       0,   387,   141,   140,     0,     0,     0,   167,     0,     0,
     634,   638,   678,     0,  1498,   612,   309,     0,   383,   481,
       0,   388,   393,   394,     0,   471,     0,   467,     0,     0,
     478,  1191,   482,   483,     0,     0,   950,   967,   968,     0,
       0,   993,   992,     0,   520,   302,   579,   302,   302,  1150,
     657,     0,   883,   882,   881,   512,     0,   885,   302,     0,
       0,     0,     0,     0,   831,   810,   830,  1840,  1700,  1710,
    1819,     0,     0,  1663,     0,     0,  1705,  2210,     0,     0,
       0,     0,  1739,  1740,  1721,     0,  2053,  1726,     0,     0,
       0,  1891,  1633,  1631,  1628,     0,  1629,     0,     0,  1611,
    1607,     0,  1613,  1638,  1383,  1382,  1381,  1380,  1452,  1450,
    1455,  1462,     0,  1447,     0,  1476,  1472,     0,  1473,     0,
       0,  1474,     0,     0,  1462,     0,     0,     0,     0,  1747,
    1753,  1753,  1678,  1758,  1755,     0,  1680,  1580,     0,     0,
    1306,  1309,     0,  1338,  1329,  1219,     0,     0,     0,   426,
       0,   993,     0,     0,     0,   931,   931,     0,   993,   475,
     653,   652,   655,   650,   654,  1228,     0,   553,   554,  1060,
       0,  1108,  1066,   965,     0,   584,   259,   260,   261,   264,
     304,   271,   265,     0,  1056,     0,  1106,  1063,  1119,  1045,
    1093,     0,     0,   718,     0,     0,     0,     0,  1120,  1046,
    1094,     0,     0,     0,     0,  1237,     0,   303,   708,   707,
     304,   320,  1081,     0,   780,   781,   357,   122,     0,   335,
       0,   364,     0,   362,   361,   363,     0,   350,     0,     0,
       0,     0,     0,  1503,     0,  1024,  1024,     0,   648,  1209,
       0,     0,   399,   475,   443,     0,   405,     0,     0,     0,
       0,     0,     0,     0,   583,     0,     0,     0,   162,   383,
     583,   633,     0,     0,     0,   705,     0,   385,     0,  1297,
     384,     0,     0,   473,     0,   471,     0,   468,     0,   472,
       0,  1184,     0,     0,   991,     0,   995,     0,   961,   938,
    1491,     0,   524,  1025,   736,   738,   617,   888,   895,   302,
     811,   812,   813,   814,  1658,     0,     0,     0,     0,  1716,
       0,  1717,  1744,  1743,  1723,  1727,     0,  1724,  1725,  1630,
    1634,  1632,  1615,  1454,     0,     0,  1456,     0,     0,  1458,
    1460,     0,     0,     0,     0,     0,  1874,  1753,  1425,  1427,
       0,  1363,  1681,  1682,     0,  1397,  1753,   211,  1789,  1493,
    1335,   889,     0,   302,   928,   475,   445,  2062,   446,   927,
       0,   929,   934,   934,     0,   475,   648,   546,     0,   582,
       0,   306,   314,     0,     0,     0,   725,   713,     0,     0,
     732,  1062,     0,     0,     0,     0,     0,   302,   783,   337,
       0,   360,   369,     0,   367,   341,   346,     0,   348,   347,
     342,   345,  1024,     0,  1021,  1020,   646,     0,   434,   406,
       0,   454,     0,     0,   661,     0,     0,     0,   423,   422,
     419,   418,   420,   421,   416,   415,   608,   722,   309,  1191,
     596,   635,   636,   631,     0,     0,     0,   467,   463,   389,
     398,   372,     0,   473,   469,   470,     0,     0,     0,  1239,
       0,   922,   994,     0,     0,     0,   519,     0,     0,   523,
     514,   856,  1659,     0,  1660,     0,     0,     0,  1729,  1728,
       0,  1463,  1479,     0,  1459,  1457,  1468,     0,  1470,  1746,
    1748,     0,     0,  1761,  1679,   906,     0,   907,   931,   449,
       0,   930,   937,   937,   436,   648,   427,  1067,   585,     0,
     267,  1064,     0,   716,     0,   727,   725,     0,     0,  1233,
       0,  1234,  1235,  1238,   322,   325,   355,   365,     0,   349,
    1019,  1023,  1022,     0,     0,   407,   440,   441,   442,     0,
     409,   450,   451,     0,   658,     0,   663,     0,     0,     0,
       0,     0,  1185,     0,     0,  1186,   471,   467,   396,   462,
     370,     0,  1188,     0,   309,     0,   993,   996,  1148,   522,
     521,  1661,  1732,  1718,  1745,  1730,  1461,     0,  1469,     0,
       0,  1757,     0,     0,     0,     0,   934,     0,   648,     0,
     925,   924,   443,   429,   305,     0,     0,   723,   726,   714,
     727,   734,   733,     0,   368,     0,   433,     0,     0,     0,
     452,     0,   453,   474,     0,   662,     0,   583,   721,     0,
       0,   637,     0,   473,   471,  1189,  1190,   473,   923,   939,
    1147,  1146,  1375,  1478,  1749,  1750,  2172,  1961,  2146,     0,
    1759,  1762,  1760,  1754,   302,   937,     0,   431,   447,   454,
       0,     0,   715,  1236,   638,   459,     0,   458,     0,   456,
     455,   659,   664,   609,   711,  1187,   641,   373,   473,  1491,
    1130,  1375,  1129,  1131,  1139,  1136,  1138,  1137,  1135,     0,
    1766,  1765,  1764,  1768,  1767,   908,   926,     0,   648,   717,
     724,     0,   457,   461,   460,   643,     0,   639,   642,   644,
     645,   371,   913,     0,  1140,  1134,  1362,  1349,     0,   448,
     432,     0,   619,     0,  1132,  1375,  1763,     0,   640,  1133,
       0,   641,     0,   620
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4044, -4044, -4044,  2961, -4044,  -774,   242,  2348, -1674, -4044,
   -4044, -4044,  2882, -4044, -4044, -4044, -4044, -4044, -4044, -4044,
    2917, -4044, -4044,  1550, -2064, -4044, -4044,   113, -1078,   328,
    2552,  1241, -4044,  -944, -4044, -4044,  -519,   105,  -604, -4044,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  -719,  1703,  1096,
    -712, -2137, -4044, -1186, -2726, -4044,   522, -4044, -4044,  1641,
   -4044, -4044, -4044,   955,   454,  -430, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  -260, -4044, -4044,  -555,   143,    41, -2047,
    -300, -4044, -4044,   398,  -302, -1100, -4044, -3027, -4044,   -13,
   -4044, -4044, -4044,  -280, -1183,  1198, -4044,  -597,  -934,  1486,
    -602, -4044,  -171, -4044,  -657,  -549,  -547,  -612,  -451, -3196,
   -3597, -3211, -2481,  1208,   145, -4044, -2667,   146, -4044, -4044,
     147,   148, -4044, -4044, -1280, -1201, -4044,  -668, -4044, -4044,
   -4044, -2495, -4044, -4044, -4044, -4044,    77, -4044, -4044, -4044,
   -4044,   426, -4044, -4044, -4044, -4044, -4044, -4044, -1749,  1611,
    1614, -4044, -4044, -2668, -4044,  -762, -4044,   567, -2535,  1118,
   -4044, -4044, -4044,  2314, -4044, -4044, -4044, -4044, -4044, -4044,
   -1358, -4044, -4044,   151, -4044,  1624,   932, -4044, -4044, -4044,
    -638,  -704,  -694, -4044, -2987, -4044, -4044, -4044, -4044,  -237,
   -4044, -4044, -4044, -4044, -4044, -4044,  -838, -4044,   991, -2652,
    -796, -4044, -4044,  1007, -4044, -4044, -4044, -4044, -4044,  -595,
    -179,  2338, -4044,  -487,  -570, -4044, -4044, -4044,  -176, -4044,
   -4044, -4044, -4044, -4044, -4044,  -905,  1188, -1315, -4044, -4044,
   -4044, -4044, -1968, -4044, -4044, -4044, -1824, -4044,  3736,  1938,
     487,   153, -4044,   -17,    66,  2775,  -949, -2204,   373,  -323,
   -4044, -1486, -4044, -4044, -4044, -2142, -4044, -4044, -4044, -4044,
   -2977,   154, -4044, -4044, -4044,   422, -4044, -3556, -3399, -3691,
   -3220, -2932, -4044, -4044,  -913, -4044, -4044, -4044, -1149,  1831,
   -1209, -4044, -1890,   418, -3218,  -603, -2771, -4044, -3162,  -418,
   -4044, -4044, -4044, -4044, -4044, -4044, -4044,  -900,  -524, -4044,
   -4044,  3211, -4044, -3706, -4044, -4044, -4044, -4044,  1350, -4044,
   -1172,  1078, -4044, -4044, -4044, -4044, -4044,  -580,  -661, -4044,
   -4044, -4044,   155, -4044, -4044, -4044, -4044,  2052,  -781,  -618,
    3093,   157,  -383, -4044, -4044, -4044, -4044, -2574, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -1568, -4044, -4044, -4044, -4044,
   -4044, -4044, -4044,  1987,  1992,    60,   -23, -4044, -4044, -1063,
   -4044,  -476, -4044,  2287, -4044, -4044, -4044, -4044,  1339,   159,
     464, -4044,     3, -4044, -4044,   257, -2898,     4, -4044, -4044,
   -4044, -4044,  1962,     5, -4044,   726, -4044, -4044, -2366, -4044,
     163,    20, -4044, -4044,     1,     0,   -41,   -40,   -36,     2,
    3097,  2653, -4044, -4044, -4044,   -18,  1573, -4044,  -713,  -161,
   -4044,  1348,  -545,  1967,  2637,  2639, -4044,  1338, -4044, -4044,
    1351, -4044, -4044, -4044,  -536,  1972, -4044,  2638, -4044, -4044,
   -4044,  1333,  1342, -2886,   798, -2906, -2849,   332,   319, -1102,
    -247,    22,  3133,  2643,   804, -3829,   753, -4044, -3598, -1945,
    1167,  1735, -1331, -4044, -4044,  -964,  5041, -4044, -4044, -4044,
   10988, 11175, -4044, -4044, 11386, 11681, -4044,  -863,   847, 12014,
    9348,  -998, -1592,  -730, 10206,   543,  -850, -2216, -4044, -4044,
   -4044,  -211,   858,   482, -4044, -4044, -4044, -4044,  -470, -2358,
    -469, -4044, -4044, -4044,  -471, -4043, -1156, -4044,  -175, -4044,
   10358,  1383, -4044,  -901, -2302, -2310,  -962, -1487, -4044, -4044,
   -4044, -4044, -4044, -4044, -4044, -1353, -2789,  -270,  1450, -4044,
   -4044,  1543, -4044, -4044, -4044, -1114,  -720, -2195,  1455, -1701,
   -4044,  -706,   779,  2180,  -660,   -82, -1097,  8934,  -442, -1931,
   -1035, -1276, -4044,  -167, -4044,    28,   -10,   -43,  -404,    11,
    3257,  7007,  -542, -1113,  6263,    30,  9220, -2641
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1205,  2127,  2002,  2794,  2795,
      53,    54,  1280,    55,    56,    57,    58,    59,    60,    61,
    1221,    62,    63,   884,  1428,  2137,    64,  1865,   688,   689,
    1703,  1704,  2065,  1705,  1693,  1120,  1514,  1240,  1207,  1241,
      66,    67,  1114,  1684,    68,    69,    70,  1265,  1266,  1215,
    1467,  3665,  4240,  1983,  2831,  2627,  2628,    71,  1326,  1327,
      72,    73,  2742,  1366,  2092,  3246,  3247,  3696,   521,  2089,
    3957,  3958,  3682,  3683,  3964,  4133,  4134,  2138,  1424,  2825,
    3338,  2785,  3760,  2786,  3761,  2787,  3762,  2773,  3297,  3298,
    3299,  2788,  3739,  4164,  2789,  1880,  4265,  2172,  1536,  1534,
    4151,  3562,  3563,  4318,  4270,  4271,  4272,  4389,  3767,  2829,
    3344,  3770,  3986,  2524,   604,  1448,  2271,   605,  2174,   552,
     606,  2139,    79,  2166,  1300,  1301,  2010,  3251,  2882,    80,
     903,  3120,  4032,  4199,  4200,    81,   205,    82,  1432,    83,
      84,  2123,  2779,    85,  1897,  2541,    86,    87,  2568,  2569,
    2570,    88,    89,  3144,  3914,  1267,  2620,  2621,  2622,  2623,
    3164,    90,  1430,  1306,  2146,    91,    92,    93,    94,    95,
    2053,    96,    97,  2140,  1440,  2158,  2159,  3751,  4002,  4173,
    4004,  4426,  4427,  3978,  3099,  3576,    99,   100,  3734,  3735,
    4277,   101,  1895,   102,   103,   104,  1408,  2115,  2116,  3252,
    1191,  1369,  2095,  2096,  3327,  3328,   105,  2702,   106,  3624,
    3625,   553,  4280,  4245,  4329,   107,   108,  3628,  3629,   109,
     110,   111,   112,   113,   598,   949,   950,  1197,   114,  1800,
     115,   857,  2733,   116,  1014,  2296,  3805,   117,   629,   963,
     964,  2141,   119,   638,  2274,   640,  1549,  2884,  2885,  3395,
    2242,   773,   120,   121,  2253,  2277,   122,  1208,  1871,  1872,
    3557,  2142,   554,  1454,  2177,  2519,  4190,  3564,  3895,  4102,
    2464,  3060,   124,   555,  1245,  1945,  2180,  2837,  2838,  1947,
    2436,  3359,  1949,  2839,  2844,  2845,  2846,  3355,  3363,  4026,
    4027,   125,  1243,  1938,   126,   127,   128,  1277,   797,   129,
     566,   567,   130,  4144,   131,   915,   132,   657,  1563,   133,
    1961,  3150,   134,   135,   136,  4402,  4433,  4434,  4435,  3368,
    4362,   137,  4404,   993,   139,   140,   141,   176,   823,   824,
     825,  2143,  4021,   143,   144,  2119,  2772,  3279,   145,   146,
    1866,  2509,   147,   148,   149,  1412,   150,   151,   152,   153,
    1345,   154,  1149,  1150,   155,   156,   516,   705,  1153,  1161,
     157,   608,   957,   958,   959,  1516,   158,   996,  2264,   609,
     952,   160,   610,  2483,  3069,  3070,  3073,   611,  2480,   163,
    1555,  2258,  2261,   612,  2487,  2488,  2489,  2490,  2491,  3075,
     613,   631,   906,  2185,   614,  1086,   168,   169,   170,   714,
     709,   710,   172,  1678,  2426,   646,  1168,   676,   722,  3520,
    1813,  1814,  1836,  1837,  1177,  1178,  1826,  1828,  2466,  1829,
    2474,  1819,  3517,  3869,  1832,  1833,  1180,  1181,  1182,  1841,
     173,  2430,  3026,  3027,  3028,  3496,  3497,  3511,  3507,  3856,
    4069,  3029,   991,  1188,  3030,  3035,  3067,  2816,  2817,  2818,
    1950,  2102,  1393,  1087,  1394,  2113,  1088,  1599,  1396,  1089,
    1090,  1091,  1399,  1092,  1093,  1094,  1095,  1582,  1641,  1096,
    1097,  1618,  2110,  2111,  1505,  2336,  1099,  1100,  3460,  3829,
    3818,  2362,  2363,  1700,  3456,  2977,  4081,  4219,  4220,  3528,
    3525,  3873,  4085,  4314,  4370,  4371,  1101,  2416,  1671,   799,
    1102,  3254,  1673,  2356,  2438,  2439,  1850,  1580,  2302,  2320,
    2321,  2333,  2938,  2340,  2345,  2961,  2962,  2357,  2385,  1103,
    2305,  2306,  2921,  1584,  1104,  1143,  1144,  1577,  2380,  1156,
    1157,   707,  1105,  1106,  1550,   698,  4065,   511,   763,  2641,
    1791,   827,   643,  1107,  1108,  1109,  1110,   924,   925,  1271,
     512,   757,   777,  2624,   513,   514,   759,  1796
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     167,   166,   171,   161,   162,   164,   568,   713,   723,  1473,
     755,   522,  1183,   880,   644,  1513,   798,   668,  1115,   774,
     167,  1477,   171,   909,  1189,   700,  1879,   510,  1282,  1792,
    1797,  1483,   633,  1558,   559,  1948,  1192,   633,   983,   984,
     985,  1331,  1422,  1343,   989,  1305,   907,  1533,   712,   632,
    1506,  2373,  1442,   551,   632,  2243,  2099,  2587,  2589,   931,
    1570,   960,  2643,  1807,   697,  1368,  1958,  1129,  2067,  1620,
    2802,  2902,  3126,  3362,  1593,  1594,  1979,  3041,  1797,  2784,
     607,  1966,  3159,  1792,  3161,  2163,   866,  1299,   639,  2112,
    1310,  2301,  1410,  1609,   597,  1946,  1415,  2699,  1336,  2022,
     669,  1419,  1810,  3256,  2456,    65,   782,  3348,  1425,  3569,
    3275,  2888,  3559,  3306,   806,  1270,  1464,  3599,  1444,  2738,
    3074,  3256,   817,  3038,  3510,  3537,   954,  2035,  2036,  3036,
    3037,   725,   917,   717,  3732,   726,  2031,  3773,  3493,   909,
    2214,  3781,  3765,    74,   776,    75,    76,    77,    78,  1957,
     802,    98,   687,   118,   123,   138,  3336,   142,  1934,   159,
     815,  1857,  1122,   165,  1586,  1587,  2167,  3896,  4013,  3542,
    1242,   724,  3438,  2985, -1556, -1997,   520,  1176,  2178,  1639,
    3508,   934, -2031,  3894,  1636,  2942,  1179, -2052, -2077,  1441,
    1606,   946,  3280,  3281,  3282,  3283,  3284,  3285,  2797,   564,
   -1906,  4195, -1907,  1798,  1967,  4103, -1566, -1775, -1906,  2047,
   -1907,  1332,  3903,  3031, -1775,  4244,  2378,   779,     3,     4,
     809,  3353,  2160,   779,  2276, -1556,  1489, -1556,  2563,   564,
    2042, -2224, -1551,   779,  2378, -1523,  3286,  1504,   615, -2224,
   -1536,  -358,  3287,  1209,   560,  3122,   819,  1010,  2919,  2563,
    2254,  1553,  3288,  1279,  2900,  2395,  2721, -1563,   564,   564,
     703,  2429,  1364,  3031,   564,  4073,  1885,  4075,  2413,  2859,
    4145,  2861,  3697,   720,  3286,  2414,   564,  1646,  1437,  3289,
   -1881,  3290,  4208,  1881,   980, -1551,  3312,  2417,  2170, -1566,
    3988,  1515,  2898,  4360,  2117,  -764,   615,  3079,  1438,  1960,
    3340,  2564,  1649,  1882,   674,  3626,  2135,  1268,  1166, -1933,
    1882,  4197,   615,  1996,  2510,  1172,  1929,  3289,   615,  1173,
    1358,  -576,  2564,  4409,  2130,  1831,   621,  1682,  2659,  2893,
    3992,   965,  1651,   621,  4326,   820,   615,   987,   621,   621,
     564,  3969,  1146, -1350,  1147,  1210,   622, -1353,  1343,    33,
    1615,   515,  1124,   622,  3291,  -122,   861,  1960,   622,   622,
    -122,   664,   798, -2000,   517,  1965,  1637,  2255,   694,  1616,
    3993,  1218,   615,  1686,  1330,  1997,   821,  1281,  2161,  2136,
    2396,  -144,  2659,  1174,  2397,   969,  2511, -1791,  3970,  1683,
    2942,  1681,  1620,  4327, -1791,  4446,  3989,   675,  2894,  1960,
    1930,  1167,   912,  3627,  1196,   909,  -144,  2029,   798,  3899,
    2418,  3292,   922,  1593,  1594,   988,  3293,   909,  4183,  2550,
    1175,  1609,  2398,  1646,  1799,   822, -1350,  2131,  1501,  2899,
   -1353,  2942,  2535,  3313,   826,  3600,  4260,   981,  1119,   859,
    2074,  2238,  1883,  1439,  1465,  2244,  1960,  2246,  1649,  3981,
    2249,  2567,  3294,  3518,  3293,  4361,  2338,  1465,  2078,  1694,
     621,  4198,  4209,  2298,  1706,  1706,  3295,  4191,  3123,   565,
    2338,   909,  2567,  1219,  2171,  1406,  4217,  1968,  1651,  1204,
     622,  1019,  3040,  1978,  2942,  1517, -2051,  1211,  3904,  1969,
    3294,   561,   875,  1960,  1574,  1960,   882,  1465,  1960, -1350,
    1276,  3466,  1475, -1353,  3295,  1920, -1523,   892,   858,  3552,
    3956,  3300,  1586,  1587,   621,  1554,  3612, -1775,  2419,  2304,
    1212,  1606,  2018,  1797,  2020,  2379,  2162,  3256,  1484,  2048,
    2097,   988,  2090,  2091,   622,  2376,  3354,  4316,   988,   704,
    1970,  2399,  2256,  3005,  2027,  3076,  1141,  1886,  3296,  1213,
    1142,  2070,  1640,  2722,  1991,   908,   568,  1581,  1922,  1554,
    2257,  2066,   713,    48,  1184,   779,  1928,  1797,  3983,   779,
    4432,  4015,   562,  3889,   563,  1001,  1342,  2043,  2415, -1523,
     779,  1148,   909,  1551,   961,  3510,  3296,  3092,  2572,  1407,
     909,   909,  3746,  1560,   856,   779,  1116,  2218,  2231,  1615,
   -1556,  2954,   167,   712,   171,  1688,  1571,  1214,  1581, -1997,
     779,  2099,  2944,  3853,  1139,   779, -2031,  3857,  1616,  4029,
    2008, -2052, -2077,  2011,  2012,   779, -1906,   962, -1907,   967,
    3810,   971,  1617,   779,  2239,  1165,  2591,   975,  1842,   994,
    1937,  3848,   953,  2250,   632, -1350,   632,  1843,   632, -1353,
     978, -1556,  3884,  2942,   632,   976,   977, -2224, -1551,  3263,
    1011,  1592,  1347,   956,  3755,  2944,  1598,  1112,   990,   798,
    1121,   908,  1123,  1353,   725,  2297,  2000,  2300,   726,  2003,
    3772,  3523,  1615, -1563,  1642,  1679,  2075,  2308,  2030,  4353,
    2443,  2312, -2051,  1670,  1466,  4228,  3139, -1791,  3140,  2324,
    2325,  1616,  1273,  3706,  1141,  2536, -1881,  1466,  1142,   627,
     628,   779,  2342,  2344,   724,  1619,   167,   166,   171,   161,
     162,   164,   990,  2358,  2945,   627,  1269,  2666,   771,  4095,
    1220,   627,   628,  1455,  3531,  2638,  4105,  3320,  2586,  4358,
   -1350,  2328,  2329, -1933, -1353,  1792,  2573,  1466,  1204,   627,
     628,  1187,  2188, -2051,  1998,  1407,  3233,  4398,  2465,  3236,
    3237,  2194,  2337,  3240,  1151,  2198,  1465,  4337, -2051,  3243,
    3301,  2204,  2205,  -122,  -122, -1350,  2360, -1350,  4266, -1353,
    1019, -1353,  3200,  2942,  3590,   627,   628,  3614,  1676,  2217,
    1418,  1131,  1118,   718,  1224,   871,  1126, -2000,  3238,  3239,
    2240,  1218,  4181,  2951,  2952,  2953,  2954,  3031,  3031,   919,
    1351,   632,  1446,  1449,  1450,   564,  2889,  2639,  1315,   564,
    3127,    65,   564,  2501,  2548,  1690,  1268,   564,  1503,  3757,
     727,   615,  2170,   653, -2225,  2776,  1667,  1668,  1669,  1670,
     564,  1475,  2949,  2950,  2951,  2952,  2953,  2954,  3728,   564,
     518,   719,  3048,  2173,  3253,  2596,  1316,  2461,  1934,    74,
    3268,    75,    76,    77,    78,  2629,  4261,    98,  1206,   118,
     123,   138,  3253,   142,  3784,   159,  3545,  3565,  4411,   165,
    3602,  3394,  4232,  4233,  1285,  2247,  2248,  1887,  2740,  3364,
    4267,  2946,  2947,  2948, -1523,  2949,  2950,  2951,  2952,  2953,
    2954,  1646,  3621,  1219,  1116, -1523,   728,  1592, -1523,  1196,
     654, -1523,  1433,  2694,  1637,   900,  1561,  1286,   720,  2313,
    1206,   564,   564,  4158,  2632,  1691,   615,  1116,  4312,  1141,
    2822,  2481,  2891,  1142,   174,  2103,  2462,   908,  3710,   564,
    2710,  1873,  2695,  2943,  4063,   873,  1321,   874,  2154,   908,
    1434,  1873,  3360,  2107,  4313,  4268,  1651,  1874,  2203,  1817,
     819,   167,   779,   171,  2944,  3365,  2022,   960,  4066,  4385,
    1948,  4159,  4290,  4070,   175,  4296,  4072,   779,  4160,   772,
    1457,  4286,  1556,  3729,  1519,  1340,  1521,   632,  1523,   779,
    1525,  4147,  1527,  1528,  1529,   785,  2777,  1132,  4186,  1531,
    3622,  2104,  4262,   908,  4412,  4161,  4187,  1317,  2774,  2890,
    3362,  1382,  1875,  2103,  2314,  3758,  1466,   779,  3999,  3603,
    3707,  1579,  1875,  2945,  2155,  2241,  3649,   779,  2190,  1876,
    4006,  3127,  2223,  1677,   721,  1692,  4338,  3712,  1887,  1876,
     779,  1596,  1322,   779,   713,  1320,   872,  2684,  1818,   820,
    2025,  1321,  1019,  2685,  2732,  2942,  1710,  3192,  1133,  2105,
     920,  1352,  2106,  3915,  2949,  2950,  2951,  2952,  2953,  2954,
    2195,  1623,   901,  1006,  2778,  2549,  4162,  1638,  1246,  2104,
    2315,  2206,   655,   656,  3804,  1634,  2331,  1643,  2451,  3623,
     821,  4354,  4009,  2213,  2741,  1318,  4375,  1680,  3366,   729,
    3145,  1435,  4423,   798,  1845,   966,   968,   970,  2633,   564,
     972,   973,   974,    38,   908,  4226,  3180,  1696,  1697,  4236,
     979,  3604,   908,   908,  3605,  2892,   670,   902,  1811,  1812,
    1803,  1816,   726,   726,  4359,   726,  1341,  2105,  2316,   822,
    2106,  2317,  4397,    42,  2879,    38,  4399,  1322,  2759,  2686,
    1491,  4386,  2107,  4288,   779,   632,  3572,  1877,  3367,  4188,
     632,   632,   779,   779,  3872,  3553,  1954,  1877,   724,   724,
    1888,   724,  1794,  1971,  3876,    42,  2081,  3650,  2338,  2338,
    2475,    46,  3883,  2338,  3115,  4214,  1128,  4431,  1492,  1436,
    2946,  2947,  2948,    47,  2949,  2950,  2951,  2952,  2953,  2954,
    2693,   645,  2004,  2235,  2156,  2007,  1458,  1187,  3531,  2079,
     174,  3866, -1878,    46,  2082,  1978,  4016,  2157,  3181,  4387,
    3875,   720,  3116,  2338,  2338,    47,  1794,    48,  4017,  3573,
    2107,  2318,   174,  1259,  1172,  2595,  2944,  2041,  3055,  4424,
     893,  4163,  4388,   720,   627,  1269,  2975,  1889,  4323,  2108,
     175,  2057,  2982,  1878,   632,  3726,  1459,  3265,  3798,  2482,
    2576,  1498,   632,  1878,  2069,  3974,  2080,  3676,  3137,  1820,
     894,  4112,   175,  3679,  3680,  2591,  2269,   564,  3253,  3146,
    2856,  1499,  3256,  3031,  3574,  2054,  3575,  3031,  2665,  1323,
     652,  2687,  2857,  3975,  2026,  2945,  2187,   977,  1915,   895,
    4320,  4321,  1174,  2862,  3147,  2193,  1821,   798,  2386,  2677,
    2387,  2807,  2808,  2809,  2810,  3266,   632,  3727,  2743,   632,
     632,   534,  1324,  2815,  2688,  1891,  4166,  2108,  2319,  2028,
    3554,  4377,  4170,  2388,   673,  1892,  1172,  1019,  2716,  1493,
    2942,  1698,  2667,   896,  2577,  1460,  2109,  3812,   651,  3813,
    2670,  1325,  2672,  2689,  1475,  2013,  2093,  3467,   779,  3555,
    3182,   695,  2996,  2165,  2997,  2083,   760,   762,  2236,  2175,
     766,  1288,   768,  3117,   774,  3714,  1948,  3551,  3556,   536,
    1699,  4018,   632,  2554,  2134,  1206,  3754,  2998,  1206,  3051,
     813,  2852,  1141,  3183,  3390,  1461,  1142,  2237,  3043,  1823,
    2054,  3044,  2917,  1820,  1174,   788,   789,   790,  2107,   791,
     792,   793,   794,   795,   796,  3168,  3087,  1289,  4106,  2144,
    4077,  2506,  3184,  3044,  3900,  2222,  2522,  1494,  2389,  3409,
    3169,  4440,  2196,  2390,  1867,   798,  3138,  1794,  2391,  2690,
    1821,  1175,  4281,  4416,  1868,  3787,   706,  3788,  2651,  1518,
    1824,  2969,  1520,  2084,  1522,  2054,  1524,   779,  1526,  1869,
    2651,  3118,  1530,  1116,  1116,  2022,  2949,  2950,  2951,  2952,
    2953,  2954,  2691,   779,  1893,  1462,  2790,  3814,  2523,  4123,
    2855,  2014,  2994,  2015,  2337,  2337,  3901,  2999,  2252,  2337,
    2696,  1822,  3000,   715,  1329,  1290,  2864,  2865,    33,   716,
    2867,  2692,  4149,  3201,   779,   779,  2871,  1894,   167,  1986,
     171,  3384,  4082,  4083,   615,   779,   543,  1636,   544,  2697,
    2652,  2944,   876,  1330,   877,  3362,  1475,   779,   779,  2337,
    2337,  1019,  2652,  1823,  2942,  3422,  4196,  3423,  2225,   779,
    2226,  1423,  2227,  1291,  2228,  1292,  2229,  1963,   534,  2593,
    2230,  3837,  2273,  3393,   601,  2021,  2392,  2649,   527,   167,
    2268,   171,  2265,  2266,  2267,  2904,  2393,  1980,  4357,   956,
    2653,   819,  4171,    14,  1311,  4238,  2259,  2881,  2833,  4124,
    2945,   718,  2653,  1294,  1824,  3419,  2019,  2322,   765,  3098,
    1259,  3394,  1870, -1397,  2427,  4039,  1204, -1397,  1964,  1302,
    4172,  1645,  2563,  2441,  1646,    19,   536,  1312,  1407,  3439,
    3001,  1313,    38,  -485,  4229,  1981,  1982,  2458,  2310,  2311,
    3002,  2654,  1296,  1980,  4235,  1201,  2323,  2759,  2791,  1649,
    2326,  2327,  1303,  2654,  2272,  1650,  1314,   534,  3031,   719,
     909,  3341,    42,  3031,  3345,  2348,  3031,  2349,  2117,  1978,
    3907,  3908,  2295,  2384,  3114,  3424,  -915,  1298,  1202,  1651,
     820, -1397,    33,  2848,   893,  3425,  2608,  2132,  2371,  2610,
    2372,  1981,  1982,  2518,   909,  2564,  3565,  2522,  1794,  4393,
      46,  3704,  4091,  3998,  4093,  2444,  2164,  1203,  1578,  1615,
      48,  3991,    47,  2032,   894,   536,  4122,  2870, -1397,  4400,
      27,   821,  2812,  4300,  2565,  1978,   720,  2813,  1616,  3954,
    3955,  4008,  2655,   621,   864,  2944,  3501,  2609,   867,  2452,
    2611,  2455,  1617,  3322,  2655,  -921,    48,  1304,  4224,  3095,
    1980,  2542,   798,   622,  2458,   890,  2803,  2566,   774,  2060,
    1604,  1605,  1193,   543,  3502,   544,  3106,  2946,  2947,  2948,
     822,  2949,  2950,  2951,  2952,  2953,  2954,   767,  1116,  3859,
    1204, -1396,    30,  2792,  1653, -1396,   730,   896,   549,  3651,
    1019,  3504,  2061,  2942,  2945,  1194,   783,  1706,  1981,  1982,
      38,  3389,  2013,  4111,  2764,  1654,  1655,  2338,    38,  3652,
    2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,  2338,
     784,  3572,  2793,  1646,  1195,  3500,  3587,  3565,  3128,   811,
      42,  2498,  1978,  4127,  3101,  2656,  2502,   860,    42,  2505,
    2338,  3570,   721,  2657,  3046,  2567,  2658,  2656,  1649, -1396,
    2467,  1658,   543,  2765,   544,  2657,  3149,  1198,  2658,   534,
     865,  2528,  4263,   546,  1659,   167,  2484,   632,    46,  2338,
    2338,  2512,  3131,  2515,   548,  3031,    46,  1423,  1651,  2914,
      47,  3667,  1151,  1972,  2221,  3452, -1396,   818,    47,  3506,
    1199,  2298,  3831,  3501,  3573,  1646,  3011,  3324,  3141,  2062,
     863,  3668,  2578,  1592,   779,  1858,  3333,   868,  1794,   779,
    2616,  2063,   779,  3152,  4401,  3154,  1592,   536,  1196,  1200,
    1649,  3502,    48,   909,  1851,  1615,  2637,  3177,  2014,  2592,
    2015,  2766,  2767,   881,   779,  2064,  3503,  2915,  3173,  2183,
    2184,  1123,  2916,    38,  1616,  2768,   888,  3276,  3504,  3574,
    1651,  3575,  2813,  2625,    27,  2472,  2473,  1852,  1619,  2571,
    3178,  2946,  2947,  2948,  -484,  2949,  2950,  2951,  2952,  2953,
    2954,  3505,  3401,    42,  2944,   779,   897,  3591,  2650,   630,
    3601,  3606,  2661,   898,   630,  2298,  1853,  3440,  3441,  3179,
    1508,  2769,  -381,  1509,  1274,  1275,  4040,  4041,  4042,  4043,
    2673,  3595,   779,   779, -2225,  4128,  1592,  3219,  1858,  1801,
    2682,    46,  1802,  3226,  1645,  3405,   899,  1646,   909,  3615,
    1141,  3302, -1881,  2706,  1142,  1794,   779,  1019,  1794,  1592,
    2942,  1858,  2713,  2945,    38,  1665,  1666,  1667,  1668,  1669,
    1670,  3105,  1649,  3267,  3269,  3270,  3506,  3838,  1650,  1804,
    1392,   779,  1805,  3253,   543,   779,   544,    48,   632,  1019,
    2220,  3473,  2942,  2221,    42,  1363,   632,  2232,   632,  2799,
    2233,   914,  1651,   779,  2629,   918,  3613,   206,  2770,  1423,
    2771,   926,   519,   779,  4167,  2234,  1420,  1421,  2233,  2734,
     599,  3446,  3015,   927,  3016,  -381,   779,  2734,  2059,  3565,
     932,  2968,    46,  2970,  2971,   779,  1452,   671,  2262,  2457,
     941,  2263,  2458,  2337,    47,   947,  2337,  2337,  2337,  2337,
    2337,  2337,  2337,  2337,  2337,  2337,  3084,  3085,   951,  3404,
    2364,  4374,  2905,  2367,  2993,  1980,  1479,  1481,  2908,  3966,
    2494,  3968,  3017,  2263,  3018,  3971,  3450,  3972,    48, -1141,
    3830, -1141,  3684,  2338,   615,  4192,  2584,  2758,  2806,  2585,
    3371, -1420, -1420,  1948,  3374,  3375,  1646,  3377,   982,  3379,
    3380,  1794,   986, -2225,  3763,  2337,  2337,  1653,  3385,   995,
    3567,  3568,  1557,  1981,  1982,  2645,  2834,   992,  2646,   167,
    2823,  1649,   908,  2759,  2745,   997,  2804,  2746,  1654,  1655,
    2946,  2947,  2948,  2574,  2949,  2950,  2951,  2952,  2953,  2954,
    3402,  2944,  4444,  2760,  4445, -2225,  2761,  1978,  2827,  2828,
    2873,  1651,  3318,  2233,  3058,  3059,   908,  3500,  2886,  1162,
    2913, -1350,   779,  2221,  1665,  1666,  1667,  1668,  1669,  1670,
    1980,     3,     4,  2944,  1658,   798,  2923,  2927,  2931,  2221,
    2221,  2221,  2886,   998,   909,  2640,   909,  1659,  1003,  2932,
    2958,  3406,  2221,  2221,  1004,  2974,   779,  3199,  2221,  3202,
    2945,  2979,  3162,  3195,  2980,  3163,  1005,  3303,  3230,  3305,
    3166,  3351,  3032,  3167,  3352,  1343,  1007,  3410,  1981,  1982,
    2221,  3447,  1980,   632,  3448,  3501,  3685,  3045,   601,  1006,
    3457,   779,  2945,  3458,  1980,  4087,  1980,  1008,  3056,  3792,
    3793,  3794,  1169,  3469,  1171,  1980,  2221,    14,  3543,   909,
    1009,  3544,  1978,  3502,  3547,   779,  3571,  3548,  1012,  2233,
    2338,  2338,  3032,  3514, -2225,  1225,  3756,  3686,  3503,  2233,
    1981,  1982,  3357,  3519,  3521,  3699,  3700,  1654,  1655,    19,
    3504,  1013,  1981,  1982,  1981,  1982,  3836,  1015,  1127,  2263,
    3019,  3687,   713,  1981,  1982,  3891,  3897,  1226,  3892,  2233,
    1564,  1565,  3898,  3505,  1978,  2233,  3688,  1557,  3959,  3592,
    3689,  3960,  1130,  1134,  4010, -2136,  1978,  4011,  1978,  1136,
    1135,  4049,  4067,  1658,  4050,  4051,  1140,  1978,  2221,  3690,
    1152,  4059,  3691,  1634,  2263,  1159,  3311,  4109,  3314,  1794,
    4110,  1160,  1170,  1162,  3692,  1794,  1980,  2384,  4168,  3616,
    1797,  2233,  3858,  1227,  3861,  3020,  3021,  3022,  1665,  1666,
    1667,  1668,  1669,  1670,  1163,  1185,  3014,  2946,  2947,  2948,
    1190,  2949,  2950,  2951,  2952,  2953,  2954,  4193,  3506,  3025,
    4194,  2298,  1186,  1196,  1228,   908,  1980,  4204,  1217,  2337,
    2263,   713,  1244,  1995,  1981,  1982,  1974,  1248, -2136,  1222,
   -2225, -2225,  3080,  2949,  2950,  2951,  2952,  2953,  2954,   167,
    2268,   171,  2265,  2266,  2267,  4211,  3672,  1276,  2458,  1279,
    1229,  3047,  3693,   632,  4216,   779,  1278,  3331,  1978,  3025,
    3694,  1287,   712,  1284,  1981,  1982,    30,  4218,  4142,  4257,
    3331,  1307,  4258,  1319,  3103, -2136,  3400,  1328,  4289,  1333,
    1230,  1685,  4068,  2037,  2038,  2039,  2040, -2136,  1338,  1339,
    3835, -2136,    38,  1344,  3695,  2071, -2136,  4294,  1978,  1346,
    4295, -2136,  1348,  3782, -2136,   779, -2136,  1350,  4301,  4302,
     908,  2263,  2980,  4303,  1557,  4306,  2221,  1354,  2458,  1355,
     779,   779,    42,  4308,  2076,  2077,  3331,  3819,  1362,  1360,
    2086,  3942,  3943, -2136,  3945,  1365,  1370,  1665,  1666,  1667,
    1668,  1669,  1670,  1367,    33,  1204,  1935,   779,  1233,  3056,
     779,  4025,  1411,  4325,  1234, -2136,  2263,  1414,  1416,  2120,
      46,  1235,  4331,  4332,   602,  2263,  2263,  3056,  1407,  1936,
    1426,  2840,    47,  3170,  2114,  1427,  4345,  4363,  1237,  4346,
    2458,  -164,  4442,  1429,  3188,  4443,  1238,  1431,  4453,  1443,
    1225,  4443, -2136,  3165,  1445,  1451,  2337,  2337,  1453,   192,
   -2136,  2149,  2150,  2151,  2152, -1362,   603,  1463,  1468,  1469,
    1487,  1471,  1470,  1472,  1474,  1482,  2189, -1362,  1475,  1485,
    1486, -1362,  1226,  1488,  1490,  3193,  1495,  1794,  1794,  1794,
    1496,  1497,  1502,  1507,  1559,  2338,  1532,  1239,  1566,  1562,
    1568,  3786,  1575, -1527,  2338,  1569,   779, -2136, -1534,  3789,
    3790,  1576,  1585,  1589,  1588,  2208,  3231,   779,  1590,  1591,
    1595,  2338,  2338, -1362,  2212,    48,  1597,   779,  1600, -1524,
   -1525,  2219,  3222,  1601,  1602, -1528, -1526,  1603,  1227,  1608,
    3307,  3308,  1610,  1611,  1612, -1362,  1613,  1614,  1621,  1622,
    1624,  1625,   645,   774,  2734,  1626,  3317,  2734,  2734,  1627,
    1628,  2734,  1629,  3795,  1674,  1630,  1631,  2734,  1689,  1228,
    3325,  1685,  1701,  1709,  3255,  1809, -2136,  1173,  1175,  3334,
    3963,  1838, -1362,  1848,  1854,  1855,  1840,  1856,  1858,   779,
   -1362,  1859,  3255,  3350,  1860,  1861,  1862,  1863,  2841, -2136,
    1884, -2136, -2136,  1890,  1896,  1229,   908,  2840,   908,  1917,
    1921,  1923,   632,  1924,  1925,  1926,  1927,  1952,  1960,  3262,
    3264,  1962,  1972,  1953,  3271,  1973,  1225,  1976,  1975,  1977,
     632,  1794,  1978,  1984, -2136,  1230,  1987, -2136, -2136, -2136,
    1988,  1985,  1992,  1993,  3329,  1999,   779,  2009,   779,  2016,
    2001,  3996,  1259,  2374,  2005,  2006,  2017,  2023,  1226,  1116,
     779,  3315,   779,  2024,  2033,  2034,  2054,  2044,  3763,  2045,
    3356,   908,   167,  3347,  2046,  2049,  2055,  2050,  2058,  2381,
    3392,  2072,  2073,  2085,  2087,  2088,  1192,  3684,  2100,  1581,
    2101,   167,  3370,  4047,  2118,  2122,  3032,  3032,  2098,    33,
    3403,  2121,  1592,  1233,  1598,  3905, -1362,  2125,  2126,  1234,
     529,   779,  2133,  2129,  1227,  1304,  1235,  2940,  2941,  2168,
    2148,  2153,  2956,  2169,  1936,  2176,  2181,  2179,  2186,  2338,
    2182,  2197,  2199,  1237,  2200,  2201,  3921,  3922,  2215,   779,
    2216,  1238,  2275,  2202,  2245,  1228,  2251,  2260,  3742,  3743,
    2270,  2303,  1646,   779,  2309,  2304,  2346,  2347,  2383,  2369,
    2359,  2365,  2991,  2992,  1141,  2370,  3032,  1162,  1142,  2377,
     779,  2429,  2442,   779,  2841,  2402,  2449,   632,  3487,  3488,
    3489,  1229,  2445,  2450,  2468,  1249,   719,  2495,  2469,  2400,
    2470,  1250,  1239,  2496,  2497,  2460,  2843,  3361,  3951,  3952,
    2446,  2337,  2459,  2479,  2471,  2493,  4078,  4210,  2508,  2513,
    4052,  1230,   713,  2516,  2527,  2520,  2518,  4210,  2521,  3464,
    2532,  2537,  2538,   713,  2540,  4025,  2543,  2337,  2337,  2547,
    2551,  1251,  2559,  3056,  2562,  2575,  2580,  3483,  3484,  3485,
    3486,  1124,  1128,  2701,  2582,  2636,  2644,  2647,  1794,  2660,
    2631,  2648,  3878,  1634,  2698,  2723,  3965,  2712,  4132,  2719,
    2724,  2725,  2727,  3490,  3492,  2728,  2720,  2731,  2729,  4253,
    2730,  2737,  2739,  3529,  2744,    33,  4139,  2748,  2751,  2842,
    1252,  2756,  2752,  2753,  2762,  1234,  2754,  1253,  2782,  2796,
    1254,  2811,  1235,  2805,  2819,  2755,  2821,  2798,  2757,  2832,
    1936,  2814,  2820,  2835,  2830,  2847,  2851,  2849,  2853,  1237,
    2850,  2854,  2863,  4033,  2866,  4034,  4035,  1238,  2869,  2875,
    2876,  3588,  2877,  2878,  4203,  2868,  4038,  2887,  2544,  2545,
    2546,  2458,  2276,  2895,  1503,  2901,  2880,  2556,  2903,  2558,
    2907,  2560,  2561,  1255,  2906,   988,  2909,  2910,  2911,  2925,
    2929,  2926,  2928,  2930,  2933,  2976,  4307,  2995,  3040,  3034,
    2934,  3042,  -961,  2964,  3066,  3010,  2597,  2936,  1239,  3068,
    3086,  3063,  2843,  3003,  3984,  2939,  2990,  2957,  3072,  2963,
    3083,  2221,   909,  2965,  2966,  2973,  3078,  2988,  3088,  4206,
    2989,  3089,  4242,  3039,   779,  3013,  4247,  4248,  3255,  3097,
    1256,  3100,  1257,  3093,  3102,  3653,  3094,  3124,  3656,  3109,
    3125,  3135,  1258,  3136,  3151,  3142,  4090,  3143,  3153,  3190,
    1259,  3637,  3191,  4129,  3638,  3194,  3639,  3196,  3197,  1260,
    3205,  3206,  3207,  1794,  3705,  2337,   632,  1794,  3198,  1794,
    3203,  3636,  4243,  4259,  2668,  3204,  3210,  3208,  1645,  3213,
    3209,  1646,  3215,  3731,  3211,  3212,  4246,  4249,   632,  4251,
    3214,  3216,  1261,  3218,  3217,  2734,  1262,  1645,  3221,  3225,
    1646,  2734,  2734,  3227,  2093,  2042,  1649,  3229,   779,  3235,
    3748,   779,  1650,  3223,  3241,  3242,  3245,  3257,  3260,  2107,
    3272,  1263,  3277,  3261,  3273,  1649,  3278,  3316,  3309,  3310,
    2726,  1650,  3319,  3323,  3321,  3342,  1651,  2750,  2735,  3709,
    3711,  3713,  3715,  2736,  3330,  1794,  3747,   976,   977,   641,
     642,  3343,  3331,  4430,   648,  1651,  3339,  3337,  3698,   659,
     665,   641,  3346,   672,  3349,  3369,   665,   665,  3386,   699,
    3387,   702,  3376,  3388,  3378,  3391,  3396,  3708,  3397,  1264,
    3398,  3399,  3408,  1578,  4132,  3413,  2960,  2942,  2959,  3443,
    3444,  4311,  3445,  1639,  3451,  3471,  3472,  4201,  3459,  3516,
    4430,  3480,  3032,  3499,  3539,  3579,  3032,  3513,  4430,  3774,
    3558,  3581,   779,   779,  3582,  3536,   167,  3771,  3522,   779,
    3594,  2886,  3593,  3596,  4182,  3617,  3618,  3598,  2824,  3619,
    3532,   798,  3607,  3533,  3648,  3630,  3631,  1652,  3620,  4098,
    3632,  1653,  4223,  3535,  3633,  3634,  3635,  3664,  3666,  3602,
    3669,  4227,  3675,  3677,  3678,  3701,  1652,  2858,  3702,  2860,
    1653,  3722,  1654,  1655,  3361,  3730,  3703,  3733,  3806,  3738,
    3740,  3844,  3845,  3846,  3847,  2279,  3745,  3766,  4116,  1656,
    3749,  1654,  1655,  2233,  3750,  4254,  3752,  3753,  3768,   632,
     909,  3769,  3783,  3791,   779,  3780,  3796,  3779,  1656,  3799,
    2896,  3800,  3785,  3801,   756,   761,   761,   764,  1658,   761,
    3802,   770,  3803,   756,  3808,   699,  3811,  3815,   800,  3820,
    3816,  1659,  2280,   699,  3821,   699,  3822,  1658,  3823,   761,
    3855,   699,  3824,  3850,  3828,  3852,  3854,  4419,  3862,  3865,
    1659,  3867,  3870,  3868,  1898,  3882,  3871,  3879,  3886,  3888,
    1677,  2281,  3893,  3894,  2912,  3902,  3421,  3916,  3913,  3426,
    3427,  3428,  3429,  3430,  3431,  3432,  3433,  3434,  3435,  3025,
    3917,  3923,  2282,  3025,  3934,  3937,  3941,  1899,  3946,  3953,
    3973,  3976,  3977,  2283,  3990,  3985,  3995,  3997,  4001,  4003,
    1900,  4012,  4014,  3877,  4020,  4022,  4023,  4031,  1661,  4037,
    4045,  4046,  2284,  1901,  4048,  4053,  4055,  2285,  4056,  4057,
    4071,  3887,  4058,   167,  3880,  4064,  4074,  1661,  3475,  3476,
    4080,  4084,  4092,  4104,  4108,  4086,  4125,  4088,  4113,  4126,
    4107,  4118,  4119,  3885,  4130,  4137,  3987,  4143,  4150,  3729,
    4152,  1902,  4153,  4155,  4156,  3928,  4157,  4174,  4175,  4176,
     632,  4184,  1903,  2286,  4180,  4178,  4207,  3938,  4185,  4213,
    4222,   720,  4230,  4239,  4273,  4264,  4274,  4276,  4279,  4269,
    4284,  1904,  4278,  4291,  2287,  4292,  1905,  4293,  4298,  4299,
    4304,  4305,  4310,  4309,  4315,  3918,  4317,  4328,  1662,  1663,
    1664,  4244,  1665,  1666,  1667,  1668,  1669,  1670,  1794,  4335,
    4333,  4336,   632,  4344,  4339,  4341,  4349,  4322, -2225, -2225,
    4350,  1665,  1666,  1667,  1668,  1669,  1670,  4355,   779,  3931,
    3932,  4356,  3524,  4337,  3935,  3936,  4376,  3948,  3949,  4381,
     779,  4373,  4415,   192,  4384,  4338,  4378,  2734,  2734,  4391,
    4392,  4396,  4410,  1906,   908,  4422,  4438,  1164,  3967,  2056,
    4441,  4447,  4451,  2800,  1283,  1708,  3049,  3032,  2635,  3611,
    2288,  2711,  3032,  1247,  3148,  3032,  2289,  3244,  3681,  4255,
    4131,  4030,  2290,  4334,  1907,  3045,  4319,  4177,  3741,  4179,
    3107,  3982,   632,  4165,   779,  3091,   909,  3979,   798,  2874,
    4379,  4096,  4418,  4342,  4340,  3032,  4390,  4287,  3737,  3096,
    3610,  2291,   192,  2292,   632,  2780,  3160,  3110,  2781,  3111,
    3112,  3113,  2763,  4005,  2145,  3326,  4421,  4452,  3056,  4448,
    2293,  4154,  3274,  3258,  4394,  4117,  2886,   798,  2128,  4330,
    4382,  4120,   647,  1552,  4115,  1908, -2138,  3797,  4225,  4024,
    3776,  1909,  3775,   828,  1910,  2294,  4297,   910,   699,  2588,
     756,  3224,  4403,   761,  4449,   764,  4282,   761,  1137,  2453,
    3806,  3806,  3806,  3806,   800,  2454,  2224,   885,  3053,  3759,
    1911,  3881,  3549,  2476,   761,  1158,  1912,   774,  3054,  3064,
    2478,  3185,  1806,  3187,  2477,  1835,  1834,  3062,  1839,  1913,
    3077,  3065,  3494,  3849,  3860,  4215,   756,  3491,  1844,   779,
    3550,   764,  3725,  1145,  2749,  3463,   756,  4205,  3453,  4364,
     800,  4365,  4372,  2886,  1914,  2886,  3057,  3008,  2920, -2138,
    3006,  3546,     0,     0,  3025,   761,  3032,  2428,     0,  3025,
       0,     0,  3025,     0,     0,     0,     0,  3220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3234,     0,     0,  4146, -2138,     0,     0,  4089,
       0,     0,     0,   699,  3032,     0,     0,     0, -2138,     0,
       0,     0, -2138,  3255,   699,  1002,   779, -2138,   779,     0,
       0,     0, -2138,     0,     0, -2138,     0, -2138,     0,     0,
       0,     0,  1116,  1111,     0,   699,   665,     0,     0,     0,
     665,     0,     0,  2734,     0,     0,     0,     0,     0,     0,
       0,   632,   908,   699, -2138,     0,  4135,   699,  4136,     0,
       0,  4140,  4141,  1111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   699,     0, -2138,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   699,     0,  4275,     0,
    1794,     0,   779,  2597,     0,     0,     0,   167,  4169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3832,
    3833,     0,     0, -2138,     0,     0,     0,     0,     0,     0,
    3372, -2138,  4234,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,   761,   761,     0,     0,     0,     0,     0,
       0,  3381,     0,     0,  3382,   798,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2138,     0,
       0,  3025,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,  3414,
       0, -2151,     0,     0,     0,     0,     0,   756,     0,  3407,
       0,   800,     0,     0,     0,     0,     0,     0,     0,  3420,
       0,     0,     0,   645,   761,     0,     0,  4352,     0,     0,
    4256,     0,     0,     0,     0,     0,     0,     0,  3032,   699,
       0,     0,     0,     0,  3442,   761,   761, -2138,     0,     0,
    1794,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,   699,   699,     0,   761,     0,   756,  4380,     0,
   -2138,     0, -2138, -2138,     0,     0,     0,     0,     0,     0,
    1557,     0,     0,     0, -2151,     0,   167,  4285,     0,     0,
       0,     0,     0,   761,     0,   761,   761,     0,     0,     0,
       0,     0,     0,     0,     0, -2138,     0,     0, -2138, -2138,
   -2138,     0,     0,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2151,     0,     0,     0, -2151,  1535,  1535,
       0,     0, -2151,   699,     0,   641,     0, -2151,   908,     0,
   -2151,     0, -2151,     0,     0,   699,     0,     0,     0,     0,
       0,     0,     0,  1567,     0,     0,   699,     0,     0,  1573,
       0,     0,  2886,     0,     0,     0,     0,     0,     0, -2151,
    4450,     0,  1111,     0,     0,     0,     0,     0,   779,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2151,     0,  3583,  3584,  3585,  3586,     0,     0,     0,
       0,  1111,  1249,     0,     0,     0,     0,     0,  1250,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2151,  1111,
    1111,     0,  1111,     0,     0,   779, -2151,     0,     0,     0,
     167,  4395,     0,     0,  4044,     0,     0,     0,  1251,  1111,
    4437,     0,   167,  4408,   171,  4405,  4406,  4407,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4060,  4061,     0,     0,     0,     0,  4429,     0,     0,     0,
       0,     0,     0, -2151,     0,   699,     0,     0,  1111,     0,
       0,  4436,  4408,   171,  4405,  4406,  4407,  1252,     0,     0,
       0,     0,     0,     0,  1253,     0,     0,  1254,     0,     0,
       0,     0,     0,     0,  4428,     0,  1794,  1111,     0,     0,
       0,  1111,  1111,  4429,     0,     0,     0,     0,   645,     0,
       0,  4429,   699,   699,  1847,   167,  4408,   171,  4405,  4406,
    4407,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     665,     0, -2151,     0,     0,     0,     0,     0,     0,     0,
    1255,  4428,     0,  1794,     0,  3723,     0,     0,     0,  4428,
       0,  1794,     0,  3744,     0, -2151,     0, -2151, -2151,     0,
       0,     0,     0,   665,     0,     0,     0,     0,     0,  2840,
       0,     0,     0,     0,     0,   699,  1959,     0,     0,     0,
       0,     0,   699,     0,     0,   761,     0,     0,  1225,     0,
   -2151,     0,     0, -2151, -2151, -2151,     0,  1256,     0,  1257,
       0,     0,     0,     0,     0,   800,     0,     0,     0,  1258,
       0,   699,     0,     0,   699,     0,     0,  1259,     0,     0,
    1226,     0,     0,     0,     0,     0,  1260,     0,     0,     0,
       0,     0,     0,     0,   699,     0,     0,     0,     0,     0,
       0,     0,   761,   761,   761,   761,   699,  1645,     0,     0,
    1646,     0,     0,     0,     0,     0,     0,   665,  4202,  1308,
     699,     0,     0,  1262,     0,     0,     0,  1647,     0,     0,
       0,  2068,     0,   699,     0,  1649,  1227,     0,     0,     0,
       0,  1650,     0,   761,   761,     0,     0,     0,  1309,   761,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1651,     0,  1228,     0,  1557,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1644,     0,     0,     0,     0,  1645,     0,     0,  1646,     0,
       0,     0,     0,   761,     0,     0,  2841,     0,     0,     0,
       0,     0,     0,  1229,     0,  1647,  1264,     0,  1648,     0,
       0,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
     761,   761,   761,   761,     0,     0,     0,     0,     0,     0,
       0,     0,   699,  1230,     0,     0,     0,     0,   699,     0,
       0,  2068,     0,  1651,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,     0,     0,   764,     0,   756,
       0,     0,     0,     0,     0,     0,  1652,     0,     0,   800,
    1653,     0,     0,     0,   761,     0,  3906,     0,     0,     0,
       0,     0,     0,   761,     0,     0,     0,     0,     0,   761,
     761,  1654,  1655,     0,   699,     0,     0,    33,     0,     0,
       0,  1233,     0,     0,  3920,     0,     0,  1234,  1656,     0,
       0,     0,     0,     0,  1235,     0,     0,     0,     0,  1535,
    3933,     0,  1936,     0,     0,     0,   761,     0,   756,     0,
       0,  1237,   699,   699,  1657,   761,     0,  1658,     0,  1238,
       0,   699,     0,     0,  1652,     0,     0,     0,  1653,     0,
    1659,     0,     0,  1660,     0,   641,   641,     0,     0,  2278,
       0,     0,     0,  1111,     0,  1111,  3950,     0,  3944,  1654,
    1655,     0,  1111,     0,     0,  1111,     0,     0,     0,  1111,
       0,     0,  3947,     0,     0,     0,  1656,  1111,  1111,     0,
    1239,     0,     0,     0,  2843,  1111,     0,   800,  1111,  1111,
    1111,  1111,     0,     0,     0,     0,     0,     0,  1111,  1111,
       0,  1111,  1657,  1111,  1111,  1658,     0,  1111,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1661,  1659,     0,
       0,  1660,     0,     0,  1111,     0,     0,     0,   761,  1111,
       0,     0,     0,  1111,     0,     0,     0,  1111,     0,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,     0,  1111,
       0,     0,     0,   699,  1111,     0,  1111,     0,     0,     0,
       0,     0,   699,     0,     0,  4007,     0,     0,     0,  1645,
       0,     0,  1646,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1647,
       0,     0,     0,     0,     0,  1661,     0,  1649,     0,     0,
       0,     0,  1557,  1650,     0,     0,     0,  1662,  1663,  1664,
       0,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,  2447,
       0,     0,     0,     0,     0,  2448,     0,  1651,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1645,     0,     0,  1646,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1647,     0,     0,     0,     0,     0,     0,     0,  1649,
       0,     0,     0,     0,     0,  1650,     0,     0,   699,     0,
     699,     0,  1111,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,  1651,
       0,     0,  4099,  4101,  4101,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   699,     0,     0,
       0,     0,     0,  2485,     0,  2492,     0,     0,  1652,     0,
       0,     0,  1653,     0,     0,     0,     0,     0,     0,     0,
     764,     0,     0,     0,     0,   641,     0,   641,     0,     0,
       0,     0,     0,  1654,  1655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1111,     0,     0,     0,     0,     0,
    1656,     0,     0,     0,     0,   756,     0,   761,   761,   761,
       0,     0,   756,     0,   800,     0,   761,     0,   761,  1645,
     761,   761,  1646,     0,   699,     0,  1657,     0,     0,  1658,
    1652,     0,     0,     0,  1653,     0,     0,     0,     0,  1647,
       0,     0,  1659,   665,     0,  1660,     0,  1649,     0,     0,
       0,     0,  1225,  1650,     0,  1654,  1655,     0,     0,     0,
    4189,     0,  1959,  1557,     0,     0,     0,     0,  2598,   829,
       0,     0,  1656,  2607,     0,     0,     0,  1651,     0,   699,
       0,     0,     0,     0,  1226,     0,     0,     0,     0,     0,
       0,     0,     0,  3220,     0,   699,     0,     0,  1657,  2642,
    2642,  1658,   830,     0,     0,     0,   764,     0,     0,     0,
       0,     0,     0,     0,  1659,   831,   832,  1660,     0,  1661,
       0,     0,     0,   761,   833,     0,     0,     0,   834,     0,
       0,  1557,     0,     0,     0,  1557,  1557,     0,  4231,     0,
    1227,     0,     0,     0,     0,   835,     0,     0,     0,  2700,
       0,  2703,  2705,     0,     0,     0,     0,     0,     0,     0,
       0,  4250,     0,  4252,     0,     0,   836,     0,     0,     0,
       0,  1228,     0,     0,     0,     0,     0,   837,  1652,   761,
       0,     0,  1653,     0,     0,   838,     0,   761,     0,     0,
       0,  1661,   761,     0,     0,     0,   839,     0,     0,     0,
       0,   840,     0,  1654,  1655,  1111,     0,  1229,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
    1656,     0,   841,     0,     0,     0,  2935,     0,     0,     0,
       0,     0,     0,  1959,     0,     0,  2642,  1230,   699,     0,
    2801,     0,     0,   641,     0,     0,  1657,   842,     0,  1658,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1659,     0,  1231,  1660,  4101,     0,   843,  2700,
       0,     0,     0,     0,     0,     0,     0,   761,  2826,     0,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,     0,     0,     0,     0,     0,     0,  1232,  2983,   844,
       0,    33,     0,     0,   761,  1233,   761,  2642,   761,  2642,
       0,  1234,     0,     0,     0,     0,  1645,  4348,  1235,  1646,
       0,     0,     0,     0,     0,     0,  1236,   192,  1111,     0,
       0,     0,     0,     0,     0,  1237,  1647,     0,     0,  1661,
    1535,     0,     0,  1238,  1649,     0,     0,     0,     0,     0,
    1650,     0,     0,     0,   845,     0,     0,     0,   846,     0,
     847,     0,     0,     0,     0,     0,   848,     0,     0,   849,
       0,  4383,     0,     0,  1651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,     0,
       0,     0,   756,     0,  1239,   850,     0,   851,     0,     0,
       0,   852,     0,   761,     0,     0,     0,     0,     0,   853,
    1111,  1111,     0,     0,   854,     0,  1111,     0,     0,  4420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   855,
       0,  1111,  1111,  2368,     0,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,  1111,  1111,
    1111,  1111,     0,     0,     0,  1645,     0,     0,  1646,     0,
       0,  1111,     0,     0,  1111,  1652,  1111,  2987,     0,  1653,
       0,     0,  1649,     0,     0,  1647,  1111,  1111,  1650,     0,
    1111,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
    1654,  1655,     0,  1111,     0,  1111,     0,   800,     0,  1111,
       0,     0,  1651,     0,     0,     0,     0,  1656,     0,     0,
       0,     0,     0,  1651,     0,  1111,     0,  -119,     0,   699,
       0,     0,     0,     0,     0,     0,  3033,     0,  1111,  1111,
    1111,     1,     0,  1657,     0,     0,  1658,     0,     0,     0,
       0,     2,     0,     3,     4,  1111,     0,     0,     0,  1659,
       0,     0,  1660,     0,     0,     0,     0,  1111,     5,     0,
       0,     0,  1111,     0,     0,     0,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,  3033,     0,     6,  3071,
       7,     8,     0,  2492,     0,     0,     9,     0,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,     0,
      12,     0,     0,  1652,     0,     0,     0,  1653,     0,     0,
       0,     0,     0,  1111,  1652,  2642,    13,     0,  1653,    14,
    1535,     0,     0,     0,     0,     0,  1661,     0,  1654,  1655,
       0,    15,     0,    16,     0,     0,     0,    17,     0,  1654,
    1655,     0,     0,    18,     0,  1656,   761,     0,   761,   761,
     761,    19,     0,    20,     0,     0,  1656,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1657,     0,    22,  1658,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,     0,  1658,     0,  1659,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1662,  1663,  1664,     0,
    1665,  1666,  1667,  1668,  1669,  1670,     0,     0,    23,    24,
    3259,     0,     0,     0,    25,  1645,     0,     0,  1646,     0,
       0,     0,     0,    26,  1395,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,  1647,     0,     0,     0,     0,
       0,     0,     0,  1649,  1661,     0,     0,     0,     0,  1650,
       0,     0,     0,     0,     0,  1661,     0,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,     0,     0,
       0,    28,     0,  1651,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,     0,     0,     0,    30,    31,
       0,    32,  1649,     0,     0,     0,    33,     0,  1650,     0,
       0,    34,     0,     0,    35,     0,  2642,  2642,    36,     0,
       0,     0,     0,    37,    38,     0,     0,     0,     0,     0,
       0,    39,  1651,     0,    40,     0,     0,     0,     0,     0,
       0,     0,    41,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,    42,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,  1395,  3534,     0,   699,
     699,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,     0,  1652,   699,     0,    45,  1653,     0,
       0,     0,    46,     0,  3004,     0,     0,     0,  1535,   699,
       0,     0,     0,     0,    47,     0,     0,  1535,   699,  1654,
    1655,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,     0,     0,     0,  1656,     0,     0,     0,
       0,     0,     0, -2225,     0,     0,     0,  1653,    48,     0,
       0,  -119,     0,     0,     0,     0,     0,     0,     0,     0,
     761,     0,  1657,   761,     0,  1658,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,   756,  1659,     0,
       0,  1660,     0,     0,     0, -2225,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   761,     0,
       0,     0,     0,     0,  1658,     0,  1111,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1111,  1659,     0,     0,
       0,     0,  1111,     0,  1111,     0,     0,     0,     0,     0,
    1111,     0,     0,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,  1111,  1111,     0,     0,  1661,  1111,  1111,     0,     0,
    1249,     0,     0,     0,     0,     0,  1250,     0,     0,  1111,
       0,  1395,     0,  1111,     0,     0,     0,  1111,     0,     0,
    1645,     0,     0,  1646,     0,     0,     0,  1111,     0,     0,
    1111,     0,  1111,     0,     0,     0,     0,     0,     0,     0,
    1647,  1111,  1111,  1111, -2225,     0,  1251,  1111,  1649,     0,
    1111,     0,     0,     0,  1650,     0,     0,   699,   699,   699,
     756,  3033,  3498,     0,     0,  1395,  3498,  3512,     0,     0,
       0,  1111,     0,     0,     0,     0,  1249,  3526,  1651,  1111,
       0,  1111,  1250,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,  1252,     0,  1395,     0,  3415,
       0,     0,  1253,  1111,     0,  1254,     0,     0,     0,  1111,
       0,     0,     0,  2492,     0,  1111,     0,     0,     0,     0,
       0,     0,  1251,     0,     0,     0,     0,     0,     0,     0,
    3566,  1535,  1535,     0,  2068,     0,     0,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,     0,
       0,     0,   761,   761,   761,   761,     0,     0,  1255,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1395,
    1249,  1252,     0,     0,     0,     0,  1250,     0,  1253,  1652,
       0,  1254,     0,  1653,     0,     0,     0,     0,  1395,     0,
    3609,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1654,  1655,     0,     0,  1395,     0,
       0,     0,     0,     0,     0,  1256,  1251,  1257,     0,     0,
     758,  1656,     0,     0,     0,     0,     0,  1258,     0,   758,
     778,     0,     0,  1395,  1255,  1259,   778,     0,     0,     0,
       0,     0,     0,     0,  1260,     0,   778,  1657,     0,     0,
    1658,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3670,  1659,     0,  1252,  1660,     0,     0,     0,
       0,     0,  1253,     0,     0,  1254,     0,  1334,     0,     0,
       0,  1262,     0,     0,     0,     0,     0,     0,     0,     0,
    1395,  1256,     0,  1257,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1258,     0,     0,  1335,     0,     0,     0,
       0,  1259,     0,   699,     0,  1645,     0,     0,  1646,     0,
    1260,     0,     0,     0,   761,     0,  1111,     0,  1255,     0,
       0,     0,   699,     0,     0,  1647,     0,     0,  3736,     0,
    1661,     0,     0,  1649,     0,     0,     0,  1959,     0,  1650,
       0,     0,     0,  1918,     0,     0,     0,  1262,     0,   699,
       0,     0,     0,     0,  1264,     0,     0,     0,  2700,     0,
       0,     0,     0,  1651,  3764,     0,     0,     0,     0,     0,
       0,     0,  1919,     0,     0,  1256,     0,  1257,     0,     0,
    1111,  1111,     0,     0,     0,     0,     0,  1258,     0,     0,
       0,     0,     0,     0,     0,  1259,     0,     0,     0,     0,
       0,     0,     0,  2642,  1260,  2642,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1645,     0,     0,  1646,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
    1264,     0,     0,     0,  3462,  1647,     0,  1989,  1111,     0,
       0,  1262,  1645,  1649,     0,  1646,     0,     0,     0,  1650,
       0,     0,     0,     0,     0,     0,     0,  1395,     0,     0,
       0,     0,  1647,     0,  1652,     0,  1990,     0,  1653,     0,
    1649,     0,     0,  1651,     0,  1111,  1650,     0,     0,     0,
       0,     0,     0,     0,     0,  1111,  1111,     0,     0,  1654,
    1655,     0,     0,  1111,  1111,     0,     0,     0,  1111,     0,
    1651,     0,     0,     0,  1111,  1111,  1656,     0,  1111,     0,
     699,   699,   699,   699,     0,     0,     0,  3498,  3512,  3498,
       0,     0,  3851,     0,  1264,     0,  3033,     0,     0,     0,
    3033,     0,  1657,     0,     0,  1658,  3864,     0,     0,     0,
    1111,     0,     0,     0,     0,  1111,     0,     0,  1659,     0,
       0,  3874,     0,     0,     0,     0,   758,  1111,     0,     0,
       0,     0,     0,   800,     0,     0,     0,     0,   778,     0,
       0,  3071,   778,     0,  1652,  2492,     0,     0,  1653,     0,
       0,     0,     0,   778,     0,   641,     0,     0,  1111,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   778,  1654,
    1655,  1652,   758,     0,     0,  1653,     0,     0,  2642,  2642,
       0,     0,   758,   778,     0,     0,  1656,     0,   778,     0,
       0,     0,     0,     0,     0,  1661,  1654,  1655,   778,     0,
       0,     0,  3919,     0,     0,     0,   778,     0,     0,     0,
       0,     0,  1657,  1656,     0,  1658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0,     0,     0,  1657,
       0,     0,  1658,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,  1659,     0,     0,  1660,     0,
       0,   761,     0,     0,     0,     0,     0,  1249,     0,     0,
       0,     0,     0,  1250,     0,     0,     0,     0,     0,   758,
       0,     0,     0,     0,   778,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,     0,     0,     0,   758,
       0,     0,     0,  1251,     0,     0,     0,     0,     0,  1111,
       0,     0,     0,  1395,     0,     0,     0,     0,  1395,  1395,
     756,     0,  1661,     0,     0,  1959,     0,     0,     0,     0,
    1395,     0,  1535,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   761,  1959,     0,     0,     0,     0,
       0,     0,  1252,     0,     0,     0,     0,     0,     0,  1253,
       0,     0,  1254,     0,     0,     0,     0,     0,     0,     0,
     699,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,  1111,  3538,
       0,     0,     0,     0,     0,     0,     0,  1111,     0,     0,
       0,     0,  1662,  1663,  1664,  1255,  1665,  1666,  1667,  1668,
    1669,  1670,   758,     0,  1111,  1111,  3560,     0,  1111,     0,
       0,     0,     0,   758,     0,     0,     0,  3498,     0,     0,
       0,  3033,     0,     0,     0,     0,  3033,     0,     0,  3033,
    2700,     0,  4076,     0,  1111,  1111,  1405,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1395,  1256,     0,  1257,     0,     0,     0,     0,  3566,
     800,   761,   761,   761,  1258,     0,     0,     0,     0,     0,
       0,     0,  1259,   758,     0,     0,     0,     0,     0,     0,
       0,  1260,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1645,     0,     0,  1646,   756,   800,
       0,     0,     0,     0,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,  1647,     0,     0,     0,  1262,     0,
     778,     0,  1649,     0,   758,     0,     0,  1249,  1650,     0,
    1395,     0,   778,  1250,     0,     0,     0,  1535,     0,     0,
       0,   756,     0,  1263,   699,     0,     0,     0,  1645,     0,
       0,  1646,  1651,     0,     0,  3736,     0,     0,     0,  1249,
     778,     0,  2642,     0,     0,  1250,  1959,     0,  1405,     0,
     778,     0,     0,  1251,     0,     0,  1649,     0,  3764,     0,
       0,   699,  1650,   778,     0,     0,   778,     0,     0,   761,
    3566,     0,     0,     0,     0,     0,     0,     0,   758,     0,
       0,  1264,     0,     0,     0,  1251,  1651,     0,     0,     0,
       0,     0,  1111,     0,  1395,  1111,     0,  1111,     0,     0,
       0,     0,  1252,     0,     0,     0,     0,   758,     0,  1253,
       0,     0,  1254,     0,  1111,     0,     0,     0,  3033,     0,
       0,  4076,     0,     0,     0,     0,     0,  4221,     0,     0,
       0,     0,     0,  1652,  1252,   758,   758,  1653,   758,     0,
       0,  1253,     0,     0,  1254,     0,     0,   761,  3477,     0,
       0,   699,     0,     0,     0,   758,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,  1255,     0,     0,     0,   761,
     761,   761,   761,     0,     0,  1656,     0,   778,     0,     0,
       0,     0,     0,     0,  1535,   778,   778, -2225,     0,     0,
       0,  1653,     0,     0,   758,  1793,     0,  1255,     0,     0,
       0,  1657,   756,     0,  1658,     0,     0,     0,     0,     0,
       0,     0,  1654,  1655,     0,     0,     0,  1659,     0,     0,
    1660,  1111,  1256,   758,  1257,     0,     0,   758,   758, -2225,
       0,     0,     0,     0,  1258,     0,     0,     0,     0,     0,
       0,     0,  1259,  1405,     0,     0,     0,     0,     0,  1793,
       0,  1260,     0,     0,  1256,     0,  1257,     0,  1658,     0,
       0,     0,     0,     0,     0,     0,  1258,     0,     0,  1111,
       0,  1659,     0,     0,  1259,   761,     0,   800,  1645,     0,
       0,  1646,     0,  1260,  2594,     0,  1111,     0,  1262,     0,
       0,     0,     0,     0,  1661,     0,     0,  1405,  1647,     0,
       0,     0,     0,     0,     0,     0,  1649,     0,     0,     0,
       0,     0,  1650,  1263,     0,     0,  2675,     0,     0,     0,
    1262,     0,     0,     0,     0,     0,   761,     0,     0,  1405,
       0,   756,     0,     0,     0,     0,  1651,     0,     0,     0,
       0,     0,  3566,     0,     0,  2676,     0,     0, -2225,     0,
       0,     0,     0,     0,     0,     0,  4221,     0,     0,  1111,
    1111,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1264,   756,     0,  1395,     0,     0,     0,     0,     0,
     761,   778,     0,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,     0,     0,     0,  3809,     0,
       0,  1405,     0,  1264,     0,  1249,     0,     0,     0,     0,
       0,  1250,     0,  1111,     0,     0,  1395,  1395,     0,  1395,
    1405,     0,     0,  1111,     0,     0,     0,     0,   761,     0,
       0,     0,     0,     0,     0,     0,     0,  1652,     0,     0,
    1405,  1653,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,
       0,  1251,     0,     0,     0,     0,     0,     0,     0,     0,
    1793,     0,  1654,  1655,     0,  1405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1395,     0,  1395,     0,  1656,
     778,     0,     0,     0,  1645,  1111,     0,  1646,     0,     0,
       0,     0,     0,     0,   756,     0,   778,     0,     0,     0,
    1252,     0,     0,     0,     0,  1657,     0,  1253,  1658,     0,
    1254,     0,  1649,     0,  1249,     0,   758,     0,  1650,     0,
    1250,  1659,  1405,     0,  1660,   758,     0,   778,   778,     0,
       0,  1395,     0,     0,     0,     0,     0,     0,   778,     0,
       0,     0,  1651,     0,     0,     0,     0,     0,     0,     0,
     778,   778,     0,     0,     0,     0,  1395,     0,     0,     0,
    1251,     0,   778,  1255,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1395,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,   758,     0,     0,     0,  1661,     0,
       0,     0,     0,     0,  3478,     0,     0,     0,     0,  1252,
       0,     0,     0,     0,     0,     0,  1253,     0,  1645,  1254,
    1256,  1646,  1257,     0,     0,     0,     0,     0,     0,   758,
       0,   758,  1258,     0,     0,     0,     0,     0,   758,     0,
    1259,   758,     0, -2225,     0,   758,  1649,  1653,     0,  1260,
       0,     0,  1650,   758,   758,     0,     0,  1395,     0,     0,
    1404,   758,     0,     0,   758,   758,   758,   758,  1654,  1655,
       0,     0,  1255,  1395,   758,   758,  1651,   758,  1645,   758,
     758,  1646,  2714,   758,  1395, -2225,  1262,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,  1647,  1405,
     758,  1793,  3843,     0,     0,   758,  1649,     0,     0,   758,
       0,  2715,  1650,   758,  1658,   758,   758,   758,   758,   758,
     758,   758,   758,   758,     0,   758,     0,  1659,     0,  1256,
     758,  1257,   758,     0,     0,     0,  1651,     0,  3481,     0,
       0,  1258,     0,     0,     0,     0,     0,     0,     0,  1259,
       0,     0,     0,  1395,     0,     0,     0,     0,  1260,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1264,
       0,     0,     0,  1395,     0,     0,     0, -2225,     0,     0,
    1645,  1653,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,  3129,  1404,     0,     0,  1262,     0,     0,  1395,     0,
    1647,     0,  1654,  1655, -2225,     0,     0,     0,  1649,     0,
       0,     0,     0,     0,  1650,     0,     0,     0,     0, -2225,
    3130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1395,     0,     0,  1652,  1651,     0,
       0,  1653,     0,     0,     0,     0,     0,     0,  1658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,     0,
       0,  1659,  1654,  1655,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1264,  1656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1665,  1666,
    1667,  1668,  1669,  1670,     0,  1657,     0,   778,  1658,     0,
       0,  1793,   778,     0,     0,   778,     0,     0,     0,     0,
       0,  1659,     0,     0,  1660,  1249,     0,     0,     0,     0,
       0,  1250,     0,     0,     0,     0,     0,   778, -2225,  1652,
     758,     0,     0,  1653,     0,     0,     0,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,  1654,  1655,     0,     0,     0,     0,
       0,  1251,     0,     0,     0,     0,     0,     0,   778,     0,
       0,  1656,     0,     0,     0,     0,     0,  1404,     0,     0,
       0,     0,     0,     0,     0,  1405,     0,     0,  1661,  1395,
    1405,  1405,     0,     0,     0,   778,   778,  1657,     0,     0,
    1658,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
    1252,     0,     0,  1659,     0,     0,  1660,  1253,  1793,   778,
    1254,  1793,  1665,  1666,  1667,  1668,  1669,  1670,     0,     0,
       0,  1951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   778,     0,     0,     0,   778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,   778,     0,  1645,     0,
       0,  1646,     0,  1255,     0,     0,   778,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,  1647,   778,
    1661,     0,  4054,     0,     0,     0,  1649,     0,   778,     0,
       0,     0,  1650,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1645,     0,
       0,  1646,     0,     0,     0,     0,  1651,     0,     0,     0,
    1256,     0,  1257,     0,     0,  1404,     0,  1395,  1647,     0,
       0,   758,  1258,  1405,     0,     0,  1649,     0,     0,     0,
    1259,     0,  1650,     0,  1404,     0,     0,     0,     0,  1260,
       0,     0,     0,     0,  1793,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,  1404,     0,  1651,     0,     0,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
       0,     0,  3171,     0,  4094,     0,  1262,     0,     0,  1404,
    1645,     0,     0,  1646,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1647,  3172,  1405,     0,     0,   778,     0,  1652,  1649,     0,
       0,  1653,     0,     0,  1650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1654,  1655,     0,     0,  1404,     0,  1651,   778,
       0,     0,     0,     0,   758,     0,     0,     0,     0,  1656,
       0,     0,     0,     0,     0,     0,     0,  1652,     0,  1264,
       0,  1653,  1395,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1395,   778,  1657,     0,     0,  1658,     0,
       0,     0,  1654,  1655,     0,     0,  1405,     0,     0,     0,
       0,  1659,     0,     0,  1660,     0,     0,     0,   778,  1656,
       0,     0,   758,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1657,   758,   758,  1658,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,  1652,
    1249,  1659,     0,  1653,  1660,     0,  1250,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   758,   758,     0,
       0,     0,   758,     0,  1654,  1655,     0,     0,  1661,     0,
       0,  1288,     0,     0,   758,   758,   758,   758,     0,     0,
    1395,  1656,  1793,     0,     0,     0,  1251,   758,  1793,     0,
     758,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   758,   758,     0,     0,   758,  1657,  1395,     0,
    1658,     0,     0,  1404,     0,     0,     0,  1289,  1661,   758,
       0,   758,     0,  1659,  1395,   758,  1660,     0,     0,     0,
       0,     0,     0,     0,     0,  1252,     0,     0,     0,     0,
       0,   758,  1253,     0,     0,  1254,  2440,     0,     0,     0,
       0,     0,   758,     0,   758,   758,   758,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   778,     0,
    1395,   758,  4148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,   758,  1290,     0,     0,  1255,     0,
    1661,     0,   758,     0,     0,     0,     0,     0,  1662,  1663,
    1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,   778,     0,
       0,     0,  4351,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   778,   778,     0,     0,     0,     0,   758,
       0,     0,     0,  1291,     0,  1292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1293,     0,  1257,     0,     0,
     778,     0,     0,   778,     0,     0,  1405,  1258,     0,     0,
       0,     0,     0,     0,     0,  1259,     0,     0,     0,     0,
       0,     0,     0,  1294,  1260,     0,     0,     0,     0,     0,
    1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,
       0,     0,     0,     0,  4439,     0,     0,     0,  1405,  1405,
       0,  1405,     0,     0,     0,     0,  1395,  1295,     0,     0,
       0,  1262,  1296,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1793,  1793,  1793,     0,  1645,     0,  1297,  1646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1298,     0,   778,
       0,     0,     0,     0,  1647,     0,     0,  1405,  2461,  1405,
     778,     0,  1649,     0,     0,     0,     0,     0,  1650,     0,
     778,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1651,     0,  1264,     0,     0,   558,     0,  2583,
       0,     0,     0,   600,  1951,  2590,     0,     0,     0,     0,
       0,     0,   650,  1405,  1395,     0,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   711,   778,     0,     0,     0,     0,  2462,  1405,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1405,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1793,  1405,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   778,
       0,   778,     0,  1652,     0,     0,     0,  1653,     0,     0,
       0,     0,     0,   778,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1395,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1656,     0,  1395,     0,  1405,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   778,  1405,     0,  1404,     0,     0,
       0,  1657,     0,     0,  1658,     0,  1405,  1395,   769,     0,
       0,     0,     0,     0,     0,     0,     0,  1659,   803,   804,
    1660,   807,   778,   810,     0,   812,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,   778,     0,     0,  1645,
       0,     0,  1646,     0,     0,  1395,     0,     0,     0,  1395,
    1395,     0,     0,   778,     0,     0,   778,     0,     0,  1647,
       0,     0,  2922,     0,     0,     0,     0,  1649,     0,     0,
       0,     0,   758,  1650,     0,  1405,  1951,     0,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,   758,     0,
     758,     0,     0,     0,  1661,  1405,   758,  1651,     0,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,     0,
       0,     0,   758,   758,     0,     0,     0,     0,     0,     0,
    1405,     0,     0,     0,     0,   758,     0,     0,     0,   758,
       0,  1793,     0,   758,     0,     0,     0,     0,     0,     0,
       0,  1645,     0,   758,  1646,  2463,   758,     0,   758,     0,
       0,     0,     0,     0,     0,     0,  1405,   758,   758,   758,
    1404,  1647,     0,   758,     0,     0,   758,     0,     0,  1649,
       0,     0,     0,     0,     0,  1650,   758,   758,     0,     0,
       0,     0,     0,     0,  1662,  1663,  1664,   758,  1665,  1666,
    1667,  1668,  1669,  1670,     0,   758,     0,   758,  1652,  1651,
       0,     0,  1653,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   758,
       0,     0,     0,  1654,  1655,   758,     0,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
    1656,     0,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1657,     0,     0,  1658,
       0,     0,     0,     0,     0,     0,     0,   778,     0,  2959,
       0,     0,  1659,     0,  2960,  1660,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
    1652,     0,     0,   780,  1653,     0,     0,     0,     0,     0,
       0,     0,     0,   780,     0,     0,  1793,     0,     0,     0,
    1793,  1405,  1793,     0,     0,  1654,  1655,     0,  2440,  2440,
    2440,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1656,     0,     0,     0,     0,     0,   862,     0,
       0,     0,     0,     0,     0,     0,   870,     0,     0,  1661,
       0,   778,     0,     0,   778,   886,   887,     0,  1657,     0,
     889,  1658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   905,     0,     0,  1659,     0,  1645,  1660,     0,  1646,
       0,     0,     0,     0,   913,     0,     0,     0,  1793,     0,
       0,     0,     0,     0,     0,     0,  1647,     0,     0,     0,
     936,     0,     0,   938,  1649,   940,     0,   943,     0,     0,
    1650,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1404,     0,   758,     0,  1651,     0,     0,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
       0,  1661,     0,     0,     0,   778,   778,     0,     0,  1405,
       0,     0,   778,     0,     0,     0,     0,   999,     0,  1000,
       0,     0,  1951,  2590,     0,  2590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1405,   758,   758,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   711,     0,     0,     0,     0,     0,     0,     0,
       0,  1404,     0,  1404,     0,  1652,     0,   778,     0,  1653,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,     0,     0,     0,   758,     0,     0,     0,     0,     0,
    1654,  1655,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1656,     0,     0,
       0,  1216,     0,     0,     0,     0,     0,  1404,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,   758,  1657,  1405,     0,  1658,     0,     0,   758,
     758,     0,  1404,     0,   758,  1405,     0,     0,     0,  1659,
     758,   758,  1660,     0,   758,     0,     0,     0,     0,     0,
       0,  2590,  1337,     0,     0,   780,     0,     0,     0,   780,
       0,  3454,   758,     0,     0,     0,   758,  1349,     0,  2590,
     780,     0,     0,     0,     0,     0,   758,     0,     0,     0,
    1359,   758,     0,     0,     0,   780,     0,  1361,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,  1409,
     780,     0,  1413,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   780,  1661,     0,     0,     0,
       0,     0,     0,   780,   758,     0,     0,     0,     0,     0,
    3455,     0,     0,  1404,  1645,  1456,     0,  1646,     0,     0,
       0,     0,  1405,     0,     0,  1645,     0,     0,  1646,  2590,
       0,     0,     0,     0,  1647,     0,     0,     0,     0,     0,
    1404,  1793,  1649,     0,     0,  1647,     0,     0,  1650,     0,
    1405,     0,     0,  1649,     0,     0,     0,     0,     0,  1650,
       0,   778,     0,     0,     0,     0,  1405,     0,     0,     0,
       0,     0,  1651,   778,     0,     0,     0,     0,     0,     0,
       0,   780,     0,  1651,     0,     0,  1662,  1663,  1664,     0,
    1665,  1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1404,
       0,     0,  1405,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   778,     0,  1404,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4413,     0,     0,  1404,  1645,     0,     0,  1646,     0,
       0,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,  1652,     0,  1647,   758,  1653,  2967,     0,
       0,     0,     0,  1649,  1652,     0,     0,     0,  1653,  1650,
    1404,     0,     0,     0,     0,     0,     0,     0,  1654,  1655,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1654,
    1655,     0,     0,  1651,     0,  1656,     0,     0,     0,     0,
       0,     0,     0,  1405,     0,     0,  1656,     0,     0,     0,
       0,  2440,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1657,   778,     0,  1658,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,   758,  1658,     0,  1659,  1405,     0,
    1660,     0,     0,   758,     0,     0,     0,     0,  1659,     0,
       0,  1660,     0,   711,  1808,  1645,     0,  4414,  1646,     0,
     758,   758,     0,     0,   758,  2937,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1647,     0,   758,     0,     0,
       0,     0,   758,  1649,     0,   758,     0,     0,     0,  1650,
     758,   758,     0,     0,  1652,     0,     0,     0,  1653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   778,
       0,   778,   780,  1651,  1661,   758,  1916,     0,     0,  1654,
    1655,     0,     0,     0,     0,  1661,     0,   780,     0,     0,
       0,     0,     0,     0,     0,  2590,  1656,     0,     0,   780,
       0,     0,     0,     0,     0,     0,  1405,     0,     0,     0,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,  1657,     0,     0,  1658,     0,   780,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,   780,  1659,     0,
       0,  1660,     0,  1793,     0,   778,     0,     0,     0,     0,
     780,     0,     0,   780,     0,     0,     0,   758,  2972,     0,
       0,     0,     0,     0,  1662,  1663,  1664,     0,  1665,  1666,
    1667,  1668,  1669,  1670,  1652,  1662,  1663,  1664,  1653,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1654,
    1655,     0,     0,     0,     0,     0,   758,     0,  1405,     0,
       0,     0,     0,     0,     0,  1661,  1656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   758,  1405,
       0,   758,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,  1657,  1404,     0,  1658,     0,     0,     0,     0,
     758,     0,     0,     0,   758,     0,     0,     0,  1659,  1405,
       0,  1660,     0,  1403,   780,     0,     0,     0,     0,     0,
    2124,     0,   780,   780,     0,     0,     0,     0,     0,  1951,
       0,     0,  1795,     0,     0,  2147,     0,  1645,     0,     0,
    1646,     0,     0,  1793,     0,     0,     0,  1405,     0,     0,
       0,  1405,  1405,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,  1649,     0,     0,     0,     0,
       0,  1650,     0,     0,     0,  2192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,  1795,     0,   758,     0,
    2207,     0,  2209,     0,  2210,  1651,     0,     0,     0,  2211,
       0,     0,     0,     0,     0,  1645,     0,   758,  1646,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1647,     0,  1405,  2978,     0,
       0,     0,     0,  1649,     0,     0,     0,     0,  1404,  1650,
       0,     0,  1808,     0,     0,  1695,  1808,     0,  1808,  1404,
       0,  1808,     0,     0,     0,   758,     0,  3841,     0,     0,
       0,     0,     0,  1651,     0,     0,     0,     0,     0,     0,
       0,     0,   758,     0,     0,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,     0,     0,
    2440,   778,     0,     0,     0,  2440, -2225,     0,     0,     0,
    1653,     0,     0,     0,     0,     0,     0,  2440,  1403,     0,
       0,     0,     0,     0,     0,     0,     0,   758,   780,     0,
       0,  1654,  1655,     0,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2225,     0,
       0,     0,     0,     0,     0,   758,   758,     0,   778,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,   758,     0,
       0,     0,  1403,     0,  1652,     0,     0,  1658,  1653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1659,     0,     0,     0,  1404,     0,     0,     0,     0,  1654,
    1655,     0,     0,     0,  1403,     0,     0,  1795,     0,   758,
    1404,     0,     0,     0,     0,     0,  1656,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1793,
       0,     0,  1657,   780,     0,  1658,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1404,     0,  1659,     0,
       0,  1660,     0,     0,     0,     0,     0, -2225,     0,     0,
       0,     0,     0,     0,   780,   780,  1403,     0,     0,  1645,
       0,   758,  1646,     0,     0,   780,  1793,     0,     0,     0,
     758,     0,     0,     0,  1793,  1403,     0,   780,   780,  1647,
       0,     0,     0,     0,     0,     0,     0,  1649,     0,   780,
       0,     0,     0,  1650,     0,  1403,     0,     0,     0,     0,
       0,     0,     0,  1645,     0,     0,  1646,     0,     0,     0,
       0,     0,     0,     0,     0,  1661,     0,  1651,     0,     0,
    1403,     0,     0,  1647,     0,     0,  3461,     0,     0,     0,
       0,  1649,     0,     0,     0,     0,     0,  1650,     0,     0,
       0,  1665,  1666,  1667,  1668,  1669,  1670,  4028,     0,  2499,
    2500,     0,     0,     0,  2503,  2504,     0,     0,  2507,     0,
       0,  1651,     0,     0,     0,     0,     0,     0,  2517,     0,
       0,     0,     0,     0,     0,  2526,     0,  1403,     0,  2529,
    2530,     0,  1404,  2533,  2534,     0,     0,     0,     0,     0,
    2539,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2555,     0,  2557,  1662,  1663,  1664,     0,  1665,
    1666,  1667,  1668,  1669,  1670,     0,     0,     0,  1652,     0,
    2579,     0,  1653,     0,     0,  2581,     0,     0,  1795,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1098,  1654,  1655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2599,  2600,  2603,  2605,
    1656,     0,  1652,  2612,  2615,     0,  1653,     0,     0,     0,
       0,  2626,  1155,     0,  2630,     0,     0,     0,  2634,     0,
       0,  1645,     0,     0,  1646,     0,  1657,  1654,  1655,  1658,
    2590,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2662,  1647,  1659,     0,  1656,  1660,     0,     0,     0,  1649,
       0,  2669,     0,  2671,     0,  1650,     0,     0,  2674,     0,
       0,     0,     0,  2678,  2679,  2680,  2681,     0,  2683,     0,
    1657,     0,     0,  1658,     0,     0,     0,     0,     0,  1651,
       0,  2707,  2708,  2709,     0,     0,  1659,     0,     0,  1660,
       0,     0,  2717,  2718,  1403,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1661,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2590,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3411,     0,     0,     0,     0,
       0,     0,     0,  1404,     0,     0,  2775,     0,     0,     0,
       0,     0,     0,  1661,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,  1795,   780,
    1652,     0,   780,  1404,  1653,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,  1654,  1655,     0,     0,  1662,
    1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,  1670,     0,
       0,  1404,  1656,     0,     0,  1404,  1404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   780,     0,     0,  1657,     0,
       0,  1658,     0,  1662,  1663,  1664,     0,  1665,  1666,  1667,
    1668,  1669,  1670,     0,  1659,     0,     0,  1660,     0,     0,
       0,     0,   780,   780,     0,  1808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1795,   780,     0,  1795,     0,
       0,  4028,     0,  2897,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   780,     0,     0,     0,   780,     0,     0,     0,     0,
       0,  1583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1661,     0,   780,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   780,     0,     0,     0,     0,     0,     0,
    1607,     0,     0,     0,     0,     0,   780,     0,     0,   523,
       0,     0,     0,     0,     0,   780,     0,     0,     0,     0,
       0,   524,     0,     0,     0,     0,     0,     0,  1632,  1633,
    1403,  1635,     0,     0,     0,  1403,  1403,     0,     0,     0,
       0,     0,   525,     0,     0,     0,     0,  1403,  1675,     0,
       0,     0,     0,     0,     0,   526,     0,     0,     0,     0,
       0,     0,     0,     0,   527,     0,     0,     0,  -720,     0,
       0,  1662,  1663,  1664,     0,  1665,  1666,  1667,  1668,  1669,
    1670,  1795,     0,     0,     0,   528,     0,  1711,     0,     0,
       0,   529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   530,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,   531,   569,     0,
    1827,  1830,     0,     0,     0,   532,     0,     0,     0,     0,
     570,     0,  3052,     0,     0,     0,   533,     0,     0,     0,
       0,     0,   780,   534,     0,     0,     0,   535,     0,     0,
       0,   571,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -915,     0,   572,     0,     0,     0,     0,     0,
    3081,  3082,     0,     0,     0,     0,   780,   573,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1808,  1403,     0,
       0,     0,     0,     0,   574,     0,  1672,     0,     0,     0,
       0,   536,     0,     0,     0,     0,     0,     0,  -485,     0,
       0,   780,  3104,     0,     0,   575,     0,     0,     0,     0,
       0,  3108,     0,     0,     0,     0,   576,     0,     0,     0,
       0,     0,     0,     0,   577,   780,  3119,  3121,     0,   537,
       0,  3121,   538,     0,     0,   578,  3132,  3133,  3134,     0,
     579,     0,     0,  1672,     0,     0,   580,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1403,     0,     0,
       0,   581,     0,     0,     0,     0,  -381,     0,     0,     0,
       0,     0,  3155,  3156,  3157,  3158,     0,     0,     0,     0,
       0,     0,     0,     0,   539,     0,     0,     0,     0,     0,
     540,     0,     0,     0,     0,     0,  -381,     0,     0,   541,
       0,     0,  3174,  3175,  3176,     0,     0,   582,     0,  1795,
       0,     0,  3189,     0,     0,  1795,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -381,     0,   542,   543,     0,
     544,   545,     0,     0,     0,     0,     0,     0,   583,   546,
       0,  1403,     0,     0,   547,     0,     0,     0,   584,     0,
     548,     0,     0,   549,     0,     0,   550,     0,     0,     0,
       0,   177,     0,     0,     0,     0,   192,     0,     0,  -381,
       0,     0,     0,     0,     0,     0,  3228,     0,     0,     0,
       0,     0,     0,     0,  3232,     0,     0,     0,     0,     0,
       0,     0,     0,   585,     0,   780,     0,   586,     0,   587,
       0,     0,     0,     0,     0,   588,     0,   178,   589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     179,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   590,     0,   591,   180,     0,     0,
     592,  3304,     0,   181,     0,   780,     0,     0,   593,     0,
       0,     0,     0,   594,     0,     0,     0,     0,   182,     0,
     780,   780,     0,     0,     0,   595,     0,     0,     0,   183,
       0,     0,     0,     0,     0,     0,     0,   184,   596,     0,
       0,     0,     0,  3332,     0,     0,  3335,   780,   185,     0,
     780,     0,     0,   186,     0,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,     0,     0,     0,  3373,     0,
       0,  2307,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3383,     0,     0,     0,     0,     0,     0,   189,
       0,     0,  1808,     0,  2330,     0,     0,  2332,     0,     0,
    2343,     0,     0,     0,     0,     0,     0,  2350,  2355,     0,
     190,     0,     0,  2361,     0,     0,  2366,  1795,  1795,  1795,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,  2375,     0,     0,   780,     0,  2382,     0,
       0,   191,  2394,  1672,     0,     0,  2401,   780,  2403,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,  2411,   780,  2412,     0,
       0,     0,     0,  1098,     0,  2437,     0,     0,     0,   192,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,     0,     0,     0,
     194,     0,   195,     0,     0,     0,     0,     0,   196,     0,
       0,   197,     0,  1403,  1403,     0,  1403,     0,     0,   780,
       0,  1672,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   198,     0,   199,
       0,     0,     0,   200,     0,  1672,     0,     0,     0,     0,
    2339,   201,     0,     0,     0,     0,   202,     0,     0,     0,
       0,  1795,     0,  1397,     0,     0,     0,     0,   203,     0,
    1672,  1672,  1403,  1672,  1403,     0,   780,     0,   780,     0,
       0,   204,     0,     0,     0,     0,     0,     0,     0,     0,
     780,  1155,   780,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1249,     0,     0,     0,     0,     0,
    1250,     0,     0,  1672,  3577,     0,  3578,     0,  1398,     0,
       0,     0,     0,  3580,     0,     0,     0,     0,  1403,     0,
       0,     0,     0,     0,     0,  1288,     0,     0,     0,  3589,
       0,   780,     0,     0,     0,     0,     0,     0,     0,  1672,
    1251,     0,     0,  1403,     0,     0,  3597,     0,     0,     0,
       0,     0,     0,     0,     0,  3608,     0,     0,     0,   780,
       0,     0,  1403,  2531,     0,     0,     0,     0,     0,     0,
       0,  1289,     0,   780,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,  1252,
     780,     0,     0,   780,     0,     0,  1253,     0,     0,  1254,
       0,  3640,  3641,  3642,  3643,  3644,  3645,  3646,  3647,     0,
       0,     0,     0,  3654,  3655,     0,  3657,  3658,  3659,  3660,
    3661,  3662,  3663,     0,     0,     0,     0,     0,     0,     0,
       0,  3671,     0,  3673,  3674,     0,     0,     0,     0,     0,
    1398,     0,     0,  1672,  1403,     0,     0,     0,  1397,  1290,
       0,     0,  1255,     0,     0,  1672,     0,     0,  1672,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,  1795,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3717,  3719,  3721,
       0,     0,  3724,     0,     0,     0,     0,  1291,     0,  1292,
       0,     0,  1397,     0,     0,     0,     0,     0,     0,  1293,
       0,  1257,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,  1258,     0,     0,     0,     0,     0,     0,     0,  1259,
       0,     0,     0,     0,  1397,     0,     0,  1294,  1260,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2663,     0,  3121,  2747,  1262,  1296,     0,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,     0,     0,     0,
    1808,  1808,  1808,     0,     0,     0,     0,     0,     0,     0,
    2664,     0,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,  1298,     0,     0,   780,     0,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,  1397,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,     0,     0,     0,     0,
       0,  1400,     0,  1795,     0,     0,     0,  1795,  1264,  1795,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,  2872,   780,     0,
       0,   780,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,  1397,     0,     0,
       0,     0,     0,     0,     0,  1795,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2918,     0,     0,     0,     0,  2924,  1403,     0,     0,     0,
       0,     0,     0,  1398,  3909,  3910,  3911,  3912,     0,     0,
       0,     0,   780,   780,     0,     0,     0,     0,     0,   780,
       0,     0,  1398,     0,  1401,     0,     0,     0,  3924,  3925,
    3926,  3927,     0,  3929,  3930,     0,     0,  2355,     0,  2355,
    2355,     0,  1398,     0,     0,  3939,  3940,     0,     0,     0,
    2981,     0,     0,  2984,     0,  2986,  1400,     0,     0,     0,
       0,     0,  1808,  1808,     0,  1808,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3007,     0,  3009,     0,     0,     0,  3012,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1400,     0,     0,     0,  1397,     0,     0,  2437,  2437,  2437,
       0,     0,     0,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3050,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,  1403,  1672,  1815,     0,     0,     0,
       0,  3061,     0,     0,  3994,     0,  1401,  1830,     0,     0,
       0,     0,     0,  4000,     0,     0,     0,     0,  1672,     0,
    1672,     0,  2339,  2339,  2955,     0,     0,  2339,     0,     0,
    1403,  1672,     0,  4019,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,  1672,     0,     0,     0,     0,     0,  1672,
       0,     0,  3090,     0,  1672,  4036,     0,     0,     0,     0,
       0,     0,     0,  1672,  1400,     0,     0,  2339,  2339,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,  1400,     0,     0,     0,     0,     0,  1672,
       0,  1672,  1672,  1672,  1672,  1672,  1672,  1672,  1672,  1672,
    1672,     0,     0,  1400,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1808,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,  1400,  1808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1403,
       0,     0,     0,     0,     0,     0,     0,     0,  1795,     0,
    1403,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     780,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1401,     0,     0,     0,  4121,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   780,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,  1403,     0,     0,
    1397,     0,     0,     0,     0,  1397,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1397,     0,     0,
       0,     0,     0,     0,     0,  1403,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,  3121,     0,     0,     0,     0,
       0,  1403,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,  1402,
       0,     0,     0,     0,     0,     0,     0,  1403,     0,   780,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1401,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4237,     0,     0,     0,     0,  4241,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,     0,     0,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1397,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,   780,     0,   780,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,  1398,  1398,     0,  3412,     0,     0,     0,     0,
       0,     0,  3121,     0,  1398,  3416,     0,     0,     0,     0,
       0,  3417,     0,  3418,     0,     0,     0,  1808,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1403,     0,  3436,  3437,  1397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1795,     0,   780,     0,     0,     0,  2361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3465,     0,     0,  3468,
       0,  3470,     0,     0,  1402,     0,     0,  4343,     0,     0,
    3474,     0,  4347,     0,     0,     0,  3479,     0,     0,  3482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3515,     0,     0,     0,     0,     0,     0,     0,  3527,     0,
    2437,  1397,     0,     0,     0,     0,     0,     0,  1402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,  3541,     0,     0,  1398,  1672,     0,  1098,     0,
       0,     0,  1672,     0,  1155,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,  2955,  2955,
       0,  2339,     0,     0,  2339,  2339,  2339,  2339,  2339,  2339,
    2339,  2339,  2339,  2339,  2955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,  1400,     0,
    1795,     0,     0,  1400,  1400,     0,     0,     0,     0,  1672,
       0,     0,  1672,     0,  1672,  1400,     0,     0,     0,  2955,
    2955,     0,     0,     0,  1398,     0,     0,     0,     0,     0,
       0,     0,  1402,  2339,  2339,  1672,     0,  1672,     0,     0,
    1672,     0,     0,  1403,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1403,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
       0,     0,     0,     0,  1403,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1403,     0,     0,     0,  1403,  1403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   780,     0,
       0,     0,     0,  1402,     0,     0,  1400,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3777,
    3778,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,  1397,  1397,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1795,  3807,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,  1401,  1401,
       0,     0,  1397,     0,  1397,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,  2339,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,  1795,  3825,  3827,     0,     0,     0,     0,
       0,  1795,     0,     0,     0,     0,     0,  3834,     0,     0,
       0,     0,     0,  3839,  3840,     0,     0,  3842,  1397,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,  1398,  2437,
       0,     0,     0,     0,  2437,     0,     0,     0,     0,     0,
       0,     0,  1397,     0,     0,     0,  2437,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,  1398,     0,  1398,     0,     0,     0,  3890,     0,     0,
    1672,     0,     0,     0,  1672,  1672,  1672,     0,     0,  2955,
       0,  1401,     0,     0,  2955,  2955,  2955,  2955,  2955,  2955,
    2955,  2955,  2955,  2955,  1672,  1672,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,     0,  1398,
       0,  1398,     0,  1672,  2339,  2339,  1672,     0,  1672,     0,
    1397,     0,  1672,  2955,  2955,     0,     0,  1672,     0,     0,
    1672,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1672,     0,  1398,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1672,
    1398,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,     0,     0,     0,  3980,  1400,
    1397,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,  1402,     0,     0,     0,
       0,  1402,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,  1400,  1402,  1400,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
    1400,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4062,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4079,     0,     0,     0,     0,     0,
       0,     0,     0,  2955,     0,     0,  1400,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,     0,     0,  1402,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1400,     0,     0,     0,     0,  1672,  1672,     0,     0,     0,
       0,     0,  1398,     0,     0,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,     0,     0,     0,  2339,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,  1672,     0,  1672,     0,     0,     0,     0,
    2955,  2955,  1672,  1402,     0,  2339,  2339,  1672,  1672,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,  2361,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,  1401,     0,  1401,
       0,     0,     0,  4212,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,  1401,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
    1397,     0,     0,  1398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1400,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4283,  1401,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2955,  2339,     0,     0,  1401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2955,  2955,
    1672,     0,     0,     0,     0,  1401,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1672,     0,     0,
       0,     0,     0,  1401,     0,  4324,     0,     0,     0,  1397,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4369,  4369,
       0,     0,     0,  1401,     0,     0,     0,  1398,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1400,     0,     0,  1402,     0,     0,
    2955,     0,     0,     0,     0,     0,     0,  1397,     0,     0,
    1672,     0,  4369,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4417,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1397,     0,     0,     0,  1402,
    1402,     0,  1402,  1401,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1398,     0,     0,     0,
       0,  1672,     0,     0,  4369,     0,     0,  1398,  1401,     0,
       0,     0,     0,     0,     0,     0,     0,  1397,  1402,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1672,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1402,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1672,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1400,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1398,     0,     0,     0,  1402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1672,  1402,     0,     0,     0,
       0,     0,  1398,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,     0,  1397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,  1398,     0,     0,  1400,     0,  1401,
       0,     0,     0,     0,     0,     0,  1402,     0,  1400,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1397,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,     0,     0,  1400,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1400,
       0,     0,     0,  1397,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,  1397,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,  1397,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1398,     0,
       0,     0,  1397,     0,     0,     0,  1397,  1397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1401,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1401,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1402,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1398,  1400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1398,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1401,  1398,
       0,     0,     0,  1398,  1398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,  1400,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1400,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1402,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,     0,
    1400,     0,     0,     0,  1400,  1400,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1401,     0,     0,     0,  1401,
    1401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1402,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1402,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,  2431,   217,   218,   219,     0,  1402,     0,
       0,  1021,  1402,  1402,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,  2432,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,  2433,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,  2434,     0,     0,     0,     0,
       0,     0,  1085,  2435,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,   207,     0,     0,     0,     0,
       0,     0,  1085,  2341,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,  3495,     0,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,     0,
       0,   246,   247,   248,   249,     0,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0, -1466,   258,   259,     0,
       0,     0,     0,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,     0,     0, -1466,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,     0,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324, -1466,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,     0,     0,   334, -1466,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343, -1466,
     344,     0,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361, -1466,   362,   363,   364,   365,     0,   366,   367,
       0,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,     0,
       0,     0,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420, -1466,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
       0,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,     0,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1162,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,     0,  1372,   733,  1373,  1374,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,  1375,  1376,
     240,     0,   241,   242,   243,   244,     0,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,  1377,  1378,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,     0,   294,   295,   296,
       0,     0,   298,     0,   299,  1379,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,     0,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,  1939,   318,   319,   320,   321,   322,   323,     0,
     324,   741,  1940,   326,   327,   328,   329,  1380,  1381,     0,
    1382,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,     0,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1383,   747,  1384,   363,   364,     0,     0,   366,   367,   748,
     368,     0,     0,   370,  1385,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,  1941,   749,   750,
     751,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   390,     0,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1386,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,     0,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,  1942,   439,   440,   753,
     441,  1388,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,     0,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1389,  1390,     0,     0,
     465,     0,   467,     0,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,     0,  1391,  1943,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,     0,  1371,     0,     0,     0,     0,
       0,     0,     0,   507,   508,   509,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,  1944,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,     0,  1372,   733,  1373,  1374,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,  1375,
    1376,   240,     0,   241,   242,   243,   244,     0,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,  1377,  1378,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,     0,   294,   295,
     296,     0,     0,   298,     0,   299,  1379,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
       0,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,  1939,   318,   319,   320,   321,   322,   323,
       0,   324,   741,  1940,   326,   327,   328,   329,  1380,  1381,
       0,  1382,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,     0,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1383,   747,  1384,   363,   364,     0,     0,   366,   367,
     748,   368,     0,     0,   370,  1385,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,  1941,   749,
     750,   751,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   390,     0,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1386,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
       0,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,  1942,   439,   440,
     753,   441,  1388,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,  1389,  1390,     0,
       0,   465,     0,   467,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,     0,  1391,  1943,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,     0,   731,  1016,   564,  1017,
    1018,  1019,   615,  1020,   507,   508,   509,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,  1021,  2836,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,  1022,   733,  1023,  1024,
    2351,   231,   232,   233,   234,   235,  1025,  1026,   236,   237,
    1027,  1028,   240,     0,   241,   242,   243,   244,  1029,     0,
    1030,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,
     263,   264,   265,  1038,  1039,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,  1041,   294,
     295,   296,  1042,  1043,   298,     0,   299,  1044,   301,     0,
     302,     0,   303,   738,  2352,   739,   304,   305,   306,     0,
     307,  1045,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,  1046,
    1047,     0,  1048,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,  2353,   342,  1049,
     745,   344,   746,     0,   345,   346,   347,  1050,  1051,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1052,   747,  1053,   363,   364,   365,  1054,   366,
     367,   748,   368,  1055,  1056,   370,  1057,   372,   373,   374,
       0,   375,     0,     0,  1058,   377,   378,     0,     0,   379,
     749,   750,   751,  1059,   381,   382,   383,   384,   385,   386,
     387,     0,   388,  1060,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1061,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,  1062,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,  1063,   437,   438,   439,
     440,   753,   441,  1064,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,  1065,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1066,  1067,
       0,  2354,   465,  1068,   467,  1069,  1070,   469,   470,   471,
     472,   473,   474,   475,     0,  1071,   476,   477,   478,   479,
     480,  1072,     0,   481,   482,   483,   484,   485,   486,  1073,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,
       0,     0,     0,     0,     0,  1082,  1083,     0,     0,     0,
       0,     0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,
    1019,   615,  1020,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,  1021,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,  1022,   733,  1023,  1024,     0,
     231,   232,   233,   234,   235,  1025,  1026,   236,   237,  1027,
    1028,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,  1038,  1039,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,  1041,   294,   295,
     296,  1042,  1043,   298,     0,   299,  1044,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,  1046,  1047,
       0,  1048,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1052,   747,  1053,   363,   364,   365,  1054,   366,   367,
     748,   368,  1055,  1056,   370,  1057,   372,   373,   374,     0,
     375,     0,     0,  1058,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1061,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
    1062,   424,   425,   426,   427,   428,   429,   430,   431,    38,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,  1064,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,    42,
     457,   458,   459,   460,   461,   462,     0,  1066,  1067,     0,
       0,   465,  1068,   467,  1069,  1070,   469,   470,   471,   472,
     473,   474,   475,     0,  1071,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   955,  1073,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,    47,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1082,  1083,     0,     0,     0,     0,
       0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,     0,     0,     0,     0,     0,
    1578,  2299,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,
    1020,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
    1021,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,  1022,   733,  1023,  1024,     0,   231,   232,
     233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
    1038,  1039,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,  1040,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,  1041,   294,   295,   296,  1042,
    1043,   298,     0,   299,  1044,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,  1046,  1047,     0,  1048,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1052,
     747,  1053,   363,   364,   365,  1054,   366,   367,   748,   368,
    1055,  1056,   370,  1057,   372,   373,   374,     0,   375,     0,
       0,  1058,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,  1061,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,  1062,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
    1064,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,  1066,  1067,     0,     0,   465,
    1068,   467,  1069,  1070,   469,   470,   471,   472,   473,   474,
     475,     0,  1071,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,  1073,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,     0,  1082,  1083,  1084,     0,     0,     0,     0,     0,
       0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,   231,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,  1154,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,  1054,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
    1058,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,  1071,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
       0,  1082,  1083,     0,     0,     0,     0,     0,     0,     0,
    1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
    1825,   217,   218,   219,     0,     0,     0,     0,  1021,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
     227,  1022,   733,  1023,  1024,     0,   231,   232,   233,   234,
     235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,  1038,  1039,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,  1041,   294,   295,   296,  1042,  1043,   298,
       0,   299,  1044,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,  1046,  1047,     0,  1048,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,   746,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1052,   747,  1053,
     363,   364,   365,  1054,   366,   367,   748,   368,  1055,  1056,
     370,  1057,   372,   373,   374,     0,   375,     0,     0,  1058,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1061,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,  1062,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,   753,   441,  1064,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1066,  1067,     0,     0,   465,  1068,   467,
    1069,  1070,   469,   470,   471,   472,   473,   474,   475,     0,
    1071,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,  1073,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,     0,
    1082,  1083,     0,     0,     0,     0,     0,     0,     0,  1085,
     731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,  1021,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
    1022,   733,  1023,  1024,     0,   231,   232,   233,   234,   235,
    1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,   242,
     243,   244,  1029,     0,  1030,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   260,   261,   262,   263,   264,   265,  1038,  1039,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,  1041,   294,   295,   296,  1042,  1043,   298,     0,
     299,  1044,   301,     0,   302,     0,   303,   738,  2352,   739,
     304,   305,   306,     0,   307,  1045,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,  1046,  1047,     0,  1048,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,  1049,   745,   344,   746,     0,   345,   346,
     347,  1050,  1051,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1052,   747,  1053,   363,
     364,   365,  1054,   366,   367,   748,   368,  1055,  1056,   370,
    1057,   372,   373,   374,     0,   375,     0,     0,  1058,   377,
     378,     0,     0,   379,   749,   750,   751,  1059,   381,   382,
     383,   384,   385,   386,   387,     0,   388,  1060,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1061,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,  1062,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
    1063,   437,   438,   439,   440,   753,   441,  1064,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
    1065,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,
    1070,   469,   470,   471,   472,   473,   474,   475,     0,  1071,
     476,   477,   478,   479,   480,  1072,     0,   481,   482,   483,
     484,   485,   486,  1073,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,
     508,   509,     0,     0,     0,     0,     0,     0,     0,  1082,
    1083,     0,     0,     0,     0,     0,     0,     0,  1085,   731,
    1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,  1021,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,   227,  1022,
     733,  1023,  1024,     0,   231,   232,   233,   234,   235,  1025,
    1026,   236,   237,  1027,  1028,   240,     0,   241,   242,   243,
     244,  1029,     0,  1030,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
     260,   261,   262,   263,   264,   265,  1038,  1039,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,  1040,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,  1041,   294,   295,   296,  1042,  1043,   298,     0,   299,
    1044,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,  1045,     0,   309,     0,   310,   311,
     312,   313,   314,   740,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,  1046,  1047,     0,  1048,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,  1049,   745,   344,   746,     0,   345,   346,   347,
    1050,  1051,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1052,   747,  1053,   363,   364,
     365,  1054,   366,   367,   748,   368,  1055,  1056,   370,  1057,
     372,   373,   374,     0,   375,     0,     0,  1058,   377,   378,
       0,     0,   379,   749,   750,   751,  1059,   381,   382,   383,
     384,   385,   386,   387,     0,   388,  1060,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,  1061,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,  1062,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,  1063,
     437,   438,   439,   440,   753,   441,  1064,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,  1065,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,
     469,   470,   471,   472,   473,   474,   475,     0,  1071,   476,
     477,   478,   479,   480,  1072,     0,   481,   482,   483,   484,
     485,   486,  1073,  3530,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,
     509,     0,     0,     0,     0,     0,     0,     0,  1082,  1083,
       0,     0,     0,     0,     0,     0,     0,  1085,   731,  1016,
     564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,  1021,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,  1022,   733,
    1023,  1024,     0,   231,   232,   233,   234,   235,  1025,  1026,
     236,   237,  1027,  1028,   240,     0,   241,   242,   243,   244,
    1029,     0,  1030,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,
     261,   262,   263,   264,   265,  1038,  1039,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
    1041,   294,   295,   296,  1042,  1043,   298,     0,   299,  1044,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,  1045,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,  1046,  1047,     0,  1048,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,  1049,   745,   344,   746,     0,   345,   346,   347,  1050,
    1051,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1052,   747,  1053,   363,   364,   365,
    1054,   366,   367,   748,   368,  1055,  1056,   370,  1057,   372,
     373,   374,     0,   375,     0,     0,  1058,   377,   378,     0,
       0,   379,   749,   750,   751,  1059,   381,   382,   383,   384,
     385,   386,   387,     0,   388,  1060,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1061,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,  1062,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,  1063,   437,
     438,   439,   440,   753,   441,  1064,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,  1065,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,   469,
     470,   471,   472,   473,   474,   475,     0,  1071,   476,   477,
     478,   479,   480,  1072,     0,   481,   482,   483,   484,   485,
     486,  1073,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,
       0,     0,     0,     0,     0,     0,     0,  1082,  1083,     0,
       0,     0,     0,     0,     0,     0,  1085,   731,  1016,   564,
    1017,  1018,  1019,   615,  1020,     0,     0,     0,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,  1021,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,  1022,   733,  1023,
    1024,     0,   231,   232,   233,   234,   235,  1025,  1026,   236,
     237,  1027,  1028,   240,     0,   241,   242,   243,   244,  1029,
       0,  1030,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
    3540,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,
     262,   263,   264,   265,  1038,  1039,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,  1040,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,  1041,
     294,   295,   296,  1042,  1043,   298,     0,   299,  1044,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,  1045,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
    1046,  1047,     0,  1048,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
    1049,   745,   344,   746,     0,   345,   346,   347,  1050,  1051,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,  1052,   747,  1053,   363,   364,   365,  1054,
     366,   367,   748,   368,  1055,  1056,   370,  1057,   372,   373,
     374,     0,   375,     0,     0,  1058,   377,   378,     0,     0,
     379,   749,   750,   751,  1059,   381,   382,   383,   384,   385,
     386,   387,     0,   388,  1060,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,  1061,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,  1062,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,  1063,   437,   438,
     439,   440,   753,   441,  1064,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,  1065,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,  1066,
    1067,     0,     0,   465,  1068,   467,  1069,  1070,   469,   470,
     471,   472,   473,   474,   475,     0,  1071,   476,   477,   478,
     479,   480,  1072,     0,   481,   482,   483,   484,   485,   486,
    1073,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,   498,  1074,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,
       0,     0,     0,     0,     0,     0,  1082,  1083,     0,     0,
       0,     0,     0,     0,     0,  1085,   731,  1016,   564,  1017,
    1018,  1019,   615,  1020,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,  1021,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,  1022,   733,  1023,  1024,
       0,   231,   232,   233,   234,   235,  1025,  1026,   236,   237,
    1027,  1028,   240,     0,   241,   242,   243,   244,  1029,     0,
    1030,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,
     263,   264,   265,  1038,  1039,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,  1041,   294,
     295,   296,  1042,  1043,   298,     0,   299,  1044,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,  1045,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,  1046,
    1047,     0,  1048,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,  1049,
     745,   344,   746,     0,   345,   346,   347,  1050,  1051,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1052,   747,  1053,   363,   364,   365,  1054,   366,
     367,   748,   368,  1055,  1056,   370,  1057,   372,   373,   374,
       0,   375,     0,     0,  1058,   377,   378,     0,     0,   379,
     749,   750,   751,  1059,   381,   382,   383,   384,   385,   386,
     387,     0,   388,  1060,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1061,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,  1062,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,  1063,   437,   438,   439,
     440,   753,   441,  1064,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,  1065,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1066,  1067,
       0,     0,   465,  1068,   467,  1069,  1070,   469,   470,   471,
     472,   473,   474,   475,     0,  1071,   476,   477,   478,   479,
     480,  1072,     0,   481,   482,   483,   484,   485,   486,  1073,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,  3817,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,
       0,     0,     0,     0,     0,  1082,  1083,     0,     0,     0,
       0,     0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,
    1019,   615,  1020,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,  1021,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,  1022,   733,  1023,  1024,     0,
     231,   232,   233,   234,   235,  1025,  1026,   236,   237,  1027,
    1028,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,  1038,  1039,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,  1041,   294,   295,
     296,  1042,  1043,   298,     0,   299,  1044,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,  1046,  1047,
       0,  1048,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1052,   747,  1053,   363,  3826,   365,  1054,   366,   367,
     748,   368,  1055,  1056,   370,  1057,   372,   373,   374,     0,
     375,     0,     0,  1058,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1061,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
    1062,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,  1064,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,  1066,  1067,     0,
       0,   465,  1068,   467,  1069,  1070,   469,   470,   471,   472,
     473,   474,   475,     0,  1071,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   486,  1073,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,     0,  1082,  1083,     0,     0,     0,     0,
       0,     0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,  4366,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,  4367,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,  1054,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,  1058,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,  4368,
     474,   475,     0,  1071,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,     0,  1082,  1083,     0,     0,     0,     0,     0,
       0,     0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,
    1020,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
    1021,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,  1022,   733,  1023,  1024,     0,   231,   232,
     233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,  4367,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
    1038,  1039,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,  1040,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,  1041,   294,   295,   296,  1042,
    1043,   298,     0,   299,  1044,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,  1046,  1047,     0,  1048,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1052,
     747,  1053,   363,   364,   365,  1054,   366,   367,   748,   368,
    1055,  1056,   370,  1057,   372,   373,   374,     0,   375,     0,
       0,  1058,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,  1061,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,  1062,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
    1064,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,  1066,  1067,     0,     0,   465,
    1068,   467,  1069,  1070,   469,   470,   471,   472,  4368,   474,
     475,     0,  1071,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,  1073,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,     0,  1082,  1083,     0,     0,     0,     0,     0,     0,
       0,  1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,   231,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,     0,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
    1058,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
       0,  2334,  2335,     0,     0,     0,     0,     0,     0,     0,
    1085,   731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,  1021,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
   -2225,  1022,   733,  1023,  1024,     0,   231,   232,   233,   234,
     235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,  4367,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,  1038,  1039,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,  1041,   294,   295,   296,  1042,  1043,   298,
       0,   299,  1044,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,  1046,  1047,     0,  1048,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,     0,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1052,   747,  1053,
     363,   364,   365,     0,   366,   367,   748,   368,  1055,  1056,
     370,  1057,   372,   373,   374,     0,   375,     0,     0,  1058,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1061,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,  1062,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,     0,   441,  1064,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1066,  1067,     0,     0,   465,  1068,   467,
    1069,  1070,   469,   470,   471,   472,  4368,   474,   475,     0,
    1071,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,  1073,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,     0,
    1082,  1083,     0,     0,   731,  1016,   564,  1017,  1018,  1085,
     615,  1020,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,  1021,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,  1022,   733,  1023,  1024,     0,   231,
     232,   233,   234,   235,  1025,  1026,   236,   237,  1027,  1028,
     240,     0,   241,   242,   243,   244,  1029,     0,  1030,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,
     265,  1038,  1039,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
    1040,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,  1041,   294,   295,   296,
    1042,  1043,   298,     0,   299,  1044,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,  1045,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,  1046,  1047,     0,
    1048,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,  1049,   745,   344,
     746,     0,   345,   346,   347,  1050,  1051,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
    1052,   747,  1053,   363,   364,   365,     0,   366,   367,   748,
     368,  1055,  1056,   370,  1057,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,  1059,   381,   382,   383,   384,   385,   386,   387,     0,
     388,  1060,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,  1061,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,  1062,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,  1063,   437,   438,   439,   440,   753,
     441,  1064,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,  1065,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,  1066,  1067,     0,     0,
     465,  1068,   467,  1069,  1070,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,  1072,
       0,   481,   482,   483,   484,   485,   486,  1073,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,   507,   508,   509,     0,     0,     0,     0,
       0,     0,   731,  1016,   564,  1017,  1018,     0,   615,  1020,
       0,     0,  1085,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,  1021,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,  1022,   733,  1023,  1024,     0,  3449,   232,   233,
     234,   235,  1025,  1026,   236,   237,  1027,  1028,   240,     0,
     241,   242,   243,   244,  1029,     0,  1030,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,   260,   261,   262,   263,   264,   265,  1038,
    1039,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,  1041,   294,   295,   296,  1042,  1043,
     298,     0,   299,  1044,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,  1045,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,  1046,  1047,     0,  1048,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,  1049,   745,   344,   746,     0,
     345,   346,   347,  1050,  1051,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1052,   747,
    1053,   363,   364,   365,     0,   366,   367,   748,   368,  1055,
    1056,   370,  1057,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,  1059,
     381,   382,   383,   384,   385,   386,   387,     0,   388,  1060,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1061,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,  1062,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,  1063,   437,   438,   439,   440,   753,   441,  1064,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,  1065,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1066,  1067,     0,     0,   465,  1068,
     467,  1069,  1070,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,  1072,     0,   481,
     482,   483,   484,   485,   486,  1073,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,   507,   508,   509,     0,     0,     0,     0,     0,     0,
     731,  1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,
    1085,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,  1021,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1022,   733,  1023,  1024,     0,   231,   232,   233,   234,   235,
    1025,  1026,   236,   237,  1027,  1028,   240,     0,   241,   242,
     243,   244,  1029,     0,  1030,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,   260,   261,   262,   263,   264,   265,  1038,  1039,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,     0,   288,     0,   289,   290,
     291,   292,  1041,   294,   295,   296,  1042,  1043,   298,     0,
     299,  1044,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,  1045,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,  1046,  1047,     0,  1048,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,  1049,   745,   344,     0,     0,   345,   346,
     347,  1050,  1051,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1052,   747,  1053,   363,
     364,   365,     0,   366,   367,   748,   368,  1055,  1056,   370,
    1057,   372,   373,   374,     0,   375,     0,     0,  1058,   377,
     378,     0,     0,   379,   749,   750,   751,  1059,   381,   382,
     383,   384,   385,   386,   387,     0,   388,  1060,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1061,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,  1062,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
    1063,   437,   438,   439,   440,     0,   441,  1064,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
    1065,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,
    1070,   469,   470,   471,   472,   473,   474,   475,     0,  1071,
     476,   477,   478,   479,   480,  1072,     0,   481,   482,   483,
     484,   485,   486,  1073,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,
     508,   509,     0,     0,     0,     0,     0,     0,     0,  1082,
    1083,     0,     0,     0,     0,     0,     0,     0,  1085,   731,
    1016,   564,  1017,  1018,  1019,   615,  1020,     0,     0,     0,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,  1021,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,     0,  1022,
     733,  1023,  1024,     0,   231,   232,   233,   234,   235,  1025,
    1026,   236,   237,  1027,  1028,   240,     0,   241,   242,   243,
     244,  1029,     0,  1030,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
     260,   261,   262,   263,   264,   265,  1038,  1039,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,  1040,   281,   282,     0,   283,
     284,   285,     0,   286,     0,   288,     0,   289,   290,   291,
     292,  1041,   294,   295,   296,  1042,  1043,   298,     0,   299,
    1044,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,  1045,     0,   309,     0,   310,   311,
     312,   313,   314,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,  1046,  1047,     0,  1048,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,  1049,   745,   344,     0,     0,   345,   346,   347,
    1050,  1051,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,  1052,   747,  1053,   363,   364,
     365,     0,   366,   367,   748,   368,  1055,  1056,   370,  1057,
     372,   373,   374,     0,   375,     0,     0,  1058,   377,   378,
       0,     0,   379,   749,   750,   751,  1059,   381,   382,   383,
     384,   385,   386,   387,     0,   388,  1060,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,  1061,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,  1062,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,  1063,
     437,   438,   439,   440,     0,   441,  1064,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,  1065,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,  1066,  1067,     0,     0,   465,  1068,   467,  1069,  1070,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,  1072,     0,   481,   482,   483,   484,
     485,   486,  1073,     0,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   731,  2334,  2335,
       0,     0,     0,     0,     0,     0,     0,  1085,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,   228,   733,   229,
     230,     0,   231,   232,   233,   234,   235,     0,  1026,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,  1029,
       0,  1030,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,  1031,  1032,  1033,  1034,  1035,  1036,  1037,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,  1042,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,  1045,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,  3023,   340,   341,     0,   342,
    1049,   745,   344,   746,     0,   345,   346,   347,  1050,  1051,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   747,   362,   363,   364,   365,     0,
     366,   367,   748,   368,     0,  1056,   370,   371,   372,   373,
     374,     0,   375,     0,   696,   376,   377,   378,     0,     0,
     379,   749,   750,   751,  1059,   381,   382,   383,   384,   385,
     386,   387,     0,   388,  1060,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    38,   432,   433,   434,   435,   436,  1063,   437,   438,
     439,   440,   753,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,  1065,     0,   455,
     456,    42,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,  1068,   467,  1069,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,  1072,     0,   481,   482,   483,   484,   485,   955,
     487,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,    47,   493,   494,   495,   496,   497,   498,  1074,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3024,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,   228,   733,   229,   230,     0,
     231,   232,   233,   234,   235,     0,  1026,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,  1029,     0,  1030,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,  1042,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
    1045,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,  3023,   340,   341,     0,   342,  1049,   745,
     344,   746,     0,   345,   346,   347,  1050,  1051,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   747,   362,   363,   364,   365,     0,   366,   367,
     748,   368,     0,  1056,   370,   371,   372,   373,   374,     0,
     375,     0,   696,   376,   377,   378,     0,     0,   379,   749,
     750,   751,  1059,   381,   382,   383,   384,   385,   386,   387,
       0,   388,  1060,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,  1063,   437,   438,   439,   440,
     753,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,  1065,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,  1068,   467,  1069,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
    1072,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,   507,   508,   509,     0,     0,     0,
       0,     0,     0,   731,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3024,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,   227,   228,   733,   229,   230,     0,   231,   232,
     233,   234,   235,     0,  1026,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,  1029,     0,  1030,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,  1042,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,  1045,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,  1049,   745,   344,   746,
       0,   345,   346,   347,  1050,  1051,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     747,   362,   363,   364,   365,     0,   366,   367,   748,   368,
       0,  1056,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,   749,   750,   751,
    1059,   381,   382,   383,   384,   385,   386,   387,     0,   388,
    1060,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,  1063,   437,   438,   439,   440,   753,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,  1065,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
    1068,   467,  1069,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,  1072,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,   507,   508,   509,     0,     0,     0,     0,     0,
       0,   731,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
     227,   228,   733,   229,   230,     0,   231,   232,   233,   234,
     235,     0,  1026,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,  1029,     0,  1030,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,  1042,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,  1045,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,  1049,   745,   344,   746,     0,   345,
     346,   347,  1050,  1051,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   747,   362,
     363,   364,   365,     0,   366,   367,   748,   368,     0,  1056,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,   749,   750,   751,  1059,   381,
     382,   383,   384,   385,   386,   387,     0,   388,  1060,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,  1063,   437,   438,   439,   440,   753,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,  1065,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,  1068,   467,
    1069,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,  1072,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     507,   508,   509,     0,     0,     0,     0,     0,     0,   775,
    1268,   564,     0,     0,     0,   615,     0,     0,     0,  3561,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,   732,   224,   225,   226,   227,   228,
     733,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,   734,     0,   246,   247,   248,   249,   735,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
     736,   258,   259,     0,     0,     0,   737,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,  1510,   298,     0,   299,
     300,   301,     0,   302,     0,   303,   738,     0,   739,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,   314,   740,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,   741,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,   742,   743,
     334,   744,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,   745,   344,   746,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   747,   362,   363,   364,
     365,     0,   366,   367,   748,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,  1511,     0,   376,   377,   378,
       0,     0,   379,   749,   750,   751,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,   752,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,   753,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,  1512,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   754,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   775,   627,  1269,
    3961,     0,     0,     0,     0,     0,     0,  3962,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       3,     4,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,   227,   228,   733,   229,
     230,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,   734,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,     0,     0,     0,   737,     0,     0,     0,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,   297,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,   308,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
     343,   745,   344,   746,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   747,   362,   363,   364,   365,     0,
     366,   367,   748,   368,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
     379,   749,   750,   751,   380,   381,   382,   383,   384,   385,
     386,   387,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,    38,   432,   433,   434,   435,   436,     0,   437,   438,
     439,   440,   753,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,    42,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,   466,   467,   468,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,   955,
     487,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,    47,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   731,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    48,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,   227,   228,   733,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   747,   362,   363,   364,   365,     0,   366,   367,
     748,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,   749,
     750,   751,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
     753,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4114,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,    38,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,    42,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   955,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,    47,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,     0,     0,
       0,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,   229,   230,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,     0,     0,   246,   247,   248,
     249,     0,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,     0,   258,   259,     0,     0,     0,     0,     0,
       0,     0,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,   297,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,     0,     0,
       0,   304,   305,   306,     0,   307,   308,     0,   309,     0,
     310,   311,   312,   313,   314,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
       0,     0,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,   343,     0,   344,     0,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,   365,     0,   366,   367,     0,   368,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,     0,     0,     0,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,   439,   440,     0,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,   466,   467,
     468,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,     0,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1138,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,     0,     0,   246,   247,   248,   249,     0,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
       0,   258,   259,     0,     0,     0,     0,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,     0,   298,     0,   299,
     300,   301,     0,   302,     0,   303,     0,     0,     0,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,   314,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,     0,     0,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,     0,   344,     0,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
     365,     0,   366,   367,     0,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,     0,   376,   377,   378,
       0,     0,   379,     0,     0,     0,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,     0,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,     0,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,     0,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2486,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,   229,
     230,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   244,   245,
       0,     0,     0,   246,   247,   248,   249,     0,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,     0,   258,
     259,     0,     0,     0,     0,     0,     0,     0,   260,   261,
     262,   263,   264,   265,   266,   267,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,   280,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,   293,
     294,   295,   296,   297,     0,   298,     0,   299,   300,   301,
       0,   302,     0,   303,     0,     0,     0,   304,   305,   306,
       0,   307,   308,     0,   309,     0,   310,   311,   312,   313,
     314,     0,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   326,   327,   328,   329,
     330,   331,     0,   332,     0,   333,     0,     0,   334,     0,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
     343,     0,   344,     0,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,     0,   362,   363,   364,   365,     0,
     366,   367,     0,   368,     0,   369,   370,   371,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
     379,     0,     0,     0,   380,   381,   382,   383,   384,   385,
     386,   387,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,     0,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,   438,
     439,   440,     0,   441,   442,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,   463,
     464,     0,     0,   465,   466,   467,   468,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,   486,
     487,     0,   488,     0,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,     0,
       0,     0,     0,     0,     0,   207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3524,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,   229,   230,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   244,   245,     0,     0,
       0,   246,   247,   248,   249,     0,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,     0,   258,   259,     0,
       0,     0,     0,     0,     0,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,   280,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,   298,     0,   299,   300,   301,     0,   302,
       0,   303,     0,     0,     0,   304,   305,   306,     0,   307,
     308,     0,   309,     0,   310,   311,   312,   313,   314,     0,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   326,   327,   328,   329,   330,   331,
       0,   332,     0,   333,     0,     0,   334,     0,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,   343,     0,
     344,     0,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,     0,   362,   363,   364,   365,     0,   366,   367,
       0,   368,     0,   369,   370,   371,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,   379,     0,
       0,     0,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,     0,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,   438,   439,   440,
       0,   441,   442,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,     0,   455,   456,     0,
     457,   458,   459,   460,   461,   462,     0,   463,   464,     0,
       0,   465,   466,   467,   468,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,   486,   487,     0,
     488,     0,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,     0,     0,     0,
       0,     0,     0,  1371,  1268,   564,     0,     0,   785,   615,
       0,     0,     0,  3863,   208,   209,   210,   211,   212,   213,
     214,   215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,   220,   221,  1721,   222,   223,   732,   224,
     225,   226,     0,  1372,   733,  1373,  1374,  1722,   231,   232,
     233,   234,   235,  1723,  1724,   236,   237,  1375,  1376,   240,
    1725,   241,   242,   243,   244,     0,  1726,   734,  1727,   246,
     247,   248,   249,   735,   250,   251,  1728,   252,   253,   254,
     255,   256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,
     737,  1733,  1734,  1735,   260,   261,   262,   263,   264,   265,
    1377,  1378,   268,  1736,   269,  1737,   270,   271,   272,   273,
     274,  1738,   275,   276,   277,  1739,  1740,   278,   279,  1040,
     281,   282,  1741,   283,   284,   285,  1742,   286,   287,   288,
    1743,   289,   290,   291,   292,     0,   294,   295,   296,     0,
    1744,   298,  1745,   299,  1379,   301,  1746,   302,  1747,   303,
     738,  1748,   739,   304,   305,   306,  1749,   307,     0,  1750,
     309,  1751,   310,   311,   312,   313,   314,   740,   315,   316,
     317,  1752,   318,   319,   320,   321,   322,   323,  1753,   324,
     741,     0,   326,   327,   328,   329,  1380,  1381,  1754,  1382,
    1755,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,  1756,   340,   341,  1757,   342,     0,   745,   344,   746,
    1758,   345,   346,   347,  1759,  1760,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,  1383,
     747,  1384,   363,   364,     0,  1761,   366,   367,   748,   368,
    1762,     0,   370,  1385,   372,   373,   374,  1763,   375,  1764,
    1765,  3248,   377,   378,  1766,  1767,     0,   749,   750,   751,
       0,   381,   382,   383,   384,   385,   386,   387,  1768,   388,
       0,   390,     0,   392,   393,   394,  1769,   395,   396,   397,
     398,   399,   400,   401,   402,  1386,   404,   405,   406,   407,
    1770,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,  1771,   419,   420,   752,   421,   422,     0,   424,
     425,   426,   427,   428,   429,   430,   431,  1772,   432,   433,
     434,   435,   436,  1773,   437,  1942,   439,   440,   753,   441,
    1388,   443,  1774,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,     0,  1775,   455,   456,  1776,   457,   458,
     459,   460,   461,   462,  1777,  1389,  1390,  1778,  1779,   465,
       0,   467,     0,  1780,   469,   470,   471,   472,   473,   474,
     475,  1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,
     481,   482,   483,   484,   485,     0,  1391,  1785,   488,   754,
     489,   490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,  3249,  3250,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   786,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   787,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   878,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   879,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   928,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   929,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   930,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,  1356,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,  1357,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,     0,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   207,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,  2552,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,  2553,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,   314,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,     0,     0,     0,   788,   789,
     790,     0,   791,   792,   793,   794,   795,   796,   207,     0,
       0,     0,     0,   785,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,  4097,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
       0,     0,  1712,   788,   789,   790,     0,   791,   792,   793,
     794,   795,   796,   208,   209,   210,   211,   212,   213,   214,
     215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,   220,   221,  1721,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,  1722,   231,   232,   233,
     234,   235,  1723,  1724,   236,   237,   238,   239,   240,  1725,
     241,   242,   243,   244,   245,  1726,   734,  1727,   246,   247,
     248,   249,   735,   250,   251,  1728,   252,   253,   254,   255,
     256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,   737,
    1733,  1734,  1735,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1736,   269,  1737,   270,   271,   272,   273,   274,
    1738,   275,   276,   277,  1739,  1740,   278,   279,   280,   281,
     282,  1741,   283,   284,   285,  1742,   286,   287,   288,  1743,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1744,
     298,  1745,   299,   300,   301,  1746,   302,  1747,   303,   738,
    1748,   739,   304,   305,   306,  1749,   307,   308,  1750,   309,
    1751,   310,   311,   312,   313,   314,   740,   315,   316,   317,
    1752,   318,   319,   320,   321,   322,   323,  1753,   324,   741,
     325,   326,   327,   328,   329,   330,   331,  1754,   332,  1755,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
    1756,   340,   341,  1757,   342,   343,   745,   344,   746,  1758,
     345,   346,   347,  1759,  1760,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,  1761,   366,   367,   748,   368,  1762,
     369,   370,   371,   372,   373,   374,  1763,   375,  1764,  1765,
     376,   377,   378,  1766,  1767,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,  1768,   388,   389,
     390,   391,   392,   393,   394,  1769,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,  1770,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,  1771,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,  1772,   432,   433,   434,
     435,   436,  1773,   437,   438,   439,   440,   753,   441,   442,
     443,  1774,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1775,   455,   456,  1776,   457,   458,   459,
     460,   461,   462,  1777,   463,   464,  1778,  1779,   465,   466,
     467,   468,  1780,   469,   470,   471,   472,   473,   474,   475,
    1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,   481,
     482,   483,   484,   485,   486,   487,  1785,   488,   754,   489,
     490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,  1790,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,   701,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,  1371,     0,
       0,     0,     0,     0,     0,     0,     0,  4138,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,     0,  1372,   733,
    1373,  1374,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,  1375,  1376,   240,     0,   241,   242,   243,   244,
       0,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,  1377,  1378,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
       0,   294,   295,   296,     0,     0,   298,     0,   299,  1379,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,     0,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,     0,   326,   327,   328,
     329,  1380,  1381,     0,  1382,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,     0,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1383,   747,  1384,   363,   364,     0,
       0,   366,   367,   748,   368,     0,     0,   370,  1385,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,     0,   749,   750,   751,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   390,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1386,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,     0,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
    1387,   439,   440,   753,   441,  1388,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1389,  1390,     0,     0,   465,     0,   467,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
       0,  1391,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,     0,     0,
    2094,     0,     0,     0,     0,     0,     0,   507,   508,   509,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  1849,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1372,   733,  1373,  1374,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,  1375,  1376,   240,     0,   241,   242,
     243,   244,     0,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,  1377,  1378,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,     0,   294,   295,   296,     0,     0,   298,     0,
     299,  1379,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,     0,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,     0,   326,
     327,   328,   329,  1380,  1381,     0,  1382,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,     0,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1383,   747,  1384,   363,
     364,     0,     0,   366,   367,   748,   368,     0,     0,   370,
    1385,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,     0,   749,   750,   751,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   390,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1386,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,     0,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,  1387,   439,   440,   753,   441,  1388,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
       0,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1389,  1390,     0,     0,   465,     0,   467,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,     0,  1391,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
       0,     0,   775,  1268,   564,     0,     0,     0,   615,   507,
     508,   509,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1849,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1702,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1510,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,  1511,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,  1512,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,  1268,   564,     0,     0,     0,
     615,   627,  1269,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  1707,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,  1510,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
    1511,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,  1512,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,  1268,   564,     0,
       0,     0,   615,   627,  1269,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,  1510,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,  1511,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,  1512,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,   615,   627,  1269,     0,     0,   208,
     616,   210,   211,   212,   213,   214,   215,   617,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   618,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   619,   300,
     301,     0,   302,     0,   620,     0,   621,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,   622,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   623,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   624,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   625,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   626,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
    1712,  4425,   564,     0,     0,     0,   615,   627,   628,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  1713,
     217,   218,   219,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
     220,   221,  1721,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,  1722,   231,   232,   233,   234,   235,
    1723,  1724,   236,   237,   238,   239,   240,  1725,   241,   242,
     243,   244,   245,  1726,   734,  1727,   246,   247,   248,   249,
     735,   250,   251,  1728,   252,   253,   254,   255,   256,   257,
    1729,   736,   258,   259,  1730,  1731,  1732,   737,  1733,  1734,
    1735,   260,   261,   262,   263,   264,   265,   266,   267,   268,
    1736,   269,  1737,   270,   271,   272,   273,   274,  1738,   275,
     276,   277,  1739,  1740,   278,   279,   280,   281,   282,  1741,
     283,   284,   285,  1742,   286,   287,   288,  1743,   289,   290,
     291,   292,   293,   294,   295,   296,   297,  1744,   298,  1745,
     299,   300,   301,  1746,   302,  1747,   303,   738,  1748,   739,
     304,   305,   306,  1749,   307,   308,  1750,   309,  1751,   310,
     311,   312,   313,   314,   740,   315,   316,   317,  1752,   318,
     319,   320,   321,   322,   323,  1753,   324,   741,   325,   326,
     327,   328,   329,   330,   331,  1754,   332,  1755,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,  1756,   340,
     341,  1757,   342,   343,   745,   344,   746,  1758,   345,   346,
     347,  1759,  1760,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,  1761,   366,   367,   748,   368,  1762,   369,   370,
     371,   372,   373,   374,  1763,   375,  1764,  1765,   376,   377,
     378,  1766,  1767,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,  1768,   388,   389,   390,   391,
     392,   393,   394,  1769,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,  1770,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,  1771,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,  1772,   432,   433,   434,   435,   436,
    1773,   437,   438,   439,   440,   753,   441,   442,   443,  1774,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,  1775,   455,   456,  1776,   457,   458,   459,   460,   461,
     462,  1777,   463,   464,  1778,  1779,   465,   466,   467,   468,
    1780,   469,   470,   471,   472,   473,   474,   475,  1781,  1782,
     476,   477,   478,   479,   480,  1783,  1784,   481,   482,   483,
     484,   485,   486,   487,  1785,   488,   754,   489,   490,   491,
    1786,  1787,   492,  1788,  1789,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,  1712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1713,   217,   218,   219,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,   220,   221,  1721,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,  1722,   231,   232,   233,
     234,   235,  1723,  1724,   236,   237,   238,   239,   240,  1725,
     241,   242,   243,   244,   245,  1726,   734,  1727,   246,   247,
     248,   249,   735,   250,   251,  1728,   252,   253,   254,   255,
     256,   257,  1729,   736,   258,   259,  1730,  1731,  1732,   737,
    1733,  1734,  1735,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  1736,   269,  1737,   270,   271,   272,   273,   274,
    1738,   275,   276,   277,  1739,  1740,   278,   279,   280,   281,
     282,  1741,   283,   284,   285,  1742,   286,   287,   288,  1743,
     289,   290,   291,   292,   293,   294,   295,   296,   297,  1744,
     298,  1745,   299,   300,   301,  1746,   302,  1747,   303,   738,
    1748,   739,   304,   305,   306,  1749,   307,   308,  1750,   309,
    1751,   310,   311,   312,   313,   314,   740,   315,   316,   317,
    1752,   318,   319,   320,   321,   322,   323,  1753,   324,   741,
     325,   326,   327,   328,   329,   330,   331,  1754,   332,  1755,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
    1756,   340,   341,  1757,   342,   343,   745,   344,   746,  1758,
     345,   346,   347,  1759,  1760,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,  1761,   366,   367,   748,   368,  1762,
     369,   370,   371,   372,   373,   374,  1763,   375,  1764,  1765,
     376,   377,   378,  1766,  1767,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,  1768,   388,   389,
     390,   391,   392,   393,   394,  1769,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,  1770,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,  1771,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,  1772,   432,   433,   434,
     435,   436,  1773,   437,   438,   439,   440,   753,   441,   442,
     443,  1774,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,  1775,   455,   456,  1776,   457,   458,   459,
     460,   461,   462,  1777,   463,   464,  1778,  1779,   465,   466,
     467,   468,  1780,   469,   470,   471,   472,   473,   474,   475,
    1781,  1782,   476,   477,   478,   479,   480,  1783,  1784,   481,
     482,   483,   484,   485,   486,   487,  1785,   488,   754,   489,
     490,   491,  1786,  1787,   492,  1788,  1789,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,  1712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,  2617,
     213,   214,   215,  1713,   217,   218,   219,  1714,  1715,  1716,
    1717,  1718,  1719,  1720,   220,   221,  1721,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,  1722,   231,
     232,   233,   234,   235,  1723,  1724,   236,   237,   238,   239,
     240,  1725,   241,   242,   243,   244,   245,  1726,   734,  1727,
     246,   247,   248,   249,   735,   250,   251,  1728,   252,   253,
     254,   255,   256,   257,  1729,   736,   258,   259,  1730,  1731,
    1732,   737,  1733,  1734,  1735,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  1736,   269,  1737,   270,   271,   272,
     273,   274,  1738,   275,   276,   277,  1739,  1740,   278,   279,
     280,  2618,   282,  1741,   283,   284,   285,  1742,   286,   287,
     288,  1743,   289,   290,   291,   292,   293,   294,   295,   296,
     297,  1744,   298,  1745,   299,   300,   301,  1746,   302,  1747,
     303,   738,  1748,   739,   304,   305,   306,  1749,   307,   308,
    1750,   309,  1751,   310,   311,   312,   313,   314,   740,   315,
     316,   317,  1752,   318,   319,   320,   321,   322,   323,  1753,
     324,   741,   325,   326,   327,   328,   329,   330,   331,  1754,
     332,  1755,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,  1756,   340,   341,  1757,   342,   343,   745,   344,
     746,  1758,   345,   346,   347,  1759,  1760,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,  1761,   366,   367,   748,
     368,  1762,   369,   370,   371,   372,   373,   374,  1763,   375,
    1764,  1765,   376,   377,   378,  1766,  1767,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,  1768,
     388,   389,   390,   391,   392,   393,   394,  1769,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,  1770,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,  1771,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,  1772,   432,
     433,   434,   435,   436,  1773,  2619,   438,   439,   440,   753,
     441,   442,   443,  1774,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,  1775,   455,   456,  1776,   457,
     458,   459,   460,   461,   462,  1777,   463,   464,  1778,  1779,
     465,   466,   467,   468,  1780,   469,   470,   471,   472,   473,
     474,   475,  1781,  1782,   476,   477,   478,   479,   480,  1783,
    1784,   481,   482,   483,   484,   485,   486,   487,  1785,   488,
     754,   489,   490,   491,  1786,  1787,   492,  1788,  1789,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,   564,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,  1510,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,  1511,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,  1512,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
     564,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,  1687,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
    2051,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,  2052,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     3,     4,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   801,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,   564,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
     564,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,  1500,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,  2883,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   814,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   891,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     731,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,   227,
     228,   733,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   911,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   747,   362,   363,
     364,   365,     0,   366,   367,   748,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,   749,   750,   751,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,   753,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,   227,   228,   733,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   921,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   747,
     362,   363,   364,   365,     0,   366,   367,   748,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,   749,   750,   751,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,   753,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   775,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,   732,
     224,   225,   226,   227,   228,   733,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,   734,     0,
     246,   247,   248,   249,   735,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,   736,   258,   259,     0,     0,
       0,   737,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,   738,     0,   739,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   923,   740,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,   741,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,   742,   743,   334,   744,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,   745,   344,
     746,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   747,   362,   363,   364,   365,     0,   366,   367,   748,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,   749,   750,
     751,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,   752,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,   753,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     754,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   775,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,   227,   228,   733,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   933,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   747,   362,   363,   364,   365,     0,   366,
     367,   748,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
     749,   750,   751,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,   753,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   775,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,   227,   228,   733,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   944,   740,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,   741,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   945,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   747,   362,   363,   364,   365,
       0,   366,   367,   748,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,   749,   750,   751,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,   753,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,  1873,   241,   242,
     243,   244,   245,     0,     0,  1955,   246,   247,   248,   249,
       0,   250,   251,  1874,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,  1956,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,  1876,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,  1877,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,  1878,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,  1873,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,  1874,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
    1956,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,  1876,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,  2783,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,  1877,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,  1878,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     666,   214,   215,   634,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,   635,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,   667,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   636,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   637,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,   634,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,   635,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,  2514,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   636,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     637,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,  1873,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,  1874,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,  1956,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,  1876,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,  1877,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,  1878,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,   634,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
     635,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   636,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   637,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,  1537,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,  1538,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,  1539,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,  1540,   303,     0,
       0,     0,  1541,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,  1542,  1543,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,  1544,   428,   429,   430,   431,     0,  1545,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,  1546,   457,  1547,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,  1548,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,   635,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   636,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   637,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     3,
       4,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,  2601,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,  2602,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,  2613,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,  2614,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   556,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   557,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,   660,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   661,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   662,   464,
       0,     0,   663,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,   690,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   691,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     692,   464,     0,     0,   693,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   696,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   808,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,   696,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,   904,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,  1113,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,  1124,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     677,   237,   238,   239,  1125,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   680,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   681,   422,   423,   424,   425,   426,   682,   428,   429,
     430,   431,     0,   432,   433,   434,   435,  1117,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     684,   464,     0,     0,   685,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   686,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,  1223,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,   696,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,  2420,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,  2421,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,  2422,   457,   458,  2423,
     460,  2424,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,  2425,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,   564,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,  3495,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,  3509,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
    3716,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,  3718,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,  3720,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,  4100,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   649,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   314,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     658,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   677,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   678,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   679,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   680,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   681,   422,   423,
     424,   425,   426,   682,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   683,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   684,   464,     0,     0,
     685,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   686,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   708,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   781,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   805,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   816,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   869,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   883,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   916,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   935,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,   937,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   939,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   942,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   948,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   677,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   680,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   681,   422,   423,   424,   425,   426,   682,
     428,   429,   430,   431,     0,   432,   433,   434,   435,  1117,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   684,   464,     0,     0,   685,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   686,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  1272,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,  1417,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,  1447,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,  1476,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,  1478,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   463,   464,     0,     0,   465,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  1480,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,   314,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,  1572,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,  1846,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,     0,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   463,   464,
       0,     0,   465,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     677,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   680,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   681,   422,   423,   424,   425,   426,   682,   428,   429,
     430,   431,     0,   432,   433,   434,   435,  1117,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,  1864,   459,   460,   461,   462,     0,
     684,   464,     0,     0,   685,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   686,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   229,   230,     0,   231,   232,   233,   234,   235,
       0,     0,   677,   237,   238,   239,   240,     0,   241,   242,
     243,   244,   245,     0,     0,     0,   246,   247,   248,   249,
       0,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,     0,     0,     0,     0,     0,     0,
       0,   260,   261,   262,   263,   264,   265,   266,   267,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,   280,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,   293,   294,   295,   296,   297,     0,   298,     0,
     299,   300,   301,     0,   302,     0,   303,     0,     0,     0,
     304,   305,   306,     0,   307,   308,     0,   309,     0,   310,
     311,   312,   313,   314,     0,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   326,
     327,   328,   329,   330,   331,     0,   332,     0,   333,     0,
       0,   334,     0,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,   343,     0,   344,     0,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   680,   361,     0,   362,   363,
     364,   365,     0,   366,   367,     0,   368,     0,   369,   370,
     371,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,   379,     0,     0,     0,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,     0,   681,   422,   423,   424,   425,   426,  1931,
     428,   429,   430,   431,     0,   432,   433,   434,   435,  1932,
       0,   437,   438,   439,   440,     0,   441,   442,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,   684,   464,     0,     0,  1933,   466,   467,   468,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,   486,   487,     0,   488,     0,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   686,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   207,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,   229,   230,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,   238,   239,   240,     0,
     241,   242,   243,   244,   245,     0,     0,     0,   246,   247,
     248,   249,     0,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,     0,   258,   259,     0,     0,     0,     0,
       0,     0,     0,   260,   261,   262,   263,   264,   265,   266,
     267,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,   280,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,   293,   294,   295,   296,   297,     0,
     298,     0,   299,   300,   301,     0,   302,     0,   303,     0,
       0,     0,   304,   305,   306,     0,   307,   308,     0,   309,
       0,   310,   311,   312,   313,  2191,     0,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   326,   327,   328,   329,   330,   331,     0,   332,     0,
     333,     0,     0,   334,     0,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,   343,     0,   344,     0,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,     0,
     362,   363,   364,   365,     0,   366,   367,     0,   368,     0,
     369,   370,   371,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,   379,     0,     0,     0,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,     0,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,   438,   439,   440,     0,   441,   442,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,   463,   464,     0,     0,   465,   466,
     467,   468,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,   486,   487,     0,   488,     0,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,   209,   210,   211,   212,
     213,   214,   215,     0,   217,   218,   219,     0,     0,     0,
       0,     0,     0,     0,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   229,   230,     0,   231,
     232,   233,   234,   235,     0,     0,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   244,   245,     0,     0,     0,
     246,   247,   248,   249,     0,   250,   251,     0,   252,   253,
     254,   255,   256,   257,     0,     0,   258,   259,     0,     0,
       0,     0,     0,     0,     0,   260,   261,   262,   263,   264,
     265,   266,   267,   268,     0,   269,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,     0,     0,   278,   279,
     280,   281,   282,     0,   283,   284,   285,     0,   286,   287,
     288,     0,   289,   290,   291,   292,   293,   294,   295,   296,
     297,     0,   298,     0,   299,   300,   301,     0,   302,     0,
     303,     0,     0,     0,   304,   305,   306,     0,   307,   308,
       0,   309,     0,   310,   311,   312,   313,  2525,     0,   315,
     316,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   326,   327,   328,   329,   330,   331,     0,
     332,     0,   333,     0,     0,   334,     0,   335,   336,   337,
     338,   339,     0,   340,   341,     0,   342,   343,     0,   344,
       0,     0,   345,   346,   347,     0,     0,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,     0,   362,   363,   364,   365,     0,   366,   367,     0,
     368,     0,   369,   370,   371,   372,   373,   374,     0,   375,
       0,     0,   376,   377,   378,     0,     0,   379,     0,     0,
       0,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,   419,   420,     0,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,   432,
     433,   434,   435,   436,     0,   437,   438,   439,   440,     0,
     441,   442,   443,     0,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,     0,   455,   456,     0,   457,
     458,   459,   460,   461,   462,     0,   463,   464,     0,     0,
     465,   466,   467,   468,     0,   469,   470,   471,   472,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,     0,
       0,   481,   482,   483,   484,   485,   486,   487,     0,   488,
       0,   489,   490,   491,     0,     0,   492,     0,     0,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   207,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   229,   230,
       0,   231,   232,   233,   234,   235,     0,     0,   677,   237,
     238,   239,   240,     0,   241,   242,   243,   244,   245,     0,
       0,     0,   246,   247,   248,   249,     0,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,     0,   258,   259,
       0,     0,     0,     0,     0,     0,     0,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,   280,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,   293,   294,
     295,   296,   297,     0,   298,     0,   299,   300,   301,     0,
     302,     0,   303,     0,     0,     0,   304,   305,   306,     0,
     307,   308,     0,   309,     0,   310,   311,   312,   313,   314,
       0,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   326,   327,   328,   329,   330,
     331,     0,   332,     0,   333,     0,     0,   334,     0,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,   343,
       0,   344,     0,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   680,   361,     0,   362,   363,   364,   365,     0,   366,
     367,     0,   368,     0,   369,   370,   371,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,   379,
       0,     0,     0,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,     0,   681,
     422,   423,   424,   425,   426,   682,   428,   429,   430,   431,
       0,   432,   433,   434,   435,  1932,     0,   437,   438,   439,
     440,     0,   441,   442,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,   684,   464,
       0,     0,  1933,   466,   467,   468,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,   486,   487,
       0,   488,     0,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   686,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,  1371,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,   732,   224,   225,   226,     0,  1372,   733,
    1373,  1374,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,  1375,  1376,   240,     0,   241,   242,   243,   244,
       0,     0,   734,     0,   246,   247,   248,   249,   735,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,   736,
     258,   259,     0,     0,     0,   737,     0,     0,     0,   260,
     261,   262,   263,   264,   265,  1377,  1378,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,  1040,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
       0,   294,   295,   296,     0,     0,   298,     0,   299,  1379,
     301,     0,   302,     0,   303,   738,     0,   739,   304,   305,
     306,     0,   307,     0,     0,   309,     0,   310,   311,   312,
     313,   314,   740,   315,   316,   317,  1939,   318,   319,   320,
     321,   322,   323,     0,   324,   741,  1940,   326,   327,   328,
     329,  1380,  1381,     0,  1382,     0,   333,   742,   743,   334,
     744,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,     0,   745,   344,   746,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,  1383,   747,  1384,   363,   364,     0,
       0,   366,   367,   748,   368,     0,     0,   370,  1385,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,  1941,   749,   750,   751,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   390,     0,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,   402,
    1386,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
     752,   421,   422,     0,   424,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
    1942,   439,   440,   753,   441,  1388,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,     0,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
    1389,  1390,     0,     0,   465,     0,   467,     0,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
       0,  1391,  1943,   488,   754,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,     0,   207,
       0,     0,     0,     0,     0,     0,     0,   507,   508,   509,
     208,   209,   210,   211,   212,   213,   214,   215,     0,   217,
     218,   219,     0,     0,     0,     0,     0,     0,     0,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,   229,   230,     0,   231,   232,   233,   234,   235,     0,
       0,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     244,   245,     0,     0,     0,   246,   247,   248,   249,     0,
     250,   251,     0,   252,   253,   254,   255,   256,   257,     0,
       0,   258,   259,     0,     0,     0,     0,     0,     0,     0,
     260,   261,   262,   263,   264,   265,   266,   267,   268,     0,
     269,     0,   270,   271,   272,   273,   274,     0,   275,   276,
     277,     0,     0,   278,   279,   280,   281,   282,     0,   283,
     284,   285,     0,   286,   287,   288,     0,   289,   290,   291,
     292,   293,   294,   295,   296,   297,     0,   298,     0,   299,
     300,   301,     0,   302,     0,   303,     0,     0,     0,   304,
     305,   306,     0,   307,   308,     0,   309,     0,   310,   311,
     312,   313,  2604,     0,   315,   316,   317,     0,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   326,   327,
     328,   329,   330,   331,     0,   332,     0,   333,     0,     0,
     334,     0,   335,   336,   337,   338,   339,     0,   340,   341,
       0,   342,   343,     0,   344,     0,     0,   345,   346,   347,
       0,     0,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,     0,   362,   363,   364,
     365,     0,   366,   367,     0,   368,     0,   369,   370,   371,
     372,   373,   374,     0,   375,     0,     0,   376,   377,   378,
       0,     0,   379,     0,     0,     0,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,   419,
     420,     0,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,     0,   432,   433,   434,   435,   436,     0,
     437,   438,   439,   440,     0,   441,   442,   443,     0,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
       0,   455,   456,     0,   457,   458,   459,   460,   461,   462,
       0,   463,   464,     0,     0,   465,   466,   467,   468,     0,
     469,   470,   471,   472,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,     0,     0,   481,   482,   483,   484,
     485,   486,   487,     0,   488,     0,   489,   490,   491,     0,
       0,   492,     0,     0,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   207,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,   229,   230,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   244,   245,     0,     0,     0,   246,   247,   248,
     249,     0,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,     0,   258,   259,     0,     0,     0,     0,     0,
       0,     0,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,   280,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,   293,   294,   295,   296,   297,     0,   298,
       0,   299,   300,   301,     0,   302,     0,   303,     0,     0,
       0,   304,   305,   306,     0,   307,   308,     0,   309,     0,
     310,   311,   312,   313,  2606,     0,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     326,   327,   328,   329,   330,   331,     0,   332,     0,   333,
       0,     0,   334,     0,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,   343,     0,   344,     0,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,     0,   362,
     363,   364,   365,     0,   366,   367,     0,   368,     0,   369,
     370,   371,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,   379,     0,     0,     0,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,     0,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,   438,   439,   440,     0,   441,   442,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,   463,   464,     0,     0,   465,   466,   467,
     468,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,   486,   487,     0,   488,     0,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,   229,   230,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   244,   245,     0,     0,     0,   246,
     247,   248,   249,     0,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,     0,   258,   259,     0,     0,     0,
       0,     0,     0,     0,   260,   261,   262,   263,   264,   265,
     266,   267,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,     0,   299,   300,   301,     0,   302,     0,   303,
       0,     0,     0,   304,   305,   306,     0,   307,   308,     0,
     309,     0,   310,   311,   312,   313,  2704,     0,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   326,   327,   328,   329,   330,   331,     0,   332,
       0,   333,     0,     0,   334,     0,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,   343,     0,   344,     0,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,   362,   363,   364,   365,     0,   366,   367,     0,   368,
       0,   369,   370,   371,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,   379,     0,     0,     0,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,     0,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,   438,   439,   440,     0,   441,
     442,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,   463,   464,     0,     0,   465,
     466,   467,   468,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,   486,   487,     0,   488,     0,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,  1371,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   217,   218,   219,     0,     0,
       0,     0,     0,     0,     0,   220,   221,     0,   222,   223,
     732,   224,   225,   226,     0,  1372,   733,  1373,  1374,     0,
     231,   232,   233,   234,   235,     0,     0,   236,   237,  1375,
    1376,   240,     0,   241,   242,   243,   244,     0,     0,   734,
       0,   246,   247,   248,   249,   735,   250,   251,     0,   252,
     253,   254,   255,   256,   257,     0,   736,   258,   259,     0,
       0,     0,   737,     0,     0,     0,   260,   261,   262,   263,
     264,   265,  1377,  1378,   268,     0,   269,     0,   270,   271,
     272,   273,   274,     0,   275,   276,   277,     0,     0,   278,
     279,  1040,   281,   282,     0,   283,   284,   285,     0,   286,
     287,   288,     0,   289,   290,   291,   292,     0,   294,   295,
     296,     0,     0,   298,     0,   299,  1379,   301,     0,   302,
       0,   303,   738,     0,   739,   304,   305,   306,     0,   307,
       0,     0,   309,     0,   310,   311,   312,   313,   314,   740,
     315,   316,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,   741,     0,   326,   327,   328,   329,  1380,  1381,
       0,  1382,     0,   333,   742,   743,   334,   744,   335,   336,
     337,   338,   339,     0,   340,   341,     0,   342,     0,   745,
     344,   746,     0,   345,   346,   347,     0,     0,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,  1383,   747,  1384,   363,   364,     0,     0,   366,   367,
     748,   368,  1927,     0,   370,  1385,   372,   373,   374,     0,
     375,     0,     0,   376,   377,   378,     0,     0,     0,   749,
     750,   751,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   390,     0,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,   402,  1386,   404,   405,
     406,   407,     0,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,   419,   420,   752,   421,   422,
       0,   424,   425,   426,   427,   428,   429,   430,   431,     0,
     432,   433,   434,   435,   436,     0,   437,  1942,   439,   440,
     753,   441,  1388,   443,     0,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,     0,     0,   455,   456,  3358,
     457,   458,   459,   460,   461,   462,     0,  1389,  1390,     0,
       0,   465,     0,   467,     0,     0,   469,   470,   471,   472,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
       0,     0,   481,   482,   483,   484,   485,     0,  1391,     0,
     488,   754,   489,   490,   491,     0,     0,   492,     0,     0,
     493,   494,   495,   496,   497,     0,  1371,     0,     0,     0,
       0,     0,     0,     0,   507,   508,   509,   208,   209,   210,
     211,   212,   213,   214,   215,     0,   217,   218,   219,     0,
       0,     0,     0,     0,     0,     0,   220,   221,     0,   222,
     223,   732,   224,   225,   226,     0,  1372,   733,  1373,  1374,
       0,   231,   232,   233,   234,   235,     0,     0,   236,   237,
    1375,  1376,   240,     0,   241,   242,   243,   244,     0,     0,
     734,     0,   246,   247,   248,   249,   735,   250,   251,     0,
     252,   253,   254,   255,   256,   257,     0,   736,   258,   259,
       0,     0,     0,   737,     0,     0,     0,   260,   261,   262,
     263,   264,   265,  1377,  1378,   268,     0,   269,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,     0,     0,
     278,   279,  1040,   281,   282,     0,   283,   284,   285,     0,
     286,   287,   288,     0,   289,   290,   291,   292,     0,   294,
     295,   296,     0,     0,   298,     0,   299,  1379,   301,     0,
     302,     0,   303,   738,     0,   739,   304,   305,   306,     0,
     307,     0,     0,   309,     0,   310,   311,   312,   313,   314,
     740,   315,   316,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,   741,     0,   326,   327,   328,   329,  1380,
    1381,     0,  1382,     0,   333,   742,   743,   334,   744,   335,
     336,   337,   338,   339,     0,   340,   341,     0,   342,     0,
     745,   344,   746,     0,   345,   346,   347,     0,     0,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,  1383,   747,  1384,   363,   364,  1994,     0,   366,
     367,   748,   368,     0,     0,   370,  1385,   372,   373,   374,
       0,   375,     0,     0,   376,   377,   378,     0,     0,     0,
     749,   750,   751,     0,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   390,     0,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,   402,  1386,   404,
     405,   406,   407,     0,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,   419,   420,   752,   421,
     422,     0,   424,   425,   426,   427,   428,   429,   430,   431,
       0,   432,   433,   434,   435,   436,     0,   437,  1387,   439,
     440,   753,   441,  1388,   443,     0,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,     0,     0,   455,   456,
       0,   457,   458,   459,   460,   461,   462,     0,  1389,  1390,
       0,     0,   465,     0,   467,     0,     0,   469,   470,   471,
     472,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,     0,     0,   481,   482,   483,   484,   485,     0,  1391,
       0,   488,   754,   489,   490,   491,     0,     0,   492,     0,
       0,   493,   494,   495,   496,   497,     0,  1371,     0,     0,
       0,     0,     0,     0,     0,   507,   508,   509,   208,   209,
     210,   211,   212,   213,   214,   215,     0,   217,   218,   219,
       0,     0,     0,     0,     0,     0,     0,   220,   221,     0,
     222,   223,   732,   224,   225,   226,     0,  1372,   733,  1373,
    1374,     0,   231,   232,   233,   234,   235,     0,     0,   236,
     237,  1375,  1376,   240,     0,   241,   242,   243,   244,     0,
       0,   734,     0,   246,   247,   248,   249,   735,   250,   251,
       0,   252,   253,   254,   255,   256,   257,     0,   736,   258,
     259,     0,     0,     0,   737,     0,     0,     0,   260,   261,
     262,   263,   264,   265,  1377,  1378,   268,     0,   269,     0,
     270,   271,   272,   273,   274,     0,   275,   276,   277,     0,
       0,   278,   279,  1040,   281,   282,     0,   283,   284,   285,
       0,   286,   287,   288,     0,   289,   290,   291,   292,     0,
     294,   295,   296,     0,     0,   298,     0,   299,  1379,   301,
       0,   302,     0,   303,   738,     0,   739,   304,   305,   306,
       0,   307,     0,     0,   309,     0,   310,   311,   312,   313,
     314,   740,   315,   316,   317,     0,   318,   319,   320,   321,
     322,   323,     0,   324,   741,     0,   326,   327,   328,   329,
    1380,  1381,     0,  1382,     0,   333,   742,   743,   334,   744,
     335,   336,   337,   338,   339,     0,   340,   341,     0,   342,
       0,   745,   344,   746,     0,   345,   346,   347,     0,     0,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,  1383,   747,  1384,   363,   364,  3186,     0,
     366,   367,   748,   368,     0,     0,   370,  1385,   372,   373,
     374,     0,   375,     0,     0,   376,   377,   378,     0,     0,
       0,   749,   750,   751,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   390,     0,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,   402,  1386,
     404,   405,   406,   407,     0,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,   419,   420,   752,
     421,   422,     0,   424,   425,   426,   427,   428,   429,   430,
     431,     0,   432,   433,   434,   435,   436,     0,   437,  1387,
     439,   440,   753,   441,  1388,   443,     0,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,     0,     0,   455,
     456,     0,   457,   458,   459,   460,   461,   462,     0,  1389,
    1390,     0,     0,   465,     0,   467,     0,     0,   469,   470,
     471,   472,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,     0,     0,   481,   482,   483,   484,   485,     0,
    1391,     0,   488,   754,   489,   490,   491,     0,     0,   492,
       0,     0,   493,   494,   495,   496,   497,     0,   207,     0,
       0,     0,     0,     0,     0,     0,   507,   508,   509,   208,
     209,   210,   211,   212,   213,   214,   215,     0,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
     229,   230,     0,   231,   232,   233,   234,   235,     0,     0,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   244,
     245,     0,     0,     0,   246,   247,   248,   249,     0,   250,
     251,     0,   252,   253,   254,   255,   256,   257,     0,     0,
     258,   259,     0,     0,     0,     0,     0,     0,     0,   260,
     261,   262,   263,   264,   265,   266,   267,   268,     0,   269,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
       0,     0,   278,   279,   280,   281,   282,     0,   283,   284,
     285,     0,   286,   287,   288,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,     0,   299,   300,
     301,     0,   302,     0,   303,     0,     0,     0,   304,   305,
     306,     0,   307,   308,     0,   309,     0,   310,   311,   312,
     313,   314,     0,   315,   316,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   326,   327,   328,
     329,   330,   331,     0,   332,     0,   333,     0,     0,   334,
       0,   335,   336,   337,   338,   339,     0,   340,   341,     0,
     342,   343,     0,   344,     0,     0,   345,   346,   347,     0,
       0,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,     0,   362,   363,   364,   365,
       0,   366,   367,     0,   368,     0,   369,   370,   371,   372,
     373,   374,     0,   375,     0,     0,   376,   377,   378,     0,
       0,   379,     0,     0,     0,   380,   381,   382,   383,   384,
       0,   386,   387,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,     0,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,   419,   420,
       0,   421,   422,   423,     0,   425,   426,   427,   428,   429,
     430,   431,     0,   432,   433,   434,   435,   436,     0,   437,
     438,   439,   440,     0,   441,   442,   443,     0,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,     0,
     455,   456,     0,   457,   458,   459,   460,   461,   462,     0,
     463,   464,     0,     0,   465,   466,   467,   468,     0,   469,
     470,   471,   472,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,     0,     0,   481,   482,   483,   484,   485,
     486,   487,     0,   488,     0,   489,   490,   491,     0,     0,
     492,     0,     0,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
    1371,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   208,   209,   210,   211,   212,   213,   214,   215,     0,
     217,   218,   219,     0,     0,     0,     0,     0,     0,     0,
     220,   221,     0,   222,   223,   732,   224,   225,   226,     0,
    1372,   733,  1373,  1374,     0,   231,   232,   233,   234,   235,
       0,     0,   236,   237,  1375,  1376,   240,     0,   241,   242,
     243,   244,     0,     0,   734,     0,   246,   247,   248,   249,
     735,   250,   251,     0,   252,   253,   254,   255,   256,   257,
       0,   736,   258,   259,     0,     0,     0,   737,     0,     0,
       0,   260,   261,   262,   263,   264,   265,  1377,  1378,   268,
       0,   269,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,     0,     0,   278,   279,  1040,   281,   282,     0,
     283,   284,   285,     0,   286,   287,   288,     0,   289,   290,
     291,   292,     0,   294,   295,   296,     0,     0,   298,     0,
     299,  1379,   301,     0,   302,     0,   303,   738,     0,   739,
     304,   305,   306,     0,   307,     0,     0,   309,     0,   310,
     311,   312,   313,   314,   740,   315,   316,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,   741,     0,   326,
     327,   328,   329,  1380,  1381,     0,  1382,     0,   333,   742,
     743,   334,   744,   335,   336,   337,   338,   339,     0,   340,
     341,     0,   342,     0,   745,   344,   746,     0,   345,   346,
     347,     0,     0,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,  1383,   747,  1384,   363,
     364,     0,     0,   366,   367,   748,   368,     0,     0,   370,
    1385,   372,   373,   374,     0,   375,     0,     0,   376,   377,
     378,     0,     0,     0,   749,   750,   751,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   390,     0,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,   402,  1386,   404,   405,   406,   407,     0,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
     419,   420,   752,   421,   422,     0,   424,   425,   426,   427,
     428,   429,   430,   431,     0,   432,   433,   434,   435,   436,
       0,   437,  1387,   439,   440,   753,   441,  1388,   443,     0,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
       0,     0,   455,   456,     0,   457,   458,   459,   460,   461,
     462,     0,  1389,  1390,     0,     0,   465,     0,   467,     0,
       0,   469,   470,   471,   472,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,     0,     0,   481,   482,   483,
     484,   485,     0,  1391,     0,   488,   754,   489,   490,   491,
       0,     0,   492,     0,     0,   493,   494,   495,   496,   497,
       0,  1371,     0,     0,     0,     0,     0,     0,     0,   507,
     508,   509,   208,   209,   210,   211,   212,   213,   214,   215,
       0,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,   220,   221,     0,   222,   223,   732,   224,   225,   226,
       0,  1372,   733,  1373,  1374,     0,   231,   232,   233,   234,
     235,     0,     0,   236,   237,  1375,  1376,   240,     0,   241,
     242,   243,   244,     0,     0,   734,     0,   246,   247,   248,
     249,   735,   250,   251,     0,   252,   253,   254,   255,   256,
     257,     0,   736,   258,   259,     0,     0,     0,   737,     0,
       0,     0,   260,   261,   262,   263,   264,   265,  1377,  1378,
     268,     0,   269,     0,   270,   271,   272,   273,   274,     0,
     275,   276,   277,     0,     0,   278,   279,  1040,   281,   282,
       0,   283,   284,   285,     0,   286,   287,   288,     0,   289,
     290,   291,   292,     0,   294,   295,   296,     0,     0,   298,
       0,   299,  1379,   301,     0,   302,     0,   303,   738,     0,
     739,   304,   305,   306,     0,   307,     0,     0,   309,     0,
     310,   311,   312,   313,   314,   740,   315,   316,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,   741,     0,
     326,   327,   328,   329,  1380,  1381,     0,  1382,     0,   333,
     742,   743,   334,   744,   335,   336,   337,   338,   339,     0,
     340,   341,     0,   342,     0,   745,   344,   746,     0,   345,
     346,   347,     0,     0,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,  1383,   747,  1384,
     363,   364,     0,     0,   366,   367,   748,   368,     0,     0,
     370,  1385,   372,   373,   374,     0,   375,     0,     0,   376,
     377,   378,     0,     0,     0,   749,   750,   751,     0,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   390,
       0,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,   402,  1386,   404,   405,   406,   407,     0,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,   419,   420,   752,   421,   422,     0,   424,   425,   426,
     427,   428,   429,   430,   431,     0,   432,   433,   434,   435,
     436,     0,   437,  1942,   439,   440,   753,   441,  1388,   443,
       0,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,     0,     0,   455,   456,     0,   457,   458,   459,   460,
     461,   462,     0,  1389,  1390,     0,     0,   465,     0,   467,
       0,     0,   469,   470,   471,   472,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,     0,     0,   481,   482,
     483,   484,   485,     0,  1391,     0,   488,   754,   489,   490,
     491,     0,     0,   492,     0,     0,   493,   494,   495,   496,
     497,     0,  1371,     0,     0,     0,     0,     0,     0,     0,
     507,   508,   509,   208,   209,   210,   211,   212,   213,   214,
     215,     0,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,   220,   221,     0,   222,   223,   732,   224,   225,
     226,     0,  1372,   733,  1373,  1374,     0,   231,   232,   233,
     234,   235,     0,     0,   236,   237,  1375,  1376,   240,     0,
     241,   242,   243,   244,     0,     0,   734,     0,   246,   247,
     248,   249,   735,   250,   251,     0,   252,   253,   254,   255,
     256,   257,     0,   736,   258,   259,     0,     0,     0,   737,
       0,     0,     0,   260,   261,   262,   263,   264,   265,  1377,
    1378,   268,     0,   269,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,     0,     0,   278,   279,  1040,   281,
     282,     0,   283,   284,   285,     0,   286,   287,   288,     0,
     289,   290,   291,   292,     0,   294,   295,   296,     0,     0,
     298,     0,   299,  1379,   301,     0,   302,     0,   303,   738,
       0,   739,   304,   305,   306,     0,   307,     0,     0,   309,
       0,   310,   311,   312,   313,   314,   740,   315,   316,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,   741,
       0,   326,   327,   328,   329,  1380,  1381,     0,  1382,     0,
     333,   742,   743,   334,   744,   335,   336,   337,   338,   339,
       0,   340,   341,     0,   342,     0,   745,   344,   746,     0,
     345,   346,   347,     0,     0,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,  1383,   747,
    1384,   363,   364,     0,     0,   366,   367,   748,   368,     0,
       0,   370,  1385,   372,   373,   374,     0,   375,     0,     0,
     376,   377,   378,     0,     0,     0,   749,   750,   751,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     390,     0,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,   402,  1386,   404,   405,   406,   407,     0,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,   419,   420,   752,   421,   422,     0,   424,   425,
     426,   427,   428,   429,   430,   431,     0,   432,   433,   434,
     435,   436,     0,   437,     0,   439,   440,   753,   441,  1388,
     443,     0,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,     0,     0,   455,   456,     0,   457,   458,   459,
     460,   461,   462,     0,  1389,  1390,     0,     0,   465,     0,
     467,     0,     0,   469,   470,   471,   472,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,     0,     0,   481,
     482,   483,   484,   485,     0,  1391,     0,   488,   754,   489,
     490,   491,     0,     0,   492,     0,     0,   493,   494,   495,
     496,   497,     0,  1371,     0,     0,     0,     0,     0,     0,
       0,   507,   508,   509,   208,   209,   210,   211,   212,   213,
     214,   215,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,     0,   220,   221,     0,   222,   223,   732,   224,
     225,   226,     0,     0,   733,     0,     0,     0,   231,   232,
     233,   234,   235,     0,     0,   236,   237,     0,     0,   240,
       0,   241,   242,   243,   244,     0,     0,   734,     0,   246,
     247,   248,   249,   735,   250,   251,     0,   252,   253,   254,
     255,   256,   257,     0,   736,   258,   259,     0,     0,     0,
     737,     0,     0,     0,   260,   261,   262,   263,   264,   265,
       0,     0,   268,     0,   269,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,     0,     0,   278,   279,   280,
     281,   282,     0,   283,   284,   285,     0,   286,   287,   288,
       0,   289,   290,   291,   292,     0,   294,   295,   296,     0,
       0,   298,     0,   299,     0,   301,     0,   302,     0,   303,
     738,     0,   739,   304,   305,   306,     0,   307,     0,     0,
     309,     0,   310,   311,   312,   313,   314,   740,   315,   316,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
     741,     0,   326,   327,   328,   329,     0,     0,     0,     0,
       0,   333,   742,   743,   334,   744,   335,   336,   337,   338,
     339,     0,   340,   341,     0,   342,     0,   745,   344,   746,
       0,   345,   346,   347,     0,     0,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,     0,
     747,     0,   363,   364,     0,     0,   366,   367,   748,   368,
       0,     0,   370,     0,   372,   373,   374,     0,   375,     0,
       0,   376,   377,   378,     0,     0,     0,   749,   750,   751,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   390,     0,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,   402,     0,   404,   405,   406,   407,
       0,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,   419,   420,   752,   421,   422,     0,   424,
     425,   426,   427,   428,   429,   430,   431,     0,   432,   433,
     434,   435,   436,     0,   437,     0,   439,   440,   753,   441,
       0,   443,     0,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,     0,     0,   455,   456,     0,   457,   458,
     459,   460,   461,   462,     0,     0,     0,     0,     0,   465,
       0,   467,     0,     0,   469,   470,   471,   472,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,     0,     0,
     481,   482,   483,   484,   485,     0,     0,     0,   488,   754,
     489,   490,   491,     0,     0,   492,     0,     0,   493,   494,
     495,   496,   497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,   508,   509
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,    48,   169,   922,
     177,    11,   725,   537,    24,   959,   191,    34,   678,   186,
      20,   926,    20,   565,   730,    43,  1209,     7,   802,  1142,
    1144,   931,    21,   995,    14,  1244,   756,    26,   635,   636,
     637,   815,   880,   824,   641,   807,   565,   981,    48,    21,
     951,  1643,   890,    12,    26,  1541,  1387,  1947,  1948,   583,
    1009,   603,  1993,  1160,    42,   861,  1249,   685,  1344,  1067,
    2134,  2275,  2567,  2844,  1038,  1039,  1262,  2435,  1192,  2126,
      20,  1253,  2617,  1196,  2619,  1443,   528,   806,    22,  1404,
     809,  1578,   866,  1057,    17,  1244,   870,  2042,   817,  1300,
      34,   875,  1165,  2744,  1805,     0,   188,  2833,   882,  3096,
    2762,  2253,  3089,  2781,   196,   783,   912,  3144,   892,  2087,
    2486,  2762,   204,  2433,  3030,  3057,   602,  1313,  1314,  2431,
    2432,   171,   574,   156,  3296,   171,  1308,  3348,  3024,   681,
    1498,  3359,  3338,     0,   187,     0,     0,     0,     0,  1249,
     193,     0,    39,     0,     0,     0,  2823,     0,  1236,     0,
     203,  1196,   681,     0,  1027,  1028,  1446,  3566,  3765,  3067,
     773,   171,  2961,  2368,     5,     0,    44,   722,  1454,    58,
    3029,   585,     0,    66,  1085,    11,   722,     0,     0,    31,
    1053,   595,  2766,  2767,  2768,  2769,  2770,  2771,  2129,     5,
       5,  4030,     5,    79,    25,  3896,     5,    22,    13,    37,
      13,   815,   105,  2429,    29,   146,    35,   187,    26,    27,
     198,   103,   127,   193,   157,     5,   938,    58,   160,     5,
      37,     5,     5,   203,    35,     5,    60,   949,     9,    13,
       5,   110,    66,    18,    22,   160,   105,   151,   122,   160,
      16,   171,    76,   171,   151,    42,    72,     5,     5,     5,
     152,   151,   859,  2479,     5,  3863,    76,  3865,    22,  2200,
    3976,  2202,  3259,   255,    60,    29,     5,    11,    20,   103,
       5,   105,   233,    76,   278,    58,   159,   308,   245,     5,
      28,   959,    96,    23,  1407,   324,     9,  2492,    40,    68,
     248,   233,    36,   103,    22,   153,    83,     4,    22,     0,
     103,   233,     9,   262,   306,   142,   107,   103,     9,   146,
     844,   253,   233,  4366,   288,  1175,   151,   106,  2002,   308,
     132,    22,    66,   151,   255,   194,     9,   357,   151,   151,
       5,   235,   150,     0,   152,   120,   171,     0,  1129,   299,
     398,   389,    38,   171,   178,     4,   523,    68,   171,   171,
       9,    33,   537,     0,   249,    76,  1086,   133,    40,   417,
     172,    18,     9,    59,   324,   324,   235,   295,   283,   156,
     167,   299,  2056,   210,   171,    22,   378,    22,   282,   168,
      11,  1111,  1390,   314,    29,  4438,   134,   115,   377,    68,
     191,   115,   569,   251,   433,   947,   324,    76,   583,  3571,
     431,   235,   579,  1377,  1378,   435,   240,   959,  4015,  1905,
     247,  1385,   209,    11,   300,   284,    83,   391,   947,   233,
      83,    11,    25,   306,   516,   235,  4142,   431,   103,   521,
    1353,  1538,   235,   185,    51,  1542,    68,  1544,    36,   235,
    1547,   383,   276,   435,   240,   185,  1612,    51,  1358,  1127,
     151,   383,   413,  1577,  1132,  1133,   290,  4023,   383,   198,
    1626,  1013,   383,   120,   431,   151,  4074,   298,    66,   397,
     171,     8,   258,   431,    11,   961,   151,   262,   381,   310,
     276,   269,   535,    68,  1013,    68,   539,    51,    68,   156,
     431,    28,   435,   156,   290,  1224,    30,   550,   518,  3083,
     379,   134,  1375,  1376,   151,   435,  3168,   332,  1674,   393,
     295,  1384,  1296,  1637,  1298,   344,   431,  3168,   932,   357,
    1368,   435,   338,   339,   171,  1648,   418,  4228,   435,   431,
     361,   328,   308,   344,  1306,   435,   429,   357,   372,   324,
     433,  1347,   431,   369,  1273,   565,   566,   388,  1226,   435,
     326,  1342,   603,   431,   725,   535,  1234,  1681,  3730,   539,
    4399,  3767,   350,  3560,   352,   657,   435,   384,   332,   103,
     550,   389,  1124,   987,   607,  3491,   372,  2518,   357,   431,
    1132,  1133,  3318,   997,   517,   565,   678,  1502,  1532,   398,
     431,   427,   602,   603,   602,  1124,  1010,   382,   388,   434,
     580,  1942,   192,  3499,   696,   585,   434,  3503,   417,  3781,
    1288,   434,   434,  1291,  1292,   595,   431,   616,   431,   618,
    3419,   620,   431,   603,  1539,   717,  1951,   626,  1183,   649,
    1243,  3490,   601,  1548,   616,   302,   618,  1183,   620,   302,
     630,   431,  3550,    11,   626,   627,   628,   431,   431,   430,
     670,   431,   829,   603,  3332,   192,   431,   677,   646,   844,
     680,   681,   682,   840,   714,  1576,  1280,  1578,   714,  1283,
    3347,  3039,   398,   431,   431,   431,  1354,  1588,   357,  4286,
     431,  1592,   357,   427,   301,  4094,  2586,   332,  2588,  1600,
    1601,   417,   784,  3277,   429,   298,   431,   301,   433,   422,
     423,   681,  1613,  1614,   714,   431,   716,   716,   716,   716,
     716,   716,   700,  1624,   251,   422,   423,  2007,    96,  3891,
     377,   422,   423,   900,  3044,   357,  3898,  2801,  1947,  4295,
     397,  1604,  1605,   434,   397,  1858,  1918,   301,   397,   422,
     423,   729,  1464,   418,  1278,   431,  2724,  4354,   431,  2727,
    2728,  1473,  1612,  2731,   704,  1477,    51,   108,   433,  2737,
     393,  1483,  1484,   422,   423,   432,  1626,   434,   152,   432,
       8,   434,   357,    11,   357,   422,   423,   357,   190,  1501,
     872,   151,   679,   130,   772,    96,   683,   434,  2729,  2730,
      96,    18,  4013,   424,   425,   426,   427,  3023,  3024,    96,
      96,   783,   894,   895,   896,     5,   133,  1989,    74,     5,
    2569,   716,     5,  1858,    96,     3,     4,     5,   435,   245,
     108,     9,   245,    97,   192,   151,   424,   425,   426,   427,
       5,   435,   422,   423,   424,   425,   426,   427,   105,     5,
     275,   188,  2444,  1450,  2744,  1955,   112,    32,  1936,   716,
     222,   716,   716,   716,   716,  1978,    34,   716,   763,   716,
     716,   716,  2762,   716,  3369,   716,  3071,  3093,   145,   716,
      96,   435,  4102,  4103,   262,  1545,  1546,   103,   151,   108,
     264,   418,   419,   420,   418,   422,   423,   424,   425,   426,
     427,    11,   153,   120,   986,   429,   184,   431,   432,   433,
     174,   435,    74,   295,  1634,   153,   998,   295,   255,     3,
     815,     5,     5,    22,    64,   103,     9,  1009,   283,   429,
     134,   103,   133,   433,   359,    98,   111,   947,   103,     5,
      18,    60,   324,   171,  3850,   350,    24,   352,   108,   959,
     112,    60,  2842,   315,   309,   329,    66,    76,  1482,   143,
     105,   961,   932,   961,   192,   184,  2167,  1509,  3854,    51,
    2179,    70,  4183,  3859,   399,  4193,  3862,   947,    77,   347,
     903,  4177,   992,   240,   964,   250,   966,   959,   968,   959,
     970,  3978,   972,   973,   974,     8,   312,   357,    52,   979,
     251,   164,   170,  1013,   271,   104,    60,   263,  2121,   326,
    3781,   189,   131,    98,    98,   431,   301,   987,   431,   235,
     103,  1021,   131,   251,   184,   321,   146,   997,  1470,   148,
    3756,  2780,  1508,   435,   371,   213,   377,   103,   103,   148,
    1010,  1041,   120,  1013,  1085,    18,   347,    18,   232,   194,
     240,    24,     8,    24,   240,    11,  1138,   240,   418,   222,
     347,   347,   225,  3598,   422,   423,   424,   425,   426,   427,
    1474,  1071,   310,   433,   390,   347,   175,  1087,   295,   164,
     164,  1485,   346,   347,   240,  1085,  1610,  1097,  1800,   340,
     235,  4287,  3759,  1497,   357,   351,  4316,  1107,   317,   377,
     120,   263,   103,  1278,  1186,   618,   619,   620,   248,     5,
     623,   624,   625,   317,  1124,  4092,    18,  1127,  1128,  4106,
     633,   337,  1132,  1133,   340,   326,   275,   365,  1168,  1169,
    1153,  1171,  1168,  1169,  4296,  1171,   401,   222,   222,   284,
     225,   225,  4353,   347,  2241,   317,  4357,   120,  2112,   120,
      74,   233,   315,  4180,  1124,  1127,   105,   276,   377,   213,
    1132,  1133,  1132,  1133,  3522,   154,  1248,   276,  1168,  1169,
     235,  1171,  1142,  1255,  3532,   347,    74,   297,  2334,  2335,
    1840,   385,  3548,  2339,    74,  4071,   331,  4398,   112,   351,
     418,   419,   420,   397,   422,   423,   424,   425,   426,   427,
    2038,   347,  1284,   154,   364,  1287,    44,  1185,  3518,   192,
     359,  3513,   249,   385,   112,   431,   108,   377,   120,   301,
    3530,   255,   112,  2379,  2380,   397,  1196,   431,   120,   178,
     315,   315,   359,   253,   142,  1954,   192,  1319,   251,   240,
     288,   340,   324,   255,   422,   423,  2359,   312,  4235,   412,
     399,  1333,  2365,   372,  1226,   106,    94,   164,  3400,   431,
     107,   146,  1234,   372,  1346,   153,   249,  3235,  2583,   196,
     318,  3923,   399,  3241,  3242,  2590,   357,     5,  3168,   299,
    2193,   166,  3923,  3499,   233,  1328,   235,  3503,  2007,   262,
     220,   262,  2197,   181,  1304,   251,  1463,  1269,  1221,   347,
    4232,  4233,   210,  2203,   324,  1472,   233,  1482,   115,  2028,
     117,  2149,  2150,  2151,  2152,   222,  1288,   168,  2092,  1291,
    1292,   155,   295,  2161,   295,   113,  3994,   412,   412,  1307,
     319,  4318,  4000,   140,   197,   123,   142,     8,  2057,   263,
      11,    78,  2010,   391,   191,   183,   431,   115,   261,   117,
    2018,   324,  2020,   324,   435,    95,  1366,    28,  1328,   348,
     262,   359,   115,  1445,   117,   263,   178,   179,   319,  1451,
     182,    49,   184,   263,  1541,   103,  2585,  3078,   367,   213,
     117,   273,  1354,  1907,  1427,  1280,  3331,   140,  1283,  2452,
     202,  2187,   429,   295,  2880,   233,   433,   348,   432,   326,
    1443,   435,  2303,   196,   210,   418,   419,   420,   315,   422,
     423,   424,   425,   426,   427,   418,  2513,    95,  3899,  1429,
     432,  1863,   324,   435,   106,  1507,   379,   351,   235,  2916,
     433,  4418,  1475,   240,   146,  1610,  2585,  1407,   245,   262,
     233,   247,  4168,  4375,   156,  3376,   431,  3378,     3,   962,
     377,  2352,   965,   351,   967,  1498,   969,  1427,   971,   171,
       3,   351,   975,  1545,  1546,  2666,   422,   423,   424,   425,
     426,   427,   295,  1443,   262,   313,    19,   245,   431,   297,
    2192,   221,  2383,   223,  2334,  2335,   168,   240,   397,  2339,
     295,   284,   245,     0,   295,   173,  2208,  2209,   299,   434,
    2212,   324,  3983,  2675,  1474,  1475,  2218,   295,  1508,     4,
    1508,  2869,  3870,  3871,     9,  1485,   350,  2418,   352,   324,
      75,   192,   350,   324,   352,  4296,   435,  1497,  1498,  2379,
    2380,     8,    75,   326,    11,   115,  4031,   117,  1518,  1509,
    1520,   375,  1522,   221,  1524,   223,  1526,   310,   155,  1953,
    1530,    28,  1569,   397,    83,   233,   363,  1999,    76,  1559,
    1559,  1559,  1559,  1559,  1559,  2277,   373,   349,  4294,  1509,
     125,   105,   308,   102,   262,  4110,  1554,  2245,  2175,   397,
     251,   130,   125,   261,   377,  2938,   312,  1597,   278,  2523,
     253,   435,   304,   142,  1676,  3799,   397,   146,   361,   262,
     336,     8,   160,  1685,    11,   134,   213,   295,   431,  2962,
     363,   299,   317,   220,  4095,   397,   398,   435,  1590,  1591,
     373,   176,   300,   349,  4105,   262,  1598,  2591,   171,    36,
    1602,  1603,   295,   176,  1568,    42,   324,   155,  3854,   188,
    2182,  2827,   347,  3859,  2830,  1617,  3862,  1619,  2761,   431,
    3581,  3582,  1575,  1653,  2554,   235,   174,   335,   295,    66,
     194,   210,   299,  2182,   288,   245,   310,  1425,  1640,   310,
    1642,   397,   398,   379,  2216,   233,  3892,   379,  1648,  4347,
     385,  3273,  3886,  3747,  3888,  1695,  1444,   324,   429,   398,
     431,  3738,   397,   312,   318,   213,   397,  2216,   247,   236,
     237,   235,   249,  4198,   262,   431,   255,   254,   417,  3677,
    3678,  3758,   267,   151,   526,   192,   152,   361,   530,  1801,
     361,  1803,   431,   347,   267,   431,   431,   390,  4086,   431,
     349,  1898,  1907,   171,   435,   547,   254,   295,  1905,   262,
      57,    58,   262,   350,   180,   352,  2542,   418,   419,   420,
     284,   422,   423,   424,   425,   426,   427,   361,  1840,   195,
     397,   142,   291,   306,   171,   146,   435,   391,   375,   146,
       8,   207,   295,    11,   251,   295,   244,  2445,   397,   398,
     317,  2878,    95,  3920,    75,   192,   193,  2943,   317,   166,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
     391,   105,   345,    11,   324,    84,  3121,  4023,  2570,   314,
     347,  1854,   431,  3950,  2526,   370,  1859,   357,   347,  1862,
    2976,  3097,   371,   378,  2442,   383,   381,   370,    36,   210,
    1819,   238,   350,   124,   352,   378,  2598,   262,   381,   155,
     361,  1884,   146,   361,   251,  1845,  1845,  1819,   385,  3005,
    3006,  1868,  2571,  1870,   372,  4071,   385,   375,    66,   430,
     397,    20,  1802,   176,   435,  2978,   247,   198,   397,   305,
     295,  2985,  3464,   152,   178,    11,  2400,  2811,   426,   284,
     431,    40,  1925,   431,  1854,   433,  2820,   361,  1858,  1859,
    1972,   296,  1862,  2605,   431,  2607,   431,   213,   433,   324,
      36,   180,   431,  2445,   262,   398,  1988,   262,   221,  1952,
     223,   202,   203,   297,  1884,   320,   195,   430,  2637,   397,
     398,  1931,   435,   317,   417,   216,   314,   249,   207,   233,
      66,   235,   254,  1976,   237,   308,   309,   295,   431,  1917,
     295,   418,   419,   420,   220,   422,   423,   424,   425,   426,
     427,   230,  2901,   347,   192,  1925,   220,  3129,  2001,    21,
    3146,  3147,  2005,    80,    26,  3079,   324,  2965,  2966,   324,
     432,   262,   288,   435,   786,   787,  3800,  3801,  3802,  3803,
    2023,   426,  1952,  1953,   192,  3953,   431,  2699,   433,   432,
    2033,   385,   435,  2705,     8,  2908,   174,    11,  2540,  3171,
     429,  2775,   431,  2046,   433,  1975,  1976,     8,  1978,   431,
      11,   433,  2055,   251,   317,   422,   423,   424,   425,   426,
     427,  2540,    36,  2753,  2754,  2755,   305,    28,    42,   432,
     863,  2001,   435,  3923,   350,  2005,   352,   431,  2010,     8,
     432,  3003,    11,   435,   347,   857,  2018,   432,  2020,  2131,
     435,   166,    66,  2023,  3167,   361,  3169,     5,   349,   375,
     351,    73,    10,  2033,  3995,   432,   878,   879,   435,  2079,
      18,  2972,   350,   391,   352,   391,  2046,  2087,   312,  4295,
      48,  2351,   385,  2353,  2354,  2055,   898,    35,   432,   432,
     314,   435,   435,  2943,   397,   198,  2946,  2947,  2948,  2949,
    2950,  2951,  2952,  2953,  2954,  2955,  2510,  2511,   431,  2905,
    1628,  4315,  2279,  1631,   128,   349,   928,   929,  2285,  3687,
     432,  3689,   350,   435,   352,  3693,  2976,  3695,   431,   432,
    3461,   434,  3245,  3289,     9,  4025,   432,  2109,  2148,   435,
    2852,   308,   309,  3352,  2856,  2857,    11,  2859,   431,  2861,
    2862,  2121,   249,   167,  3337,  3005,  3006,   171,  2870,   431,
    3094,  3095,   995,   397,   398,   432,  2176,   435,   435,  2169,
    2169,    36,  2182,  3137,   432,    48,  2135,   435,   192,   193,
     418,   419,   420,   312,   422,   423,   424,   425,   426,   427,
    2902,   192,   432,   432,   434,   209,   435,   431,   397,   398,
     432,    66,  2799,   435,   415,   416,  2216,    84,  2251,   432,
     432,   434,  2182,   435,   422,   423,   424,   425,   426,   427,
     349,    26,    27,   192,   238,  2400,   432,   432,   432,   435,
     435,   435,  2275,   391,  2776,   312,  2778,   251,    38,   432,
     432,  2909,   435,   435,   414,   432,  2216,   312,   435,   312,
     251,   432,   432,  2657,   435,   435,   194,  2776,   312,  2778,
     432,   432,  2429,   435,   435,  3046,   252,   432,   397,   398,
     435,   432,   349,  2245,   435,   152,    44,  2438,    83,   433,
     432,  2251,   251,   435,   349,  3877,   349,   252,  2463,  3386,
    3387,  3388,   719,   432,   721,   349,   435,   102,   432,  2841,
     249,   435,   431,   180,   432,  2275,   432,   435,   357,   435,
    3466,  3467,  2479,  3033,   328,    50,   432,    85,   195,   435,
     397,   398,  2841,  3036,  3037,   397,   398,   192,   193,   134,
     207,   146,   397,   398,   397,   398,   432,   249,   414,   435,
    2422,   109,  2383,   397,   398,   432,   432,    82,   435,   435,
    1000,  1001,   432,   230,   431,   435,   124,  1190,   432,   312,
     128,   435,   252,    38,   432,     0,   431,   435,   431,   194,
     414,   432,   249,   238,   435,   432,   424,   431,   435,   147,
     150,   432,   150,  2383,   435,   435,  2790,   432,  2792,  2359,
     435,   431,    48,   432,   162,  2365,   349,  2397,   432,   312,
    3514,   435,  3504,   138,  3506,  2423,  2424,  2425,   422,   423,
     424,   425,   426,   427,   432,   151,  2416,   418,   419,   420,
     431,   422,   423,   424,   425,   426,   427,   432,   305,  2429,
     435,  3545,   190,   433,   169,  2445,   349,   432,   324,  3289,
     435,  2482,   431,  1276,   397,   398,  1258,   135,    83,   400,
     419,   420,  2495,   422,   423,   424,   425,   426,   427,  2459,
    2459,  2459,  2459,  2459,  2459,   432,  3228,   431,   435,   171,
     205,  2443,   240,  2445,   432,  2445,   433,   435,   431,  2479,
     248,   135,  2482,   249,   397,   398,   291,   432,  3974,   432,
     435,   135,   435,   249,  2537,   130,  2900,   146,   432,   135,
     235,   435,   379,  1315,  1316,  1317,  1318,   142,   208,   105,
    3472,   146,   317,   379,   282,  1348,   151,   432,   431,   249,
     435,   156,   431,  3361,   159,  2495,   161,   361,   432,   432,
    2540,   435,   435,   432,  1367,   432,   435,   244,   435,   391,
    2510,  2511,   347,   432,  1356,  1357,   435,  3448,   198,   314,
    1362,  3648,  3649,   188,  3651,   281,    60,   422,   423,   424,
     425,   426,   427,   431,   299,   397,   301,  2537,   303,  2744,
    2540,  3780,    31,   432,   309,   210,   435,   235,   400,  1412,
     385,   316,   432,   432,   389,   435,   435,  2762,   431,   324,
     235,    31,   397,  2636,  1406,    38,   432,   432,   333,   435,
     435,    38,   432,   366,  2647,   435,   341,   262,   432,   146,
      50,   435,   247,  2623,   391,   391,  3466,  3467,    73,   279,
     255,  1433,  1434,  1435,  1436,   130,   431,   135,   135,   431,
     249,   400,   135,   135,   135,   135,  1469,   142,   435,   135,
     135,   146,    82,   135,   135,  2655,   135,  2617,  2618,  2619,
     249,   135,   135,   347,    31,  3811,   431,   392,   208,   147,
     146,  3373,   249,     5,  3820,   146,  2636,   302,     5,  3381,
    3382,   431,   431,   146,   431,  1487,  2719,  2647,   431,   431,
     272,  3837,  3838,   188,  1496,   431,   431,  2657,   431,     5,
       5,  1503,  2702,   431,   431,     5,     5,   431,   138,   431,
    2782,  2783,   431,   431,   431,   210,   431,   431,   431,   431,
     431,   431,   347,  2880,  2724,   431,  2798,  2727,  2728,   431,
     431,  2731,   431,  3391,   259,   431,   431,  2737,    31,   169,
    2812,   435,    86,   208,  2744,    31,   371,   146,   247,  2821,
    3684,   146,   247,   324,   357,   357,   245,   312,   433,  2719,
     255,   357,  2762,  2835,   357,   312,   357,   357,   198,   394,
     357,   396,   397,    76,   312,   205,  2776,    31,  2778,   135,
     249,   316,  2744,   205,   357,   357,   240,   357,    68,  2751,
    2752,   249,   176,   378,  2756,   245,    50,   357,   431,   357,
    2762,  2761,   431,    76,   429,   235,   262,   432,   433,   434,
     135,   435,   379,   379,  2814,    97,  2776,    48,  2778,    48,
     357,  3745,   253,  1646,   357,   357,   357,   357,    82,  2901,
    2790,  2793,  2792,   357,   357,   357,  2869,    37,  4011,    37,
    2840,  2841,  2832,  2832,   357,   312,   357,   435,   357,  1651,
    2883,   249,   400,   249,   192,   397,  3566,  3960,    31,   388,
      30,  2851,  2851,  3815,    20,   135,  3023,  3024,   431,   299,
    2903,   249,   431,   303,   431,  3577,   371,   235,   431,   309,
     103,  2841,   135,   379,   138,   390,   316,  2334,  2335,   235,
     216,   245,  2339,    31,   324,   146,    31,   431,   313,  4045,
     198,   135,   135,   333,   379,   135,  3608,  3609,   135,  2869,
     135,   341,   151,   379,   244,   169,   357,   239,  3312,  3313,
     397,   431,    11,  2883,   431,   393,   355,   414,   431,   435,
     227,   227,  2379,  2380,   429,   324,  3093,   432,   433,   355,
    2900,   151,   359,  2903,   198,   357,   165,  2909,  3020,  3021,
    3022,   205,   435,   165,   326,    18,   188,   357,   196,   431,
     250,    24,   392,   357,   312,   435,   396,   397,  3670,  3671,
     432,  3811,   431,   379,   435,   432,  3867,  4064,    75,   312,
    3820,   235,  3013,   431,   240,   196,   379,  4074,   196,  2989,
     240,   357,   357,  3024,   357,  4194,   431,  3837,  3838,   361,
     391,    64,   314,  3168,   198,   240,   249,  3015,  3016,  3017,
    3018,    38,   331,   166,   256,   357,   435,   357,  2978,   295,
     248,   312,  3536,  3013,   295,   284,  3684,   321,  3962,   357,
     192,    31,   192,  3023,  3024,   192,   357,   192,   379,  4126,
     379,   192,   248,  3043,   418,   299,  3970,    30,   429,   303,
     113,   431,   429,   357,   418,   309,   357,   120,   135,   146,
     123,   245,   316,   148,   321,   357,   135,   391,   357,    31,
     324,   431,   431,   249,   397,   249,   146,   163,    31,   333,
     163,   135,   249,  3785,   249,  3787,  3788,   341,   146,   171,
     171,  3124,   171,   400,  4046,   321,  3798,    19,  1900,  1901,
    1902,   435,   157,   224,   435,   249,   435,  1909,    48,  1911,
     347,  1913,  1914,   176,   361,   435,   244,   391,   198,   432,
     151,   432,   432,   432,   432,   266,  4213,   151,   258,   394,
     432,    13,    13,   414,   394,   357,  1959,   432,   392,   385,
     249,   377,   396,   431,  3731,   432,   414,   432,   302,   432,
     210,   435,  3684,   432,   432,   432,   418,   432,   252,  4050,
     432,   249,  4114,   432,  3124,   431,  4118,  4119,  3168,   174,
     233,   135,   235,   431,   357,  3208,   431,   357,  3211,   400,
     357,   182,   245,   240,   135,   357,  3882,   253,   135,   210,
     253,  3191,   267,  3957,  3194,   267,  3196,   376,   357,   262,
     218,   218,   218,  3163,  3276,  4045,  3168,  3167,   357,  3169,
     357,  3190,  4115,  4137,  2016,   357,   312,   357,     8,   312,
     357,    11,   312,  3295,   357,   357,  4116,  4122,  3190,  4124,
     357,   357,   295,   357,   312,  3235,   299,     8,   235,   135,
      11,  3241,  3242,   357,  3244,    37,    36,   357,  3208,   192,
    3322,  3211,    42,   324,   192,   192,   431,     3,   429,   315,
     225,   324,   210,   432,   432,    36,   418,   366,   432,   435,
    2072,    42,    38,    96,   297,   248,    66,  2100,  2080,  3279,
    3280,  3281,  3282,  2085,   432,  3245,  3319,  3249,  3250,    22,
      23,   249,   435,  4396,    27,    66,   432,   431,  3260,    32,
      33,    34,    31,    36,   357,   160,    39,    40,   312,    42,
     312,    44,   379,   312,   379,   435,   252,  3279,   133,   382,
     133,    96,   192,   429,  4258,   126,   151,    11,   146,   432,
     432,  4222,   432,    58,   432,   151,   431,  4039,   390,   159,
    4443,   432,  3499,   435,   250,    31,  3503,   431,  4451,  3349,
     146,   379,  3312,  3313,   379,   431,  3346,  3346,   432,  3319,
     182,  3394,   357,   366,  4014,   357,   357,   431,  2170,   357,
     432,  3536,   366,   432,   146,   357,   357,   167,   312,  3893,
     312,   171,  4085,   432,   432,   432,   432,    66,   135,    96,
     366,  4093,   432,   192,   192,   430,   167,  2199,   430,  2201,
     171,   431,   192,   193,   397,   196,   432,   280,  3408,   431,
     321,  3483,  3484,  3485,  3486,    21,   431,   177,  3932,   209,
     400,   192,   193,   435,   146,  4127,   432,   435,    71,  3391,
    3962,   349,   357,   321,  3394,   431,   156,   435,   209,   151,
    2263,   192,   432,   192,   177,   178,   179,   180,   238,   182,
     192,   184,   192,   186,   432,   188,   151,   431,   191,   289,
     432,   251,    68,   196,    48,   198,   395,   238,   395,   202,
     257,   204,   432,   432,   435,   431,   195,  4380,   195,   431,
     251,    48,   432,   161,    21,   418,   432,   245,   357,   151,
     435,    97,   397,    66,  2296,   176,  2943,   240,   366,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,  3499,
     240,   418,   118,  3503,   435,   435,   357,    54,   135,   192,
     430,   153,   151,   129,   171,   379,   379,    31,   121,   393,
      67,   397,   431,  3533,   397,   151,   431,   179,   328,   252,
     151,   431,   148,    80,   431,   289,   384,   153,   334,   432,
     195,  3558,   432,  3543,  3543,   431,   431,   328,  3005,  3006,
     396,   265,   249,   290,   357,   432,   397,   432,   357,   146,
     432,   431,   431,  3552,   110,   240,  3733,    31,   219,   240,
     174,   118,   431,   280,   431,  3618,   432,   431,   134,    31,
    3552,   309,   129,   199,   253,   432,    48,  3630,   309,   431,
      48,   255,   431,   379,   349,   233,   432,     5,   141,   249,
     280,   148,   321,    60,   220,   252,   153,    60,   116,   383,
     289,   384,    31,   435,   151,  3604,   394,   287,   418,   419,
     420,   146,   422,   423,   424,   425,   426,   427,  3598,   121,
     397,   176,  3604,   431,   249,   249,    31,  4234,   419,   420,
      31,   422,   423,   424,   425,   426,   427,   252,  3618,  3621,
    3622,   252,   431,   108,  3626,  3627,   431,  3667,  3668,    48,
    3630,   432,  4374,   279,   308,   377,   432,  3677,  3678,   432,
       5,   431,   308,   220,  3684,    17,    28,   716,  3688,  1331,
     134,   280,   431,  2133,   802,  1133,  2445,  3854,  1985,  3167,
     306,  2050,  3859,   776,  2598,  3862,   312,  2742,  3244,  4129,
    3960,  3783,   318,  4258,   251,  3866,  4230,  4007,  3310,  4011,
    2543,  3724,  3684,  3993,  3684,  2517,  4258,  3706,  3893,  2233,
    4322,  3892,  4379,  4272,  4271,  3892,  4338,  4178,  3302,  2521,
    3163,   347,   279,   349,  3706,  2124,  2618,  2549,  2124,  2551,
    2552,  2553,  2118,  3753,  1430,  2813,  4384,  4451,  3923,  4443,
     366,  3988,  2761,  2746,  4349,  3934,  3799,  3932,  1420,  4246,
    4330,  3937,    26,   988,  3931,   312,     0,  3394,  4091,  3779,
    3352,   318,  3350,   516,   321,   391,  4194,   566,   521,  1948,
     523,  2703,  4362,   526,  4445,   528,  4169,   530,   695,  1802,
    3800,  3801,  3802,  3803,   537,  1803,  1509,   540,  2459,  3335,
     347,  3544,  3076,  1841,   547,   708,   353,  3974,  2460,  2471,
    1843,  2644,  1159,  2646,  1842,  1178,  1177,  2466,  1180,   366,
    2487,  2479,  3024,  3491,  3505,  4072,   569,  3023,  1185,  3799,
    3077,   574,  3289,   700,  2099,  2988,   579,  4048,  2980,  4309,
     583,  4310,  4313,  3886,   391,  3888,  2463,  2397,  2305,    83,
    2395,  3072,    -1,    -1,  3854,   598,  4023,  1677,    -1,  3859,
      -1,    -1,  3862,    -1,    -1,    -1,    -1,  2700,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2725,    -1,    -1,  3977,   130,    -1,    -1,  3879,
      -1,    -1,    -1,   646,  4071,    -1,    -1,    -1,   142,    -1,
      -1,    -1,   146,  3923,   657,   658,  3886,   151,  3888,    -1,
      -1,    -1,   156,    -1,    -1,   159,    -1,   161,    -1,    -1,
      -1,    -1,  4014,   676,    -1,   678,   679,    -1,    -1,    -1,
     683,    -1,    -1,  3953,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,  3962,   696,   188,    -1,  3966,   700,  3968,    -1,
      -1,  3971,  3972,   706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   717,    -1,   210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   729,    -1,  4155,    -1,
    3960,    -1,  3962,  2826,    -1,    -1,    -1,  3997,  3997,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3466,
    3467,    -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,
    2853,   255,  4104,    -1,    -1,    -1,    -1,    -1,    -1,   772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   784,    -1,   786,   787,    -1,    -1,    -1,    -1,    -1,
      -1,  2863,    -1,    -1,  2866,  4230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,
      -1,  4071,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   829,    -1,    -1,  2922,
      -1,     0,    -1,    -1,    -1,    -1,    -1,   840,    -1,  2911,
      -1,   844,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2942,
      -1,    -1,    -1,   347,   857,    -1,    -1,  4284,    -1,    -1,
    4130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4295,   872,
      -1,    -1,    -1,    -1,  2967,   878,   879,   371,    -1,    -1,
    4110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   894,   895,   896,    -1,   898,    -1,   900,  4325,    -1,
     394,    -1,   396,   397,    -1,    -1,    -1,    -1,    -1,    -1,
    3003,    -1,    -1,    -1,    83,    -1,  4176,  4176,    -1,    -1,
      -1,    -1,    -1,   926,    -1,   928,   929,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   429,    -1,    -1,   432,   433,
     434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   951,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   142,    -1,    -1,    -1,   146,   981,   982,
      -1,    -1,   151,   986,    -1,   988,    -1,   156,  4258,    -1,
     159,    -1,   161,    -1,    -1,   998,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1006,    -1,    -1,  1009,    -1,    -1,  1012,
      -1,    -1,  4315,    -1,    -1,    -1,    -1,    -1,    -1,   188,
    4447,    -1,  1025,    -1,    -1,    -1,    -1,    -1,  4258,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,  3115,  3116,  3117,  3118,    -1,    -1,    -1,
      -1,  1054,    18,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,  1082,
    1083,    -1,  1085,    -1,    -1,  4315,   255,    -1,    -1,    -1,
    4350,  4350,    -1,    -1,  3811,    -1,    -1,    -1,    64,  1102,
    4401,    -1,  4362,  4362,  4362,  4362,  4362,  4362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3837,  3838,    -1,    -1,    -1,    -1,  4396,    -1,    -1,    -1,
      -1,    -1,    -1,   302,    -1,  1138,    -1,    -1,  1141,    -1,
      -1,  4401,  4401,  4401,  4401,  4401,  4401,   113,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
      -1,    -1,    -1,    -1,  4396,    -1,  4396,  1170,    -1,    -1,
      -1,  1174,  1175,  4443,    -1,    -1,    -1,    -1,   347,    -1,
      -1,  4451,  1185,  1186,  1187,  4445,  4445,  4445,  4445,  4445,
    4445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1203,    -1,   371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,  4443,    -1,  4443,    -1,  3287,    -1,    -1,    -1,  4451,
      -1,  4451,    -1,  3316,    -1,   394,    -1,   396,   397,    -1,
      -1,    -1,    -1,  1236,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,  1248,  1249,    -1,    -1,    -1,
      -1,    -1,  1255,    -1,    -1,  1258,    -1,    -1,    50,    -1,
     429,    -1,    -1,   432,   433,   434,    -1,   233,    -1,   235,
      -1,    -1,    -1,    -1,    -1,  1278,    -1,    -1,    -1,   245,
      -1,  1284,    -1,    -1,  1287,    -1,    -1,   253,    -1,    -1,
      82,    -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1307,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1315,  1316,  1317,  1318,  1319,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,  1330,  4045,   295,
    1333,    -1,    -1,   299,    -1,    -1,    -1,    28,    -1,    -1,
      -1,  1344,    -1,  1346,    -1,    36,   138,    -1,    -1,    -1,
      -1,    42,    -1,  1356,  1357,    -1,    -1,    -1,   324,  1362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,   169,    -1,  3472,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,  1406,    -1,    -1,   198,    -1,    -1,    -1,
      -1,    -1,    -1,   205,    -1,    28,   382,    -1,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
    1433,  1434,  1435,  1436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1445,   235,    -1,    -1,    -1,    -1,  1451,    -1,
      -1,  1454,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
    1463,    -1,    -1,    -1,    -1,    -1,    -1,  1470,    -1,  1472,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,  1482,
     171,    -1,    -1,    -1,  1487,    -1,  3579,    -1,    -1,    -1,
      -1,    -1,    -1,  1496,    -1,    -1,    -1,    -1,    -1,  1502,
    1503,   192,   193,    -1,  1507,    -1,    -1,   299,    -1,    -1,
      -1,   303,    -1,    -1,  3607,    -1,    -1,   309,   209,    -1,
      -1,    -1,    -1,    -1,   316,    -1,    -1,    -1,    -1,  1532,
    3623,    -1,   324,    -1,    -1,    -1,  1539,    -1,  1541,    -1,
      -1,   333,  1545,  1546,   235,  1548,    -1,   238,    -1,   341,
      -1,  1554,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,
     251,    -1,    -1,   254,    -1,  1568,  1569,    -1,    -1,  1572,
      -1,    -1,    -1,  1576,    -1,  1578,  3669,    -1,  3650,   192,
     193,    -1,  1585,    -1,    -1,  1588,    -1,    -1,    -1,  1592,
      -1,    -1,  3664,    -1,    -1,    -1,   209,  1600,  1601,    -1,
     392,    -1,    -1,    -1,   396,  1608,    -1,  1610,  1611,  1612,
    1613,  1614,    -1,    -1,    -1,    -1,    -1,    -1,  1621,  1622,
      -1,  1624,   235,  1626,  1627,   238,    -1,  1630,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,   251,    -1,
      -1,   254,    -1,    -1,  1647,    -1,    -1,    -1,  1651,  1652,
      -1,    -1,    -1,  1656,    -1,    -1,    -1,  1660,    -1,  1662,
    1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,    -1,  1672,
      -1,    -1,    -1,  1676,  1677,    -1,  1679,    -1,    -1,    -1,
      -1,    -1,  1685,    -1,    -1,  3757,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    36,    -1,    -1,
      -1,    -1,  3815,    42,    -1,    -1,    -1,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,    -1,    -1,   430,
      -1,    -1,    -1,    -1,    -1,   436,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,  1801,    -1,
    1803,    -1,  1805,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    66,
      -1,    -1,  3894,  3895,  3896,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1840,    -1,    -1,
      -1,    -1,    -1,  1846,    -1,  1848,    -1,    -1,   167,    -1,
      -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1863,    -1,    -1,    -1,    -1,  1868,    -1,  1870,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1887,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,  1898,    -1,  1900,  1901,  1902,
      -1,    -1,  1905,    -1,  1907,    -1,  1909,    -1,  1911,     8,
    1913,  1914,    11,    -1,  1917,    -1,   235,    -1,    -1,   238,
     167,    -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,    28,
      -1,    -1,   251,  1936,    -1,   254,    -1,    36,    -1,    -1,
      -1,    -1,    50,    42,    -1,   192,   193,    -1,    -1,    -1,
    4022,    -1,  1955,  4046,    -1,    -1,    -1,    -1,  1961,    21,
      -1,    -1,   209,  1966,    -1,    -1,    -1,    66,    -1,  1972,
      -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4076,    -1,  1988,    -1,    -1,   235,  1992,
    1993,   238,    54,    -1,    -1,    -1,  1999,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    67,    68,   254,    -1,   328,
      -1,    -1,    -1,  2016,    76,    -1,    -1,    -1,    80,    -1,
      -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,  4100,    -1,
     138,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,  2042,
      -1,  2044,  2045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4123,    -1,  4125,    -1,    -1,   118,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,    -1,   129,   167,  2072,
      -1,    -1,   171,    -1,    -1,   137,    -1,  2080,    -1,    -1,
      -1,   328,  2085,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,   153,    -1,   192,   193,  2098,    -1,   205,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
     209,    -1,   174,    -1,    -1,    -1,   435,    -1,    -1,    -1,
      -1,    -1,    -1,  2126,    -1,    -1,  2129,   235,  2131,    -1,
    2133,    -1,    -1,  2136,    -1,    -1,   235,   199,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,   262,   254,  4228,    -1,   220,  2162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2170,  2171,    -1,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,    -1,    -1,    -1,    -1,    -1,    -1,   295,   435,   251,
      -1,   299,    -1,    -1,  2197,   303,  2199,  2200,  2201,  2202,
      -1,   309,    -1,    -1,    -1,    -1,     8,  4279,   316,    11,
      -1,    -1,    -1,    -1,    -1,    -1,   324,   279,  2221,    -1,
      -1,    -1,    -1,    -1,    -1,   333,    28,    -1,    -1,   328,
    2233,    -1,    -1,   341,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,   306,    -1,    -1,    -1,   310,    -1,
     312,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,   321,
      -1,  4333,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2279,    -1,    -1,    -1,
      -1,    -1,  2285,    -1,   392,   347,    -1,   349,    -1,    -1,
      -1,   353,    -1,  2296,    -1,    -1,    -1,    -1,    -1,   361,
    2303,  2304,    -1,    -1,   366,    -1,  2309,    -1,    -1,  4381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   391,
      -1,  2334,  2335,   432,    -1,    -1,  2339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  2351,  2352,
    2353,  2354,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,  2364,    -1,    -1,  2367,   167,  2369,  2370,    -1,   171,
      -1,    -1,    36,    -1,    -1,    28,  2379,  2380,    42,    -1,
    2383,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
     192,   193,    -1,  2396,    -1,  2398,    -1,  2400,    -1,  2402,
      -1,    -1,    66,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    66,    -1,  2418,    -1,     0,    -1,  2422,
      -1,    -1,    -1,    -1,    -1,    -1,  2429,    -1,  2431,  2432,
    2433,    14,    -1,   235,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    24,    -1,    26,    27,  2448,    -1,    -1,    -1,   251,
      -1,    -1,   254,    -1,    -1,    -1,    -1,  2460,    41,    -1,
      -1,    -1,  2465,    -1,    -1,    -1,    -1,    -1,  2471,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2479,    -1,    61,  2482,
      63,    64,    -1,  2486,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,  2516,   167,  2518,    99,    -1,   171,   102,
    2523,    -1,    -1,    -1,    -1,    -1,   328,    -1,   192,   193,
      -1,   114,    -1,   116,    -1,    -1,    -1,   120,    -1,   192,
     193,    -1,    -1,   126,    -1,   209,  2549,    -1,  2551,  2552,
    2553,   134,    -1,   136,    -1,    -1,   209,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   156,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,   238,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,    -1,    -1,   211,   212,
     432,    -1,    -1,    -1,   217,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   226,   863,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,   328,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,   274,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,    -1,    -1,   291,   292,
      -1,   294,    36,    -1,    -1,    -1,   299,    -1,    42,    -1,
      -1,   304,    -1,    -1,   307,    -1,  2729,  2730,   311,    -1,
      -1,    -1,    -1,   316,   317,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    66,    -1,   327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   347,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,   995,   430,    -1,  2782,
    2783,   364,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,   167,  2798,    -1,   380,   171,    -1,
      -1,    -1,   385,    -1,   128,    -1,    -1,    -1,  2811,  2812,
      -1,    -1,    -1,    -1,   397,    -1,    -1,  2820,  2821,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2835,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    -1,    -1,   171,   431,    -1,
      -1,   434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2863,    -1,   235,  2866,    -1,   238,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2880,   251,    -1,
      -1,   254,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2901,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2911,    -1,
      -1,    -1,    -1,    -1,   238,    -1,  2919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2929,   251,    -1,    -1,
      -1,    -1,  2935,    -1,  2937,    -1,    -1,    -1,    -1,    -1,
    2943,    -1,    -1,  2946,  2947,  2948,  2949,  2950,  2951,  2952,
    2953,  2954,  2955,    -1,    -1,   328,  2959,  2960,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,  2972,
      -1,  1190,    -1,  2976,    -1,    -1,    -1,  2980,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,  2990,    -1,    -1,
    2993,    -1,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,  3004,  3005,  3006,   328,    -1,    64,  3010,    36,    -1,
    3013,    -1,    -1,    -1,    42,    -1,    -1,  3020,  3021,  3022,
    3023,  3024,  3025,    -1,    -1,  1244,  3029,  3030,    -1,    -1,
      -1,  3034,    -1,    -1,    -1,    -1,    18,  3040,    66,  3042,
      -1,  3044,    24,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   113,    -1,  1276,    -1,   432,
      -1,    -1,   120,  3066,    -1,   123,    -1,    -1,    -1,  3072,
      -1,    -1,    -1,  3076,    -1,  3078,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3093,  3094,  3095,    -1,  3097,    -1,    -1,    -1,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3115,  3116,  3117,  3118,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1348,
      18,   113,    -1,    -1,    -1,    -1,    24,    -1,   120,   167,
      -1,   123,    -1,   171,    -1,    -1,    -1,    -1,  1367,    -1,
    3153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,  1387,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    64,   235,    -1,    -1,
     177,   209,    -1,    -1,    -1,    -1,    -1,   245,    -1,   186,
     187,    -1,    -1,  1412,   176,   253,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,   203,   235,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3225,   251,    -1,   113,   254,    -1,    -1,    -1,
      -1,    -1,   120,    -1,    -1,   123,    -1,   295,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1469,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   245,    -1,    -1,   324,    -1,    -1,    -1,
      -1,   253,    -1,  3276,    -1,     8,    -1,    -1,    11,    -1,
     262,    -1,    -1,    -1,  3287,    -1,  3289,    -1,   176,    -1,
      -1,    -1,  3295,    -1,    -1,    28,    -1,    -1,  3301,    -1,
     328,    -1,    -1,    36,    -1,    -1,    -1,  3310,    -1,    42,
      -1,    -1,    -1,   295,    -1,    -1,    -1,   299,    -1,  3322,
      -1,    -1,    -1,    -1,   382,    -1,    -1,    -1,  3331,    -1,
      -1,    -1,    -1,    66,  3337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,   233,    -1,   235,    -1,    -1,
    3353,  3354,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3376,   262,  3378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     382,    -1,    -1,    -1,   432,    28,    -1,   295,  3411,    -1,
      -1,   299,     8,    36,    -1,    11,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,    -1,    -1,
      -1,    -1,    28,    -1,   167,    -1,   324,    -1,   171,    -1,
      36,    -1,    -1,    66,    -1,  3448,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3458,  3459,    -1,    -1,   192,
     193,    -1,    -1,  3466,  3467,    -1,    -1,    -1,  3471,    -1,
      66,    -1,    -1,    -1,  3477,  3478,   209,    -1,  3481,    -1,
    3483,  3484,  3485,  3486,    -1,    -1,    -1,  3490,  3491,  3492,
      -1,    -1,  3495,    -1,   382,    -1,  3499,    -1,    -1,    -1,
    3503,    -1,   235,    -1,    -1,   238,  3509,    -1,    -1,    -1,
    3513,    -1,    -1,    -1,    -1,  3518,    -1,    -1,   251,    -1,
      -1,  3524,    -1,    -1,    -1,    -1,   523,  3530,    -1,    -1,
      -1,    -1,    -1,  3536,    -1,    -1,    -1,    -1,   535,    -1,
      -1,  3544,   539,    -1,   167,  3548,    -1,    -1,   171,    -1,
      -1,    -1,    -1,   550,    -1,  3558,    -1,    -1,  3561,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   565,   192,
     193,   167,   569,    -1,    -1,   171,    -1,    -1,  3581,  3582,
      -1,    -1,   579,   580,    -1,    -1,   209,    -1,   585,    -1,
      -1,    -1,    -1,    -1,    -1,   328,   192,   193,   595,    -1,
      -1,    -1,  3605,    -1,    -1,    -1,   603,    -1,    -1,    -1,
      -1,    -1,   235,   209,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
      -1,    -1,   238,    -1,    -1,    -1,    -1,  3650,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,   254,    -1,
      -1,  3664,    -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,   676,
      -1,    -1,    -1,    -1,   681,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,  3722,
      -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,  1947,  1948,
    3733,    -1,   328,    -1,    -1,  3738,    -1,    -1,    -1,    -1,
    1959,    -1,  3745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3757,  3758,    -1,    -1,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3783,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,  3811,   432,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3820,    -1,    -1,
      -1,    -1,   418,   419,   420,   176,   422,   423,   424,   425,
     426,   427,   829,    -1,  3837,  3838,   432,    -1,  3841,    -1,
      -1,    -1,    -1,   840,    -1,    -1,    -1,  3850,    -1,    -1,
      -1,  3854,    -1,    -1,    -1,    -1,  3859,    -1,    -1,  3862,
    3863,    -1,  3865,    -1,  3867,  3868,   863,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2100,   233,    -1,   235,    -1,    -1,    -1,    -1,  3892,
    3893,  3894,  3895,  3896,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,   900,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  3931,  3932,
      -1,    -1,    -1,    -1,    -1,   932,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,   299,    -1,
     947,    -1,    36,    -1,   951,    -1,    -1,    18,    42,    -1,
    2179,    -1,   959,    24,    -1,    -1,    -1,  3970,    -1,    -1,
      -1,  3974,    -1,   324,  3977,    -1,    -1,    -1,     8,    -1,
      -1,    11,    66,    -1,    -1,  3988,    -1,    -1,    -1,    18,
     987,    -1,  3995,    -1,    -1,    24,  3999,    -1,   995,    -1,
     997,    -1,    -1,    64,    -1,    -1,    36,    -1,  4011,    -1,
      -1,  4014,    42,  1010,    -1,    -1,  1013,    -1,    -1,  4022,
    4023,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1025,    -1,
      -1,   382,    -1,    -1,    -1,    64,    66,    -1,    -1,    -1,
      -1,    -1,  4045,    -1,  2263,  4048,    -1,  4050,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,  1054,    -1,   120,
      -1,    -1,   123,    -1,  4067,    -1,    -1,    -1,  4071,    -1,
      -1,  4074,    -1,    -1,    -1,    -1,    -1,  4080,    -1,    -1,
      -1,    -1,    -1,   167,   113,  1082,  1083,   171,  1085,    -1,
      -1,   120,    -1,    -1,   123,    -1,    -1,  4100,   128,    -1,
      -1,  4104,    -1,    -1,    -1,  1102,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,  4122,
    4123,  4124,  4125,    -1,    -1,   209,    -1,  1124,    -1,    -1,
      -1,    -1,    -1,    -1,  4137,  1132,  1133,   167,    -1,    -1,
      -1,   171,    -1,    -1,  1141,  1142,    -1,   176,    -1,    -1,
      -1,   235,  4155,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   192,   193,    -1,    -1,    -1,   251,    -1,    -1,
     254,  4174,   233,  1170,   235,    -1,    -1,  1174,  1175,   209,
      -1,    -1,    -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,  1190,    -1,    -1,    -1,    -1,    -1,  1196,
      -1,   262,    -1,    -1,   233,    -1,   235,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,  4222,
      -1,   251,    -1,    -1,   253,  4228,    -1,  4230,     8,    -1,
      -1,    11,    -1,   262,   295,    -1,  4239,    -1,   299,    -1,
      -1,    -1,    -1,    -1,   328,    -1,    -1,  1244,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,   324,    -1,    -1,   295,    -1,    -1,    -1,
     299,    -1,    -1,    -1,    -1,    -1,  4279,    -1,    -1,  1276,
      -1,  4284,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,  4295,    -1,    -1,   324,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,  4312,
    4313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   382,  4325,    -1,  2543,    -1,    -1,    -1,    -1,    -1,
    4333,  1328,    -1,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,    -1,    -1,    -1,    -1,   432,    -1,
      -1,  1348,    -1,   382,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    24,    -1,  4366,    -1,    -1,  2585,  2586,    -1,  2588,
    1367,    -1,    -1,  4376,    -1,    -1,    -1,    -1,  4381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
    1387,   171,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1407,    -1,   192,   193,    -1,  1412,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2644,    -1,  2646,    -1,   209,
    1427,    -1,    -1,    -1,     8,  4438,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,  4447,    -1,  1443,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,   235,    -1,   120,   238,    -1,
     123,    -1,    36,    -1,    18,    -1,  1463,    -1,    42,    -1,
      24,   251,  1469,    -1,   254,  1472,    -1,  1474,  1475,    -1,
      -1,  2700,    -1,    -1,    -1,    -1,    -1,    -1,  1485,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1497,  1498,    -1,    -1,    -1,    -1,  2725,    -1,    -1,    -1,
      64,    -1,  1509,   176,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2762,  1541,    -1,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,   113,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,     8,   123,
     233,    11,   235,    -1,    -1,    -1,    -1,    -1,    -1,  1576,
      -1,  1578,   245,    -1,    -1,    -1,    -1,    -1,  1585,    -1,
     253,  1588,    -1,   167,    -1,  1592,    36,   171,    -1,   262,
      -1,    -1,    42,  1600,  1601,    -1,    -1,  2826,    -1,    -1,
     863,  1608,    -1,    -1,  1611,  1612,  1613,  1614,   192,   193,
      -1,    -1,   176,  2842,  1621,  1622,    66,  1624,     8,  1626,
    1627,    11,   295,  1630,  2853,   209,   299,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,    28,  1646,
    1647,  1648,   432,    -1,    -1,  1652,    36,    -1,    -1,  1656,
      -1,   324,    42,  1660,   238,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,    -1,  1672,    -1,   251,    -1,   233,
    1677,   235,  1679,    -1,    -1,    -1,    66,    -1,   128,    -1,
      -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,  2922,    -1,    -1,    -1,    -1,   262,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,
      -1,    -1,    -1,  2942,    -1,    -1,    -1,   167,    -1,    -1,
       8,   171,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,   995,    -1,    -1,   299,    -1,    -1,  2967,    -1,
      28,    -1,   192,   193,   328,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,   209,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3003,    -1,    -1,   167,    66,    -1,
      -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1805,    -1,
      -1,   251,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,
     424,   425,   426,   427,    -1,   235,    -1,  1854,   238,    -1,
      -1,  1858,  1859,    -1,    -1,  1862,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,   254,    18,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,  1884,   328,   167,
    1887,    -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1898,    -1,    -1,    -1,    -1,    -1,    -1,  1905,    -1,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,  1925,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,  1190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,   328,  3168,
    1947,  1948,    -1,    -1,    -1,  1952,  1953,   235,    -1,    -1,
     238,    -1,  1959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,   251,    -1,    -1,   254,   120,  1975,  1976,
     123,  1978,   422,   423,   424,   425,   426,   427,    -1,    -1,
      -1,  1244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2001,    -1,    -1,    -1,  2005,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1276,    -1,    -1,  2023,    -1,     8,    -1,
      -1,    11,    -1,   176,    -1,    -1,  2033,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,    28,  2046,
     328,    -1,   432,    -1,    -1,    -1,    36,    -1,  2055,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
     233,    -1,   235,    -1,    -1,  1348,    -1,  3316,    28,    -1,
      -1,  2098,   245,  2100,    -1,    -1,    36,    -1,    -1,    -1,
     253,    -1,    42,    -1,  1367,    -1,    -1,    -1,    -1,   262,
      -1,    -1,    -1,    -1,  2121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3352,  1387,    -1,    66,    -1,    -1,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
      -1,    -1,   295,    -1,   432,    -1,   299,    -1,    -1,  1412,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,   324,  2179,    -1,    -1,  2182,    -1,   167,    36,    -1,
      -1,   171,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   192,   193,    -1,    -1,  1469,    -1,    66,  2216,
      -1,    -1,    -1,    -1,  2221,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,   382,
      -1,   171,  3461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3472,  2251,   235,    -1,    -1,   238,    -1,
      -1,    -1,   192,   193,    -1,    -1,  2263,    -1,    -1,    -1,
      -1,   251,    -1,    -1,   254,    -1,    -1,    -1,  2275,   209,
      -1,    -1,  2279,    -1,    -1,    -1,    -1,    -1,  2285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   235,  2303,  2304,   238,    -1,
      -1,    -1,  2309,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      18,   251,    -1,   171,   254,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2334,  2335,    -1,
      -1,    -1,  2339,    -1,   192,   193,    -1,    -1,   328,    -1,
      -1,    49,    -1,    -1,  2351,  2352,  2353,  2354,    -1,    -1,
    3579,   209,  2359,    -1,    -1,    -1,    64,  2364,  2365,    -1,
    2367,    -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2379,  2380,    -1,    -1,  2383,   235,  3607,    -1,
     238,    -1,    -1,  1646,    -1,    -1,    -1,    95,   328,  2396,
      -1,  2398,    -1,   251,  3623,  2402,   254,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
      -1,  2418,   120,    -1,    -1,   123,  1679,    -1,    -1,    -1,
      -1,    -1,  2429,    -1,  2431,  2432,  2433,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,  2445,    -1,
    3669,  2448,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2460,    -1,    -1,    -1,    -1,  2465,    -1,
      -1,    -1,    -1,    -1,  2471,   173,    -1,    -1,   176,    -1,
     328,    -1,  2479,    -1,    -1,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,  2495,    -1,
      -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2510,  2511,    -1,    -1,    -1,    -1,  2516,
      -1,    -1,    -1,   221,    -1,   223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,   235,    -1,    -1,
    2537,    -1,    -1,  2540,    -1,    -1,  2543,   245,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   261,   262,    -1,    -1,    -1,    -1,    -1,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,  2585,  2586,
      -1,  2588,    -1,    -1,    -1,    -1,  3815,   295,    -1,    -1,
      -1,   299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2617,  2618,  2619,    -1,     8,    -1,   324,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,  2636,
      -1,    -1,    -1,    -1,    28,    -1,    -1,  2644,    32,  2646,
    2647,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,
    2657,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,   382,    -1,    -1,    13,    -1,  1942,
      -1,    -1,    -1,    19,  1947,  1948,    -1,    -1,    -1,    -1,
      -1,    -1,    28,  2700,  3923,    -1,  1959,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,  2719,    -1,    -1,    -1,    -1,   111,  2725,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2744,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2761,  2762,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2776,
      -1,  2778,    -1,   167,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,  2790,    -1,  2792,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4025,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,  4046,    -1,  2826,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2841,  2842,    -1,  2100,    -1,    -1,
      -1,   235,    -1,    -1,   238,    -1,  2853,  4076,   184,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,   194,   195,
     254,   197,  2869,   199,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2880,    -1,    -1,  2883,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,  4114,    -1,    -1,    -1,  4118,
    4119,    -1,    -1,  2900,    -1,    -1,  2903,    -1,    -1,    28,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,  2919,    42,    -1,  2922,  2179,    -1,    -1,    -1,
      -1,    -1,  2929,    -1,    -1,    -1,    -1,    -1,  2935,    -1,
    2937,    -1,    -1,    -1,   328,  2942,  2943,    66,    -1,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,    -1,
      -1,    -1,  2959,  2960,    -1,    -1,    -1,    -1,    -1,    -1,
    2967,    -1,    -1,    -1,    -1,  2972,    -1,    -1,    -1,  2976,
      -1,  2978,    -1,  2980,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,  2990,    11,   379,  2993,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3003,  3004,  3005,  3006,
    2263,    28,    -1,  3010,    -1,    -1,  3013,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,  3023,  3024,    -1,    -1,
      -1,    -1,    -1,    -1,   418,   419,   420,  3034,   422,   423,
     424,   425,   426,   427,    -1,  3042,    -1,  3044,   167,    66,
      -1,    -1,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3066,
      -1,    -1,    -1,   192,   193,  3072,    -1,    -1,    -1,    -1,
      -1,  3078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,  3093,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,   238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3124,    -1,   146,
      -1,    -1,   251,    -1,   151,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,
     167,    -1,    -1,   193,   171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,    -1,  3163,    -1,    -1,    -1,
    3167,  3168,  3169,    -1,    -1,   192,   193,    -1,  2431,  2432,
    2433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,   524,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   532,    -1,    -1,   328,
      -1,  3208,    -1,    -1,  3211,   541,   542,    -1,   235,    -1,
     546,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   557,    -1,    -1,   251,    -1,     8,   254,    -1,    11,
      -1,    -1,    -1,    -1,   570,    -1,    -1,    -1,  3245,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
     586,    -1,    -1,   589,    36,   591,    -1,   593,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2543,    -1,  3289,    -1,    66,    -1,    -1,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
      -1,   328,    -1,    -1,    -1,  3312,  3313,    -1,    -1,  3316,
      -1,    -1,  3319,    -1,    -1,    -1,    -1,   653,    -1,   655,
      -1,    -1,  2585,  2586,    -1,  2588,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3352,  3353,  3354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2644,    -1,  2646,    -1,   167,    -1,  3394,    -1,   171,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,    -1,    -1,    -1,  3411,    -1,    -1,    -1,    -1,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,   767,    -1,    -1,    -1,    -1,    -1,  2700,    -1,    -1,
      -1,  3448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3458,  3459,   235,  3461,    -1,   238,    -1,    -1,  3466,
    3467,    -1,  2725,    -1,  3471,  3472,    -1,    -1,    -1,   251,
    3477,  3478,   254,    -1,  3481,    -1,    -1,    -1,    -1,    -1,
      -1,  2744,   818,    -1,    -1,   535,    -1,    -1,    -1,   539,
      -1,   273,  3499,    -1,    -1,    -1,  3503,   833,    -1,  2762,
     550,    -1,    -1,    -1,    -1,    -1,  3513,    -1,    -1,    -1,
     846,  3518,    -1,    -1,    -1,   565,    -1,   853,    -1,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,   865,
     580,    -1,   868,    -1,    -1,   585,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   595,   328,    -1,    -1,    -1,
      -1,    -1,    -1,   603,  3561,    -1,    -1,    -1,    -1,    -1,
     342,    -1,    -1,  2826,     8,   901,    -1,    11,    -1,    -1,
      -1,    -1,  3579,    -1,    -1,     8,    -1,    -1,    11,  2842,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
    2853,  3598,    36,    -1,    -1,    28,    -1,    -1,    42,    -1,
    3607,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,  3618,    -1,    -1,    -1,    -1,  3623,    -1,    -1,    -1,
      -1,    -1,    66,  3630,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   681,    -1,    66,    -1,    -1,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2922,
      -1,    -1,  3669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3684,    -1,  2942,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,  2967,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,  3722,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    28,  3733,   171,    31,    -1,
      -1,    -1,    -1,    36,   167,    -1,    -1,    -1,   171,    42,
    3003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    66,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3780,    -1,    -1,   209,    -1,    -1,    -1,
      -1,  3044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   235,  3799,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,  3811,   238,    -1,   251,  3815,    -1,
     254,    -1,    -1,  3820,    -1,    -1,    -1,    -1,   251,    -1,
      -1,   254,    -1,  1159,  1160,     8,    -1,   271,    11,    -1,
    3837,  3838,    -1,    -1,  3841,   268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  3854,    -1,    -1,
      -1,    -1,  3859,    36,    -1,  3862,    -1,    -1,    -1,    42,
    3867,  3868,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3886,
      -1,  3888,   932,    66,   328,  3892,  1222,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,   328,    -1,   947,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3168,   209,    -1,    -1,   959,
      -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,   238,    -1,   987,    -1,    -1,
      -1,   863,    -1,    -1,    -1,    -1,    -1,   997,   251,    -1,
      -1,   254,    -1,  3960,    -1,  3962,    -1,    -1,    -1,    -1,
    1010,    -1,    -1,  1013,    -1,    -1,    -1,  3974,   151,    -1,
      -1,    -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   167,   418,   419,   420,   171,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,  4023,    -1,  4025,    -1,
      -1,    -1,    -1,    -1,    -1,   328,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4045,  4046,
      -1,  4048,    -1,  4050,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   235,  3316,    -1,   238,    -1,    -1,    -1,    -1,
    4067,    -1,    -1,    -1,  4071,    -1,    -1,    -1,   251,  4076,
      -1,   254,    -1,   995,  1124,    -1,    -1,    -1,    -1,    -1,
    1416,    -1,  1132,  1133,    -1,    -1,    -1,    -1,    -1,  3352,
      -1,    -1,  1142,    -1,    -1,  1431,    -1,     8,    -1,    -1,
      11,    -1,    -1,  4110,    -1,    -1,    -1,  4114,    -1,    -1,
      -1,  4118,  4119,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,  1471,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,  1196,    -1,  4155,    -1,
    1486,    -1,  1488,    -1,  1490,    66,    -1,    -1,    -1,  1495,
      -1,    -1,    -1,    -1,    -1,     8,    -1,  4174,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,  4194,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,  3461,    42,
      -1,    -1,  1538,    -1,    -1,  1127,  1542,    -1,  1544,  3472,
      -1,  1547,    -1,    -1,    -1,  4222,    -1,   128,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4239,    -1,    -1,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,    -1,    -1,
    3513,  4258,    -1,    -1,    -1,  3518,   167,    -1,    -1,    -1,
     171,    -1,    -1,    -1,    -1,    -1,    -1,  3530,  1190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4284,  1328,    -1,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,  4295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,  4312,  4313,    -1,  4315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3579,    -1,  4325,    -1,
      -1,    -1,  1244,    -1,   167,    -1,    -1,   238,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,  1276,    -1,    -1,  1407,    -1,  4366,
    3623,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,  4376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1427,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4396,
      -1,    -1,   235,  1443,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3669,    -1,   251,    -1,
      -1,   254,    -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,
      -1,    -1,    -1,    -1,  1474,  1475,  1348,    -1,    -1,     8,
      -1,  4438,    11,    -1,    -1,  1485,  4443,    -1,    -1,    -1,
    4447,    -1,    -1,    -1,  4451,  1367,    -1,  1497,  1498,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,  1509,
      -1,    -1,    -1,    42,    -1,  1387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    66,    -1,    -1,
    1412,    -1,    -1,    28,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,   422,   423,   424,   425,   426,   427,  3780,    -1,  1855,
    1856,    -1,    -1,    -1,  1860,  1861,    -1,    -1,  1864,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,  1874,    -1,
      -1,    -1,    -1,    -1,    -1,  1881,    -1,  1469,    -1,  1885,
    1886,    -1,  3815,  1889,  1890,    -1,    -1,    -1,    -1,    -1,
    1896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1908,    -1,  1910,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,    -1,    -1,    -1,   167,    -1,
    1926,    -1,   171,    -1,    -1,  1931,    -1,    -1,  1648,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   676,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1962,  1963,  1964,  1965,
     209,    -1,   167,  1969,  1970,    -1,   171,    -1,    -1,    -1,
      -1,  1977,   706,    -1,  1980,    -1,    -1,    -1,  1984,    -1,
      -1,     8,    -1,    -1,    11,    -1,   235,   192,   193,   238,
    3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2006,    28,   251,    -1,   209,   254,    -1,    -1,    -1,    36,
      -1,  2017,    -1,  2019,    -1,    42,    -1,    -1,  2024,    -1,
      -1,    -1,    -1,  2029,  2030,  2031,  2032,    -1,  2034,    -1,
     235,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    66,
      -1,  2047,  2048,  2049,    -1,    -1,   251,    -1,    -1,   254,
      -1,    -1,  2058,  2059,  1646,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4046,    -1,    -1,  2122,    -1,    -1,    -1,
      -1,    -1,    -1,   328,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1854,    -1,    -1,    -1,  1858,  1859,
     167,    -1,  1862,  4076,   171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1884,   192,   193,    -1,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,    -1,
      -1,  4114,   209,    -1,    -1,  4118,  4119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1925,    -1,    -1,   235,    -1,
      -1,   238,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,    -1,   251,    -1,    -1,   254,    -1,    -1,
      -1,    -1,  1952,  1953,    -1,  2241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1975,  1976,    -1,  1978,    -1,
      -1,  4194,    -1,  2269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2001,    -1,    -1,    -1,  2005,    -1,    -1,    -1,    -1,
      -1,  1025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   328,    -1,  2023,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2033,    -1,    -1,    -1,    -1,    -1,    -1,
    1054,    -1,    -1,    -1,    -1,    -1,  2046,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,  2055,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,  1082,  1083,
    1942,  1085,    -1,    -1,    -1,  1947,  1948,    -1,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,  1959,  1102,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    80,    -1,
      -1,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,  2121,    -1,    -1,    -1,    97,    -1,  1141,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1170,   129,    21,    -1,
    1174,  1175,    -1,    -1,    -1,   137,    -1,    -1,    -1,    -1,
      33,    -1,  2458,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,    -1,  2182,   155,    -1,    -1,    -1,   159,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   174,    -1,    67,    -1,    -1,    -1,    -1,    -1,
    2496,  2497,    -1,    -1,    -1,    -1,  2216,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2513,  2100,    -1,
      -1,    -1,    -1,    -1,    97,    -1,  1098,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,  2251,  2538,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,  2547,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   137,  2275,  2562,  2563,    -1,   251,
      -1,  2567,   254,    -1,    -1,   148,  2572,  2573,  2574,    -1,
     153,    -1,    -1,  1155,    -1,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2179,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,  2608,  2609,  2610,  2611,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,   321,
      -1,    -1,  2638,  2639,  2640,    -1,    -1,   220,    -1,  2359,
      -1,    -1,  2648,    -1,    -1,  2365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   347,    -1,   349,   350,    -1,
     352,   353,    -1,    -1,    -1,    -1,    -1,    -1,   251,   361,
      -1,  2263,    -1,    -1,   366,    -1,    -1,    -1,   261,    -1,
     372,    -1,    -1,   375,    -1,    -1,   378,    -1,    -1,    -1,
      -1,    21,    -1,    -1,    -1,    -1,   279,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,  2712,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2720,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   306,    -1,  2445,    -1,   310,    -1,   312,
      -1,    -1,    -1,    -1,    -1,   318,    -1,    67,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   347,    -1,   349,    97,    -1,    -1,
     353,  2777,    -1,   103,    -1,  2495,    -1,    -1,   361,    -1,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,   118,    -1,
    2510,  2511,    -1,    -1,    -1,   378,    -1,    -1,    -1,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,   391,    -1,
      -1,    -1,    -1,  2819,    -1,    -1,  2822,  2537,   148,    -1,
    2540,    -1,    -1,   153,    -1,    -1,    -1,    -1,    -1,   159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,  2854,    -1,
      -1,  1585,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2868,    -1,    -1,    -1,    -1,    -1,    -1,   199,
      -1,    -1,  2878,    -1,  1608,    -1,    -1,  1611,    -1,    -1,
    1614,    -1,    -1,    -1,    -1,    -1,    -1,  1621,  1622,    -1,
     220,    -1,    -1,  1627,    -1,    -1,  1630,  2617,  2618,  2619,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   863,    -1,  1647,    -1,    -1,  2636,    -1,  1652,    -1,
      -1,   251,  1656,  1505,    -1,    -1,  1660,  2647,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  2657,  1672,    -1,
      -1,    -1,    -1,  1677,    -1,  1679,    -1,    -1,    -1,   279,
      -1,  2543,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   306,    -1,    -1,    -1,
     310,    -1,   312,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,   321,    -1,  2585,  2586,    -1,  2588,    -1,    -1,  2719,
      -1,  1583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,    -1,   349,
      -1,    -1,    -1,   353,    -1,  1607,    -1,    -1,    -1,    -1,
    1612,   361,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,  2761,    -1,   995,    -1,    -1,    -1,    -1,   378,    -1,
    1632,  1633,  2644,  1635,  2646,    -1,  2776,    -1,  2778,    -1,
      -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2790,  1805,  2792,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,  1675,  3100,    -1,  3102,    -1,   863,    -1,
      -1,    -1,    -1,  3109,    -1,    -1,    -1,    -1,  2700,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,  3125,
      -1,  2841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1711,
      64,    -1,    -1,  2725,    -1,    -1,  3142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3151,    -1,    -1,    -1,  2869,
      -1,    -1,  2744,  1887,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    -1,  2883,    -1,    -1,    -1,    -1,    -1,    -1,
    2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
    2900,    -1,    -1,  2903,    -1,    -1,   120,    -1,    -1,   123,
      -1,  3197,  3198,  3199,  3200,  3201,  3202,  3203,  3204,    -1,
      -1,    -1,    -1,  3209,  3210,    -1,  3212,  3213,  3214,  3215,
    3216,  3217,  3218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3227,    -1,  3229,  3230,    -1,    -1,    -1,    -1,    -1,
     995,    -1,    -1,  1815,  2826,    -1,    -1,    -1,  1190,   173,
      -1,    -1,   176,    -1,    -1,  1827,    -1,    -1,  1830,    -1,
    2842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2978,    -1,
      -1,  2853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3283,  3284,  3285,
      -1,    -1,  3288,    -1,    -1,    -1,    -1,   221,    -1,   223,
      -1,    -1,  1244,    -1,    -1,    -1,    -1,    -1,    -1,   233,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   863,
      -1,   245,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,    -1,    -1,  1276,    -1,    -1,   261,   262,    -1,
    2922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,  3369,  2098,   299,   300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2967,    -1,    -1,    -1,    -1,
    3386,  3387,  3388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,  1348,    -1,    -1,    -1,
      -1,   335,    -1,    -1,  3124,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,  1367,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1387,    -1,    -1,    -1,    -1,
      -1,   995,    -1,  3163,    -1,    -1,    -1,  3167,   382,  3169,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2221,  3208,    -1,
      -1,  3211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1276,    -1,    -1,    -1,    -1,    -1,  1469,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3245,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2304,    -1,    -1,    -1,    -1,  2309,  3168,    -1,    -1,    -1,
      -1,    -1,    -1,  1348,  3590,  3591,  3592,  3593,    -1,    -1,
      -1,    -1,  3312,  3313,    -1,    -1,    -1,    -1,    -1,  3319,
      -1,    -1,  1367,    -1,   863,    -1,    -1,    -1,  3614,  3615,
    3616,  3617,    -1,  3619,  3620,    -1,    -1,  2351,    -1,  2353,
    2354,    -1,  1387,    -1,    -1,  3631,  3632,    -1,    -1,    -1,
    2364,    -1,    -1,  2367,    -1,  2369,  1190,    -1,    -1,    -1,
      -1,    -1,  3648,  3649,    -1,  3651,    -1,  1412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2396,    -1,  2398,    -1,    -1,    -1,  2402,    -1,
      -1,    -1,    -1,    -1,  3394,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1244,    -1,    -1,    -1,  1646,    -1,    -1,  2431,  2432,  2433,
      -1,    -1,    -1,    -1,  1469,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2448,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1276,    -1,  3316,  2307,  2460,    -1,    -1,    -1,
      -1,  2465,    -1,    -1,  3740,    -1,   995,  2471,    -1,    -1,
      -1,    -1,    -1,  3749,    -1,    -1,    -1,    -1,  2330,    -1,
    2332,    -1,  2334,  2335,  2336,    -1,    -1,  2339,    -1,    -1,
    3352,  2343,    -1,  3769,    -1,    -1,    -1,    -1,  2350,    -1,
      -1,    -1,    -1,  2355,    -1,    -1,    -1,    -1,    -1,  2361,
      -1,    -1,  2516,    -1,  2366,  3791,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2375,  1348,    -1,    -1,  2379,  2380,    -1,
    2382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2394,  1367,    -1,    -1,    -1,    -1,    -1,  2401,
      -1,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,    -1,    -1,  1387,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3852,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2437,    -1,    -1,  1412,  3865,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3461,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3598,    -1,
    3472,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3618,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3630,    -1,    -1,    -1,    -1,  1469,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1190,    -1,    -1,    -1,  3941,    -1,   863,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2531,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3684,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1244,    -1,  3579,    -1,    -1,
    1942,    -1,    -1,    -1,    -1,  1947,  1948,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1959,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,  1276,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4031,    -1,    -1,    -1,    -1,
      -1,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4064,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4074,   995,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,    -1,  3799,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1348,
      -1,    -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4108,    -1,    -1,    -1,    -1,  4113,  1367,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1387,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2100,    -1,
      -1,    -1,    -1,  1412,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2747,  3886,    -1,  3888,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,
      -1,    -1,  1947,  1948,    -1,  2919,    -1,    -1,    -1,    -1,
      -1,    -1,  4198,    -1,  1959,  2929,    -1,    -1,    -1,    -1,
      -1,  2935,    -1,  2937,    -1,    -1,    -1,  4213,    -1,    -1,
    1469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3815,    -1,  2959,  2960,  2179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3960,    -1,  3962,    -1,    -1,    -1,  2980,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2990,    -1,    -1,  2993,
      -1,  2995,    -1,    -1,  1190,    -1,    -1,  4273,    -1,    -1,
    3004,    -1,  4278,    -1,    -1,    -1,  3010,    -1,    -1,  3013,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2872,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3042,    -1,
    3044,  2263,    -1,    -1,    -1,    -1,    -1,    -1,  1244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,  3066,    -1,    -1,  2100,  2918,    -1,  3072,    -1,
      -1,    -1,  2924,    -1,  3078,    -1,    -1,    -1,    -1,    -1,
    1276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2940,  2941,
      -1,  2943,    -1,    -1,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1646,  1942,    -1,
    4110,    -1,    -1,  1947,  1948,    -1,    -1,    -1,    -1,  2981,
      -1,    -1,  2984,    -1,  2986,  1959,    -1,    -1,    -1,  2991,
    2992,    -1,    -1,    -1,  2179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1348,  3005,  3006,  3007,    -1,  3009,    -1,    -1,
    3012,    -1,    -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4046,    -1,    -1,    -1,    -1,    -1,
      -1,  1387,    -1,    -1,    -1,    -1,    -1,    -1,  3050,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3061,
      -1,    -1,    -1,    -1,  4076,    -1,  1412,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2263,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3090,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4258,    -1,
      -1,    -1,    -1,  1469,    -1,    -1,  2100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2543,    -1,    -1,    -1,  4315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3353,
    3354,    -1,    -1,    -1,    -1,  2179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2585,  2586,    -1,  2588,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4396,  3411,    -1,    -1,
      -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,  1947,  1948,
      -1,    -1,  2644,    -1,  2646,    -1,    -1,    -1,    -1,    -1,
    1959,    -1,    -1,    -1,    -1,    -1,    -1,  3289,    -1,  2263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1646,    -1,    -1,  4443,  3458,  3459,    -1,    -1,    -1,    -1,
      -1,  4451,    -1,    -1,    -1,    -1,    -1,  3471,    -1,    -1,
      -1,    -1,    -1,  3477,  3478,    -1,    -1,  3481,  2700,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2725,    -1,    -1,    -1,    -1,  2543,  3513,
      -1,    -1,    -1,    -1,  3518,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2744,    -1,    -1,    -1,  3530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2585,  2586,    -1,  2588,    -1,    -1,    -1,  3561,    -1,    -1,
    3412,    -1,    -1,    -1,  3416,  3417,  3418,    -1,    -1,  3421,
      -1,  2100,    -1,    -1,  3426,  3427,  3428,  3429,  3430,  3431,
    3432,  3433,  3434,  3435,  3436,  3437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2826,    -1,    -1,    -1,    -1,  2644,
      -1,  2646,    -1,  3465,  3466,  3467,  3468,    -1,  3470,    -1,
    2842,    -1,  3474,  3475,  3476,    -1,    -1,  3479,    -1,    -1,
    3482,  2853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3515,    -1,  2700,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3527,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3541,
    2725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2744,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3722,  2543,
    2942,    -1,    -1,    -1,    -1,    -1,    -1,  2762,    -1,    -1,
      -1,    -1,    -1,    -1,  2263,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2967,  1942,    -1,    -1,    -1,
      -1,  1947,  1948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2585,  2586,  1959,  2588,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2842,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,    -1,
    2644,    -1,  2646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3725,    -1,    -1,  2700,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2922,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2725,    -1,    -1,  2100,    -1,    -1,  2942,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2744,    -1,    -1,    -1,    -1,  3777,  3778,    -1,    -1,    -1,
      -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,  2762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3807,    -1,    -1,    -1,  3811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,
      -1,    -1,    -1,  3825,    -1,  3827,    -1,    -1,    -1,    -1,
    3832,  3833,  3834,  2179,    -1,  3837,  3838,  3839,  3840,    -1,
    3842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2543,    -1,    -1,    -1,  2842,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3890,    -1,
      -1,    -1,    -1,    -1,  4048,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2585,  2586,    -1,  2588,
      -1,    -1,    -1,  4067,    -1,    -1,    -1,  2263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3316,    -1,    -1,    -1,  2922,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2644,    -1,  2646,  2942,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3980,    -1,
    3352,    -1,    -1,  3168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4174,  2700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3003,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4044,  4045,    -1,    -1,  2725,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4060,  4061,
    4062,    -1,    -1,    -1,    -1,  2744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4079,    -1,    -1,
      -1,    -1,    -1,  2762,    -1,  4239,    -1,    -1,    -1,  3461,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4312,  4313,
      -1,    -1,    -1,  2842,    -1,    -1,    -1,  3352,    -1,    -1,
      -1,    -1,    -1,    -1,  2853,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3168,    -1,    -1,  2543,    -1,    -1,
    4202,    -1,    -1,    -1,    -1,    -1,    -1,  3579,    -1,    -1,
    4212,    -1,  4366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,  2585,
    2586,    -1,  2588,  2922,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2942,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3461,    -1,    -1,    -1,
      -1,  4283,    -1,    -1,  4438,    -1,    -1,  3472,  2967,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3669,  2644,    -1,
    2646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4324,    -1,  3003,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2700,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4369,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3352,  2725,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3579,    -1,    -1,    -1,  2744,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4417,  2762,    -1,    -1,    -1,
      -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,    -1,
      -1,    -1,    -1,  3815,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2826,    -1,    -1,    -1,  3669,    -1,    -1,  3461,    -1,  3168,
      -1,    -1,    -1,    -1,    -1,    -1,  2842,    -1,  3472,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2853,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2922,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2942,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3579,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3815,    -1,    -1,  3607,    -1,    -1,    -1,  3316,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,
      -1,    -1,    -1,  4025,    -1,    -1,    -1,  3003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3352,  4046,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4076,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,
      -1,    -1,  4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4025,  3815,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,  4114,
      -1,    -1,    -1,  4118,  4119,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3623,    -1,    -1,    -1,    -1,  3923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3352,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3815,    -1,    -1,    -1,
    4114,    -1,    -1,    -1,  4118,  4119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3579,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3923,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3623,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3669,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4025,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4046,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4076,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4114,    -1,    -1,    -1,  4118,
    4119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3815,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4025,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,  4114,    -1,
      -1,    30,  4118,  4119,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,   115,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,   424,    -1,    -1,    -1,    -1,
      -1,    -1,   431,   432,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,     3,    -1,    -1,    -1,    -1,
      -1,    -1,   431,   432,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
      -1,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,    -1,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,    -1,    -1,   236,   237,   238,
     239,    -1,    -1,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,    -1,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,    -1,   271,    -1,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,    -1,   361,    -1,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   412,   413,   414,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,   432,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,    -1,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,    -1,    -1,   236,   237,
     238,   239,    -1,    -1,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,   412,   413,   414,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,   432,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,
     429,   430,   431,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   422,   423,   424,    -1,    -1,    -1,    -1,    -1,
      -1,   431,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     431,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   431,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   431,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     431,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,    -1,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,   423,    -1,    -1,     3,     4,     5,     6,     7,   431,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,    -1,     9,    10,
      -1,    -1,   431,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
     431,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,    -1,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,    -1,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,    -1,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,   422,   423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,   250,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,   250,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   431,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,   249,    -1,   251,   252,   253,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,   389,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,   422,   423,
     424,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,    -1,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
     206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
     256,    -1,    -1,    -1,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,    -1,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,   385,
     386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   431,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,   206,    -1,
     208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,
      -1,    -1,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
      -1,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,   385,   386,    -1,
     388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,   431,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,    -1,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,    -1,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,    -1,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,    -1,    -1,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,    -1,     3,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   424,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,    -1,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
      -1,   236,   237,   238,   239,    -1,    -1,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,    -1,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
      -1,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,   424,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,    -1,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,    -1,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,    -1,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,    -1,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,   412,
     413,   414,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,   424,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,     4,     5,    -1,    -1,    -1,
       9,   422,   423,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,     4,     5,    -1,
      -1,    -1,     9,   422,   423,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,     9,   422,   423,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,     4,     5,    -1,    -1,    -1,     9,   422,   423,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
     389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    68,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,   148,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,   148,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,   148,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,   148,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,   250,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,   250,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,    -1,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,    -1,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,   385,   386,    -1,   388,    -1,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,    -1,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,   385,   386,    -1,   388,    -1,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,    -1,   202,   203,    -1,   205,   206,    -1,   208,
      -1,    -1,   211,   212,   213,    -1,    -1,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,    -1,   248,
      -1,    -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,    -1,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,    -1,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,    -1,
     329,   330,   331,    -1,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,    -1,    -1,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,    -1,   373,   374,   375,   376,   377,    -1,
      -1,   380,   381,   382,   383,   384,   385,   386,    -1,   388,
      -1,   390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,    -1,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,   385,   386,
      -1,   388,    -1,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,    -1,   207,   208,   209,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,    -1,
      -1,   236,   237,   238,   239,    -1,    -1,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,   257,   258,   259,    -1,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,    -1,   271,    -1,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,    -1,   202,   203,
      -1,   205,   206,    -1,   208,    -1,    -1,   211,   212,   213,
      -1,    -1,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,    -1,   248,    -1,    -1,   251,   252,   253,
      -1,    -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,    -1,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,    -1,   329,   330,   331,    -1,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,    -1,    -1,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,    -1,   373,
     374,   375,   376,   377,    -1,    -1,   380,   381,   382,   383,
     384,   385,   386,    -1,   388,    -1,   390,   391,   392,    -1,
      -1,   395,    -1,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,   206,    -1,   208,    -1,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,   256,    -1,    -1,    -1,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,    -1,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,   385,   386,    -1,   388,    -1,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    -1,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,   206,    -1,   208,    -1,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,   256,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,    -1,   329,
     330,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,    -1,    -1,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,   385,   386,    -1,   388,    -1,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,    -1,   205,    -1,   207,
     208,   209,    -1,   211,   212,   213,    -1,    -1,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,    -1,    -1,   236,   237,
     238,   239,   240,    -1,   242,   243,   244,   245,   246,    -1,
     248,    -1,    -1,   251,   252,   253,    -1,    -1,    -1,   257,
     258,   259,    -1,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,   330,   331,    -1,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,    -1,
      -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,    -1,   373,   374,   375,   376,   377,
      -1,    -1,   380,   381,   382,   383,   384,    -1,   386,    -1,
     388,   389,   390,   391,   392,    -1,    -1,   395,    -1,    -1,
     398,   399,   400,   401,   402,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,   413,   414,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,   138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,    -1,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,    -1,   205,    -1,
     207,   208,   209,    -1,   211,   212,   213,    -1,    -1,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,    -1,   242,   243,   244,   245,   246,
      -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,    -1,
     257,   258,   259,    -1,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,    -1,   271,    -1,   273,   274,   275,    -1,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,    -1,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
      -1,    -1,   359,    -1,   361,    -1,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,    -1,   373,   374,   375,   376,
     377,    -1,    -1,   380,   381,   382,   383,   384,    -1,   386,
      -1,   388,   389,   390,   391,   392,    -1,    -1,   395,    -1,
      -1,   398,   399,   400,   401,   402,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   412,   413,   414,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,    -1,   205,
      -1,   207,   208,   209,    -1,   211,   212,   213,    -1,    -1,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,    -1,   242,   243,   244,   245,
     246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,    -1,
      -1,   257,   258,   259,    -1,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,    -1,   271,    -1,   273,   274,   275,
      -1,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,    -1,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,    -1,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,    -1,    -1,   359,    -1,   361,    -1,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,    -1,   373,   374,   375,
     376,   377,    -1,    -1,   380,   381,   382,   383,   384,    -1,
     386,    -1,   388,   389,   390,   391,   392,    -1,    -1,   395,
      -1,    -1,   398,   399,   400,   401,   402,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   412,   413,   414,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,    -1,   202,   203,    -1,
     205,   206,    -1,   208,    -1,    -1,   211,   212,   213,    -1,
      -1,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,    -1,   248,    -1,    -1,   251,   252,   253,    -1,
      -1,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
      -1,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,    -1,   277,   278,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    -1,   303,   304,
      -1,   306,   307,   308,    -1,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,    -1,   329,   330,   331,    -1,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,    -1,    -1,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,    -1,   373,   374,
     375,   376,   377,    -1,    -1,   380,   381,   382,   383,   384,
     385,   386,    -1,   388,    -1,   390,   391,   392,    -1,    -1,
     395,    -1,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,    -1,   205,    -1,   207,   208,   209,    -1,   211,   212,
     213,    -1,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,   242,
     243,   244,   245,   246,    -1,   248,    -1,    -1,   251,   252,
     253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,    -1,
     273,   274,   275,    -1,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,   329,   330,   331,    -1,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,    -1,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,    -1,
     373,   374,   375,   376,   377,    -1,    -1,   380,   381,   382,
     383,   384,    -1,   386,    -1,   388,   389,   390,   391,   392,
      -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,   402,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
     413,   414,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,    -1,   205,    -1,   207,   208,   209,    -1,   211,
     212,   213,    -1,    -1,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,    -1,    -1,   236,   237,   238,   239,    -1,    -1,
     242,   243,   244,   245,   246,    -1,   248,    -1,    -1,   251,
     252,   253,    -1,    -1,    -1,   257,   258,   259,    -1,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
      -1,   273,   274,   275,    -1,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
      -1,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,    -1,    -1,   359,    -1,   361,
      -1,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
      -1,   373,   374,   375,   376,   377,    -1,    -1,   380,   381,
     382,   383,   384,    -1,   386,    -1,   388,   389,   390,   391,
     392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,   401,
     402,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     412,   413,   414,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,    -1,   205,    -1,   207,   208,   209,    -1,
     211,   212,   213,    -1,    -1,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,    -1,    -1,   236,   237,   238,   239,    -1,
      -1,   242,   243,   244,   245,   246,    -1,   248,    -1,    -1,
     251,   252,   253,    -1,    -1,    -1,   257,   258,   259,    -1,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,    -1,
     271,    -1,   273,   274,   275,    -1,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,    -1,   324,    -1,   326,   327,   328,   329,   330,
     331,    -1,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,    -1,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,    -1,    -1,   359,    -1,
     361,    -1,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,   380,
     381,   382,   383,   384,    -1,   386,    -1,   388,   389,   390,
     391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,   400,
     401,   402,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   412,   413,   414,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    -1,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
      -1,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,   138,    -1,
      -1,   141,    -1,   143,    -1,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,   185,    -1,    -1,    -1,    -1,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,    -1,   205,    -1,   207,   208,   209,
      -1,   211,   212,   213,    -1,    -1,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,    -1,
     230,    -1,   232,   233,    -1,    -1,   236,   237,   238,   239,
      -1,    -1,   242,    -1,   244,   245,   246,    -1,   248,    -1,
      -1,   251,   252,   253,    -1,    -1,    -1,   257,   258,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
      -1,   271,    -1,   273,   274,   275,    -1,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,    -1,   324,    -1,   326,   327,   328,   329,
      -1,   331,    -1,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,    -1,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,    -1,    -1,    -1,    -1,    -1,   359,
      -1,   361,    -1,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,    -1,   373,   374,   375,   376,   377,    -1,    -1,
     380,   381,   382,   383,   384,    -1,    -1,    -1,   388,   389,
     390,   391,   392,    -1,    -1,   395,    -1,    -1,   398,   399,
     400,   401,   402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   134,
     136,   142,   156,   211,   212,   217,   226,   237,   274,   286,
     291,   292,   294,   299,   304,   307,   311,   316,   317,   324,
     327,   335,   347,   364,   374,   380,   385,   397,   431,   438,
     439,   440,   441,   447,   448,   450,   451,   452,   453,   454,
     455,   456,   458,   459,   463,   474,   477,   478,   481,   482,
     483,   494,   497,   498,   514,   551,   554,   557,   558,   559,
     566,   572,   574,   576,   577,   580,   583,   584,   588,   589,
     598,   602,   603,   604,   605,   606,   608,   609,   610,   623,
     624,   628,   630,   631,   632,   643,   645,   652,   653,   656,
     657,   658,   659,   660,   665,   667,   670,   674,   678,   679,
     689,   690,   693,   698,   709,   728,   731,   732,   733,   736,
     739,   741,   743,   746,   749,   750,   751,   758,   759,   761,
     762,   763,   768,   770,   771,   775,   776,   779,   780,   781,
     783,   784,   785,   786,   788,   791,   792,   797,   803,   806,
     808,   809,   814,   816,   820,   827,   831,   832,   833,   834,
     835,   836,   839,   867,   359,   399,   764,    21,    67,    80,
      97,   103,   118,   129,   137,   148,   153,   159,   174,   199,
     220,   251,   279,   306,   310,   312,   318,   321,   347,   349,
     353,   361,   366,   378,   391,   573,   764,     3,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      33,    34,    36,    37,    39,    40,    41,    42,    43,    45,
      46,    48,    49,    50,    51,    52,    55,    56,    57,    58,
      59,    61,    62,    63,    64,    65,    69,    70,    71,    72,
      74,    75,    77,    78,    79,    80,    81,    82,    85,    86,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   104,
     106,   107,   108,   109,   110,   112,   113,   114,   117,   118,
     119,   120,   121,   123,   124,   125,   127,   128,   129,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   141,   143,
     144,   145,   147,   149,   153,   154,   155,   157,   158,   160,
     162,   163,   164,   165,   166,   168,   169,   170,   172,   173,
     174,   175,   176,   177,   179,   181,   182,   183,   184,   185,
     186,   187,   189,   191,   194,   196,   197,   198,   199,   200,
     202,   203,   205,   206,   208,   211,   212,   213,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   231,   232,   233,   234,   236,   237,   239,   241,
     242,   243,   244,   245,   246,   248,   251,   252,   253,   256,
     260,   261,   262,   263,   264,   265,   266,   267,   269,   270,
     271,   272,   273,   274,   275,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   303,
     304,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   318,   319,   320,   321,   322,   324,   325,   326,
     327,   329,   330,   331,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   345,   346,   348,   349,   350,
     351,   352,   353,   355,   356,   359,   360,   361,   362,   364,
     365,   366,   367,   368,   369,   370,   373,   374,   375,   376,
     377,   380,   381,   382,   383,   384,   385,   386,   388,   390,
     391,   392,   395,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     828,   974,   987,   991,   992,   389,   793,   249,   275,   764,
      44,   505,   832,    21,    33,    54,    67,    76,    97,   103,
     118,   129,   137,   148,   155,   159,   213,   251,   254,   306,
     312,   321,   349,   350,   352,   353,   361,   366,   372,   375,
     378,   515,   556,   648,   699,   710,    22,   274,   974,   828,
      22,   269,   350,   352,     5,   198,   737,   738,   983,    21,
      33,    54,    67,    80,    97,   118,   129,   137,   148,   153,
     159,   174,   220,   251,   261,   306,   310,   312,   318,   321,
     347,   349,   353,   361,   366,   378,   391,   573,   661,   764,
     974,    83,   389,   431,   551,   554,   557,   792,   798,   806,
     809,   814,   820,   827,   831,     9,    15,    22,    39,   143,
     149,   151,   171,   200,   232,   277,   293,   422,   423,   675,
     676,   828,   982,   986,    22,    83,   290,   317,   680,   681,
     682,   987,   987,   979,   983,   347,   842,   675,   987,   359,
     974,   261,   220,    97,   174,   346,   347,   744,   311,   987,
      22,   322,   355,   359,   466,   987,    19,   156,   680,   681,
     275,   764,   987,   197,    22,   115,   844,    55,    77,   213,
     228,   306,   312,   322,   355,   359,   402,   464,   465,   466,
      22,   322,   355,   359,   466,   359,   250,   878,   972,   987,
     842,   424,   987,   152,   431,   794,   431,   968,   288,   837,
     838,   974,   832,   833,   836,     0,   434,   793,   130,   188,
     255,   371,   845,   846,   832,   834,   835,   108,   184,   377,
     435,     3,    38,    44,    67,    73,    84,    90,   150,   152,
     167,   180,   192,   193,   195,   207,   209,   230,   238,   257,
     258,   259,   305,   328,   389,   980,   987,   988,   991,   993,
     663,   987,   663,   975,   987,   278,   663,   361,   663,   974,
     987,    96,   347,   688,   980,     3,   984,   989,   991,   992,
     993,   166,   972,   244,   391,     8,    62,   141,   418,   419,
     420,   422,   423,   424,   425,   426,   427,   735,   935,   936,
     987,    22,   984,   974,   974,   166,   972,   974,   166,   878,
     974,   314,   974,   663,   218,   984,   166,   972,   198,   105,
     194,   235,   284,   765,   766,   767,   972,   978,   987,    21,
      54,    67,    68,    76,    80,    97,   118,   129,   137,   148,
     153,   174,   199,   220,   251,   306,   310,   312,   318,   321,
     347,   349,   353,   361,   366,   391,   573,   668,   983,   972,
     357,   980,   974,   431,   663,   361,   975,   663,   361,   166,
     974,    96,   347,   350,   352,   984,   350,   352,    62,   141,
     735,   297,   984,   166,   460,   987,   974,   974,   314,   974,
     663,   218,   984,   288,   318,   347,   391,   220,    80,   174,
     153,   310,   365,   567,    22,   974,   829,   473,   983,   989,
     738,   166,   980,   974,   166,   742,   166,   975,   361,    96,
     347,   166,   980,   166,   984,   985,    73,   391,    62,   141,
     166,   735,    48,   166,   985,   166,   974,   166,   974,   166,
     974,   314,   166,   974,   166,   218,   985,   198,   166,   662,
     663,   431,   807,   515,   798,   385,   792,   799,   800,   801,
     989,   793,   986,   676,   677,    22,   677,   986,   677,    22,
     677,   986,   677,   677,   677,   986,   982,   982,   828,   677,
     278,   431,   431,   534,   534,   534,   249,   357,   435,   534,
     878,   879,   435,   760,   983,   431,   804,    48,   391,   974,
     974,   972,   987,    38,   414,   194,   433,   252,   252,   249,
     151,   983,   357,   146,   671,   249,     4,     6,     7,     8,
      10,    30,    43,    45,    46,    53,    54,    57,    58,    65,
      67,    87,    88,    89,    90,    91,    92,    93,   100,   101,
     119,   135,   139,   140,   144,   158,   186,   187,   189,   206,
     214,   215,   229,   231,   235,   240,   241,   243,   251,   260,
     270,   285,   308,   323,   330,   343,   355,   356,   360,   362,
     363,   372,   378,   386,   404,   405,   406,   407,   408,   409,
     410,   411,   422,   423,   424,   431,   832,   890,   893,   896,
     897,   898,   900,   901,   902,   903,   906,   907,   911,   913,
     914,   933,   937,   956,   961,   969,   970,   980,   981,   982,
     983,   987,   983,    22,   479,   971,   972,   322,   464,   103,
     472,   983,   473,   983,    38,    59,   464,   414,   331,   766,
     252,   151,   357,   418,    38,   414,   194,   767,   431,   972,
     424,   429,   433,   962,   963,   879,   150,   152,   389,   789,
     790,   792,   150,   795,   103,   911,   966,   967,   837,   435,
     431,   796,   432,   432,   440,   972,    22,   115,   843,   843,
      48,   843,   142,   146,   210,   247,   849,   851,   852,   861,
     863,   864,   865,   845,   846,   151,   190,   878,   880,   968,
     431,   637,   963,   262,   295,   324,   433,   664,   262,   295,
     324,   262,   295,   324,   397,   442,   474,   475,   694,    18,
     120,   262,   295,   324,   382,   486,   974,   324,    18,   120,
     377,   457,   400,   166,   878,    50,    82,   138,   169,   205,
     235,   262,   295,   303,   309,   316,   324,   333,   341,   392,
     474,   476,   722,   729,   431,   711,   295,   457,   135,    18,
      24,    64,   113,   120,   123,   176,   233,   235,   245,   253,
     262,   295,   299,   324,   382,   484,   485,   592,     4,   423,
     564,   986,   166,   972,   663,   663,   431,   734,   433,   171,
     449,   295,   442,   449,   249,   262,   295,   135,    49,    95,
     173,   221,   223,   233,   261,   295,   300,   324,   335,   484,
     561,   562,   262,   295,   390,   592,   600,   135,   295,   324,
     484,   262,   295,   299,   324,    74,   112,   263,   351,   249,
      18,    24,   120,   262,   295,   324,   495,   496,   146,   295,
     324,   442,   475,   135,   295,   324,   484,   974,   208,   105,
     250,   401,   435,   765,   379,   787,   249,   980,   431,   974,
     361,    96,   347,   980,   244,   391,    62,   141,   735,   974,
     314,   974,   198,   663,   534,   281,   500,   431,   637,   638,
      60,     3,    43,    45,    46,    57,    58,   100,   101,   144,
     186,   187,   189,   229,   231,   243,   285,   325,   330,   355,
     356,   386,   887,   889,   891,   893,   895,   897,   898,   899,
     901,   902,   906,   907,   988,   991,   151,   431,   633,   974,
     442,    31,   782,   974,   235,   442,   400,   166,   972,   442,
     663,   663,   633,   375,   515,   442,   235,    38,   461,   366,
     599,   262,   575,    74,   112,   263,   351,    20,    40,   185,
     611,    31,   633,   146,   442,   391,   972,   166,   552,   972,
     972,   391,   663,    73,   700,   980,   974,   573,    44,    94,
     183,   233,   313,   135,   637,    51,   301,   487,   135,   431,
     135,   400,   135,   711,   135,   435,   166,   662,   166,   663,
     166,   663,   135,   734,   985,   135,   135,   249,   135,   487,
     135,    74,   112,   263,   351,   135,   249,   135,   146,   166,
     166,   473,   135,   435,   487,   911,   940,   347,   432,   435,
     140,   249,   363,   470,   473,   564,   802,   798,   677,   828,
     677,   828,   677,   828,   677,   828,   677,   828,   828,   828,
     677,   828,   431,   535,   536,   987,   535,    22,    97,   118,
     148,   153,   198,   199,   312,   318,   347,   349,   366,   683,
     971,   985,   682,   171,   435,   817,   983,   887,   943,    31,
     985,   972,   147,   745,   745,   745,   208,   987,   146,   146,
     683,   985,   311,   987,   473,   249,   431,   964,   429,   832,
     944,   388,   904,   911,   960,   431,   904,   904,   431,   146,
     431,   431,   431,   892,   892,   272,   832,   431,   431,   894,
     431,   431,   431,   431,    57,    58,   904,   911,   431,   892,
     431,   431,   431,   431,   431,   398,   417,   431,   908,   431,
     908,   431,   431,   832,   431,   431,   431,   431,   431,   431,
     431,   431,   911,   911,   832,   911,   940,   963,   983,    58,
     431,   905,   431,   983,     3,     8,    11,    28,    31,    36,
      42,    66,   167,   171,   192,   193,   209,   235,   238,   251,
     254,   328,   418,   419,   420,   422,   423,   424,   425,   426,
     427,   935,   937,   939,   259,   911,   190,   435,   840,   431,
     983,   963,   106,   168,   480,   435,    59,   103,   473,    31,
       3,   103,   213,   471,   564,   907,   983,   983,    78,   117,
     920,    86,   103,   467,   468,   470,   564,   103,   467,   208,
     972,   911,     3,    22,    26,    27,    28,    29,    30,    31,
      32,    35,    47,    53,    54,    60,    66,    68,    76,    83,
      87,    88,    89,    91,    92,    93,   103,   105,   111,   115,
     116,   122,   126,   130,   140,   142,   146,   148,   151,   156,
     159,   161,   171,   178,   188,   190,   201,   204,   210,   214,
     215,   235,   240,   247,   249,   250,   254,   255,   268,   276,
     290,   302,   317,   323,   332,   344,   347,   354,   357,   358,
     363,   371,   372,   378,   379,   387,   393,   394,   396,   397,
     424,   977,   990,   991,   992,   993,   994,   962,    79,   300,
     666,   432,   435,   793,   432,   435,   838,   973,   974,    31,
     796,   834,   834,   847,   848,   911,   834,   143,   232,   858,
     196,   233,   284,   326,   377,    22,   853,   911,   854,   856,
     911,   913,   861,   862,   852,   851,   849,   850,   146,   864,
     245,   866,   849,   861,   880,   972,    31,   987,   324,   424,
     943,   262,   295,   324,   357,   357,   312,   977,   433,   357,
     357,   312,   357,   357,   349,   464,   777,   146,   156,   171,
     304,   695,   696,    60,    76,   131,   148,   276,   372,   531,
     532,    76,   103,   235,   357,    76,   357,   103,   235,   312,
      76,   113,   123,   262,   295,   629,   312,   581,    21,    54,
      67,    80,   118,   129,   148,   153,   220,   251,   312,   318,
     321,   347,   353,   366,   391,   573,   974,   135,   295,   324,
     484,   249,   564,   316,   205,   357,   357,   240,   564,   107,
     191,   312,   322,   359,   465,   301,   324,   722,   730,   171,
     181,   256,   325,   387,   432,   712,   715,   716,   717,   719,
     887,   988,   357,   378,   972,    68,   131,   522,   531,   987,
      68,   747,   249,   310,   361,    76,   747,    25,   298,   310,
     361,   972,   176,   245,   663,   431,   357,   357,   431,   490,
     349,   397,   398,   490,    76,   435,     4,   262,   135,   295,
     324,   484,   379,   379,   234,   887,   262,   324,   735,    97,
     475,   357,   444,   475,   972,   357,   357,   972,   564,    48,
     563,   564,   564,    95,   221,   223,    48,   357,   442,   312,
     442,   233,   562,   357,   357,   240,   983,   592,   878,    76,
     357,   747,   312,   357,   357,   490,   490,   663,   663,   663,
     663,   972,    37,   384,    37,    37,   357,    37,   357,   312,
     435,    93,   378,   607,   984,   357,   444,   972,   357,   312,
     262,   295,   284,   296,   320,   469,   765,   978,   987,   972,
     637,   887,   249,   400,   711,   564,   663,   663,   734,   192,
     249,    74,   112,   263,   351,   249,   663,   192,   397,   506,
     338,   339,   501,   983,     3,   639,   640,   633,   431,   889,
      31,    30,   888,    98,   164,   222,   225,   315,   412,   431,
     909,   910,   664,   892,   663,   634,   635,   990,    20,   772,
     887,   249,   135,   578,   974,   235,   431,   443,   648,   379,
     288,   391,   443,   135,   984,    83,   156,   462,   514,   558,
     610,   678,   698,   768,   983,   600,   601,   974,   216,   663,
     663,   663,   663,   245,   108,   184,   364,   377,   612,   613,
     127,   283,   431,   607,   443,   972,   560,   561,   235,    31,
     245,   431,   534,   534,   555,   972,   146,   701,   978,   431,
     713,    31,   198,   397,   398,   830,   313,   980,   487,   887,
     975,   166,   974,   980,   487,   985,   984,   135,   487,   135,
     379,   135,   379,   735,   487,   487,   985,   974,   663,   974,
     974,   974,   663,   985,   607,   135,   135,   487,   662,   663,
     432,   435,   972,   798,   800,   828,   828,   828,   828,   828,
     828,   535,   432,   435,   432,   154,   319,   348,   973,   662,
      96,   321,   687,   688,   973,   244,   973,   971,   971,   973,
     662,   357,   397,   691,    16,   133,   308,   326,   818,   878,
     239,   819,   432,   435,   805,   809,   814,   820,   831,   357,
     397,   553,   681,   680,   681,   151,   157,   692,   987,    21,
      68,    97,   118,   129,   148,   153,   199,   220,   306,   312,
     318,   347,   349,   366,   391,   573,   672,   940,   962,   430,
     940,   944,   945,   431,   393,   957,   958,   911,   940,   431,
     982,   982,   940,     3,    98,   164,   222,   225,   315,   412,
     946,   947,   983,   982,   940,   940,   982,   982,   904,   904,
     911,   735,   911,   948,   422,   423,   912,   913,   933,   937,
     950,   432,   940,   911,   940,   951,   355,   414,   982,   982,
     911,    47,   151,   204,   358,   911,   940,   954,   940,   227,
     913,   911,   918,   919,   920,   227,   911,   920,   432,   435,
     324,   982,   982,   909,   887,   911,   990,   355,    35,   344,
     965,   663,   911,   431,   832,   955,   115,   117,   140,   235,
     240,   245,   363,   373,   911,    42,   167,   171,   209,   328,
     431,   911,   357,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,    22,    29,   332,   934,   308,   431,   933,
     155,   213,   347,   350,   352,   375,   841,   972,   970,   151,
     868,    22,   115,   387,   424,   432,   717,   911,   941,   942,
     988,   972,   359,   431,   983,   435,   432,   430,   436,   165,
     165,   487,   972,   790,   791,   972,   966,   432,   435,   431,
     435,    32,   111,   379,   707,   431,   855,   986,   326,   196,
     250,   435,   308,   309,   857,   971,   819,   862,   850,   379,
     815,   103,   431,   810,   831,   987,   431,   821,   822,   823,
     824,   825,   987,   432,   432,   357,   357,   312,   984,   974,
     974,   977,   984,   974,   974,   984,   975,   974,    75,   778,
     306,   378,   680,   312,   156,   680,   431,   974,   379,   702,
     196,   196,   379,   431,   550,   166,   974,   240,   984,   974,
     974,   911,   240,   974,   974,    25,   298,   357,   357,   974,
     357,   582,   980,   431,   663,   663,   663,   361,    96,   347,
     688,   391,    62,   141,   735,   974,   663,   974,   663,   314,
     663,   663,   198,   160,   233,   262,   295,   383,   585,   586,
     587,   878,   357,   747,   312,   240,   107,   191,   984,   974,
     249,   974,   256,   988,   432,   435,   717,   719,   716,   719,
     988,   664,   984,   985,   295,   484,   522,   887,   987,   974,
     974,    22,   378,   974,   166,   974,   166,   987,   310,   361,
     310,   361,   974,    22,   378,   974,   972,    18,   120,   324,
     593,   594,   595,   596,   990,   984,   974,   492,   493,   990,
     974,   248,    64,   248,   974,   485,   357,   972,   357,   747,
     312,   976,   987,   976,   435,   432,   435,   357,   312,   975,
     984,     3,    75,   125,   176,   267,   370,   378,   381,   445,
     295,   984,   974,   295,   324,   484,   561,   564,   663,   974,
     564,   974,   564,   984,   974,   295,   324,   484,   974,   974,
     974,   974,   984,   974,    18,    24,   120,   262,   295,   324,
     262,   295,   324,   633,   295,   324,   295,   324,   295,   886,
     987,   166,   644,   987,   166,   987,   984,   974,   974,   974,
      18,   496,   321,   984,   295,   324,   484,   974,   974,   357,
     357,    72,   369,   284,   192,    31,   663,   192,   192,   379,
     379,   192,   240,   669,   983,   663,   663,   192,   669,   248,
     151,   357,   499,   442,   418,   432,   435,   911,    30,   888,
     887,   429,   429,   357,   357,   357,   431,   357,   982,   892,
     432,   435,   418,   612,    75,   124,   202,   203,   216,   262,
     349,   351,   773,   524,   990,   974,   151,   312,   390,   579,
     586,   587,   135,   209,   516,   518,   520,   522,   528,   531,
      19,   171,   306,   345,   445,   446,   146,   976,   391,   972,
     460,   987,   461,   254,   515,   148,   983,   633,   633,   633,
     633,   245,   249,   254,   431,   633,   884,   885,   886,   321,
     431,   135,   134,   831,   663,   516,   987,   397,   398,   546,
     397,   491,    31,   534,   983,   249,   432,   714,   715,   720,
      31,   198,   303,   396,   721,   722,   723,   249,   473,   163,
     163,   146,   637,    31,   135,   487,   711,   662,   663,   976,
     663,   976,   734,   249,   487,   487,   249,   487,   321,   146,
     473,   487,   911,   432,   536,   171,   171,   171,   400,   973,
     435,   564,   565,   159,   684,   685,   984,    19,   692,   133,
     326,   133,   326,   308,   377,   224,   887,   974,    96,   233,
     151,   249,   684,    48,   487,   980,   361,   347,   980,   244,
     391,   198,   663,   432,   430,   430,   435,   940,   911,   122,
     958,   959,    31,   432,   911,   432,   432,   432,   432,   151,
     432,   432,   432,   432,   432,   435,   432,   268,   949,   432,
     912,   912,    11,   171,   192,   251,   418,   419,   420,   422,
     423,   424,   425,   426,   427,   937,   912,   432,   432,   146,
     151,   952,   953,   432,   414,   432,   432,    31,   954,   940,
     954,   954,   151,   432,   432,   990,   266,   922,    31,   432,
     435,   911,   990,   435,   911,   964,   911,   987,   432,   432,
     414,   912,   912,   128,   940,   151,   115,   117,   140,   240,
     245,   363,   373,   431,   128,   344,   965,   911,   955,   911,
     357,   735,   911,   431,   832,   350,   352,   350,   352,   972,
     842,   842,   842,   201,   431,   832,   869,   870,   871,   878,
     881,   914,   980,   987,   394,   882,   941,   941,   942,   432,
     258,   926,    13,   432,   435,   846,   766,   982,   909,   468,
     911,   796,   974,   805,   848,   251,   935,   938,   415,   416,
     708,   911,   857,   377,   854,   869,   394,   883,   385,   811,
     812,   987,   302,   813,   825,   826,   435,   868,   418,   964,
     984,   974,   974,   210,   985,   985,   249,   973,   252,   249,
     911,   532,   976,   431,   431,   431,   550,   174,   535,   621,
     135,   487,   357,   984,   974,   473,   637,   887,   974,   400,
     663,   663,   663,   663,   734,    74,   112,   263,   351,   974,
     568,   974,   160,   383,   357,   357,   568,   585,   592,   295,
     324,   484,   974,   974,   974,   182,   240,   664,   715,   719,
     719,   426,   357,   253,   590,   120,   299,   324,   486,   592,
     748,   135,   487,   135,   487,   974,   974,   974,   974,   595,
     596,   595,   432,   435,   597,   983,   432,   435,   418,   433,
     984,   295,   324,   484,   974,   974,   974,   262,   295,   324,
      18,   120,   262,   295,   324,   887,   234,   887,   984,   974,
     210,   267,   240,   983,   267,   985,   376,   357,   357,   312,
     357,   747,   312,   357,   357,   218,   218,   218,   357,   357,
     312,   357,   357,   312,   357,   312,   357,   312,   357,   487,
     887,   235,   983,   324,   748,   135,   487,   357,   974,   357,
     312,   984,   974,   669,   887,   192,   669,   669,   976,   976,
     669,   192,   192,   669,   500,   431,   502,   503,   251,   422,
     423,   564,   636,   719,   938,   983,   994,     3,   640,   432,
     429,   432,   982,   430,   982,   164,   222,   910,   222,   910,
     910,   982,   225,   432,   635,   636,   249,   210,   418,   774,
     774,   774,   774,   774,   774,   774,    60,    66,    76,   103,
     105,   178,   235,   240,   276,   290,   372,   525,   526,   527,
     134,   393,   442,   473,   974,   473,   590,   972,   972,   432,
     435,   985,   159,   306,   985,   982,   366,   972,   534,    38,
     461,   297,   347,    96,   535,   972,   613,   641,   642,   983,
     432,   435,   974,   535,   972,   974,   553,   431,   517,   432,
     248,   490,   248,   249,   547,   490,    31,   831,   491,   357,
     972,   432,   435,   103,   418,   724,   983,   473,   347,   718,
     719,   397,   723,   725,   108,   184,   317,   377,   756,   160,
     831,   487,   887,   974,   487,   487,   379,   487,   379,   487,
     487,   663,   663,   974,   607,   487,   312,   312,   312,   973,
     688,   435,   984,   397,   435,   686,   252,   133,   133,    96,
     985,   683,   487,   984,   637,   711,   564,   663,   192,   944,
     432,   354,   911,   126,   887,   432,   911,   911,   911,   952,
     887,   912,   115,   117,   235,   245,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   911,   911,   953,   952,
     908,   908,   887,   432,   432,   432,   940,   432,   435,    48,
     913,   432,   990,   919,   273,   342,   921,   432,   435,   390,
     915,    31,   432,   905,   983,   911,    28,    28,   911,   432,
     911,   151,   431,   943,   911,   912,   912,   128,   128,   911,
     432,   128,   911,   842,   842,   842,   842,   972,   972,   972,
     832,   881,   832,   870,   871,    31,   872,   873,   987,   435,
      84,   152,   180,   195,   207,   230,   305,   875,   873,    31,
     872,   874,   987,   431,   963,   911,   159,   859,   435,   845,
     846,   845,   432,   926,   431,   927,   987,   911,   926,   983,
     387,   942,   432,   432,   430,   432,   431,   708,   432,   250,
      86,   911,   813,   432,   435,   964,   969,   432,   435,   822,
     883,   966,   774,   154,   319,   348,   367,   697,   146,   697,
     432,   431,   538,   539,   704,   914,   987,   535,   535,   621,
     978,   432,   105,   178,   233,   235,   622,   974,   974,    31,
     974,   379,   379,   663,   663,   663,   663,   664,   984,   974,
     357,   747,   312,   357,   182,   426,   366,   974,   431,   524,
     235,   490,    96,   235,   337,   340,   490,   366,   974,   987,
     594,   493,   636,   990,   357,   747,   312,   357,   357,   357,
     312,   153,   251,   340,   646,   647,   153,   251,   654,   655,
     357,   357,   312,   432,   432,   432,   986,   983,   983,   983,
     974,   974,   974,   974,   974,   974,   974,   974,   146,   146,
     297,   146,   166,   984,   974,   974,   984,   974,   974,   974,
     974,   974,   974,   974,    66,   488,   135,    20,    40,   366,
     987,   974,   592,   974,   974,   432,   669,   192,   192,   669,
     669,   501,   509,   510,   990,    44,    85,   109,   124,   128,
     147,   150,   162,   240,   248,   282,   504,   621,   982,   397,
     398,   430,   430,   432,   909,   972,   774,   103,   982,   983,
     103,   983,   103,   983,   103,   983,   103,   974,   103,   974,
     103,   974,   431,   663,   974,   912,   106,   168,   105,   240,
     196,   972,   725,   280,   625,   626,   987,   578,   431,   529,
     321,   520,   985,   985,   887,   431,   491,   984,   972,   400,
     146,   614,   432,   435,   886,   590,   432,   245,   431,   807,
     519,   521,   523,   531,   987,   546,   177,   545,    71,   349,
     548,   831,   553,   548,   983,   702,   720,   911,   911,   435,
     431,   721,   633,   357,   568,   432,   487,   976,   976,   487,
     487,   321,   973,   973,   973,   564,   156,   685,   692,   151,
     192,   192,   192,   192,   240,   673,   983,   911,   432,   432,
     953,   151,   115,   117,   245,   431,   432,   403,   917,   940,
     289,    48,   395,   395,   432,   911,   233,   911,   435,   916,
     889,   909,   912,   912,   911,   943,   432,    28,    28,   911,
     911,   128,   911,   432,   972,   972,   972,   972,   873,   874,
     432,   987,   431,   870,   195,   257,   876,   870,   876,   195,
     875,   876,   195,   431,   987,   431,   941,    48,   161,   860,
     432,   432,   926,   928,   987,   942,   926,   983,   735,   245,
     831,   812,   418,   825,   813,   986,   357,   680,   151,   621,
     911,   432,   435,   397,    66,   705,   705,   432,   432,   725,
     106,   168,   176,   105,   381,   487,   887,   976,   976,   974,
     974,   974,   974,   366,   591,   595,   240,   240,   986,   987,
     887,   487,   487,   418,   974,   974,   974,   974,   984,   974,
     974,   982,   982,   887,   435,   982,   982,   435,   984,   974,
     974,   357,   973,   973,   663,   973,   135,   663,   983,   983,
     887,   487,   487,   192,   669,   669,   379,   507,   508,   432,
     435,   424,   431,   470,   511,   564,   782,   983,   782,   235,
     282,   782,   782,   430,   153,   181,   153,   151,   620,   986,
     911,   235,   526,   725,   534,   379,   549,   980,    28,   134,
     171,   516,   132,   172,   974,   379,   535,    31,   461,   431,
     974,   121,   615,   393,   617,   983,   491,   663,   516,   553,
     432,   435,   397,   547,   431,   546,   108,   120,   273,   974,
     397,   769,   151,   431,   983,   717,   726,   727,   988,   725,
     972,   179,   569,   487,   487,   487,   974,   252,   487,   684,
     673,   673,   673,   673,   912,   151,   431,   943,   431,   432,
     435,   432,   913,   289,   432,   384,   334,   432,   432,   432,
     912,   912,   911,   872,   431,   973,   870,   249,   379,   877,
     870,   195,   870,   885,   431,   885,   987,   432,   940,   911,
     396,   923,   926,   926,   265,   929,   432,   909,   432,   828,
     968,   684,   249,   684,   432,   725,   539,   251,   735,   663,
     379,   663,   706,   706,   290,   725,   549,   432,   357,   432,
     435,   488,   636,   357,   431,   980,   735,   647,   431,   431,
     655,   974,   397,   297,   397,   397,   146,   488,   669,   442,
     110,   510,   470,   512,   513,   983,   983,   240,   424,   535,
     983,   983,   688,    31,   740,   740,   972,   621,   432,   549,
     219,   537,   174,   431,   626,   280,   431,   432,    22,    70,
      77,   104,   175,   340,   530,   530,   590,   976,   432,   831,
     590,   308,   336,   616,   431,   134,    31,   517,   432,   521,
     253,   548,   971,   547,   309,   309,    52,    60,   213,   663,
     703,   704,   719,   432,   435,   882,   568,   233,   383,   570,
     571,   487,   912,   943,   432,   918,   940,    48,   233,   413,
     973,   432,   911,   431,   870,   877,   432,   885,   432,   924,
     925,   987,    48,   845,   926,   686,   697,   487,   705,   549,
     431,   663,   707,   707,   972,   549,   621,   974,   595,   379,
     489,   974,   943,   711,   146,   650,   734,   943,   943,   662,
     663,   662,   663,   973,   487,   502,   983,   432,   435,   535,
     740,    34,   170,   146,   233,   533,   152,   264,   329,   249,
     541,   542,   543,   349,   432,   980,     5,   627,   321,   141,
     649,   491,   769,   911,   280,   831,   546,   545,   524,   432,
     548,    60,   252,    60,   432,   435,   721,   726,   116,   383,
     568,   432,   432,   432,   289,   384,   432,   973,   432,   435,
      31,   940,   283,   309,   930,   151,   706,   394,   540,   735,
     708,   708,   534,   621,   911,   432,   255,   314,   287,   651,
     650,   432,   432,   397,   513,   121,   176,   108,   377,   249,
     543,   249,   542,   974,   431,   432,   435,   974,   663,    31,
      31,   432,   980,   547,   546,   252,   252,   491,   704,   725,
      23,   185,   757,   432,   925,   927,    42,    86,   368,   911,
     931,   932,   931,   432,   684,   707,   431,   621,   432,   537,
     980,    48,   651,   663,   308,    51,   233,   301,   324,   544,
     544,   432,     5,   590,   646,   831,   431,   548,   547,   548,
     236,   431,   752,   754,   759,   809,   814,   820,   831,   932,
     308,   145,   271,   145,   271,   487,   708,   911,   541,   711,
     663,   617,    17,   103,   240,     4,   618,   619,   982,   983,
     990,   548,   882,   753,   754,   755,   832,   833,    28,   432,
     621,   134,   432,   435,   432,   434,   932,   280,   619,   755,
     980,   431,   618,   432
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   437,   438,   439,   439,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     441,   442,   442,   443,   443,   444,   444,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   446,   446,   446,   446,
     446,   446,   447,   448,   449,   449,   450,   450,   451,   452,
     453,   453,   454,   454,   455,   456,   457,   457,   458,   458,
     459,   459,   459,   459,   460,   460,   461,   461,   462,   462,
     462,   462,   462,   462,   463,   463,   463,   464,   464,   464,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   466,   466,   467,   467,   468,   468,
     469,   469,   469,   469,   470,   470,   470,   470,   471,   471,
     471,   471,   471,   471,   471,   472,   472,   472,   473,   473,
     474,   474,   474,   474,   474,   475,   475,   476,   476,   477,
     477,   477,   477,   477,   478,   479,   479,   480,   480,   481,
     482,   482,   482,   482,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   484,   484,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   486,   486,
     487,   487,   487,   488,   488,   489,   489,   490,   491,   491,
     492,   492,   493,   493,   493,   493,   494,   495,   495,   496,
     496,   496,   496,   497,   497,   498,   498,   499,   499,   500,
     500,   501,   501,   501,   502,   502,   503,   503,   504,   504,
     504,   504,   504,   504,   504,   504,   504,   504,   504,   504,
     504,   505,   505,   506,   506,   507,   507,   508,   508,   509,
     509,   510,   511,   511,   511,   511,   511,   512,   512,   513,
     514,   514,   514,   514,   515,   515,   515,   515,   515,   515,
     515,   515,   516,   516,   517,   517,   518,   518,   519,   519,
     520,   520,   520,   521,   521,   522,   523,   524,   524,   525,
     525,   525,   525,   526,   526,   526,   526,   526,   526,   526,
     527,   527,   527,   527,   528,   529,   529,   529,   530,   530,
     530,   530,   530,   530,   531,   531,   532,   532,   532,   532,
     532,   532,   532,   533,   533,   534,   534,   535,   535,   536,
     537,   537,   537,   537,   538,   538,   539,   539,   540,   540,
     541,   541,   541,   541,   541,   542,   543,   544,   544,   544,
     544,   544,   545,   545,   546,   546,   546,   546,   547,   547,
     547,   547,   548,   548,   549,   549,   550,   551,   552,   553,
     553,   553,   554,   555,   556,   556,   557,   558,   559,   559,
     560,   560,   561,   561,   562,   562,   562,   562,   562,   562,
     562,   562,   562,   562,   562,   562,   563,   563,   564,   564,
     564,   565,   565,   566,   566,   567,   567,   568,   568,   569,
     569,   570,   570,   571,   571,   572,   572,   573,   573,   574,
     575,   575,   576,   576,   577,   577,   578,   578,   579,   579,
     579,   580,   581,   581,   582,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   584,
     585,   585,   585,   585,   586,   586,   587,   587,   588,   588,
     589,   589,   590,   590,   591,   591,   592,   593,   593,   594,
     594,   594,   594,   595,   596,   597,   598,   599,   599,   600,
     600,   601,   601,   602,   602,   603,   603,   603,   604,   604,
     605,   605,   606,   607,   607,   607,   608,   608,   609,   610,
     610,   611,   611,   611,   612,   612,   613,   613,   613,   613,
     613,   614,   614,   615,   615,   616,   616,   617,   617,   618,
     618,   618,   619,   619,   619,   619,   620,   620,   621,   621,
     622,   622,   622,   622,   622,   622,   623,   623,   624,   624,
     625,   625,   626,   627,   627,   628,   629,   629,   629,   629,
     630,   631,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   633,   634,   634,   635,
     635,   636,   636,   636,   636,   636,   637,   637,   638,   639,
     639,   640,   641,   641,   642,   642,   643,   643,   643,   644,
     644,   645,   646,   646,   647,   647,   647,   647,   647,   648,
     648,   649,   649,   650,   650,   650,   651,   651,   652,   653,
     653,   654,   654,   655,   655,   656,   656,   657,   657,   658,
     659,   660,   660,   660,   660,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   662,   662,   663,   663,   664,   664,   665,   666,
     666,   666,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   669,   669,
     670,   670,   670,   670,   670,   671,   671,   672,   672,   672,
     672,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     673,   673,   674,   674,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     676,   676,   677,   677,   678,   679,   679,   680,   680,   680,
     680,   680,   681,   681,   682,   682,   682,   682,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   684,   684,   685,   685,   686,   686,
     687,   687,   688,   689,   690,   690,   691,   691,   692,   692,
     693,   694,   694,   695,   695,   695,   696,   696,   696,   697,
     697,   697,   697,   698,   699,   699,   700,   700,   701,   701,
     702,   702,   703,   703,   704,   704,   704,   705,   705,   706,
     706,   706,   707,   707,   707,   708,   708,   708,   709,   709,
     709,   710,   710,   711,   711,   712,   712,   713,   713,   714,
     714,   715,   715,   715,   715,   715,   716,   716,   716,   716,
     716,   717,   718,   719,   719,   719,   720,   720,   720,   721,
     721,   722,   722,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   723,   723,   723,   723,
     724,   724,   725,   725,   726,   727,   727,   728,   729,   729,
     730,   730,   731,   731,   732,   732,   733,   733,   734,   734,
     734,   734,   735,   735,   736,   737,   737,   738,   738,   739,
     739,   739,   740,   740,   740,   741,   742,   742,   743,   743,
     743,   744,   744,   745,   745,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   747,   747,   748,   748,   749,   749,   749,   749,
     749,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     749,   749,   749,   749,   749,   749,   749,   749,   749,   749,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   751,
     752,   752,   752,   753,   753,   754,   754,   754,   754,   754,
     755,   755,   756,   756,   756,   756,   757,   757,   757,   758,
     758,   759,   760,   760,   761,   762,   762,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   764,   764,   764,   765,   765,   765,   765,   765,   766,
     766,   766,   767,   767,   768,   768,   768,   768,   769,   769,
     769,   769,   770,   771,   772,   772,   773,   773,   773,   773,
     773,   773,   773,   773,   773,   773,   773,   773,   773,   773,
     773,   773,   774,   774,   775,   775,   776,   777,   777,   778,
     779,   779,   780,   781,   781,   781,   781,   781,   781,   781,
     782,   782,   783,   784,   784,   784,   784,   784,   784,   785,
     786,   786,   786,   787,   787,   788,   788,   788,   788,   788,
     789,   789,   790,   790,   790,   790,   791,   791,   792,   792,
     793,   793,   794,   794,   795,   795,   796,   796,   797,   797,
     797,   797,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   799,   799,   800,   801,   801,   802,   802,   802,   803,
     804,   804,   805,   805,   805,   805,   806,   806,   807,   807,
     808,   808,   808,   808,   809,   810,   810,   810,   811,   811,
     812,   813,   813,   814,   815,   815,   816,   817,   817,   818,
     818,   818,   818,   818,   818,   818,   818,   819,   819,   820,
     821,   821,   822,   822,   823,   824,   825,   826,   826,   827,
     828,   829,   829,   829,   829,   829,   830,   830,   830,   831,
     831,   832,   832,   833,   833,   833,   833,   833,   833,   833,
     833,   834,   834,   835,   835,   835,   835,   835,   835,   836,
     836,   837,   837,   838,   839,   839,   840,   840,   841,   841,
     841,   841,   841,   841,   841,   841,   841,   842,   842,   843,
     843,   843,   844,   844,   844,   844,   845,   845,   846,   847,
     847,   848,   848,   849,   849,   849,   849,   850,   850,   851,
     851,   851,   852,   852,   853,   853,   854,   855,   855,   855,
     856,   857,   857,   858,   858,   859,   859,   860,   860,   861,
     861,   862,   862,   863,   863,   864,   865,   865,   865,   865,
     866,   866,   867,   867,   868,   868,   869,   869,   870,   870,
     870,   870,   870,   870,   870,   871,   871,   871,   871,   871,
     871,   872,   872,   872,   872,   873,   873,   874,   874,   874,
     874,   874,   875,   875,   875,   875,   876,   876,   877,   877,
     878,   878,   878,   878,   879,   879,   880,   880,   880,   881,
     882,   882,   883,   883,   883,   884,   884,   885,   885,   886,
     887,   887,   887,   887,   887,   887,   888,   888,   888,   889,
     889,   889,   889,   889,   889,   889,   890,   890,   890,   890,
     891,   891,   892,   892,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   894,   894,   895,   895,   896,
     896,   897,   898,   899,   899,   900,   900,   901,   902,   903,
     903,   903,   903,   903,   903,   904,   904,   905,   905,   906,
     906,   906,   906,   907,   908,   908,   908,   909,   909,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   909,
     909,   910,   910,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   913,   913,   913,   913,   913,   913,
     913,   913,   913,   913,   913,   913,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   915,   915,   916,   916,
     916,   916,   917,   918,   918,   919,   919,   920,   920,   921,
     921,   921,   922,   922,   922,   922,   923,   923,   924,   924,
     925,   926,   926,   926,   927,   928,   928,   929,   929,   930,
     930,   930,   931,   931,   932,   932,   932,   932,   932,   933,
     933,   933,   934,   934,   934,   935,   935,   936,   936,   936,
     936,   936,   936,   936,   936,   936,   937,   937,   938,   938,
     939,   939,   939,   939,   939,   939,   940,   940,   941,   941,
     942,   942,   943,   943,   944,   944,   944,   945,   945,   946,
     946,   947,   947,   947,   947,   947,   947,   947,   947,   948,
     948,   949,   950,   950,   951,   951,   951,   951,   951,   951,
     952,   953,   954,   954,   954,   955,   955,   956,   957,   957,
     958,   959,   959,   960,   960,   961,   961,   962,   962,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   967,
     967,   968,   969,   969,   970,   970,   970,   970,   971,   971,
     972,   972,   973,   973,   974,   975,   976,   977,   978,   979,
     980,   980,   981,   981,   981,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   981,   982,   983,   984,   985,   985,
     986,   986,   986,   987,   987,   987,   988,   988,   988,   989,
     989,   989,   989,   990,   990,   990,   990,   990,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   991,   991,   991,   991,   991,   991,   991,   991,
     991,   991,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     992,   992,   992,   992,   992,   992,   992,   992,   992,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   994
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       5,     1,     0,     2,     0,     2,     0,     2,     2,     3,
       3,     1,     3,     3,     2,     1,     1,     2,     2,     2,
       3,     3,     5,     5,     0,     3,     5,     5,     5,     4,
       3,     5,     3,     5,     5,     6,     1,     1,     3,     5,
       6,     4,     9,     7,     1,     0,     2,     0,     1,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     1,     3,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     3,     4,     3,     2,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     6,     4,     6,     4,     6,
       4,     6,     5,     7,     1,     3,     2,     3,     4,     6,
       6,     6,     5,     5,     6,     6,     4,     8,     4,     2,
       3,     6,     4,     3,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     2,
       3,     2,     2,     3,     3,     2,     2,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     3,     2,     0,
       1,     3,     3,     1,     5,     3,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    11,     7,     1,     1,     1,
       0,     1,     1,     1,     1,     3,     2,     0,     1,     1,
       1,     3,     3,     1,     1,     3,     3,     3,     3,     4,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,     5,     2,
       3,     0,     8,     4,     1,     0,     5,     5,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     5,     7,     1,     0,     6,
       2,     0,     3,     5,     5,     8,     2,     0,     2,     2,
       2,     5,     2,     0,     2,     7,    10,     6,     6,     6,
       6,     7,     7,     9,     9,     6,     7,     6,     8,     8,
       8,     8,     6,     6,     7,     7,     8,     6,     6,     7,
       2,     2,     2,     2,     1,     2,     1,     0,     6,     8,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,     2,     0,     2,
       2,     1,     0,     4,     6,     5,     4,     4,    10,    13,
       5,     7,     8,     1,     1,     1,     7,     9,     8,    15,
      20,     1,     1,     2,     1,     3,     1,     1,     1,     3,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       3,     0,     1,     1,     1,     1,     2,     0,     0,     2,
       2,     1,     2,     2,     2,     2,     6,     8,    11,    13,
       1,     3,     5,     1,     3,     5,     1,     2,     2,     1,
       8,     4,     5,     4,     4,     4,     3,     7,     8,     6,
       6,     6,     6,     6,     4,     5,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     3,     1,     0,     1,     3,     7,     9,     9,     3,
       0,    13,     1,     3,     5,     6,     4,     7,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     5,     7,     1,     1,     1,     2,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     1,     2,     2,     3,     5,     2,
       2,     0,     6,     7,     7,     7,     8,     8,     6,     8,
       9,     9,     7,    10,     7,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     3,     2,     3,     3,     3,     3,     1,     1,
       8,     9,     9,     9,     9,     2,     0,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     2,     3,     2,     2,
       2,     5,     5,     5,     1,     3,     1,     2,     3,     0,
       1,     3,     2,     6,     6,     9,     3,     0,     3,     0,
       5,     2,     0,     3,     3,     3,     7,     7,    10,     1,
       1,     1,     1,    14,     1,     0,     1,     0,     1,     0,
       2,     0,     1,     3,     5,     5,     7,     2,     0,     1,
       2,     0,     1,     1,     0,     1,     1,     0,     9,    12,
       7,     2,     0,     3,     2,     1,     3,     3,     2,     1,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     4,     5,     1,     3,     3,     1,
       2,     4,     5,     1,     1,     1,     1,     3,     3,     2,
       2,     1,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     5,     1,     2,
       1,     0,     5,     7,     5,     7,     5,     7,     3,     5,
       5,     5,     1,     3,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,     4,     4,
       4,     1,     1,     1,     0,     7,     6,     6,     6,     6,
       8,     8,     6,     6,     7,     9,     9,     6,     6,     6,
       8,     6,     8,     6,     8,     7,     9,     6,     8,     7,
       9,     8,    10,     9,    11,     8,     9,    11,     8,     8,
       7,     6,     6,     6,     5,     5,     8,     8,     8,     8,
       6,     9,     1,     0,     2,     0,     7,     6,     6,     6,
       6,     6,     7,     9,     9,     6,     8,     8,     8,     8,
       8,     6,     8,     6,     8,     7,     9,     7,     9,     6,
       7,     6,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,     7,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     6,
       8,     3,     2,     0,     2,     2,     2,     2,     3,     3,
       2,     2,     2,     2,     3,     2,     5,     4,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     2,     1,
       3,     2,     1,     0,     9,    11,    11,    13,     3,     4,
       4,     0,     2,     5,     2,     0,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       3,     3,     1,     0,     5,     6,     4,     2,     0,     4,
       3,     5,     6,     4,     6,     6,     5,     7,     9,     6,
       1,     0,     6,    11,    11,    11,    13,     9,    11,    10,
       4,     2,     5,     2,     0,     4,     5,     5,     4,     6,
       1,     3,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     0,     1,     0,     1,     0,     3,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1,     1,     1,     1,     0,     5,
       3,     0,     1,     1,     1,     1,     3,     9,     3,     0,
       2,     3,     2,     3,     6,     1,     4,     2,     1,     3,
       2,     2,     0,     7,     2,     0,     5,     3,     0,     2,
       2,     2,     3,     1,     3,     1,     2,     1,     0,     8,
       1,     3,     1,     1,     3,     5,     2,     1,     3,     7,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     1,     2,     4,     4,     4,     2,
       3,     1,     3,     6,     1,     0,     2,     0,     3,     3,
       4,     4,     4,     4,     3,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     0,     3,     1,
       3,     4,     3,     2,     2,     1,     1,     1,     0,     2,
       4,     5,     2,     3,     1,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     1,     3,     0,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     2,
       3,     2,     3,     1,     4,     3,     4,     5,     4,     5,
       4,     5,     2,     4,     1,     1,     0,     1,     4,     5,
       4,     0,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     1,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     2,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     3,     3,     2,     3,     5,     4,     6,     3,     5,
       4,     6,     4,     6,     5,     7,     3,     2,     4,     2,
       3,     3,     4,     3,     4,     3,     4,     5,     6,     6,
       7,     6,     7,     6,     7,     3,     4,     4,     6,     2,
       3,     4,     1,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     5,     6,
       6,     7,     3,     4,     1,     1,     2,     4,     1,     1,
       1,     2,     2,     2,     2,     1,     4,     5,     6,     8,
       6,     7,     7,     5,     5,     1,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     4,     4,     6,     5,     5,     5,     4,
       6,     4,     4,     4,     4,     5,     7,     7,     9,     5,
       4,     6,     5,     7,     7,     7,     2,     3,     3,     3,
       4,     0,     4,     1,     3,     3,     1,     1,     1,     2,
       2,     0,     2,     4,     4,     6,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     2,
       2,     0,     1,     4,     2,     2,     2,     2,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     4,
       1,     4,     1,     2,     1,     2,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     3,     2,     1,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     2,     3,     0,     3,     3,     2,     2,     1,     0,
       2,     2,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     2,     0,     2,     1,     0,     1,     1,     1,
       3,     3,     1,     3,     3,     2,     1,     1,     1,     3,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     5,     2,
       3,     6,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 679 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 19623 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 686 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 19634 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 693 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 19645 "gram.c" /* yacc.c:1646  */
    break;

  case 119:
#line 817 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19651 "gram.c" /* yacc.c:1646  */
    break;

  case 120:
#line 828 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19663 "gram.c" /* yacc.c:1646  */
    break;

  case 121:
#line 838 "gram.y" /* yacc.c:1646  */
    {}
#line 19669 "gram.c" /* yacc.c:1646  */
    break;

  case 122:
#line 839 "gram.y" /* yacc.c:1646  */
    {}
#line 19675 "gram.c" /* yacc.c:1646  */
    break;

  case 123:
#line 848 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 19681 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 849 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19687 "gram.c" /* yacc.c:1646  */
    break;

  case 125:
#line 853 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 19693 "gram.c" /* yacc.c:1646  */
    break;

  case 126:
#line 854 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19699 "gram.c" /* yacc.c:1646  */
    break;

  case 127:
#line 859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19708 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 864 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 19716 "gram.c" /* yacc.c:1646  */
    break;

  case 129:
#line 868 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19725 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 19734 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 878 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 19742 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 19750 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 886 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 19758 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 891 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 19766 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 895 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 19821 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 948 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 19827 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 951 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 19835 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 955 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 19843 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 959 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 19851 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 963 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 19859 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 967 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 19867 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 981 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19879 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 999 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 19891 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1009 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19897 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1010 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19903 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1015 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 19915 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1023 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 19927 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1041 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 19939 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1053 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-1].str);
					n->database = NULL;
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 19951 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1074 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19962 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1081 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19973 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1100 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19984 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1107 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 19995 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1124 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20007 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1142 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 20020 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1152 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 20026 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1153 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 20032 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1166 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20043 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1173 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20054 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1190 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20071 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1203 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20085 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1213 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20107 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1231 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20126 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1248 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20132 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1249 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20138 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1254 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 20148 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20154 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1288 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20164 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1294 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 20174 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1300 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 20184 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1309 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20196 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1317 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20208 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1329 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20220 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1337 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 20232 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1345 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20243 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1352 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20254 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1359 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 20265 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1367 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 20280 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1378 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 20292 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1386 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 20304 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1394 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 20319 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1405 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 20331 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1413 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 20343 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1421 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 20354 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1428 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 20366 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1437 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 20378 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1446 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20384 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.str) = palloc(strlen((yyvsp[-2].str)) + strlen((yyvsp[0].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
				}
#line 20393 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1454 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 20399 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1455 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 20405 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 20411 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1461 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 20417 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1464 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 20423 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1465 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 20429 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1466 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 20435 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1467 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 20441 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1471 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 20447 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1472 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 20453 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1473 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 20459 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1479 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20465 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 20473 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 20481 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1500 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 20500 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1515 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 20527 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1537 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 20533 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1538 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20539 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1539 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20545 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1543 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20551 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1544 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20557 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1545 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20563 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1549 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20569 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1550 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20575 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1555 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 20586 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1562 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 20597 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1569 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 20608 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1576 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 20619 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1583 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
#line 20629 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1592 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 20635 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1593 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 20641 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1598 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 20647 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1599 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 20653 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1605 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 20663 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1611 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 20673 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1617 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 20683 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1623 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 20693 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1629 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 20703 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1639 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 20714 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1648 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20720 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1649 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 20726 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1653 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 20732 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1654 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 20738 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1663 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 20747 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1678 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 20757 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1684 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 20767 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1690 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 20777 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1696 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 20787 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1714 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20800 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1723 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20813 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1732 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20826 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1741 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20839 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1750 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20852 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1759 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20865 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1768 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20878 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1777 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20891 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1786 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 20904 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1795 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 20917 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 20923 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1807 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 20929 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1813 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20940 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1821 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20951 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1829 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 20963 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1838 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 20974 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1846 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 20985 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1854 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 20997 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1863 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21009 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1872 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21021 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1881 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 21033 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1890 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21046 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1900 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21059 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1913 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21076 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1927 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21088 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1936 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 21099 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1944 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21110 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1952 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21123 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1962 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21136 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1972 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 21146 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1979 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 21156 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1986 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21167 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1994 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 21178 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2002 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21189 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2010 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21200 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2018 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21211 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2026 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 21221 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2033 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 21231 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2040 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21242 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2048 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 21252 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2055 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 21262 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2062 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21273 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2070 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21284 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2078 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21295 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2086 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21306 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2094 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 21317 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2102 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 21328 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2110 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 21341 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2120 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 21351 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2127 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21362 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2135 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21373 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2143 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21384 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2151 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21395 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2158 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 21406 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2167 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21412 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2168 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21418 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2172 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 21424 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2173 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 21430 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2174 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 21436 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2179 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 21448 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2186 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21454 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2190 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 21460 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2191 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21466 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2195 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21472 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2198 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21478 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21484 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 21490 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2204 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 21496 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 21504 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 21512 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 21521 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2223 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 21529 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2238 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 21543 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2250 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21549 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2251 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21555 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2257 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 21567 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2266 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 21580 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2276 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 21593 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2286 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					(yyval.node) = (Node *)n;
				}
#line 21611 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2311 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 21621 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2317 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 21631 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2348 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-5].boolean);
					n->is_program = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-6].defelt))
						n->options = lappend(n->options, (yyvsp[-6].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 21663 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2376 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-5].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-2]))));

					(yyval.node) = (Node *)n;
				}
#line 21686 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2397 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21692 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2398 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21698 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2402 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21704 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2403 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21710 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2412 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21716 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2413 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21722 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2414 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21728 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2417 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21734 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2418 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21740 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 21746 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21752 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2429 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 21760 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 21768 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 21776 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 21784 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2445 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 21792 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2449 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 21800 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 21808 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2457 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 21816 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 21824 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2465 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 21832 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2469 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 21840 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 21848 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 21856 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2486 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 21864 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2489 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21870 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 21878 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2497 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21884 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 21892 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2505 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 21898 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2509 "gram.y" /* yacc.c:1646  */
    {}
#line 21904 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2510 "gram.y" /* yacc.c:1646  */
    {}
#line 21910 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2516 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 21918 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2520 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 21926 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 21934 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2533 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 21940 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2534 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 21946 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2535 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 21952 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2536 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 21958 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2537 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21964 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 21972 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 21980 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2553 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 21986 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2566 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 22004 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2582 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 22022 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2597 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 22041 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2613 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 22060 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2640 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22066 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2641 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22072 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2642 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22078 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2643 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 22084 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2645 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 22095 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2652 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 22106 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2658 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 22112 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2659 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 22118 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2663 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22124 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2664 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22130 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2668 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22136 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2669 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22142 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2674 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 22150 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2678 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 22158 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2685 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 22166 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 22174 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2695 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22180 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22186 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22192 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22198 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2702 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22204 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2706 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = (yyvsp[-2].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22226 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2726 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22247 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2745 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 22253 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2746 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22259 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2751 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 22271 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2758 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22277 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2759 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22283 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2761 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 22300 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2792 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 22311 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2799 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 22322 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2806 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22337 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2817 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 22352 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2828 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22366 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2838 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22379 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2847 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 22398 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2880 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 22409 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2887 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 22420 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2894 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 22431 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2901 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 22442 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2912 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 22453 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2921 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 22459 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2922 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 22465 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2923 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 22471 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2927 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 22477 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2928 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 22483 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2929 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 22489 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2930 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 22495 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2931 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 22501 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2932 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 22507 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2942 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 22519 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2949 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22525 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2954 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 22542 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2968 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22560 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2982 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22578 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2997 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22596 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3011 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22614 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3027 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 22634 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3044 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 22656 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3063 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 22662 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3064 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 22668 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3068 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22674 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22680 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 22686 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 22692 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 22700 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3084 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 22708 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3088 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 22720 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3096 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 22728 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3100 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 22736 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3106 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 22742 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 22748 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3112 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 22756 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3117 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 22764 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3123 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 22770 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3124 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22776 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3135 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 22782 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3137 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 22788 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 22794 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3141 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 22800 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3143 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 22806 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3146 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 22812 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3149 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 22818 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3153 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 22824 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3154 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 22830 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3155 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 22836 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3156 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 22842 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3157 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 22848 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3160 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22854 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22860 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22866 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3167 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 22872 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3168 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 22878 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3169 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22884 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3172 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 22890 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3173 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 22896 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3174 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 22902 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3175 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 22908 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3178 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22914 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3179 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22920 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3182 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22926 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3183 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22932 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3186 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22938 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3202 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 22954 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 22969 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3230 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22975 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3231 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22981 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3232 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22987 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3245 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 23003 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3260 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 23018 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3272 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 23024 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3273 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 23030 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3286 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 23041 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3305 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 23054 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3317 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 23066 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3325 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 23078 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23084 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3336 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23090 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3339 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 23096 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23102 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 23110 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 23118 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 23126 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 23134 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3360 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 23142 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3364 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 23150 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 23158 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 23166 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 23174 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 23182 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3384 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 23190 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3388 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 23198 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3393 "gram.y" /* yacc.c:1646  */
    {}
#line 23204 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3394 "gram.y" /* yacc.c:1646  */
    {}
#line 23210 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3398 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 23216 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 23225 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3404 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 23231 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3407 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 23237 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3408 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 23243 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3421 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 23259 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3434 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 23274 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3447 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23280 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3448 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23286 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3456 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 23292 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 23298 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3461 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23304 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3462 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23310 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3466 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23316 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23322 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3471 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23328 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23334 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3477 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 23349 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3488 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 23363 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3500 "gram.y" /* yacc.c:1646  */
    {}
#line 23369 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3501 "gram.y" /* yacc.c:1646  */
    {}
#line 23375 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3512 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-3].str);
					n->owner = (yyvsp[-2].str);
					n->location = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23387 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3521 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 23393 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3522 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 23399 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3536 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 23410 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3543 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 23421 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3560 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23433 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3568 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23445 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3579 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23451 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3581 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23457 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 23465 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 23473 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 23481 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3606 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23492 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23498 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23504 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 23512 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3636 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23526 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3646 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 23540 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3656 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23553 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3665 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23566 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3674 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23579 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3683 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 23593 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3693 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23606 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3702 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23620 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3712 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23634 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3722 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23648 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3732 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23661 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3741 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23674 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3750 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23687 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3759 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23700 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3768 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23713 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3777 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23726 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3786 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23739 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3795 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23752 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3804 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23765 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3813 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23778 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3822 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23791 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3831 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23804 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3840 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 23817 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3849 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23830 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3867 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23842 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3877 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 23848 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3878 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 23854 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3879 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 23860 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3880 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 23866 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 23872 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 23878 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3889 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23884 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23890 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3901 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23905 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3912 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 23920 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3932 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23932 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3940 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 23944 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23950 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23956 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 23964 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 23972 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3968 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23978 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 23986 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 23994 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 24002 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3988 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 24011 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 24020 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 24028 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4005 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 24036 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4011 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24042 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4016 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 24048 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4028 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24062 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4040 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24068 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4041 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24074 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4046 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24080 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4047 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24086 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4051 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24092 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4052 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24098 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4063 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24113 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4074 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24128 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4094 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 24141 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4103 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 24153 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4111 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24164 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4130 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24181 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4145 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24198 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4168 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 24211 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4177 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 24224 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4195 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24236 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4206 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 24242 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4207 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 24248 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4208 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 24254 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4219 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 24266 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4227 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 24278 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4244 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 24290 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4265 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 24312 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4286 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 24335 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4307 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 24341 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4308 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 24347 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4309 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 24353 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4314 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24359 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4316 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 24382 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4338 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 24388 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 24394 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 24400 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 24406 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4346 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 24412 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 24420 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4355 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 24432 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4365 "gram.y" /* yacc.c:1646  */
    {}
#line 24438 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4366 "gram.y" /* yacc.c:1646  */
    {}
#line 24444 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4370 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24450 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4371 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24456 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4375 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 24462 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4376 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 24468 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4380 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 24474 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 24480 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4382 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24486 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4387 "gram.y" /* yacc.c:1646  */
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 24496 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4392 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 24502 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4393 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 24508 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4394 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 24514 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4398 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 24520 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4399 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 24526 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4404 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 24532 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4406 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 24560 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4432 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 24566 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4433 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 24572 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4434 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 24578 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4435 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 24584 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4436 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 24590 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4437 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 24596 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4443 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24611 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4454 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 24626 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4478 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 24639 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4489 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 24652 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24658 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4503 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 24664 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4508 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 24670 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 24676 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 24682 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4520 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 24693 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4529 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 24699 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4530 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 24705 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4531 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 24711 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4532 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 24717 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4546 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 24737 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4565 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 24753 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4588 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24767 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4598 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24782 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4609 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24796 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4619 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24810 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4629 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 24825 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4640 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 24838 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4649 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 24849 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4656 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24860 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4663 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24873 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4672 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24886 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4681 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24899 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4690 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24912 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4699 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 24925 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4708 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 24938 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4718 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 24944 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4721 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 24950 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 24956 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 24964 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 24972 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4736 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 24978 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4737 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 24984 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4738 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 24990 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4739 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 24996 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4740 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 25002 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25008 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4744 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25014 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4747 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25020 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4750 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25026 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4751 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 25032 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 25040 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25046 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25052 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4771 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25058 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 25064 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4784 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 25078 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4794 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 25092 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4804 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 25106 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4815 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 25112 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4816 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 25118 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4834 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25133 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4847 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 25139 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4848 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 25145 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4853 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 25159 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4864 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 25173 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4874 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 25186 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4883 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 25200 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4893 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 25211 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4901 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25217 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4902 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25223 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4905 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25229 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4906 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25235 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4909 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25241 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25247 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25253 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4915 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 25271 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4928 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25277 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4934 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25288 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4944 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25301 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4953 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 25314 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 4964 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 25320 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 4965 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 25326 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 4970 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 25338 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 4978 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 25350 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 4990 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25365 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5001 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25380 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5015 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25395 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5026 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 25410 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5049 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25421 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5059 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 25432 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5077 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 25447 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5088 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 25462 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5099 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 25477 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5110 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 25492 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5123 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 25498 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5124 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 25504 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5125 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 25510 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5126 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 25516 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5127 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 25522 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5128 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 25528 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5129 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 25534 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5130 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 25540 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5131 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 25546 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5132 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 25552 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5133 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 25558 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5134 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 25564 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5135 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 25570 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5136 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 25576 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5137 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 25582 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5138 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 25588 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5139 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 25594 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 25600 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 25606 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25612 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 25618 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25624 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 25630 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5167 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25642 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5177 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 25648 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5178 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 25654 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5179 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 25660 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5212 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25673 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5221 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25686 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5230 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25699 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5239 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25712 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5248 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25725 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5257 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25738 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5266 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25752 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5276 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25765 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5285 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25778 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5294 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25791 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5303 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25804 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5312 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25817 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5321 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25830 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5332 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 25836 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5333 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 25842 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5334 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 25848 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5335 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 25854 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5336 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 25860 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5337 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 25866 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5338 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 25872 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5339 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 25878 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5340 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 25884 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5341 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 25890 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5342 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 25896 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5343 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 25902 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5344 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 25908 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5345 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 25914 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5346 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 25920 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5347 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 25926 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5348 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 25932 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5349 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 25938 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5350 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 25944 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5351 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 25950 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5352 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 25956 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5353 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 25962 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5354 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 25968 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5358 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25974 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5359 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25980 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5375 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 25994 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5386 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26008 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5397 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26022 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5408 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26036 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5419 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 26050 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5430 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26056 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5431 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26062 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5435 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 26068 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5436 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 26074 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5437 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 26080 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5438 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 26086 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5439 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 26092 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5440 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 26098 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5441 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26104 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5442 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26110 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5443 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 26116 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5444 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 26122 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5445 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 26128 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5446 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 26134 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5447 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 26140 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5450 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26146 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5451 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26152 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5462 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 26162 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5468 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 26172 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5476 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26184 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5484 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26196 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5492 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26208 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5500 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26220 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5508 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26232 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5516 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 26244 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5524 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 26256 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5532 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 26268 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5540 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 26280 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5548 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 26292 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5556 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26304 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5564 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 26316 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5572 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 26328 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5580 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 26340 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5588 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 26352 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5596 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 26364 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5605 "gram.y" /* yacc.c:1646  */
    {}
#line 26370 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5606 "gram.y" /* yacc.c:1646  */
    {}
#line 26376 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5609 "gram.y" /* yacc.c:1646  */
    {}
#line 26382 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5610 "gram.y" /* yacc.c:1646  */
    {}
#line 26388 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5622 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 26404 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5638 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26421 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5652 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26438 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5677 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 26444 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5679 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26450 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26456 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5683 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 26467 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5690 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 26478 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5698 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 26484 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5699 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 26490 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5703 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 26501 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5710 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 26512 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5717 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 26523 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5724 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 26534 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5738 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26546 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5746 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26558 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5754 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26570 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5762 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26582 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5770 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26594 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5778 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26606 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5786 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26618 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5794 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26630 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5802 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26642 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5810 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26654 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5818 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26666 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5826 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26678 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5834 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26690 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5842 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26702 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5850 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26714 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5858 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 26726 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26732 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5870 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 26738 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5874 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26752 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5884 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26766 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5897 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26772 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5898 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26778 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 26784 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5904 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 26790 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5909 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 26801 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5925 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 26815 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5938 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 26829 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5948 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 26843 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5959 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26849 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5960 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26855 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5963 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 26861 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5964 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 26867 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 5975 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 26878 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 5984 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 26884 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 5985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26890 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 5990 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 26898 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 5994 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 26906 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 5998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 26914 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6010 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 26930 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6023 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26947 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6037 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26964 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6052 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 26970 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6053 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 26976 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6054 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 26982 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6055 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 26988 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6070 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
#line 27014 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6094 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27020 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6095 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27026 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6099 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27032 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6100 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27038 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6104 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27044 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6105 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27050 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6109 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27056 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6110 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 27062 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 27068 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 27074 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 27089 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6134 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 27104 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 27119 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6157 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27125 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6158 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27131 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27137 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6162 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27143 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6163 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27149 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6166 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 27155 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6167 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 27161 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6168 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 27167 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6171 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 27173 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6172 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 27179 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 27185 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6191 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27200 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6203 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27216 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6216 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27231 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6229 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27237 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6230 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27243 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6233 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27249 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27255 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6238 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 27261 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 27267 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6247 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 27273 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6248 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27279 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6252 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 27285 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 27291 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6269 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27304 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6278 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27317 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6287 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27330 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6296 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27343 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6305 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27356 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6316 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 27362 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6317 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 27368 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6318 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 27374 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6319 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 27380 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6320 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 27386 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6331 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 27398 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6345 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 27404 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6347 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 27414 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 27425 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 27433 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 27442 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 27451 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27457 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6382 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27463 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6390 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 27471 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6394 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 27479 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 27487 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6402 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 27495 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6406 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 27503 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6410 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 27511 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6414 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 27519 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6418 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 27527 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6422 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 27535 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 27543 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6430 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 27551 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6434 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 27559 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6438 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 27567 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6442 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 27575 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6446 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 27584 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 27592 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6458 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 27600 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6462 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 27608 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 27616 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6471 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 27622 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 27630 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 27636 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6480 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27642 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6484 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 27655 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 27663 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 27671 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6515 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 27682 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6525 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27688 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6526 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27694 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6548 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27709 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6559 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27724 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6573 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27739 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6584 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27754 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6598 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27769 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6609 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27784 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6623 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 27796 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6631 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 27802 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6633 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 27808 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6635 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 27814 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 27820 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 27826 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6655 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27836 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6663 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27842 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6664 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27848 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6669 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 27856 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6673 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 27864 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6686 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 27878 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6697 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 27892 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6708 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 27906 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6719 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 27912 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6720 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 27918 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6721 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 27924 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6726 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 27939 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 6738 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 27945 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 6739 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 27951 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6754 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 27963 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6762 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 27977 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6772 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 27991 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6784 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 27997 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6785 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 28003 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6788 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 28009 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6789 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 28015 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6800 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28029 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6810 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28042 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6819 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28055 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6828 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28068 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6837 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28081 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6846 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28095 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6856 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28108 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6865 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28122 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6875 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28135 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6884 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28148 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6893 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28162 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 6903 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28176 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 6913 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28189 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 6922 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28202 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 6931 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28216 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 6941 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28230 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 6951 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28244 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 6961 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28258 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 6971 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28272 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 6981 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28286 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 6991 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28300 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7001 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28314 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7011 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28328 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7021 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28342 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7031 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28356 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7041 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28370 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7051 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28385 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7062 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28400 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7073 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28415 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7084 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28430 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7095 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28444 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28459 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7116 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28474 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7127 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28488 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7137 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28502 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7147 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 28514 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7155 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28527 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7164 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28540 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7173 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28553 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7182 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 28566 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7191 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 28579 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7200 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28592 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7209 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28605 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7218 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28618 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7227 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28631 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7236 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28644 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7245 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28660 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7258 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 28666 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7259 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28672 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7262 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 28678 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7263 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28684 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7274 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28698 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7284 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28711 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7293 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28724 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7302 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28737 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7311 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28750 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7320 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28764 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7330 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28778 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7340 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28792 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7350 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28806 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7360 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28819 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7369 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28832 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7378 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28845 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7387 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28858 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7396 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28871 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7405 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28884 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7414 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28897 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7423 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28910 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7432 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28923 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7441 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28936 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7450 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28949 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7459 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28962 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7468 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28975 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7477 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28988 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7486 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29001 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7503 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29014 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7512 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29026 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7520 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29038 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7528 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29050 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7536 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29062 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7544 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29075 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7553 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29087 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7561 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29099 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7569 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29112 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7578 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29125 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7587 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29138 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7596 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29150 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7604 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29162 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7612 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29174 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7620 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29186 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7628 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29198 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7636 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29210 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7644 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29222 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7652 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29234 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7671 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29250 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7685 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29256 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29262 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 29268 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7693 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 29278 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7699 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 29288 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7715 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29294 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7716 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29300 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7719 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 29306 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7720 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 29312 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7721 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 29318 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7722 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 29324 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7726 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 29330 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7727 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29336 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7728 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 29342 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7734 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29357 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7745 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 29372 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7767 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29383 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7776 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29389 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7777 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29395 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7781 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29405 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7790 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29415 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7796 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29425 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7815 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29436 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7822 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29447 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7829 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29458 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7836 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29469 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7843 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29480 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7850 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29491 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7857 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 29503 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7865 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 29515 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7873 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 29527 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7881 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 29539 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7889 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 29551 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7897 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7904 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29573 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7911 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29584 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7919 "gram.y" /* yacc.c:1646  */
    {}
#line 29590 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7920 "gram.y" /* yacc.c:1646  */
    {}
#line 29596 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7921 "gram.y" /* yacc.c:1646  */
    {}
#line 29602 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7926 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 29609 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7929 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 29616 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7932 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 29623 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 7935 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 29630 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 7938 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 29637 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 7945 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 7947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 7949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29655 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 7955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29661 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 7969 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 29676 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 7981 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 29691 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 7993 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-6].range);
					n->view->relpersistence = (yyvsp[-9].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[0].node));
					n->replace = false;
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 29706 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8005 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-6].range);
					n->view->relpersistence = (yyvsp[-9].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[0].node));
					n->replace = true;
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 29721 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 29731 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8025 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 29741 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8031 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 29751 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8036 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29757 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8047 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29767 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8063 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29778 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29784 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29790 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 29798 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 29806 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8086 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 29814 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8090 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 29822 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 29830 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8098 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 29838 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 29846 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8106 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 29854 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 29862 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 29870 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8118 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 29878 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 29886 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8126 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 29894 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8130 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 29902 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8134 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 29910 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8138 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 29918 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8147 "gram.y" /* yacc.c:1646  */
    {}
#line 29924 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8148 "gram.y" /* yacc.c:1646  */
    {}
#line 29930 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8160 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 29941 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8167 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 29953 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8178 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 29964 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8188 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29970 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8189 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29976 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8208 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29995 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8215 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30006 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8232 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 30019 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8245 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 30031 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8254 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 30042 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8262 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 30053 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8270 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 30065 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8279 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30079 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8290 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30093 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8301 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30105 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8310 "gram.y" /* yacc.c:1646  */
    {}
#line 30111 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8311 "gram.y" /* yacc.c:1646  */
    {}
#line 30117 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8323 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30128 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8333 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 30142 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8343 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 30156 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8353 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 30170 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8363 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 30184 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8373 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 30196 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8381 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 30208 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8403 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 30222 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8425 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 30234 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8433 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 30246 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8442 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 30258 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8452 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30264 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8453 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30270 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8466 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30290 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8482 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30310 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8498 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 30328 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8512 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 30352 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8532 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 30378 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8556 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 30384 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8557 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 30390 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8561 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 30396 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8562 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 30402 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8563 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 30408 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8564 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 30414 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8569 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 30432 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8583 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30450 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8599 "gram.y" /* yacc.c:1646  */
    {}
#line 30456 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8600 "gram.y" /* yacc.c:1646  */
    {}
#line 30462 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8604 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30468 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8605 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30474 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8608 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30480 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8609 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30486 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8612 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30492 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8613 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30498 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8617 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30504 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30510 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8632 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 30521 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8639 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 30535 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8649 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 30546 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8656 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 30557 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8678 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30565 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8682 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30573 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 30581 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8695 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30587 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8696 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 30593 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30599 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8701 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 30605 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8702 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30611 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8713 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30623 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30629 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30635 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8741 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30646 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8749 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 30665 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30671 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30677 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8777 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 30687 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8783 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 30697 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8789 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 30707 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 8795 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 30717 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 8811 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 30728 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 30738 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8827 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 30748 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8833 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 30758 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 30764 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8844 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 30770 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 30782 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30788 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8860 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30794 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8873 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 30808 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30814 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30820 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8898 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 30833 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8908 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 30839 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8909 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 30845 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8912 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 30851 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 8913 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 30857 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 8914 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 30863 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 8915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 30869 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 8916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 30875 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 8917 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 30881 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 8918 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 30887 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 8919 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 30893 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 8922 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30899 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 8923 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30905 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 8939 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 30920 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 8952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30926 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 8953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 30932 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 8957 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 30938 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 8958 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30944 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 8963 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 30953 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 8971 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 30982 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 8999 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 30994 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9009 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 31000 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9010 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 31006 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9021 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 31019 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9031 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31025 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9034 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31031 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9035 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 31037 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9036 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 31043 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9037 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 31049 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9038 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 31055 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9041 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31061 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9042 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 31067 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9043 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31073 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9096 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31079 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9097 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31085 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9112 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31091 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9114 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 31102 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9121 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 31114 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9129 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 31126 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9137 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 31138 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9145 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 31150 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9153 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 31162 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9161 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 31174 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9171 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31180 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9172 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31186 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9202 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 31203 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9214 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31209 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9216 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 31232 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 31240 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 31248 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 31256 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9258 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 31267 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9265 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 31278 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31284 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9275 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31290 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9279 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 31303 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9290 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 31309 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9291 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 31315 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 31330 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9307 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 31336 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31345 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31354 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9326 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31363 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9331 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31372 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9336 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31384 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9344 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 31396 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 31405 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 31414 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9362 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 31423 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9368 "gram.y" /* yacc.c:1646  */
    {}
#line 31429 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9369 "gram.y" /* yacc.c:1646  */
    {}
#line 31435 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9372 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 31441 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9373 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31447 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9374 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 31453 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 31459 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9382 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31465 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9383 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31471 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9384 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31477 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9388 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 31483 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9389 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31489 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31495 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9397 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 31501 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 31507 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9402 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 31520 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9411 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 31533 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 31539 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 31545 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9425 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 31551 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9426 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 31557 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31563 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 31569 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9436 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31575 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9438 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 31588 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9448 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 31594 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9453 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31600 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9456 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31606 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9460 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31612 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9462 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 31621 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9469 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31627 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9479 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 31633 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9480 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31639 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9481 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 31645 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9489 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31651 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9493 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31657 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9494 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31663 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9497 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31669 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9498 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31675 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9503 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31681 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9504 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31687 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9508 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31693 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9509 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31699 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31705 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31711 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9518 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31717 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9519 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31723 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9523 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31729 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9524 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31735 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9529 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 31747 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9539 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 31753 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9540 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 31759 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9541 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 31765 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9542 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 31771 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31777 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9547 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31783 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9553 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 31793 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9559 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 31803 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9576 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31809 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9577 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31815 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9581 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31821 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9582 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31827 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9589 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 31836 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9594 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->funccallnode = (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 31849 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9603 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = true;
					n->funccallnode = (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 31862 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9612 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 31901 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9647 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same coment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 31930 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 31938 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9676 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 31947 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9702 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 31955 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9706 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 31971 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9718 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 31988 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9731 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 32006 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9745 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 32021 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9756 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 32037 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9771 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 32047 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9777 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 32056 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9782 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 32066 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9788 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 32075 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9794 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 32081 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9795 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 32087 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9808 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 32103 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9812 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 32113 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 9818 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 32123 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 9824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 32131 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 9829 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 32137 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 9830 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 9831 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 32149 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 9832 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 9836 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32161 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 9837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 9849 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 32173 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 9850 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32179 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 9856 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 32190 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 9863 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 32201 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 9870 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 32212 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 9877 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 32223 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 9887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 32229 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 9888 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 32235 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 9902 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 32243 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 9906 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 32254 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 9913 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 32265 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 9922 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32271 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 9927 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32277 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 9928 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32283 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 9933 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32289 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 9935 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 32301 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 9942 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32307 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 9947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32313 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 9948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32319 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 9953 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32327 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 9957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32335 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 9963 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
#line 32356 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 9992 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 32365 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 9997 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 32375 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10004 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 32384 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10009 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 32394 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10015 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 32403 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10020 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 32413 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10029 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 32419 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10031 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 32425 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 10033 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 32431 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 10037 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32437 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10038 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32443 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10039 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32449 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10040 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32455 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10041 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32461 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 32470 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10048 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 32490 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10077 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32496 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10078 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32502 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10079 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32508 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10080 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 32514 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32524 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10098 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 32534 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10105 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32540 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10106 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32546 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10113 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32555 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10118 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32564 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32573 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10128 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32582 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10133 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32591 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10138 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32600 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10143 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32609 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10148 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32619 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32629 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10160 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32639 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10166 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32648 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 10173 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 32673 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 10194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 32681 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 10204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32689 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 10208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32697 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 10216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 32714 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10228 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 32727 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10240 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32745 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32753 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32761 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 32769 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10275 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 32784 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10288 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-4].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-4].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-4].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 32805 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10307 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-1].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-1].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-1].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32830 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10330 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 32836 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10332 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 32842 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10334 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 32848 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10336 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 32854 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10338 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 32860 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10340 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 32866 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10344 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32872 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10345 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32878 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10349 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32884 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10350 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32890 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10358 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 32903 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10367 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32915 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10375 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 32928 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10384 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 32940 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10395 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 32949 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10402 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32955 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10403 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10404 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32967 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 32973 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10411 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 32979 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 32985 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10415 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 32991 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10417 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 32997 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10419 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33003 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 33012 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 33021 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10431 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 33031 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 33043 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10445 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 33052 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 33063 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10457 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 33073 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33079 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 33087 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 33096 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10501 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33102 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10503 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 33108 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10505 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33120 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10513 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[0].node), (yyvsp[-4].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 33137 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10535 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 33143 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10537 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 33149 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10539 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33155 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10541 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33161 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10543 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33167 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10545 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33173 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10547 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33179 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10549 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33185 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10551 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33191 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10553 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33197 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10555 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33203 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10558 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33209 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10560 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 33215 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10562 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 33221 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10565 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33227 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10567 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33233 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10569 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 33239 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33245 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10574 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 33262 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10587 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 33268 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10589 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 33285 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10602 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33291 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10604 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 33308 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10617 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 33314 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10619 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 33331 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10633 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 33348 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10646 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 33365 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10659 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 33382 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10672 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 33399 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10695 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 33410 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10702 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 33421 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10709 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 33432 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10716 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 33443 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10723 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlaps");
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					n->args = list_concat((yyvsp[-2].list), (yyvsp[0].list));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 33470 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10746 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 33481 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10753 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 33492 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10760 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 33503 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10767 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 33514 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10774 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 33525 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10781 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 33536 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10788 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 33544 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 10792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 33556 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 10800 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 33564 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 10804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 33572 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 10814 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 33583 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 10821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 33594 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 10828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 33611 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 10841 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 33628 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 10854 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 33651 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 10873 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 33676 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 10894 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 33690 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 10904 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 33701 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 10911 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 33721 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 10927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 33730 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 10932 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 33741 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 10950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33747 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 10952 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 33753 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 10954 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 33759 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 10956 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 33765 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 10958 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33771 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 10960 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33777 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 10962 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33783 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 10964 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33789 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 10966 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33795 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 10968 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33801 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 10970 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33807 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 10972 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33813 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 10974 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33819 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 10976 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 33825 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 10978 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 33831 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 10980 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 33837 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 10982 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 33845 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 10986 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 33854 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 10991 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 33862 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 10995 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 33870 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 10999 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 33879 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11004 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 33890 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11020 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33896 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11021 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33902 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11023 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 33921 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11038 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 33937 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11050 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33943 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11052 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33949 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11054 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 33963 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11064 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 33990 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11087 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 34004 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11097 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 34018 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11107 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 34030 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11115 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 34043 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11134 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-3].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34060 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11147 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34077 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11160 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = list_make1((yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 34094 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11173 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-7].list);
					n->args = lappend((yyvsp[-5].list), (yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *)n;
				}
#line 34111 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11186 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 34128 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11199 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 34149 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11216 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 34166 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11229 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34193 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11252 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("pg_collation_for");
					n->args = list_make1((yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34210 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11265 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 34240 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11291 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 34254 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11301 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 34271 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11314 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34292 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11331 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 34309 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11344 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 34323 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11354 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 34340 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11367 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 34354 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11377 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 34371 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11390 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34388 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11403 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34405 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11416 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34422 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11429 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34439 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11442 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34456 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11455 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 34473 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 34479 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11470 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34496 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11483 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34518 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11501 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34536 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11515 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34556 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11531 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[-3].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 34582 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11553 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34602 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11569 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34619 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11582 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34636 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11595 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 34653 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 34661 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11612 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 34672 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11619 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 34684 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11627 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 34696 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 34704 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 34712 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11643 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 34720 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11647 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 34728 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 34736 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11655 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 34755 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 34763 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11674 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 34776 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11683 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 34784 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11687 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 34792 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 34801 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11696 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 34814 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11710 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34820 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11712 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 34826 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11716 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 34832 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11718 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 34838 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11720 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 34844 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11722 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 34850 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11725 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34856 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 34862 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11729 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 34868 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 34880 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11741 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 34892 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11750 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 34898 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11751 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 34904 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11754 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 34910 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11755 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34916 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11756 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 34922 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 34930 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11766 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 34938 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11770 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 34946 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11774 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 34954 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11784 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34960 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11785 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34966 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11789 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 34972 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11791 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 34978 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11796 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 34988 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11804 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 34994 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11806 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 35011 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11819 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 35017 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11824 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 35035 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11849 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35041 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11850 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35047 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11853 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35053 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11854 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35059 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11866 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 35081 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11884 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 35091 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11890 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35103 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11900 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 35124 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 11917 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 35165 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 11962 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35177 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11970 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35189 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11978 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35201 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11986 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35213 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11994 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 35225 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35231 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12015 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35237 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 35243 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12019 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 35249 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12020 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 35255 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12021 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 35261 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12024 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35267 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12025 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35273 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12028 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 35279 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 12029 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 35285 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 12030 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 35291 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 12031 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 35297 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 12032 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 35303 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 12033 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 35309 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 12034 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 35315 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 12035 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 35321 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 12036 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 35327 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 12040 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35333 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35339 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12047 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35345 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35351 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12054 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35357 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12056 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35363 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 35369 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12060 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 35375 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12062 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 35381 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 35387 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12076 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 35395 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12080 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 35403 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12087 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 35411 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 35419 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 35427 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12101 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 35440 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12111 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 35446 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12112 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 35452 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12116 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 35460 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 35468 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12124 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 35476 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35482 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12130 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35488 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12136 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 35496 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12139 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35502 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12146 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35508 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12147 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 35514 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12148 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 35520 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12149 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 35526 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12150 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 35532 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12151 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 35538 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12152 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 35544 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12153 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35550 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12164 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 35558 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12168 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 35566 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12175 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35572 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 35578 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35584 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 35592 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12203 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 35601 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 35609 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12212 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 35628 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12227 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 35636 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35642 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12235 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35648 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12238 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35654 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 35660 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12242 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35666 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12243 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35672 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12247 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 35683 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12253 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 35689 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12264 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 35703 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12277 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35709 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12278 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35715 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12283 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 35727 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12293 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35733 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12294 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35739 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12297 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35745 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12298 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35751 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 35759 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 35767 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12313 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 35775 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12317 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 35783 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12321 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 35794 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12328 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 35805 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12337 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35811 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12338 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35817 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35823 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12343 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35829 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12358 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 35835 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12360 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 35845 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12368 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35851 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12369 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35857 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35863 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12388 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 35869 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12389 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 35875 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 35887 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 35899 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 12417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 35911 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 12425 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 35927 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 12446 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 35933 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 12447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 35939 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 12459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 35947 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 12463 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 35976 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 12490 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35982 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 12492 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35988 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 12496 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35994 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 12499 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36000 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 12502 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36006 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 12504 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36012 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 12506 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36018 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 12508 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36024 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 12519 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36030 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 12521 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 36039 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 12532 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 36047 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 12536 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36055 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 12540 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36063 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 12544 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36071 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 12548 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 36084 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 12557 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 36095 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 12564 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-4].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[-2].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[-2].list);
					t->location = (yylsp[-4]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 36124 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 12589 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 36132 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 12593 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 36142 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 12599 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 36163 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 12616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 36171 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 12620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 36179 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 12624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 36187 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 12629 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 36193 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 12630 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36199 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 12631 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36205 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 12634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36211 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 12636 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36217 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 12639 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 36223 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 12640 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 36229 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 12641 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 36235 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 12657 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36241 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 12658 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36247 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 12659 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36253 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 12664 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36259 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 12665 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36265 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 12666 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36271 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 12671 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36277 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 12672 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36283 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 12673 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36289 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 12674 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36295 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 12680 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36301 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 12681 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36307 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 12682 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36313 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 12683 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36319 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 12684 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 36325 "gram.c" /* yacc.c:1646  */
    break;


#line 36329 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 13142 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"
